/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/objects","fs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/product/common/productService","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/product/common/product","vs/base/common/map","os","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/process","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/userDataPath","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/base/parts/sandbox/electron-sandbox/globals","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","vs/platform/log/common/bufferLog","vs/platform/log/common/fileLog","vs/platform/log/node/loggerService","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/environment/node/environmentService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","path","util","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],Z=function(G){for(var e=[],v=0,T=G.length;v<T;v++)e[v]=Q[G[v]];return e};define(Q[85],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(T,k){if(!T)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=v}),define(Q[62],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function T(C){const d=[];for(let b in C)v.call(C,b)&&d.push(C[b]);return d}e.values=T;function k(C,d){for(let b in C)if(v.call(C,b)&&d({key:b,value:C[b]},function(){delete C[b]})===!1)return}e.forEach=k;function R(C,d){const b=Object.create(null);for(const I of C){const a=d(I);let D=b[a];D||(D=b[a]=[]),D.push(I)}return b}e.groupBy=R;function L(C){const d=Object.create(null);return C&&C.forEach((b,I)=>{d[I]=b}),d}e.fromMap=L;function P(C,d){const b=[],I=[];for(let a of C)d.has(a)||b.push(a);for(let a of d)C.has(a)||I.push(a);return{removed:b,added:I}}e.diffSets=P;function g(C,d){const b=[],I=[];for(let[a,D]of C)d.has(a)||b.push(D);for(let[a,D]of d)C.has(a)||I.push(D);return{removed:b,added:I}}e.diffMaps=g;class p{constructor(){this.map=new Map}add(d,b){let I=this.map.get(d);I||(I=new Set,this.map.set(d,I)),I.add(b)}delete(d,b){const I=this.map.get(d);!I||(I.delete(b),I.size===0&&this.map.delete(d))}forEach(d,b){const I=this.map.get(d);!I||I.forEach(b)}}e.SetMap=p}),define(Q[86],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function v(g){return(p,C,d)=>{let b=null,I=null;if(typeof d.value=="function"?(b="value",I=d.value):typeof d.get=="function"&&(b="get",I=d.get),!I)throw new Error("not supported");d[b]=g(I,C)}}e.createDecorator=v;let T=0;function k(){const g=`$memoize${T++}`;let p;const C=function(b,I,a){let D=null,S=null;if(typeof a.value=="function"?(D="value",S=a.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(D="get",S=a.get),!S)throw new Error("not supported");const w=`${g}:${I}`;a[D]=function(...y){return p=this,this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,y)}),this[w]}};return C.clear=()=>{typeof p!="undefined"&&Object.getOwnPropertyNames(p).forEach(d=>{d.indexOf(g)===0&&delete p[d]})},C}e.createMemoizer=k;function R(g,p,C){return k()(g,p,C)}e.memoize=R;function L(g,p,C){return v((d,b)=>{const I=`$debounce$${b}`,a=`$debounce$result$${b}`;return function(...D){this[a]||(this[a]=C?C():void 0),clearTimeout(this[I]),p&&(this[a]=p(this[a],...D),D=[this[a]]),this[I]=setTimeout(()=>{d.apply(this,D),this[a]=C?C():void 0},g)}})}e.debounce=L;function P(g,p,C){return v((d,b)=>{const I=`$throttle$timer$${b}`,a=`$throttle$result$${b}`,D=`$throttle$lastRun$${b}`,S=`$throttle$pending$${b}`;return function(...w){if(this[a]||(this[a]=C?C():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),p&&(this[a]=p(this[a],...w)),!this[S]){const y=this[D]+g;y<=Date.now()?(this[D]=Date.now(),d.apply(this,[this[a]]),this[a]=C?C():void 0):(this[S]=!0,this[I]=setTimeout(()=>{this[S]=!1,this[D]=Date.now(),d.apply(this,[this[a]]),this[a]=C?C():void 0},y-Date.now()))}}})}e.throttle=P}),define(Q[15],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function T(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=T;function k(i){g(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=k;function R(i){g(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=R;function L(i){if(i instanceof Error){let{name:t,message:n}=i;const r=i.stacktrace||i.stack;return{$isError:!0,name:t,message:n,stack:r}}return i}e.transformErrorForSerialization=L;const P="Canceled";function g(i){return i instanceof Error&&i.name===P&&i.message===P}e.isPromiseCanceledError=g;class p extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=p;function C(){const i=new Error(P);return i.name=i.message,i}e.canceled=C;function d(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=d;function b(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=b;function I(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function a(i){const t=new Error(`${i} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function D(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=D;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function m(i){const t=i;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=m;function o(i,t=Object.create(null)){const n=new Error(i);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=o}),define(Q[18],Z([0,1,15]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(B,M=0){return B[B.length-(1+M)]}e.tail=T;function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=k;function R(B,M,F=(A,U)=>A===U){if(B===M)return!0;if(!B||!M||B.length!==M.length)return!1;for(let A=0,U=B.length;A<U;A++)if(!F(B[A],M[A]))return!1;return!0}e.equals=R;function L(B,M,F){let A=0,U=B.length-1;for(;A<=U;){const N=(A+U)/2|0,z=F(B[N],M);if(z<0)A=N+1;else if(z>0)U=N-1;else return N}return-(A+1)}e.binarySearch=L;function P(B,M){let F=0,A=B.length;if(A===0)return 0;for(;F<A;){const U=Math.floor((F+A)/2);M(B[U])?A=U:F=U+1}return F}e.findFirstInSorted=P;function g(B,M,F){if(B=B|0,B>=M.length)throw new TypeError("invalid index");let A=M[Math.floor(M.length*Math.random())],U=[],N=[],z=[];for(let H of M){const K=F(H,A);K<0?U.push(H):K>0?N.push(H):z.push(H)}return B<U.length?g(B,U,F):B<U.length+z.length?z[0]:g(B-(U.length+z.length),N,F)}e.quickSelect=g;function p(B,M){const F=[];let A;for(const U of B.slice(0).sort(M))!A||M(A[0],U)!==0?(A=[U],F.push(A)):A.push(U);return F}e.groupBy=p;function C(B,M,F){const A=[];function U(H,K,te){if(!(K===0&&te.length===0)){const X=A[A.length-1];X&&X.start+X.deleteCount===H?(X.deleteCount+=K,X.toInsert.push(...te)):A.push({start:H,deleteCount:K,toInsert:te})}}let N=0,z=0;for(;;){if(N===B.length){U(N,0,M.slice(z));break}if(z===M.length){U(N,B.length-N,[]);break}const H=B[N],K=M[z],te=F(H,K);te===0?(N+=1,z+=1):te<0?(U(N,1,[]),N+=1):te>0&&(U(N,0,[K]),z+=1)}return A}e.sortedDiff=C;function d(B,M,F){const A=C(B,M,F),U=[],N=[];for(const z of A)U.push(...B.slice(z.start,z.start+z.deleteCount)),N.push(...z.toInsert);return{removed:U,added:N}}e.delta=d;function b(B,M,F){if(F===0)return[];const A=B.slice(0,F).sort(M);return a(B,M,A,F,B.length),A}e.top=b;function I(B,M,F,A,U){return F===0?Promise.resolve([]):new Promise((N,z)=>{(async()=>{const H=B.length,K=B.slice(0,F).sort(M);for(let te=F,X=Math.min(F+A,H);te<H;te=X,X=Math.min(X+A,H)){if(te>F&&await new Promise(ie=>setTimeout(ie)),U&&U.isCancellationRequested)throw(0,v.canceled)();a(B,M,K,te,X)}return K})().then(N,z)})}e.topAsync=I;function a(B,M,F,A,U){for(const N=F.length;A<U;A++){const z=B[A];if(M(z,F[N-1])<0){F.pop();const H=P(F,K=>M(z,K)<0);F.splice(H,0,z)}}}function D(B){return B.filter(M=>!!M)}e.coalesce=D;function S(B){let M=0;for(let F=0;F<B.length;F++)B[F]&&(B[M]=B[F],M+=1);B.length=M}e.coalesceInPlace=S;function w(B,M,F){B.splice(F,0,B.splice(M,1)[0])}e.move=w;function y(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=y;function m(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=m;function o(B,M){if(!M)return B.filter((A,U)=>B.indexOf(A)===U);const F=Object.create(null);return B.filter(A=>{const U=M(A);return F[U]?!1:(F[U]=!0,!0)})}e.distinct=o;function i(B){const M=new Set;return B.filter(F=>M.has(F)?!1:(M.add(F),!0))}e.distinctES6=i;function t(B){const M=Object.create(null);return F=>{const A=B(F);return M[A]?!1:(M[A]=!0,!0)}}e.uniqueFilter=t;function n(B,M){for(let F=B.length-1;F>=0;F--){const A=B[F];if(M(A))return F}return-1}e.lastIndex=n;function r(B,M){return B.length>0?B[0]:M}e.firstOrDefault=r;function c(B,M,F=(A,U)=>A===U){let A=0;for(let U=0,N=Math.min(B.length,M.length);U<N&&F(B[U],M[U]);U++)A++;return A}e.commonPrefixLength=c;function s(B){return[].concat(...B)}e.flatten=s;function l(B,M){let F=typeof M=="number"?B:0;typeof M=="number"?F=B:(F=0,M=B);const A=[];if(F<=M)for(let U=F;U<M;U++)A.push(U);else for(let U=F;U>M;U--)A.push(U);return A}e.range=l;function h(B,M,F){return B.reduce((A,U)=>(A[M(U)]=F?F(U):U,A),Object.create(null))}e.index=h;function f(B,M){return B.push(M),()=>E(B,M)}e.insert=f;function E(B,M){const F=B.indexOf(M);if(F>-1)return B.splice(F,1),M}e.remove=E;function u(B,M,F){const A=B.slice(0,M),U=B.slice(M);return A.concat(F,U)}e.arrayInsert=u;function O(B,M){let F;if(typeof M=="number"){let A=M;F=()=>{const U=Math.sin(A++)*179426549;return U-Math.floor(U)}}else F=Math.random;for(let A=B.length-1;A>0;A-=1){const U=Math.floor(F()*(A+1)),N=B[A];B[A]=B[U],B[U]=N}}e.shuffle=O;function _(B,M){const F=B.indexOf(M);F>-1&&(B.splice(F,1),B.unshift(M))}e.pushToStart=_;function q(B,M){const F=B.indexOf(M);F>-1&&(B.splice(F,1),B.push(M))}e.pushToEnd=q;function x(B,M){return Array.isArray(B)?B.map(M):M(B)}e.mapArrayOrNot=x;function j(B){return Array.isArray(B)?B:[B]}e.asArray=j;function $(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=$;function W(B,M){for(const F of B){const A=M(F);if(A!==void 0)return A}}e.mapFind=W}),define(Q[63],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(T){const k=this;let R=!1,L;return function(){return R||(R=!0,L=T.apply(k,arguments)),L}}e.once=v}),define(Q[52],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(T){function k(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}T.is=k;const R=Object.freeze([]);function L(){return R}T.empty=L;function*P(i){yield i}T.single=P;function g(i){return i||R}T.from=g;function p(i){return!i||i[Symbol.iterator]().next().done===!0}T.isEmpty=p;function C(i){return i[Symbol.iterator]().next().value}T.first=C;function d(i,t){for(const n of i)if(t(n))return!0;return!1}T.some=d;function b(i,t){for(const n of i)if(t(n))return n}T.find=b;function*I(i,t){for(const n of i)t(n)&&(yield n)}T.filter=I;function*a(i,t){for(const n of i)yield t(n)}T.map=a;function*D(...i){for(const t of i)for(const n of t)yield n}T.concat=D;function*S(i){for(const t of i)for(const n of t)yield n}T.concatNested=S;function w(i,t,n){let r=n;for(const c of i)r=t(r,c);return r}T.reduce=w;function*y(i,t,n=i.length){for(t<0&&(t+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);t<n;t++)yield i[t]}T.slice=y;function m(i,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,i];const r=i[Symbol.iterator]();for(let c=0;c<t;c++){const s=r.next();if(s.done)return[n,T.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return r}}]}T.consume=m;function o(i,t,n=(r,c)=>r===c){const r=i[Symbol.iterator](),c=t[Symbol.iterator]();for(;;){const s=r.next(),l=c.next();if(s.done!==l.done)return!1;if(s.done)return!0;if(!n(s.value,l.value))return!1}}T.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(Q[32],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function L(t,n=!1){let r=0,c=t.length,s="",l=0,h=16,f=0;function E($){let W=0,B=0;for(;W<$;){const M=t.charCodeAt(r);if(M>=48&&M<=57)B=B*16+M-48;else if(M>=65&&M<=70)B=B*16+M-65+10;else if(M>=97&&M<=102)B=B*16+M-97+10;else break;r++,W++}return W<$&&(B=-1),B}function u($){r=$,s="",l=0,h=16,f=0}function O(){const $=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&p(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&p(t.charCodeAt(r)))for(r++;r<t.length&&p(t.charCodeAt(r));)r++;else return f=3,t.substring($,r);let W=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&p(t.charCodeAt(r))){for(r++;r<t.length&&p(t.charCodeAt(r));)r++;W=r}else f=3;return t.substring($,W)}function _(){let $="",W=r;for(;;){if(r>=c){$+=t.substring(W,r),f=2;break}const B=t.charCodeAt(r);if(B===34){$+=t.substring(W,r),r++;break}if(B===92){if($+=t.substring(W,r),r++,r>=c){f=2;break}switch(t.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const F=E(4);F>=0?$+=String.fromCharCode(F):f=4;break;default:f=5}W=r;continue}if(B>=0&&B<=31)if(g(B)){$+=t.substring(W,r),f=2;break}else f=6;r++}return $}function q(){if(s="",f=0,l=r,r>=c)return l=c,h=17;let $=t.charCodeAt(r);if(P($)){do r++,s+=String.fromCharCode($),$=t.charCodeAt(r);while(P($));return h=15}if(g($))return r++,s+=String.fromCharCode($),$===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),h=14;switch($){case 123:return r++,h=1;case 125:return r++,h=2;case 91:return r++,h=3;case 93:return r++,h=4;case 58:return r++,h=6;case 44:return r++,h=5;case 34:return r++,s=_(),h=10;case 47:const W=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<c&&!g(t.charCodeAt(r));)r++;return s=t.substring(W,r),h=12}if(t.charCodeAt(r+1)===42){r+=2;const B=c-1;let M=!1;for(;r<B;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,M=!0;break}r++}return M||(r++,f=1),s=t.substring(W,r),h=13}return s+=String.fromCharCode($),r++,h=16;case 45:if(s+=String.fromCharCode($),r++,r===c||!p(t.charCodeAt(r)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),h=11;default:for(;r<c&&x($);)r++,$=t.charCodeAt(r);if(l!==r){switch(s=t.substring(l,r),s){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return s+=String.fromCharCode($),r++,h=16}}function x($){if(P($)||g($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let $;do $=q();while($>=12&&$<=15);return $}return{setPosition:u,getPosition:()=>r,scan:n?j:q,getToken:()=>h,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>f}}e.createScanner=L;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function d(t,n){const r=[],c=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function f(E,u,O,_){l.value=E,l.offset=u,l.length=O,l.type=_,l.colonOffset=void 0,s=l}try{m(t,{onObjectBegin:(E,u)=>{if(n<=E)throw c;s=void 0,h=n>E,r.push("")},onObjectProperty:(E,u,O)=>{if(n<u||(f(E,u,O,"property"),r[r.length-1]=E,n<=u+O))throw c},onObjectEnd:(E,u)=>{if(n<=E)throw c;s=void 0,r.pop()},onArrayBegin:(E,u)=>{if(n<=E)throw c;s=void 0,r.push(0)},onArrayEnd:(E,u)=>{if(n<=E)throw c;s=void 0,r.pop()},onLiteralValue:(E,u,O)=>{if(n<u||(f(E,u,O,i(E)),n<=u+O))throw c},onSeparator:(E,u,O)=>{if(n<=u)throw c;if(E===":"&&s&&s.type==="property")s.colonOffset=u,h=!1,s=void 0;else if(E===","){const _=r[r.length-1];typeof _=="number"?r[r.length-1]=_+1:(h=!0,r[r.length-1]=""),s=void 0}}})}catch(E){if(E!==c)throw E}return{path:r,previousNode:s,isAtPropertyKey:h,matches:E=>{let u=0;for(let O=0;u<E.length&&O<r.length;O++)if(E[u]===r[O]||E[u]==="*")u++;else if(E[u]!=="**")return!1;return u===E.length}}}e.getLocation=d;function b(t,n=[],r=R.DEFAULT){let c=null,s=[];const l=[];function h(E){Array.isArray(s)?s.push(E):c!==null&&(s[c]=E)}return m(t,{onObjectBegin:()=>{const E={};h(E),l.push(s),s=E,c=null},onObjectProperty:E=>{c=E},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const E=[];h(E),l.push(s),s=E,c=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:h,onError:(E,u,O)=>{n.push({error:E,offset:u,length:O})}},r),s[0]}e.parse=b;function I(t,n=[],r=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(E){c.type==="property"&&(c.length=E-c.offset,c=c.parent)}function l(E){return c.children.push(E),E}m(t,{onObjectBegin:E=>{c=l({type:"object",offset:E,length:-1,parent:c,children:[]})},onObjectProperty:(E,u,O)=>{c=l({type:"property",offset:u,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:E,offset:u,length:O,parent:c})},onObjectEnd:(E,u)=>{c.length=E+u-c.offset,c=c.parent,s(E+u)},onArrayBegin:(E,u)=>{c=l({type:"array",offset:E,length:-1,parent:c,children:[]})},onArrayEnd:(E,u)=>{c.length=E+u-c.offset,c=c.parent,s(E+u)},onLiteralValue:(E,u,O)=>{l({type:i(E),offset:u,length:O,parent:c,value:E}),s(u+O)},onSeparator:(E,u,O)=>{c.type==="property"&&(E===":"?c.colonOffset=u:E===","&&s(u))},onError:(E,u,O)=>{n.push({error:E,offset:u,length:O})}},r);const f=c.children[0];return f&&delete f.parent,f}e.parseTree=I;function a(t,n){if(!!t){let r=t;for(let c of n)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===c){r=l.children[1],s=!0;break}if(!s)return}else{const s=c;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}}e.findNodeAtLocation=a;function D(t){if(!t.parent||!t.parent.children)return[];const n=D(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=D;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const n=Object.create(null);for(let r of t.children){const c=r.children[1];c&&(n[r.children[0].value]=S(c))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=w;function y(t,n,r=!1){if(w(t,n,r)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=n;s++){const l=y(c[s],n,r);if(l)return l}return t}}e.findNodeAtOffset=y;function m(t,n,r=R.DEFAULT){const c=L(t,!1);function s(K){return K?()=>K(c.getTokenOffset(),c.getTokenLength()):()=>!0}function l(K){return K?te=>K(te,c.getTokenOffset(),c.getTokenLength()):()=>!0}const h=s(n.onObjectBegin),f=l(n.onObjectProperty),E=s(n.onObjectEnd),u=s(n.onArrayBegin),O=s(n.onArrayEnd),_=l(n.onLiteralValue),q=l(n.onSeparator),x=s(n.onComment),j=l(n.onError),$=r&&r.disallowComments,W=r&&r.allowTrailingComma;function B(){for(;;){const K=c.scan();switch(c.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:$||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(K){case 12:case 13:$?M(10):x();break;case 16:M(1);break;case 15:case 14:break;default:return K}}}function M(K,te=[],X=[]){if(j(K),te.length+X.length>0){let ie=c.getToken();for(;ie!==17;){if(te.indexOf(ie)!==-1){B();break}else if(X.indexOf(ie)!==-1)break;ie=B()}}}function F(K){const te=c.getTokenValue();return K?_(te):f(te),B(),!0}function A(){switch(c.getToken()){case 11:let K=0;try{K=JSON.parse(c.getTokenValue()),typeof K!="number"&&(M(2),K=0)}catch(te){M(2)}_(K);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return B(),!0}function U(){return c.getToken()!==10?(M(3,[],[2,5]),!1):(F(!1),c.getToken()===6?(q(":"),B(),H()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function N(){h(),B();let K=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(K||M(4,[],[]),q(","),B(),c.getToken()===2&&W)break}else K&&M(6,[],[]);U()||M(4,[],[2,5]),K=!0}return E(),c.getToken()!==2?M(7,[2],[]):B(),!0}function z(){u(),B();let K=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(K||M(4,[],[]),q(","),B(),c.getToken()===4&&W)break}else K&&M(6,[],[]);H()||M(4,[],[4,5]),K=!0}return O(),c.getToken()!==4?M(8,[4],[]):B(),!0}function H(){switch(c.getToken()){case 3:return z();case 1:return N();case 10:return F(!0);default:return A()}}return B(),c.getToken()===17?r.allowEmptyContent?!0:(M(4,[],[]),!1):H()?(c.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=m;function o(t,n){let r=L(t),c=[],s,l=0,h;do switch(h=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:l!==h&&c.push(t.substring(l,h)),n!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,n)),l=r.getPosition();break}while(s!==17);return c.join("")}e.stripComments=o;function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=i}),define(Q[46],Z([0,1,32]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function T(g,p,C){let d,b,I,a,D;if(p){for(a=p.offset,D=a+p.length,I=a;I>0&&!P(g,I-1);)I--;let l=D;for(;l<g.length&&!P(g,l);)l++;b=g.substring(I,l),d=R(b,C)}else b=g,d=0,I=0,a=0,D=g.length;const S=L(C,g);let w=!1,y=0,m;C.insertSpaces?m=k(" ",C.tabSize||4):m="	";const o=(0,v.createScanner)(b,!1);let i=!1;function t(){return S+k(m,d+y)}function n(){let l=o.scan();for(w=!1;l===15||l===14;)w=w||l===14,l=o.scan();return i=l===16||o.getTokenError()!==0,l}const r=[];function c(l,h,f){!i&&h<D&&f>a&&g.substring(h,f)!==l&&r.push({offset:h,length:f-h,content:l})}let s=n();if(s!==17){const l=o.getTokenOffset()+I,h=k(m,d);c(h,I,l)}for(;s!==17;){let l=o.getTokenOffset()+o.getTokenLength()+I,h=n(),f="";for(;!w&&(h===12||h===13);){const u=o.getTokenOffset()+I;c(" ",l,u),l=o.getTokenOffset()+o.getTokenLength()+I,f=h===12?t():"",h=n()}if(h===2)s!==1&&(y--,f=t());else if(h===4)s!==3&&(y--,f=t());else{switch(s){case 3:case 1:y++,f=t();break;case 5:case 12:f=t();break;case 13:w?f=t():f=" ";break;case 6:f=" ";break;case 10:if(h===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?f=" ":h!==5&&h!==17&&(i=!0);break;case 16:i=!0;break}w&&(h===12||h===13)&&(f=t())}const E=o.getTokenOffset()+I;c(f,l,E),s=h}return r}e.format=T;function k(g,p){let C="";for(let d=0;d<p;d++)C+=g;return C}function R(g,p){let C=0,d=0;const b=p.tabSize||4;for(;C<g.length;){const I=g.charAt(C);if(I===" ")d++;else if(I==="	")d+=b;else break;C++}return Math.floor(d/b)}function L(g,p){for(let C=0;C<p.length;C++){const d=p.charAt(C);if(d==="\r")return C+1<p.length&&p.charAt(C+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return g&&g.eol||`
`}e.getEOL=L;function P(g,p){return`\r
`.indexOf(g.charAt(p))!==-1}e.isEOL=P}),define(Q[41],Z([0,1,32,46]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(p,C,d){return R(p,C,void 0,d)}e.removeProperty=k;function R(p,C,d,b,I){const a=C.slice(),D=[],S=(0,v.parseTree)(p,D);let w,y;for(;a.length>0&&(y=a.pop(),w=(0,v.findNodeAtLocation)(S,a),w===void 0&&d!==void 0);)typeof y=="string"?d={[y]:d}:d=[d];if(w)if(w.type==="object"&&typeof y=="string"&&Array.isArray(w.children)){const m=(0,v.findNodeAtLocation)(w,[y]);if(m!==void 0)if(d===void 0){if(!m.parent)throw new Error("Malformed AST");const o=w.children.indexOf(m.parent);let i,t=m.parent.offset+m.parent.length;if(o>0){const n=w.children[o-1];i=n.offset+n.length}else i=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return L(p,{offset:i,length:t-i,content:""},b)}else return L(p,{offset:m.offset,length:m.length,content:JSON.stringify(d)},b);else{if(d===void 0)return[];const o=`${JSON.stringify(y)}: ${JSON.stringify(d)}`,i=I?I(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(i>0){const n=w.children[i-1];t={offset:n.offset+n.length,length:0,content:","+o}}else w.children.length===0?t={offset:w.offset+1,length:0,content:o}:t={offset:w.offset+1,length:0,content:o+","};return L(p,t,b)}}else if(w.type==="array"&&typeof y=="number"&&Array.isArray(w.children))if(d!==void 0){const m=`${JSON.stringify(d)}`;let o;if(w.children.length===0||y===0)o={offset:w.offset+1,length:0,content:w.children.length===0?m:m+","};else{const i=y===-1||y>w.children.length?w.children.length:y,t=w.children[i-1];o={offset:t.offset+t.length,length:0,content:","+m}}return L(p,o,b)}else{const m=y,o=w.children[m];let i;if(w.children.length===1)i={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===m){const t=w.children[m-1],n=t.offset+t.length,r=w.offset+w.length;i={offset:n,length:r-2-n,content:""}}else i={offset:o.offset,length:w.children[m+1].offset-o.offset,content:""};return L(p,i,b)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${w.type}`);else{if(d===void 0)throw new Error("Can not delete in empty document");return L(p,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(d)},b)}}e.setProperty=R;function L(p,C,d){let b=P(p,C),I=C.offset,a=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;I>0&&!(0,T.isEOL)(b,I-1);)I--;for(;a<b.length&&!(0,T.isEOL)(b,a);)a++}const D=(0,T.format)(b,{offset:I,length:a-I},d);for(let w=D.length-1;w>=0;w--){const y=D[w];b=P(b,y),I=Math.min(I,y.offset),a=Math.max(a,y.offset+y.length),a+=y.content.length-y.length}const S=p.length-(b.length-a)-I;return[{offset:I,length:S,content:b.substring(I,a)}]}e.withFormatting=L;function P(p,C){return p.substring(0,C.offset)+C.content+p.substring(C.offset+C.length)}e.applyEdit=P;function g(p,C){let d=C.slice(0).sort((I,a)=>{const D=I.offset-a.offset;return D===0?I.length-a.length:D}),b=p.length;for(let I=d.length-1;I>=0;I--){let a=d[I];if(a.offset+a.length<=b)p=P(p,a);else throw new Error("Overlapping edit");b=a.offset}return p}e.applyEdits=g}),define(Q[2],Z([0,1,63,52]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let R=null;function L(m){R=m}if(e.setDisposableTracker=L,k){const m="__is_disposable_tracked__";R=new class{trackDisposable(o){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[m]||console.log(i)},3e3)}markTracked(o){if(o&&o!==D.None)try{o[m]=!0}catch(i){}}}}function P(m){!R||R.markTracked(m)}function g(m){return R&&R.trackDisposable(m),m}e.trackDisposable=g;class p extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=p;function C(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=C;function d(m){if(T.Iterable.is(m)){let o=[];for(const i of m)if(i){P(i);try{i.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new p(o);return Array.isArray(m)?[]:m}else if(m)return P(m),m.dispose(),m}e.dispose=d;function b(...m){return m.forEach(P),I(()=>d(m))}e.combinedDisposable=b;function I(m){const o=g({dispose:()=>{P(o),m()}});return o}e.toDisposable=I;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return P(o),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class D{constructor(){this._store=new a,g(this)}dispose(){P(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=D,D.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,g(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var i;this._isDisposed||o===this._value||((i=this._value)===null||i===void 0||i.dispose(),o&&P(o),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,P(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}e.MutableDisposable=S;class w{constructor(){this.references=new Map}acquire(o,...i){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...i)},this.references.set(o,t));const{object:n}=t,r=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:n,dispose:r}}}e.ReferenceCollection=w;class y{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=y}),define(Q[64],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(R){this.element=R,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class T{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,L){const P=new v(R);if(this._first===v.Undefined)this._first=P,this._last=P;else if(L){const p=this._last;this._last=P,P.prev=p,p.next=P}else{const p=this._first;this._first=P,P.next=p,p.prev=P}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(P))}}shift(){if(this._first!==v.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==v.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==v.Undefined&&R.next!==v.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===v.Undefined&&R.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):R.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):R.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==v.Undefined;)yield R.element,R=R.next}}e.LinkedList=T});"use strict";(function(){function G(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function L(g){R.push(g,Date.now())}function P(){const g=[];for(let p=0;p<R.length;p+=2)g.push({name:R[p],startTime:R[p+1]});return g}return{mark:L,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(k+L.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=v(T))})(),define(Q[7],Z([0,1]),function(G,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const T="en";let k=!1,R=!1,L=!1,P=!1,g=!1,p=!1,C=!1,d,b=T,I,a;const D=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof process!="undefined"?S=process:typeof D.vscode!="undefined"&&(S=D.vscode.process);const w=typeof((v=S==null?void 0:S.versions)===null||v===void 0?void 0:v.electron)=="string"&&S.type==="renderer";if(e.isElectronSandboxed=w&&(S==null?void 0:S.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=S==null?void 0:S.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w)a=navigator.userAgent,k=a.indexOf("Windows")>=0,R=a.indexOf("Macintosh")>=0,C=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=a.indexOf("Linux")>=0,p=!0,d=navigator.language,b=d;else if(typeof S=="object"){k=S.platform==="win32",R=S.platform==="darwin",L=S.platform==="linux",P=L&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,d=T,b=T;const s=S.env.VSCODE_NLS_CONFIG;if(s)try{const l=JSON.parse(s),h=l.availableLanguages["*"];d=l.locale,b=h||T,I=l._translationsConfigFile}catch(l){}g=!0}else console.error("Unable to resolve platform.");var y;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function m(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let o=0;R?o=1:k?o=3:L&&(o=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=L,e.isLinuxSnap=P,e.isNative=g,e.isWeb=p,e.isIOS=C,e.platform=o,e.userAgent=a,e.language=b;var i;(function(s){function l(){return e.language}s.value=l;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=h;function f(){return e.language==="en"}s.isDefault=f})(i=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=I,e.globals=D,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let u=0,O=h.length;u<O;u++){const _=h[u];if(_.id===E.data.vscodeSetImmediateId){h.splice(u,1),_.callback();return}}});let f=0;return E=>{const u=++f;h.push({id:u,callback:E}),e.globals.postMessage({vscodeSetImmediateId:u},"*")}}if(S&&typeof S.nextTick=="function")return S.nextTick.bind(S);const l=Promise.resolve();return h=>l.then(h)}();var t;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||C?2:k?1:3;let n=!0,r=!1;function c(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,n=new Uint16Array(s.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=c}),define(Q[53],Z([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;typeof process!="undefined"?T=process:typeof v.globals.vscode!="undefined"?T={get platform(){return v.globals.vscode.process.platform},get env(){return v.globals.vscode.process.env},nextTick(k){return(0,v.setImmediate)(k)},cwd(){return v.globals.vscode.process.env.VSCODE_CWD||v.globals.vscode.process.execPath.substr(0,v.globals.vscode.process.execPath.lastIndexOf(v.globals.vscode.process.platform==="win32"?"\\":"/"))}}:T={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(k){return(0,v.setImmediate)(k)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(Q[8],Z([0,1,53]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,k=97,R=90,L=122,P=46,g=47,p=92,C=58,d=63;class b extends Error{constructor(o,i,t){let n;typeof i=="string"&&i.indexOf("not ")===0?(n="must not be",i=i.replace(/^not /,"")):n="must be";const r=o.indexOf(".")!==-1?"property":"argument";let c=`The "${o}" ${r} ${n} of type ${i}`;c+=`. Received type ${typeof t}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function I(m,o){if(typeof m!="string")throw new b(o,"string",m)}function a(m){return m===g||m===p}function D(m){return m===g}function S(m){return m>=T&&m<=R||m>=k&&m<=L}function w(m,o,i,t){let n="",r=0,c=-1,s=0,l=0;for(let h=0;h<=m.length;++h){if(h<m.length)l=m.charCodeAt(h);else{if(t(l))break;l=g}if(t(l)){if(!(c===h-1||s===1))if(s===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const f=n.lastIndexOf(i);f===-1?(n="",r=0):(n=n.slice(0,f),r=n.length-1-n.lastIndexOf(i)),c=h,s=0;continue}else if(n.length!==0){n="",r=0,c=h,s=0;continue}}o&&(n+=n.length>0?`${i}..`:"..",r=2)}else n.length>0?n+=`${i}${m.slice(c+1,h)}`:n=m.slice(c+1,h),r=h-c-1;c=h,s=0}else l===P&&s!==-1?++s:s=-1}return n}function y(m,o){if(o===null||typeof o!="object")throw new b("pathObject","Object",o);const i=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return i?i===o.root?`${i}${t}`:`${i}${m}${t}`:t}e.win32={resolve(...m){let o="",i="",t=!1;for(let n=m.length-1;n>=-1;n--){let r;if(n>=0){if(r=m[n],I(r,"path"),r.length===0)continue}else o.length===0?r=v.cwd():(r=v.env[`=${o}`]||v.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===p)&&(r=`${o}\\`));const c=r.length;let s=0,l="",h=!1;const f=r.charCodeAt(0);if(c===1)a(f)&&(s=1,h=!0);else if(a(f))if(h=!0,a(r.charCodeAt(1))){let E=2,u=E;for(;E<c&&!a(r.charCodeAt(E));)E++;if(E<c&&E!==u){const O=r.slice(u,E);for(u=E;E<c&&a(r.charCodeAt(E));)E++;if(E<c&&E!==u){for(u=E;E<c&&!a(r.charCodeAt(E));)E++;(E===c||E!==u)&&(l=`\\\\${O}\\${r.slice(u,E)}`,s=E)}}}else s=1;else S(f)&&r.charCodeAt(1)===C&&(l=r.slice(0,2),s=2,c>2&&a(r.charCodeAt(2))&&(h=!0,s=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(t){if(o.length>0)break}else if(i=`${r.slice(s)}\\${i}`,t=h,h&&o.length>0)break}return i=w(i,!t,"\\",a),t?`${o}\\${i}`:`${o}${i}`||"."},normalize(m){I(m,"path");const o=m.length;if(o===0)return".";let i=0,t,n=!1;const r=m.charCodeAt(0);if(o===1)return D(r)?"\\":m;if(a(r))if(n=!0,a(m.charCodeAt(1))){let s=2,l=s;for(;s<o&&!a(m.charCodeAt(s));)s++;if(s<o&&s!==l){const h=m.slice(l,s);for(l=s;s<o&&a(m.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&!a(m.charCodeAt(s));)s++;if(s===o)return`\\\\${h}\\${m.slice(l)}\\`;s!==l&&(t=`\\\\${h}\\${m.slice(l,s)}`,i=s)}}}else i=1;else S(r)&&m.charCodeAt(1)===C&&(t=m.slice(0,2),i=2,o>2&&a(m.charCodeAt(2))&&(n=!0,i=3));let c=i<o?w(m.slice(i),!n,"\\",a):"";return c.length===0&&!n&&(c="."),c.length>0&&a(m.charCodeAt(o-1))&&(c+="\\"),t===void 0?n?`\\${c}`:c:n?`${t}\\${c}`:`${t}${c}`},isAbsolute(m){I(m,"path");const o=m.length;if(o===0)return!1;const i=m.charCodeAt(0);return a(i)||o>2&&S(i)&&m.charCodeAt(1)===C&&a(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let o,i;for(let r=0;r<m.length;++r){const c=m[r];I(c,"path"),c.length>0&&(o===void 0?o=i=c:o+=`\\${c}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof i=="string"&&a(i.charCodeAt(0))){++n;const r=i.length;r>1&&a(i.charCodeAt(1))&&(++n,r>2&&(a(i.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&a(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.win32.normalize(o)},relative(m,o){if(I(m,"from"),I(o,"to"),m===o)return"";const i=e.win32.resolve(m),t=e.win32.resolve(o);if(i===t||(m=i.toLowerCase(),o=t.toLowerCase(),m===o))return"";let n=0;for(;n<m.length&&m.charCodeAt(n)===p;)n++;let r=m.length;for(;r-1>n&&m.charCodeAt(r-1)===p;)r--;const c=r-n;let s=0;for(;s<o.length&&o.charCodeAt(s)===p;)s++;let l=o.length;for(;l-1>s&&o.charCodeAt(l-1)===p;)l--;const h=l-s,f=c<h?c:h;let E=-1,u=0;for(;u<f;u++){const _=m.charCodeAt(n+u);if(_!==o.charCodeAt(s+u))break;_===p&&(E=u)}if(u!==f){if(E===-1)return t}else{if(h>f){if(o.charCodeAt(s+u)===p)return t.slice(s+u+1);if(u===2)return t.slice(s+u)}c>f&&(m.charCodeAt(n+u)===p?E=u:u===2&&(E=3)),E===-1&&(E=0)}let O="";for(u=n+E+1;u<=r;++u)(u===r||m.charCodeAt(u)===p)&&(O+=O.length===0?"..":"\\..");return s+=E,O.length>0?`${O}${t.slice(s,l)}`:(t.charCodeAt(s)===p&&++s,t.slice(s,l))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const o=e.win32.resolve(m);if(o.length<=2)return m;if(o.charCodeAt(0)===p){if(o.charCodeAt(1)===p){const i=o.charCodeAt(2);if(i!==d&&i!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(S(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===p)return`\\\\?\\${o}`;return m},dirname(m){I(m,"path");const o=m.length;if(o===0)return".";let i=-1,t=0;const n=m.charCodeAt(0);if(o===1)return a(n)?m:".";if(a(n)){if(i=t=1,a(m.charCodeAt(1))){let s=2,l=s;for(;s<o&&!a(m.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&a(m.charCodeAt(s));)s++;if(s<o&&s!==l){for(l=s;s<o&&!a(m.charCodeAt(s));)s++;if(s===o)return m;s!==l&&(i=t=s+1)}}}}else S(n)&&m.charCodeAt(1)===C&&(i=o>2&&a(m.charCodeAt(2))?3:2,t=i);let r=-1,c=!0;for(let s=o-1;s>=t;--s)if(a(m.charCodeAt(s))){if(!c){r=s;break}}else c=!1;if(r===-1){if(i===-1)return".";r=i}return m.slice(0,r)},basename(m,o){o!==void 0&&I(o,"ext"),I(m,"path");let i=0,t=-1,n=!0,r;if(m.length>=2&&S(m.charCodeAt(0))&&m.charCodeAt(1)===C&&(i=2),o!==void 0&&o.length>0&&o.length<=m.length){if(o===m)return"";let c=o.length-1,s=-1;for(r=m.length-1;r>=i;--r){const l=m.charCodeAt(r);if(a(l)){if(!n){i=r+1;break}}else s===-1&&(n=!1,s=r+1),c>=0&&(l===o.charCodeAt(c)?--c==-1&&(t=r):(c=-1,t=s))}return i===t?t=s:t===-1&&(t=m.length),m.slice(i,t)}for(r=m.length-1;r>=i;--r)if(a(m.charCodeAt(r))){if(!n){i=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":m.slice(i,t)},extname(m){I(m,"path");let o=0,i=-1,t=0,n=-1,r=!0,c=0;m.length>=2&&m.charCodeAt(1)===C&&S(m.charCodeAt(0))&&(o=t=2);for(let s=m.length-1;s>=o;--s){const l=m.charCodeAt(s);if(a(l)){if(!r){t=s+1;break}continue}n===-1&&(r=!1,n=s+1),l===P?i===-1?i=s:c!==1&&(c=1):i!==-1&&(c=-1)}return i===-1||n===-1||c===0||c===1&&i===n-1&&i===t+1?"":m.slice(i,n)},format:y.bind(null,"\\"),parse(m){I(m,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return o;const i=m.length;let t=0,n=m.charCodeAt(0);if(i===1)return a(n)?(o.root=o.dir=m,o):(o.base=o.name=m,o);if(a(n)){if(t=1,a(m.charCodeAt(1))){let E=2,u=E;for(;E<i&&!a(m.charCodeAt(E));)E++;if(E<i&&E!==u){for(u=E;E<i&&a(m.charCodeAt(E));)E++;if(E<i&&E!==u){for(u=E;E<i&&!a(m.charCodeAt(E));)E++;E===i?t=E:E!==u&&(t=E+1)}}}}else if(S(n)&&m.charCodeAt(1)===C){if(i<=2)return o.root=o.dir=m,o;if(t=2,a(m.charCodeAt(2))){if(i===3)return o.root=o.dir=m,o;t=3}}t>0&&(o.root=m.slice(0,t));let r=-1,c=t,s=-1,l=!0,h=m.length-1,f=0;for(;h>=t;--h){if(n=m.charCodeAt(h),a(n)){if(!l){c=h+1;break}continue}s===-1&&(l=!1,s=h+1),n===P?r===-1?r=h:f!==1&&(f=1):r!==-1&&(f=-1)}return s!==-1&&(r===-1||f===0||f===1&&r===s-1&&r===c+1?o.base=o.name=m.slice(c,s):(o.name=m.slice(c,r),o.base=m.slice(c,s),o.ext=m.slice(r,s))),c>0&&c!==t?o.dir=m.slice(0,c-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let o="",i=!1;for(let t=m.length-1;t>=-1&&!i;t--){const n=t>=0?m[t]:v.cwd();I(n,"path"),n.length!==0&&(o=`${n}/${o}`,i=n.charCodeAt(0)===g)}return o=w(o,!i,"/",D),i?`/${o}`:o.length>0?o:"."},normalize(m){if(I(m,"path"),m.length===0)return".";const o=m.charCodeAt(0)===g,i=m.charCodeAt(m.length-1)===g;return m=w(m,!o,"/",D),m.length===0?o?"/":i?"./":".":(i&&(m+="/"),o?`/${m}`:m)},isAbsolute(m){return I(m,"path"),m.length>0&&m.charCodeAt(0)===g},join(...m){if(m.length===0)return".";let o;for(let i=0;i<m.length;++i){const t=m[i];I(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(m,o){if(I(m,"from"),I(o,"to"),m===o||(m=e.posix.resolve(m),o=e.posix.resolve(o),m===o))return"";const i=1,t=m.length,n=t-i,r=1,c=o.length-r,s=n<c?n:c;let l=-1,h=0;for(;h<s;h++){const E=m.charCodeAt(i+h);if(E!==o.charCodeAt(r+h))break;E===g&&(l=h)}if(h===s)if(c>s){if(o.charCodeAt(r+h)===g)return o.slice(r+h+1);if(h===0)return o.slice(r+h)}else n>s&&(m.charCodeAt(i+h)===g?l=h:h===0&&(l=0));let f="";for(h=i+l+1;h<=t;++h)(h===t||m.charCodeAt(h)===g)&&(f+=f.length===0?"..":"/..");return`${f}${o.slice(r+l)}`},toNamespacedPath(m){return m},dirname(m){if(I(m,"path"),m.length===0)return".";const o=m.charCodeAt(0)===g;let i=-1,t=!0;for(let n=m.length-1;n>=1;--n)if(m.charCodeAt(n)===g){if(!t){i=n;break}}else t=!1;return i===-1?o?"/":".":o&&i===1?"//":m.slice(0,i)},basename(m,o){o!==void 0&&I(o,"ext"),I(m,"path");let i=0,t=-1,n=!0,r;if(o!==void 0&&o.length>0&&o.length<=m.length){if(o===m)return"";let c=o.length-1,s=-1;for(r=m.length-1;r>=0;--r){const l=m.charCodeAt(r);if(l===g){if(!n){i=r+1;break}}else s===-1&&(n=!1,s=r+1),c>=0&&(l===o.charCodeAt(c)?--c==-1&&(t=r):(c=-1,t=s))}return i===t?t=s:t===-1&&(t=m.length),m.slice(i,t)}for(r=m.length-1;r>=0;--r)if(m.charCodeAt(r)===g){if(!n){i=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":m.slice(i,t)},extname(m){I(m,"path");let o=-1,i=0,t=-1,n=!0,r=0;for(let c=m.length-1;c>=0;--c){const s=m.charCodeAt(c);if(s===g){if(!n){i=c+1;break}continue}t===-1&&(n=!1,t=c+1),s===P?o===-1?o=c:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||t===-1||r===0||r===1&&o===t-1&&o===i+1?"":m.slice(o,t)},format:y.bind(null,"/"),parse(m){I(m,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return o;const i=m.charCodeAt(0)===g;let t;i?(o.root="/",t=1):t=0;let n=-1,r=0,c=-1,s=!0,l=m.length-1,h=0;for(;l>=t;--l){const f=m.charCodeAt(l);if(f===g){if(!s){r=l+1;break}continue}c===-1&&(s=!1,c=l+1),f===P?n===-1?n=l:h!==1&&(h=1):n!==-1&&(h=-1)}if(c!==-1){const f=r===0&&i?1:r;n===-1||h===0||h===1&&n===c-1&&n===r+1?o.base=o.name=m.slice(f,c):(o.name=m.slice(f,n),o.base=m.slice(f,c),o.ext=m.slice(n,c))}return r>0?o.dir=m.slice(0,r-1):i&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var T in v)(typeof exports=="object"?exports:G)[T]=v[T]}}(typeof self!="undefined"?self:this,function(){return function(G){var e={};function v(T){if(e[T])return e[T].exports;var k=e[T]={i:T,l:!1,exports:{}};return G[T].call(k.exports,k,k.exports,v),k.l=!0,k.exports}return v.m=G,v.c=e,v.d=function(T,k,R){v.o(T,k)||Object.defineProperty(T,k,{enumerable:!0,get:R})},v.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},v.t=function(T,k){if(1&k&&(T=v(T)),8&k||4&k&&typeof T=="object"&&T&&T.__esModule)return T;var R=Object.create(null);if(v.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:T}),2&k&&typeof T!="string")for(var L in T)v.d(R,L,function(P){return T[P]}.bind(null,L));return R},v.n=function(T){var k=T&&T.__esModule?function(){return T.default}:function(){return T};return v.d(k,"a",k),k},v.o=function(T,k){return Object.prototype.hasOwnProperty.call(T,k)},v.p="",v(v.s=0)}([function(G,e,v){(function(T){var k;e=G.exports=X,k=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],g=e.src=[],p=0,C=p++;g[C]="0|[1-9]\\d*";var d=p++;g[d]="[0-9]+";var b=p++;g[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=p++;g[I]="("+g[C]+")\\.("+g[C]+")\\.("+g[C]+")";var a=p++;g[a]="("+g[d]+")\\.("+g[d]+")\\.("+g[d]+")";var D=p++;g[D]="(?:"+g[C]+"|"+g[b]+")";var S=p++;g[S]="(?:"+g[d]+"|"+g[b]+")";var w=p++;g[w]="(?:-("+g[D]+"(?:\\."+g[D]+")*))";var y=p++;g[y]="(?:-?("+g[S]+"(?:\\."+g[S]+")*))";var m=p++;g[m]="[0-9A-Za-z-]+";var o=p++;g[o]="(?:\\+("+g[m]+"(?:\\."+g[m]+")*))";var i=p++,t="v?"+g[I]+g[w]+"?"+g[o]+"?";g[i]="^"+t+"$";var n="[v=\\s]*"+g[a]+g[y]+"?"+g[o]+"?",r=p++;g[r]="^"+n+"$";var c=p++;g[c]="((?:<|>)?=?)";var s=p++;g[s]=g[d]+"|x|X|\\*";var l=p++;g[l]=g[C]+"|x|X|\\*";var h=p++;g[h]="[v=\\s]*("+g[l]+")(?:\\.("+g[l]+")(?:\\.("+g[l]+")(?:"+g[w]+")?"+g[o]+"?)?)?";var f=p++;g[f]="[v=\\s]*("+g[s]+")(?:\\.("+g[s]+")(?:\\.("+g[s]+")(?:"+g[y]+")?"+g[o]+"?)?)?";var E=p++;g[E]="^"+g[c]+"\\s*"+g[h]+"$";var u=p++;g[u]="^"+g[c]+"\\s*"+g[f]+"$";var O=p++;g[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=p++;g[_]="(?:~>?)";var q=p++;g[q]="(\\s*)"+g[_]+"\\s+",P[q]=new RegExp(g[q],"g");var x=p++;g[x]="^"+g[_]+g[h]+"$";var j=p++;g[j]="^"+g[_]+g[f]+"$";var $=p++;g[$]="(?:\\^)";var W=p++;g[W]="(\\s*)"+g[$]+"\\s+",P[W]=new RegExp(g[W],"g");var B=p++;g[B]="^"+g[$]+g[h]+"$";var M=p++;g[M]="^"+g[$]+g[f]+"$";var F=p++;g[F]="^"+g[c]+"\\s*("+n+")$|^$";var A=p++;g[A]="^"+g[c]+"\\s*("+t+")$|^$";var U=p++;g[U]="(\\s*)"+g[c]+"\\s*("+n+"|"+g[h]+")",P[U]=new RegExp(g[U],"g");var N=p++;g[N]="^\\s*("+g[h]+")\\s+-\\s+("+g[h]+")\\s*$";var z=p++;g[z]="^\\s*("+g[f]+")\\s+-\\s+("+g[f]+")\\s*$";var H=p++;g[H]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)k(K,g[K]),P[K]||(P[K]=new RegExp(g[K]));function te(J,ne){if(J instanceof X)return J;if(typeof J!="string"||J.length>R||!(ne?P[r]:P[i]).test(J))return null;try{return new X(J,ne)}catch(re){return null}}function X(J,ne){if(J instanceof X){if(J.loose===ne)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof X))return new X(J,ne);k("SemVer",J,ne),this.loose=ne;var re=J.trim().match(ne?P[r]:P[i]);if(!re)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+re[1],this.minor=+re[2],this.patch=+re[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");re[4]?this.prerelease=re[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var V=+ge;if(V>=0&&V<L)return V}return ge}):this.prerelease=[],this.build=re[5]?re[5].split("."):[],this.format()}e.parse=te,e.valid=function(J,ne){var re=te(J,ne);return re?re.version:null},e.clean=function(J,ne){var re=te(J.trim().replace(/^[=v]+/,""),ne);return re?re.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(J){return k("SemVer.compare",this.version,this.loose,J),J instanceof X||(J=new X(J,this.loose)),this.compareMain(J)||this.comparePre(J)},X.prototype.compareMain=function(J){return J instanceof X||(J=new X(J,this.loose)),se(this.major,J.major)||se(this.minor,J.minor)||se(this.patch,J.patch)},X.prototype.comparePre=function(J){if(J instanceof X||(J=new X(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var ne=0;do{var re=this.prerelease[ne],ge=J.prerelease[ne];if(k("prerelease compare",ne,re,ge),re===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(re===void 0)return-1;if(re!==ge)return se(re,ge)}while(++ne)},X.prototype.inc=function(J,ne){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ne);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ne);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ne),this.inc("pre",ne);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ne),this.inc("pre",ne);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var re=this.prerelease.length;--re>=0;)typeof this.prerelease[re]=="number"&&(this.prerelease[re]++,re=-2);re===-1&&this.prerelease.push(0)}ne&&(this.prerelease[0]===ne?isNaN(this.prerelease[1])&&(this.prerelease=[ne,0]):this.prerelease=[ne,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,ne,re,ge){typeof re=="string"&&(ge=re,re=void 0);try{return new X(J,re).inc(ne,ge).version}catch(V){return null}},e.diff=function(J,ne){if(we(J,ne))return null;var re=te(J),ge=te(ne);if(re.prerelease.length||ge.prerelease.length){for(var V in re)if((V==="major"||V==="minor"||V==="patch")&&re[V]!==ge[V])return"pre"+V;return"prerelease"}for(var V in re)if((V==="major"||V==="minor"||V==="patch")&&re[V]!==ge[V])return V},e.compareIdentifiers=se;var ie=/^[0-9]+$/;function se(J,ne){var re=ie.test(J),ge=ie.test(ne);return re&&ge&&(J=+J,ne=+ne),re&&!ge?-1:ge&&!re?1:J<ne?-1:J>ne?1:0}function ce(J,ne,re){return new X(J,re).compare(new X(ne,re))}function he(J,ne,re){return ce(J,ne,re)>0}function me(J,ne,re){return ce(J,ne,re)<0}function we(J,ne,re){return ce(J,ne,re)===0}function Ie(J,ne,re){return ce(J,ne,re)!==0}function Ae(J,ne,re){return ce(J,ne,re)>=0}function ke(J,ne,re){return ce(J,ne,re)<=0}function Fe(J,ne,re,ge){var V;switch(ne){case"===":typeof J=="object"&&(J=J.version),typeof re=="object"&&(re=re.version),V=J===re;break;case"!==":typeof J=="object"&&(J=J.version),typeof re=="object"&&(re=re.version),V=J!==re;break;case"":case"=":case"==":V=we(J,re,ge);break;case"!=":V=Ie(J,re,ge);break;case">":V=he(J,re,ge);break;case">=":V=Ae(J,re,ge);break;case"<":V=me(J,re,ge);break;case"<=":V=ke(J,re,ge);break;default:throw new TypeError("Invalid operator: "+ne)}return V}function Ue(J,ne){if(J instanceof Ue){if(J.loose===ne)return J;J=J.value}if(!(this instanceof Ue))return new Ue(J,ne);k("comparator",J,ne),this.loose=ne,this.parse(J),this.semver===Me?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(J,ne){return se(ne,J)},e.major=function(J,ne){return new X(J,ne).major},e.minor=function(J,ne){return new X(J,ne).minor},e.patch=function(J,ne){return new X(J,ne).patch},e.compare=ce,e.compareLoose=function(J,ne){return ce(J,ne,!0)},e.rcompare=function(J,ne,re){return ce(ne,J,re)},e.sort=function(J,ne){return J.sort(function(re,ge){return e.compare(re,ge,ne)})},e.rsort=function(J,ne){return J.sort(function(re,ge){return e.rcompare(re,ge,ne)})},e.gt=he,e.lt=me,e.eq=we,e.neq=Ie,e.gte=Ae,e.lte=ke,e.cmp=Fe,e.Comparator=Ue;var Me={};function De(J,ne){if(J instanceof De)return J.loose===ne?J:new De(J.raw,ne);if(J instanceof Ue)return new De(J.value,ne);if(!(this instanceof De))return new De(J,ne);if(this.loose=ne,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(re){return this.parseRange(re.trim())},this).filter(function(re){return re.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Te(J){return!J||J.toLowerCase()==="x"||J==="*"}function $e(J,ne,re,ge,V,ee,oe,ae,le,de,ve,ye,Ee){return((ne=Te(re)?"":Te(ge)?">="+re+".0.0":Te(V)?">="+re+"."+ge+".0":">="+ne)+" "+(ae=Te(le)?"":Te(de)?"<"+(+le+1)+".0.0":Te(ve)?"<"+le+"."+(+de+1)+".0":ye?"<="+le+"."+de+"."+ve+"-"+ye:"<="+ae)).trim()}function He(J,ne){for(var re=0;re<J.length;re++)if(!J[re].test(ne))return!1;if(ne.prerelease.length){for(re=0;re<J.length;re++)if(k(J[re].semver),J[re].semver!==Me&&J[re].semver.prerelease.length>0){var ge=J[re].semver;if(ge.major===ne.major&&ge.minor===ne.minor&&ge.patch===ne.patch)return!0}return!1}return!0}function Ne(J,ne,re){try{ne=new De(ne,re)}catch(ge){return!1}return ne.test(J)}function ze(J,ne,re,ge){var V,ee,oe,ae,le;switch(J=new X(J,ge),ne=new De(ne,ge),re){case">":V=he,ee=ke,oe=me,ae=">",le=">=";break;case"<":V=me,ee=Ae,oe=he,ae="<",le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(J,ne,ge))return!1;for(var de=0;de<ne.set.length;++de){var ve=ne.set[de],ye=null,Ee=null;if(ve.forEach(function(be){be.semver===Me&&(be=new Ue(">=0.0.0")),ye=ye||be,Ee=Ee||be,V(be.semver,ye.semver,ge)?ye=be:oe(be.semver,Ee.semver,ge)&&(Ee=be)}),ye.operator===ae||ye.operator===le||(!Ee.operator||Ee.operator===ae)&&ee(J,Ee.semver)||Ee.operator===le&&oe(J,Ee.semver))return!1}return!0}Ue.prototype.parse=function(J){var ne=this.loose?P[F]:P[A],re=J.match(ne);if(!re)throw new TypeError("Invalid comparator: "+J);this.operator=re[1],this.operator==="="&&(this.operator=""),re[2]?this.semver=new X(re[2],this.loose):this.semver=Me},Ue.prototype.toString=function(){return this.value},Ue.prototype.test=function(J){return k("Comparator.test",J,this.loose),this.semver===Me||(typeof J=="string"&&(J=new X(J,this.loose)),Fe(J,this.operator,this.semver,this.loose))},Ue.prototype.intersects=function(J,ne){if(!(J instanceof Ue))throw new TypeError("a Comparator is required");var re;if(this.operator==="")return re=new De(J.value,ne),Ne(this.value,re,ne);if(J.operator==="")return re=new De(this.value,ne),Ne(J.semver,re,ne);var ge=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),V=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),ee=this.semver.version===J.semver.version,oe=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),ae=Fe(this.semver,"<",J.semver,ne)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),le=Fe(this.semver,">",J.semver,ne)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return ge||V||ee&&oe||ae||le},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(J){var ne=this.loose;J=J.trim(),k("range",J,ne);var re=ne?P[z]:P[N];J=J.replace(re,$e),k("hyphen replace",J),J=J.replace(P[U],"$1$2$3"),k("comparator trim",J,P[U]),J=(J=(J=J.replace(P[q],"$1~")).replace(P[W],"$1^")).split(/\s+/).join(" ");var ge=ne?P[F]:P[A],V=J.split(" ").map(function(ee){return function(oe,ae){return k("comp",oe),oe=function(le,de){return le.trim().split(/\s+/).map(function(ve){return function(ye,Ee){k("caret",ye,Ee);var be=Ee?P[M]:P[B];return ye.replace(be,function(Pe,Se,pe,Ce,Re){var Oe;return k("caret",ye,Pe,Se,pe,Ce,Re),Te(Se)?Oe="":Te(pe)?Oe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Te(Ce)?Oe=Se==="0"?">="+Se+"."+pe+".0 <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+".0 <"+(+Se+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Oe=Se==="0"?pe==="0"?">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+pe+"."+(+Ce+1):">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+"."+Ce+Re+" <"+(+Se+1)+".0.0"):(k("no pr"),Oe=Se==="0"?pe==="0"?">="+Se+"."+pe+"."+Ce+" <"+Se+"."+pe+"."+(+Ce+1):">="+Se+"."+pe+"."+Ce+" <"+Se+"."+(+pe+1)+".0":">="+Se+"."+pe+"."+Ce+" <"+(+Se+1)+".0.0"),k("caret return",Oe),Oe})}(ve,de)}).join(" ")}(oe,ae),k("caret",oe),oe=function(le,de){return le.trim().split(/\s+/).map(function(ve){return function(ye,Ee){var be=Ee?P[j]:P[x];return ye.replace(be,function(Pe,Se,pe,Ce,Re){var Oe;return k("tilde",ye,Pe,Se,pe,Ce,Re),Te(Se)?Oe="":Te(pe)?Oe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Te(Ce)?Oe=">="+Se+"."+pe+".0 <"+Se+"."+(+pe+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Oe=">="+Se+"."+pe+"."+Ce+Re+" <"+Se+"."+(+pe+1)+".0"):Oe=">="+Se+"."+pe+"."+Ce+" <"+Se+"."+(+pe+1)+".0",k("tilde return",Oe),Oe})}(ve,de)}).join(" ")}(oe,ae),k("tildes",oe),oe=function(le,de){return k("replaceXRanges",le,de),le.split(/\s+/).map(function(ve){return function(ye,Ee){ye=ye.trim();var be=Ee?P[u]:P[E];return ye.replace(be,function(Pe,Se,pe,Ce,Re,Oe){k("xRange",ye,Pe,Se,pe,Ce,Re,Oe);var fe=Te(pe),Le=fe||Te(Ce),_e=Le||Te(Re);return Se==="="&&_e&&(Se=""),fe?Pe=Se===">"||Se==="<"?"<0.0.0":"*":Se&&_e?(Le&&(Ce=0),_e&&(Re=0),Se===">"?(Se=">=",Le?(pe=+pe+1,Ce=0,Re=0):_e&&(Ce=+Ce+1,Re=0)):Se==="<="&&(Se="<",Le?pe=+pe+1:Ce=+Ce+1),Pe=Se+pe+"."+Ce+"."+Re):Le?Pe=">="+pe+".0.0 <"+(+pe+1)+".0.0":_e&&(Pe=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0"),k("xRange return",Pe),Pe})}(ve,de)}).join(" ")}(oe,ae),k("xrange",oe),oe=function(le,de){return k("replaceStars",le,de),le.trim().replace(P[H],"")}(oe,ae),k("stars",oe),oe}(ee,ne)}).join(" ").split(/\s+/);return this.loose&&(V=V.filter(function(ee){return!!ee.match(ge)})),V=V.map(function(ee){return new Ue(ee,ne)})},De.prototype.intersects=function(J,ne){if(!(J instanceof De))throw new TypeError("a Range is required");return this.set.some(function(re){return re.every(function(ge){return J.set.some(function(V){return V.every(function(ee){return ge.intersects(ee,ne)})})})})},e.toComparators=function(J,ne){return new De(J,ne).set.map(function(re){return re.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},De.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new X(J,this.loose));for(var ne=0;ne<this.set.length;ne++)if(He(this.set[ne],J))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(J,ne,re){var ge=null,V=null;try{var ee=new De(ne,re)}catch(oe){return null}return J.forEach(function(oe){ee.test(oe)&&(ge&&V.compare(oe)!==-1||(V=new X(ge=oe,re)))}),ge},e.minSatisfying=function(J,ne,re){var ge=null,V=null;try{var ee=new De(ne,re)}catch(oe){return null}return J.forEach(function(oe){ee.test(oe)&&(ge&&V.compare(oe)!==1||(V=new X(ge=oe,re)))}),ge},e.validRange=function(J,ne){try{return new De(J,ne).range||"*"}catch(re){return null}},e.ltr=function(J,ne,re){return ze(J,ne,"<",re)},e.gtr=function(J,ne,re){return ze(J,ne,">",re)},e.outside=ze,e.prerelease=function(J,ne){var re=te(J,ne);return re&&re.prerelease.length?re.prerelease:null},e.intersects=function(J,ne,re){return J=new De(J,re),ne=new De(ne,re),J.intersects(ne)},e.coerce=function(J){if(J instanceof X)return J;if(typeof J!="string")return null;var ne=J.match(P[O]);return ne==null?null:te((ne[1]||"0")+"."+(ne[2]||"0")+"."+(ne[3]||"0"))}}).call(this,v(1))},function(G,e){var v,T,k=G.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(S){if(v===setTimeout)return setTimeout(S,0);if((v===R||!v)&&setTimeout)return v=setTimeout,setTimeout(S,0);try{return v(S,0)}catch(w){try{return v.call(null,S,0)}catch(y){return v.call(this,S,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:R}catch(S){v=R}try{T=typeof clearTimeout=="function"?clearTimeout:L}catch(S){T=L}})();var g,p=[],C=!1,d=-1;function b(){C&&g&&(C=!1,g.length?p=g.concat(p):d=-1,p.length&&I())}function I(){if(!C){var S=P(b);C=!0;for(var w=p.length;w;){for(g=p,p=[];++d<w;)g&&g[d].run();d=-1,w=p.length}g=null,C=!1,function(y){if(T===clearTimeout)return clearTimeout(y);if((T===L||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(y);try{T(y)}catch(m){try{return T.call(null,y)}catch(o){return T.call(this,y)}}}(S)}}function a(S,w){this.fun=S,this.array=w}function D(){}k.nextTick=function(S){var w=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)w[y-1]=arguments[y];p.push(new a(S,w)),p.length!==1||C||P(I)},a.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=D,k.addListener=D,k.once=D,k.off=D,k.removeListener=D,k.removeAllListeners=D,k.emit=D,k.prependListener=D,k.prependOnceListener=D,k.listeners=function(S){return[]},k.binding=function(S){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(S){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Q[87],Z([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(L){this._highResolution=T&&L,this._startTime=this._now(),this._stopTime=-1}static create(L=!0){return new k(L)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Q[3],Z([0,1,15,63,2,64,87]),function(G,e,v,T,k,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(w){w.None=()=>k.Disposable.None;function y(j){return($,W=null,B)=>{let M=!1,F;return F=j(A=>{if(!M)return F?F.dispose():M=!0,$.call(W,A)},null,B),M&&F.dispose(),F}}w.once=y;function m(j,$){return c((W,B=null,M)=>j(F=>W.call(B,$(F)),null,M))}w.map=m;function o(j,$){return c((W,B=null,M)=>j(F=>{$(F),W.call(B,F)},null,M))}w.forEach=o;function i(j,$){return c((W,B=null,M)=>j(F=>$(F)&&W.call(B,F),null,M))}w.filter=i;function t(j){return j}w.signal=t;function n(...j){return($,W=null,B)=>(0,k.combinedDisposable)(...j.map(M=>M(F=>$.call(W,F),null,B)))}w.any=n;function r(j,$,W){let B=W;return m(j,M=>(B=$(B,M),B))}w.reduce=r;function c(j){let $;const W=new b({onFirstListenerAdd(){$=j(W.fire,W)},onLastListenerRemove(){$.dispose()}});return W.event}w.snapshot=c;function s(j,$,W=100,B=!1,M){let F,A,U,N=0;const z=new b({leakWarningThreshold:M,onFirstListenerAdd(){F=j(H=>{N++,A=$(A,H),B&&!U&&(z.fire(A),A=void 0),clearTimeout(U),U=setTimeout(()=>{const K=A;A=void 0,U=void 0,(!B||N>1)&&z.fire(K),N=0},W)})},onLastListenerRemove(){F.dispose()}});return z.event}w.debounce=s;function l(j){const $=new Date().getTime();return m(y(j),W=>new Date().getTime()-$)}w.stopwatch=l;function h(j){let $=!0,W;return i(j,B=>{const M=$||B!==W;return $=!1,W=B,M})}w.latch=h;function f(j,$=!1,W=[]){let B=W.slice(),M=j(U=>{B?B.push(U):A.fire(U)});const F=()=>{B&&B.forEach(U=>A.fire(U)),B=null},A=new b({onFirstListenerAdd(){M||(M=j(U=>A.fire(U)))},onFirstListenerDidAdd(){B&&($?setTimeout(F):F())},onLastListenerRemove(){M&&M.dispose(),M=null}});return A.event}w.buffer=f;class E{constructor($){this.event=$}map($){return new E(m(this.event,$))}forEach($){return new E(o(this.event,$))}filter($){return new E(i(this.event,$))}reduce($,W){return new E(r(this.event,$,W))}latch(){return new E(h(this.event))}debounce($,W=100,B=!1,M){return new E(s(this.event,$,W,B,M))}on($,W,B){return this.event($,W,B)}once($,W,B){return y(this.event)($,W,B)}}function u(j){return new E(j)}w.chain=u;function O(j,$,W=B=>B){const B=(...U)=>A.fire(W(...U)),M=()=>j.on($,B),F=()=>j.removeListener($,B),A=new b({onFirstListenerAdd:M,onLastListenerRemove:F});return A.event}w.fromNodeEventEmitter=O;function _(j,$,W=B=>B){const B=(...U)=>A.fire(W(...U)),M=()=>j.addEventListener($,B),F=()=>j.removeEventListener($,B),A=new b({onFirstListenerAdd:M,onLastListenerRemove:F});return A.event}w.fromDOMEventEmitter=_;function q(j){const $=new b;let W=!1;return j.then(void 0,()=>null).then(()=>{W?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),W=!0,$.event}w.fromPromise=q;function x(j){return new Promise($=>y(j)($))}w.toPromise=x})(P=e.Event||(e.Event={}));class g{constructor(y){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${y}_${g._idPool++}`}start(y){this._stopWatch=new L.StopWatch(!0),this._listenerCount=y}stop(){if(this._stopWatch){const y=this._stopWatch.elapsed();this._elapsedOverall+=y,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${y.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}g._idPool=0;let p=-1;function C(w){const y=p;return p=w,{dispose(){p=y}}}e.setGlobalLeakWarningThreshold=C;class d{constructor(y,m=Math.random().toString(18).slice(2,5)){this.customThreshold=y,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(y){let m=p;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),!(m<=0||y<m)){this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(o)||0;if(this._stacks.set(o,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let t,n=0;for(const[r,c]of this._stacks)(!t||n<c)&&(t=r,n=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}}class b{constructor(y){var m;this._disposed=!1,this._options=y,this._leakageMon=p>0?new d(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((m=this._options)===null||m===void 0?void 0:m._profName)?new g(this._options._profName):void 0}get event(){return this._event||(this._event=(y,m,o)=>{var i;this._listeners||(this._listeners=new R.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(m?[y,m]:y);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,y,m);const r=(i=this._leakageMon)===null||i===void 0?void 0:i.check(this._listeners.size);let c;return c={dispose:()=>{r&&r(),c.dispose=b._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof k.DisposableStore?o.add(c):Array.isArray(o)&&o.push(c),c}),this._event}fire(y){var m,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new R.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,y]);for((m=this._perfMon)===null||m===void 0||m.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,t]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,t):i[0].call(i[1],t)}catch(n){(0,v.onUnexpectedError)(n)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var y,m,o;(y=this._listeners)===null||y===void 0||y.clear(),(m=this._deliveryQueue)===null||m===void 0||m.clear(),(o=this._leakageMon)===null||o===void 0||o.dispose(),this._disposed=!0}}e.Emitter=b,b._noop=function(){};class I extends b{constructor(y){super(y);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=y==null?void 0:y.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const y=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(y))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(y){this._listeners&&(this._isPaused!==0?this._eventQueue.push(y):super.fire(y))}}e.PauseableEmitter=I;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(y){const m={event:y,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const o=()=>{this.hasListeners&&this.unhook(m);const i=this.events.indexOf(m);this.events.splice(i,1)};return(0,k.toDisposable)((0,T.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(y=>this.hook(y))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(y=>this.unhook(y))}hook(y){y.listener=y.event(m=>this.emitter.fire(m))}unhook(y){y.listener&&y.listener.dispose(),y.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class D{constructor(){this.buffers=[]}wrapEvent(y){return(m,o,i)=>y(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>m.call(o,t)):m.call(o,t)},void 0,i)}bufferEvents(y){const m=[];this.buffers.push(m);const o=y();return this.buffers.pop(),m.forEach(i=>i()),o}}e.EventBufferer=D;class S{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(y){this.inputEvent=y,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=y(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(Q[29],Z([0,1,3]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(P,g){const p=setTimeout(P.bind(g),0);return{dispose(){clearTimeout(p)}}});var k;(function(P){function g(p){return p===P.None||p===P.Cancelled||p instanceof R?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}P.isCancellationToken=g,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=L}),define(Q[47],Z([0,1,15,2]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(S){const w=S;return w&&[w.on,w.pause,w.resume,w.destroy].every(y=>typeof y=="function")}e.isReadableStream=k;function R(S){const w=S;return w&&k(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean"}e.isReadableBufferedStream=R;function L(S,w){return new P(S,w)}e.newWriteableStream=L;class P{constructor(w,y){this.reducer=w,this.options=y,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){var y;if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof((y=this.options)===null||y===void 0?void 0:y.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w!="undefined"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(y=>y(w))}emitError(w){this.listeners.error.length===0?(0,v.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(y=>y(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,y){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(y),this.resume();break;case"end":this.listeners.end.push(y),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(y),this.state.flowing&&this.flowErrors();break}}removeListener(w,y){if(!this.state.destroyed){let m;switch(w){case"data":m=this.listeners.data;break;case"end":m=this.listeners.end;break;case"error":m=this.listeners.error;break}if(m){const o=m.indexOf(y);o>=0&&m.splice(o,1)}}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const y=[...this.pendingWritePromises];this.pendingWritePromises.length=0,y.forEach(m=>m())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(S,w){const y=[];let m;for(;(m=S.read())!==null;)y.push(m);return w(y)}e.consumeReadable=g;function p(S,w,y){const m=[];let o;for(;(o=S.read())!==null&&m.length<y;)m.push(o);return o===null&&m.length>0?w(m):{read:()=>{if(m.length>0)return m.shift();if(typeof o!="undefined"){const i=o;return o=void 0,i}return S.read()}}}e.peekReadable=p;function C(S,w){return new Promise((y,m)=>{const o=[];d(S,{onData:i=>{w&&o.push(i)},onError:i=>{w?m(i):y(void 0)},onEnd:()=>{y(w?w(o):void 0)}})})}e.consumeStream=C;function d(S,w){S.on("error",y=>w.onError(y)),S.on("end",()=>w.onEnd()),S.on("data",y=>w.onData(y))}e.listenStream=d;function b(S,w){return new Promise((y,m)=>{const o=new T.DisposableStore,i=[],t=c=>{if(i.push(c),i.length>w)return o.dispose(),S.pause(),y({stream:S,buffer:i,ended:!1})},n=c=>m(c),r=()=>y({stream:S,buffer:i,ended:!0});o.add((0,T.toDisposable)(()=>S.removeListener("error",n))),S.on("error",n),o.add((0,T.toDisposable)(()=>S.removeListener("end",r))),S.on("end",r),o.add((0,T.toDisposable)(()=>S.removeListener("data",t))),S.on("data",t)})}e.peekStream=b;function I(S,w){const y=L(w);return y.end(S),y}e.toStream=I;function a(S){let w=!1;return{read:()=>w?null:(w=!0,S)}}e.toReadable=a;function D(S,w,y){const m=L(y);return d(S,{onData:o=>m.write(w.data(o)),onError:o=>m.error(w.error?w.error(o):o),onEnd:()=>m.end()}),m}e.transform=D}),define(Q[21],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=v;const T=/{(\d+)}/g;function k(V,...ee){return ee.length===0?V:V.replace(T,function(oe,ae){const le=parseInt(ae,10);return isNaN(le)||le<0||le>=ee.length?oe:ee[le]})}e.format=k;function R(V){return V.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=R;function L(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=L;function P(V,ee){let oe=0;const ae=ee.charCodeAt(0);for(let le=V.length-1;le>=0;le--)V.charCodeAt(le)===ae&&oe++;return oe}e.count=P;function g(V,ee,oe="\u2026"){return V.length<=ee?V:`${V.substr(0,ee)}${oe}`}e.truncate=g;function p(V,ee=" "){const oe=C(V,ee);return d(oe,ee)}e.trim=p;function C(V,ee){if(!V||!ee)return V;const oe=ee.length;if(oe===0||V.length===0)return V;let ae=0;for(;V.indexOf(ee,ae)===ae;)ae=ae+oe;return V.substring(ae)}e.ltrim=C;function d(V,ee){if(!V||!ee)return V;const oe=ee.length,ae=V.length;if(oe===0||ae===0)return V;let le=ae,de=-1;for(;de=V.lastIndexOf(ee,le-1),!(de===-1||de+oe!==le);){if(de===0)return"";le=de}return V.substring(0,le)}e.rtrim=d;function b(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function I(V){return V.replace(/\*/g,"")}e.stripWildcards=I;function a(V,ee,oe={}){if(!V)throw new Error("Cannot create regex from empty string");ee||(V=L(V)),oe.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let ae="";return oe.global&&(ae+="g"),oe.matchCase||(ae+="i"),oe.multiline&&(ae+="m"),oe.unicode&&(ae+="u"),new RegExp(V,ae)}e.createRegExp=a;function D(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=D;function S(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function w(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=w;function y(V){return V.split(/\r\n|\r|\n/)}e.splitLines=y;function m(V){for(let ee=0,oe=V.length;ee<oe;ee++){const ae=V.charCodeAt(ee);if(ae!==32&&ae!==9)return ee}return-1}e.firstNonWhitespaceIndex=m;function o(V,ee=0,oe=V.length){for(let ae=ee;ae<oe;ae++){const le=V.charCodeAt(ae);if(le!==32&&le!==9)return V.substring(ee,ae)}return V.substring(ee,oe)}e.getLeadingWhitespace=o;function i(V,ee=V.length-1){for(let oe=ee;oe>=0;oe--){const ae=V.charCodeAt(oe);if(ae!==32&&ae!==9)return oe}return-1}e.lastNonWhitespaceIndex=i;function t(V,ee){return V<ee?-1:V>ee?1:0}e.compare=t;function n(V,ee,oe=0,ae=V.length,le=0,de=ee.length){for(;oe<ae&&le<de;oe++,le++){let Ee=V.charCodeAt(oe),be=ee.charCodeAt(le);if(Ee<be)return-1;if(Ee>be)return 1}const ve=ae-oe,ye=de-le;return ve<ye?-1:ve>ye?1:0}e.compareSubstring=n;function r(V,ee){return c(V,ee,0,V.length,0,ee.length)}e.compareIgnoreCase=r;function c(V,ee,oe=0,ae=V.length,le=0,de=ee.length){for(;oe<ae&&le<de;oe++,le++){let Ee=V.charCodeAt(oe),be=ee.charCodeAt(le);if(Ee!==be){const Pe=Ee-be;if(!(Pe===32&&l(be))&&!(Pe===-32&&l(Ee)))return s(Ee)&&s(be)?Pe:n(V.toLowerCase(),ee.toLowerCase(),oe,ae,le,de)}}const ve=ae-oe,ye=de-le;return ve<ye?-1:ve>ye?1:0}e.compareSubstringIgnoreCase=c;function s(V){return V>=97&&V<=122}e.isLowerAsciiLetter=s;function l(V){return V>=65&&V<=90}e.isUpperAsciiLetter=l;function h(V){return s(V)||l(V)}function f(V,ee){return V.length===ee.length&&E(V,ee)}e.equalsIgnoreCase=f;function E(V,ee,oe=V.length){for(let ae=0;ae<oe;ae++){const le=V.charCodeAt(ae),de=ee.charCodeAt(ae);if(le!==de){if(h(le)&&h(de)){const ve=Math.abs(le-de);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(le).toLowerCase()!==String.fromCharCode(de).toLowerCase())return!1}}return!0}function u(V,ee){const oe=ee.length;return ee.length>V.length?!1:E(V,ee,oe)}e.startsWithIgnoreCase=u;function O(V,ee){let oe,ae=Math.min(V.length,ee.length);for(oe=0;oe<ae;oe++)if(V.charCodeAt(oe)!==ee.charCodeAt(oe))return oe;return ae}e.commonPrefixLength=O;function _(V,ee){let oe,ae=Math.min(V.length,ee.length);const le=V.length-1,de=ee.length-1;for(oe=0;oe<ae;oe++)if(V.charCodeAt(le-oe)!==ee.charCodeAt(de-oe))return oe;return ae}e.commonSuffixLength=_;function q(V){return 55296<=V&&V<=56319}e.isHighSurrogate=q;function x(V){return 56320<=V&&V<=57343}e.isLowSurrogate=x;function j(V,ee){return(V-55296<<10)+(ee-56320)+65536}e.computeCodePoint=j;function $(V,ee,oe){const ae=V.charCodeAt(oe);if(q(ae)&&oe+1<ee){const le=V.charCodeAt(oe+1);if(x(le))return j(ae,le)}return ae}e.getNextCodePoint=$;function W(V,ee){const oe=V.charCodeAt(ee-1);if(x(oe)&&ee>1){const ae=V.charCodeAt(ee-2);if(q(ae))return j(ae,oe)}return oe}function B(V,ee){const oe=re.getInstance(),ae=ee,le=V.length,de=$(V,le,ee);ee+=de>=65536?2:1;let ve=oe.getGraphemeBreakType(de);for(;ee<le;){const ye=$(V,le,ee),Ee=oe.getGraphemeBreakType(ye);if(J(ve,Ee))break;ee+=ye>=65536?2:1,ve=Ee}return ee-ae}e.nextCharLength=B;function M(V,ee){const oe=re.getInstance(),ae=ee,le=W(V,ee);ee-=le>=65536?2:1;let de=oe.getGraphemeBreakType(le);for(;ee>0;){const ve=W(V,ee),ye=oe.getGraphemeBreakType(ve);if(J(ye,de))break;ee-=ve>=65536?2:1,de=ye}return ae-ee}e.prevCharLength=M;function F(V,ee){const oe=re.getInstance(),ae=V.length,le=ee,de=$(V,ae,ee),ve=oe.getGraphemeBreakType(de);ee+=de>=65536?2:1;let ye=ve;for(;ee<ae;){const be=$(V,ae,ee),Pe=oe.getGraphemeBreakType(be);if(J(ye,Pe))break;ee+=be>=65536?2:1,ye=Pe}const Ee=ee;for(ee=le,ye=ve;ee>0;){const be=W(V,ee),Pe=oe.getGraphemeBreakType(be);if(J(Pe,ye))break;ee-=be>=65536?2:1,ye=Pe}return[ee,Ee]}function A(V,ee){return ee>0&&x(V.charCodeAt(ee))?F(V,ee-1):F(V,ee)}e.getCharContainingOffset=A;function U(V){const ee=V.length;let oe=0,ae=0;for(;ae<ee;){const ve=$(V,ee,ae);ae+=ve>=65536?2:1,ve<128?oe+=1:ve<2048?oe+=2:ve<65536?oe+=3:oe+=4}const le=new Uint8Array(oe);ae=0;let de=0;for(;ae<ee;){const ve=$(V,ee,ae);ae+=ve>=65536?2:1,ve<128?le[de++]=ve:ve<2048?(le[de++]=192|(ve&1984)>>>6,le[de++]=128|(ve&63)>>>0):ve<65536?(le[de++]=224|(ve&61440)>>>12,le[de++]=128|(ve&4032)>>>6,le[de++]=128|(ve&63)>>>0):(le[de++]=240|(ve&1835008)>>>18,le[de++]=128|(ve&258048)>>>12,le[de++]=128|(ve&4032)>>>6,le[de++]=128|(ve&63)>>>0)}return le}e.encodeUTF8=U;function N(V){const ee=V.byteLength,oe=[];let ae=0;for(;ae<ee;){const le=V[ae];let de;if(le>=240&&ae+3<ee?de=(V[ae++]&7)<<18>>>0|(V[ae++]&63)<<12>>>0|(V[ae++]&63)<<6>>>0|(V[ae++]&63)<<0>>>0:le>=224&&ae+2<ee?de=(V[ae++]&15)<<12>>>0|(V[ae++]&63)<<6>>>0|(V[ae++]&63)<<0>>>0:le>=192&&ae+1<ee?de=(V[ae++]&31)<<6>>>0|(V[ae++]&63)<<0>>>0:de=V[ae++],de>=0&&de<=55295||de>=57344&&de<=65535)oe.push(String.fromCharCode(de));else if(de>=65536&&de<=1114111){const ve=de-65536,ye=55296+((ve&1047552)>>>10),Ee=56320+((ve&1023)>>>0);oe.push(String.fromCharCode(ye)),oe.push(String.fromCharCode(Ee))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=N;const z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function H(V){return z.test(V)}e.containsRTL=H;const K=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function te(V){return K.test(V)}e.containsEmoji=te;const X=/^[\t\n\r\x20-\x7E]*$/;function ie(V){return X.test(V)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=se;function ce(V){for(let ee=0,oe=V.length;ee<oe;ee++)if(he(V.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=ce;function he(V){return V=+V,V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=he;function me(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129003||V>=129280&&V<=129535||V>=129648&&V<=129750}e.isEmojiImprecise=me;function we(V,ee){if(V.length<ee)return V;const oe=/\b/g;let ae=0;for(;oe.test(V)&&!(V.length-oe.lastIndex<ee);)ae=oe.lastIndex,oe.lastIndex+=1;return V.substring(ae).replace(/^\s/,"")}e.lcut=we;const Ie=/\x1B\x5B[12]?K/g,Ae=/\x1b\[\d+m/g,ke=/\x1b\[0?m/g;function Fe(V){return V&&(V=V.replace(Ie,""),V=V.replace(Ae,""),V=V.replace(ke,"")),V}e.removeAnsiEscapeCodes=Fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ue(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ue;function Me(V){return Ue(V)?V.substr(1):V}e.stripUTF8BOM=Me;function De(V,ee){if(!V||!ee||V.length<ee.length)return!1;const oe=ee.length,ae=V.toLowerCase();let le=0,de=-1;for(;le<oe;){const ve=ae.indexOf(ee[le],de+1);if(ve<0)return!1;de=ve,le++}return!0}e.fuzzyContains=De;function Te(V,ee=!1){return V?(ee&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=Te;function $e(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=$e;function He(V,ee=1){if(ee===0)return"";let oe=-1;do oe=V.indexOf(`
`,oe+1),ee--;while(ee>0&&oe>=0);return oe===-1?V:(V[oe-1]==="\r"&&oe--,V.substr(0,oe))}e.getNLines=He;function Ne(V){const ee=90-65+1;return V=V%(2*ee),V<ee?String.fromCharCode(97+V):String.fromCharCode(65+V-ee)}e.singleLetterHash=Ne;function ze(V){return re.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=ze;function J(V,ee){return V===0?ee!==5&&ee!==7:V===2&&ee===3?!1:V===4||V===2||V===3||ee===4||ee===2||ee===3?!0:!(V===8&&(ee===8||ee===9||ee===11||ee===12)||(V===11||V===9)&&(ee===9||ee===10)||(V===12||V===10)&&ee===10||ee===5||ee===13||ee===7||V===1||V===13&&ee===14||V===6&&ee===6)}e.breakBetweenGraphemeBreakType=J;var ne;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(ne=e.GraphemeBreakType||(e.GraphemeBreakType={}));class re{constructor(){this._data=ge()}static getInstance(){return re._INSTANCE||(re._INSTANCE=new re),re._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const oe=this._data,ae=oe.length/3;let le=1;for(;le<=ae;)if(ee<oe[3*le])le=2*le;else if(ee>oe[3*le+1])le=2*le+1;else return oe[3*le+2];return 0}}re._INSTANCE=null;function ge(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Q[22],Z([0,1,21,47]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",R=typeof TextEncoder!="undefined",L=typeof TextDecoder!="undefined";let P,g;class p{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return k?new p(Buffer.allocUnsafe(s)):new p(new Uint8Array(s))}static wrap(s){return k&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new p(s)}static fromString(s,l){return!((l==null?void 0:l.dontUseNodeBuffer)||!1)&&k?new p(Buffer.from(s)):R?(P||(P=new TextEncoder),new p(P.encode(s))):new p(v.encodeUTF8(s))}static concat(s,l){if(typeof l=="undefined"){l=0;for(let E=0,u=s.length;E<u;E++)l+=s[E].byteLength}const h=p.alloc(l);let f=0;for(let E=0,u=s.length;E<u;E++){const O=s[E];h.set(O,f),f+=O.byteLength}return h}toString(){return k?this.buffer.toString():L?(g||(g=new TextDecoder),g.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(s,l){return new p(this.buffer.subarray(s,l))}set(s,l){s instanceof p?this.buffer.set(s.buffer,l):this.buffer.set(s,l)}readUInt32BE(s){return b(this.buffer,s)}writeUInt32BE(s,l){I(this.buffer,s,l)}readUInt32LE(s){return a(this.buffer,s)}writeUInt32LE(s,l){D(this.buffer,s,l)}readUInt8(s){return S(this.buffer,s)}writeUInt8(s,l){w(this.buffer,s,l)}}e.VSBuffer=p;function C(c,s){return c[s+0]<<0>>>0|c[s+1]<<8>>>0}e.readUInt16LE=C;function d(c,s,l){c[l+0]=s&255,s=s>>>8,c[l+1]=s&255}e.writeUInt16LE=d;function b(c,s){return c[s]*2**24+c[s+1]*2**16+c[s+2]*2**8+c[s+3]}e.readUInt32BE=b;function I(c,s,l){c[l+3]=s,s=s>>>8,c[l+2]=s,s=s>>>8,c[l+1]=s,s=s>>>8,c[l]=s}e.writeUInt32BE=I;function a(c,s){return c[s+0]<<0>>>0|c[s+1]<<8>>>0|c[s+2]<<16>>>0|c[s+3]<<24>>>0}e.readUInt32LE=a;function D(c,s,l){c[l+0]=s&255,s=s>>>8,c[l+1]=s&255,s=s>>>8,c[l+2]=s&255,s=s>>>8,c[l+3]=s&255}e.writeUInt32LE=D;function S(c,s){return c[s]}e.readUInt8=S;function w(c,s,l){c[l]=s}e.writeUInt8=w;function y(c){return T.consumeReadable(c,s=>p.concat(s))}e.readableToBuffer=y;function m(c){return T.toReadable(c)}e.bufferToReadable=m;function o(c){return T.consumeStream(c,s=>p.concat(s))}e.streamToBuffer=o;async function i(c){return c.ended?p.concat(c.buffer):p.concat([...c.buffer,await o(c.stream)])}e.bufferedStreamToBuffer=i;function t(c){return T.toStream(c,s=>p.concat(s))}e.bufferToStream=t;function n(c){return T.transform(c,{data:s=>typeof s=="string"?p.fromString(s):p.wrap(s)},s=>p.concat(s))}e.streamToBufferReadableStream=n;function r(c){return T.newWriteableStream(s=>p.concat(s),c)}e.newWriteableBufferStream=r}),define(Q[17],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(s){return Array.isArray(s)}e.isArray=v;function T(s){return typeof s=="string"}e.isString=T;function k(s){return Array.isArray(s)&&s.every(l=>T(l))}e.isStringArray=k;function R(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=R;function L(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=L;function P(s){return s===!0||s===!1}e.isBoolean=P;function g(s){return typeof s=="undefined"}e.isUndefined=g;function p(s){return!C(s)}e.isDefined=p;function C(s){return g(s)||s===null}e.isUndefinedOrNull=C;function d(s,l){if(!s)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=d;function b(s){if(C(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=b;function I(...s){const l=[];for(let h=0;h<s.length;h++){const f=s[h];if(C(f))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);l.push(f)}return l}e.assertAllDefined=I;const a=Object.prototype.hasOwnProperty;function D(s){if(!R(s))return!1;for(let l in s)if(a.call(s,l))return!1;return!0}e.isEmptyObject=D;function S(s){return typeof s=="function"}e.isFunction=S;function w(...s){return s.length>0&&s.every(S)}e.areFunctions=w;function y(s,l){const h=Math.min(s.length,l.length);for(let f=0;f<h;f++)m(s[f],l[f])}e.validateConstraints=y;function m(s,l){if(T(l)){if(typeof s!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(S(l)){try{if(s instanceof l)return}catch(h){}if(!C(s)&&s.constructor===l||l.length===1&&l.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function o(s){let l=[],h=Object.getPrototypeOf(s);for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.getAllPropertyNames=o;function i(s){const l=[];for(const h of o(s))typeof s[h]=="function"&&l.push(h);return l}e.getAllMethodNames=i;function t(s,l){const h=E=>function(){const u=Array.prototype.slice.call(arguments,0);return l(E,u)};let f={};for(const E of s)f[E]=h(E);return f}e.createProxyObject=t;function n(s){return s===null?void 0:s}e.withNullAsUndefined=n;function r(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=r;function c(s){return class{constructor(){return new Proxy({},{get(l,h){if(l[h])return l[h];throw new Error(`Not Implemented: ${s}->${String(h)}`)}})}}}e.NotImplementedProxy=c}),define(Q[42],Z([0,1,7,21,8,17]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function L(n){return n===47||n===92}e.isPathSeparator=L;function P(n){return n.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=P;function g(n,r=k.posix.sep){if(!n)return"";const c=n.length,s=n.charCodeAt(0);if(L(s)){if(L(n.charCodeAt(1))&&!L(n.charCodeAt(2))){let h=3;const f=h;for(;h<c&&!L(n.charCodeAt(h));h++);if(f!==h&&!L(n.charCodeAt(h+1))){for(h+=1;h<c;h++)if(L(n.charCodeAt(h)))return n.slice(0,h+1).replace(/[\\/]/g,r)}}return r}else if(S(s)&&n.charCodeAt(1)===58)return L(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let l=n.indexOf("://");if(l!==-1){for(l+=3;l<c;l++)if(L(n.charCodeAt(l)))return n.slice(0,l+1)}return""}e.getRoot=g;function p(n){if(!v.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let c=2;const s=c;for(;c<n.length&&(r=n.charCodeAt(c),r!==92);c++);return!(s===c||(r=n.charCodeAt(c+1),isNaN(r)||r===92))}e.isUNC=p;const C=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function I(n,r=v.isWindows){const c=r?C:d;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||r&&b.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=I;function a(n,r,c){const s=n===r;return!c||s?s:!n||!r?!1:(0,T.equalsIgnoreCase)(n,r)}e.isEqual=a;function D(n,r,c,s=k.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(c){if(!(0,T.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let h=r.length;return r.charAt(r.length-1)===s&&h--,n.charAt(h)===s}return r.charAt(r.length-1)!==s&&(r+=s),n.indexOf(r)===0}e.isEqualOrParent=D;function S(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=S;function w(n,r){return v.isWindows&&n.endsWith(":")&&(n+=k.sep),(0,k.isAbsolute)(n)||(n=(0,k.join)(r,n)),n=(0,k.normalize)(n),v.isWindows?(n=(0,T.rtrim)(n,k.sep),n.endsWith(":")&&(n+=k.sep)):(n=(0,T.rtrim)(n,k.sep),n||(n=k.sep)),n}e.sanitizeFilePath=w;function y(n){const r=(0,k.normalize)(n);return v.isWindows?n.length>3?!1:m(r)&&(n.length===2||r.charCodeAt(2)===92):r===k.posix.sep}e.isRootOrDriveLetter=y;function m(n){return v.isWindows?S(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function o(n){return m(n)?n[0]:void 0}e.getDriveLetter=o;function i(n,r,c){return r.length>n.length?-1:n===r?0:(c&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=i;function t(n){const r=n.split(":");let c,s,l;if(r.forEach(h=>{const f=Number(h);(0,R.isNumber)(f)?s===void 0?s=f:l===void 0&&(l=f):c=c?[c,h].join(":"):h}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:s!==void 0?s:void 0,column:l!==void 0?l:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Q[26],Z([0,1,17]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const D=Array.isArray(a)?[]:{};return Object.keys(a).forEach(S=>{a[S]&&typeof a[S]=="object"?D[S]=T(a[S]):D[S]=a[S]}),D}e.deepClone=T;function k(a){if(!a||typeof a!="object")return a;const D=[a];for(;D.length>0;){const S=D.shift();Object.freeze(S);for(const w in S)if(R.call(S,w)){const y=S[w];typeof y=="object"&&!Object.isFrozen(y)&&D.push(y)}}return a}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function L(a,D){return P(a,D,new Set)}e.cloneAndChange=L;function P(a,D,S){if((0,v.isUndefinedOrNull)(a))return a;const w=D(a);if(typeof w!="undefined")return w;if((0,v.isArray)(a)){const y=[];for(const m of a)y.push(P(m,D,S));return y}if((0,v.isObject)(a)){if(S.has(a))throw new Error("Cannot clone recursive data-structure");S.add(a);const y={};for(let m in a)R.call(a,m)&&(y[m]=P(a[m],D,S));return S.delete(a),y}return a}function g(a,D,S=!0){return(0,v.isObject)(a)?((0,v.isObject)(D)&&Object.keys(D).forEach(w=>{w in a?S&&((0,v.isObject)(a[w])&&(0,v.isObject)(D[w])?g(a[w],D[w],S):a[w]=D[w]):a[w]=D[w]}),a):D}e.mixin=g;function p(a,D){if(a===D)return!0;if(a==null||D===null||D===void 0||typeof a!=typeof D||typeof a!="object"||Array.isArray(a)!==Array.isArray(D))return!1;let S,w;if(Array.isArray(a)){if(a.length!==D.length)return!1;for(S=0;S<a.length;S++)if(!p(a[S],D[S]))return!1}else{const y=[];for(w in a)y.push(w);y.sort();const m=[];for(w in D)m.push(w);if(m.sort(),!p(y,m))return!1;for(S=0;S<y.length;S++)if(!p(a[y[S]],D[y[S]]))return!1}return!0}e.equals=p;function C(a){const D=new Set;return JSON.stringify(a,(S,w)=>{if((0,v.isObject)(w)||Array.isArray(w)){if(D.has(w))return"[Circular]";D.add(w)}return w})}e.safeStringify=C;function d(a,D,S){const w=D(a);return typeof w=="undefined"?S:w}e.getOrDefault=d;function b(a,D){const S=Object.create(null);return!a||!D||Object.keys(D).forEach(y=>{const m=a[y],o=D[y];p(m,o)||(S[y]=o)}),S}e.distinct=b;function I(a,D){const S=D.toLowerCase(),w=Object.keys(a).find(y=>y.toLowerCase()===S);return w?a[w]:a[D]}e.getCaseInsensitive=I}),define(Q[5],Z([0,1,7,8]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,L=/^\/\//;function P(r,c){if(!r.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(r,c){return!r&&!c?"file":r}function p(r,c){switch(r){case"https":case"http":case"file":c?c[0]!==d&&(c=d+c):c=d;break}return c}const C="",d="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{constructor(c,s,l,h,f,E=!1){typeof c=="object"?(this.scheme=c.scheme||C,this.authority=c.authority||C,this.path=c.path||C,this.query=c.query||C,this.fragment=c.fragment||C):(this.scheme=g(c,E),this.authority=s||C,this.path=p(this.scheme,l||C),this.query=h||C,this.fragment=f||C,P(this,E))}static isUri(c){return c instanceof I?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}get fsPath(){return m(this,!1)}with(c){if(!c)return this;let{scheme:s,authority:l,path:h,query:f,fragment:E}=c;return s===void 0?s=this.scheme:s===null&&(s=C),l===void 0?l=this.authority:l===null&&(l=C),h===void 0?h=this.path:h===null&&(h=C),f===void 0?f=this.query:f===null&&(f=C),E===void 0?E=this.fragment:E===null&&(E=C),s===this.scheme&&l===this.authority&&h===this.path&&f===this.query&&E===this.fragment?this:new D(s,l,h,f,E)}static parse(c,s=!1){const l=b.exec(c);return l?new D(l[2]||C,n(l[4]||C),n(l[5]||C),n(l[7]||C),n(l[9]||C),s):new D(C,C,C,C,C)}static file(c){let s=C;if(v.isWindows&&(c=c.replace(/\\/g,d)),c[0]===d&&c[1]===d){const l=c.indexOf(d,2);l===-1?(s=c.substring(2),c=d):(s=c.substring(2,l),c=c.substring(l)||d)}return new D("file",s,c,C,C)}static from(c){return new D(c.scheme,c.authority,c.path,c.query,c.fragment)}static joinPath(c,...s){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return v.isWindows&&c.scheme==="file"?l=I.file(T.win32.join(m(c,!0),...s)).path:l=T.posix.join(c.path,...s),c.with({path:l})}toString(c=!1){return o(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof I)return c;{const s=new D(c);return s._formatted=c.external,s._fsPath=c._sep===a?c.fsPath:null,s}}else return c}}e.URI=I;const a=v.isWindows?1:void 0;class D extends I{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(c=!1){return c?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=a),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(r,c){let s,l=-1;for(let h=0;h<r.length;h++){const f=r.charCodeAt(h);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||c&&f===47)l!==-1&&(s+=encodeURIComponent(r.substring(l,h)),l=-1),s!==void 0&&(s+=r.charAt(h));else{s===void 0&&(s=r.substr(0,h));const E=S[f];E!==void 0?(l!==-1&&(s+=encodeURIComponent(r.substring(l,h)),l=-1),s+=E):l===-1&&(l=h)}}return l!==-1&&(s+=encodeURIComponent(r.substring(l))),s!==void 0?s:r}function y(r){let c;for(let s=0;s<r.length;s++){const l=r.charCodeAt(s);l===35||l===63?(c===void 0&&(c=r.substr(0,s)),c+=S[l]):c!==void 0&&(c+=r[s])}return c!==void 0?c:r}function m(r,c){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?c?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,v.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=m;function o(r,c){const s=c?y:w;let l="",{scheme:h,authority:f,path:E,query:u,fragment:O}=r;if(h&&(l+=h,l+=":"),(f||h==="file")&&(l+=d,l+=d),f){let _=f.indexOf("@");if(_!==-1){const q=f.substr(0,_);f=f.substr(_+1),_=q.indexOf(":"),_===-1?l+=s(q,!1):(l+=s(q.substr(0,_),!1),l+=":",l+=s(q.substr(_+1),!1)),l+="@"}f=f.toLowerCase(),_=f.indexOf(":"),_===-1?l+=s(f,!1):(l+=s(f.substr(0,_),!1),l+=f.substr(_))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const _=E.charCodeAt(1);_>=65&&_<=90&&(E=`/${String.fromCharCode(_+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const _=E.charCodeAt(0);_>=65&&_<=90&&(E=`${String.fromCharCode(_+32)}:${E.substr(2)}`)}l+=s(E,!0)}return u&&(l+="?",l+=s(u,!1)),O&&(l+="#",l+=c?O:w(O,!1)),l}function i(r){try{return decodeURIComponent(r)}catch(c){return r.length>3?r.substr(0,3)+i(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,c=>i(c)):r}}),define(Q[88],Z([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(p){const C=p;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=T;function k(p){const C=[];let d;try{const b=JSON.parse(p.arguments),I=b[b.length-1];I&&I.__$stack&&(b.pop(),d=I.__$stack),C.push(...b)}catch(b){C.push("Unable to log remote console arguments",p.arguments)}return{args:C,stack:d}}e.parse=k;function R(p){if(typeof p!="string")return R(k(p).stack);const C=p;if(C){const d=L(C),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(b&&b.length===4)return{uri:v.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=R;function L(p){if(!p)return p;const C=p.indexOf(`
`);return C===-1?p:p.substring(0,C)}function P(p,C){const{args:d,stack:b}=k(p),I=typeof d[0]=="string"&&d.length===1;let a=L(b);a&&(a=`(${a.trim()})`);let D=[];if(typeof d[0]=="string"?a&&I?D=[`%c[${C}] %c${d[0]} %c${a}`,g("blue"),g(""),g("grey")]:D=[`%c[${C}] %c${d[0]}`,g("blue"),g(""),...d.slice(1)]:D=[`%c[${C}]%`,g("blue"),...d],a&&!I&&D.push(a),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,D)}e.log=P;function g(p){return`color: ${p}`}}),define(Q[37],Z([0,1,5,21]),function(G,e,v,T){"use strict";var k,R;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function L(o,i,t){let n=o.get(i);return n===void 0&&(n=t,o.set(i,n)),n}e.getOrSet=L;function P(o){const i=[];return o.forEach((t,n)=>{i.push(`${n} => ${t}`)}),`Map(${o.size}) {${i.join(", ")}}`}e.mapToString=P;function g(o){const i=[];return o.forEach(t=>{i.push(t)}),`Set(${o.size}) {${i.join(", ")}}`}e.setToString=g;class p{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const t=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return t-n}value(){return this._value[this._pos]}}e.StringIterator=p;class C{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,T.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class d{constructor(i=!0,t=!0){this._splitOnBackslash=i,this._caseSensitive=t}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,T.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var b;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(b||(b={}));class I{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,T.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=I;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(i){this._iter=i}static forUris(i=()=>!1){return new D(new I(i))}static forPaths(){return new D(new d)}static forStrings(){return new D(new p)}static forConfigKeys(){return new D(new C)}clear(){this._root=void 0}set(i,t){const n=this._iter.reset(i);let r;for(this._root||(this._root=new a,this._root.segment=n.value()),r=this._root;;){const s=n.cmp(r.segment);if(s>0)r.left||(r.left=new a,r.left.segment=n.value()),r=r.left;else if(s<0)r.right||(r.right=new a,r.right.segment=n.value()),r=r.right;else if(n.hasNext())n.next(),r.mid||(r.mid=new a,r.mid.segment=n.value()),r=r.mid;else break}const c=r.value;return r.value=t,r.key=i,c}get(i){var t;return(t=this._getNode(i))===null||t===void 0?void 0:t.value}_getNode(i){const t=this._iter.reset(i);let n=this._root;for(;n;){const r=t.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else break}return n}has(i){const t=this._getNode(i);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,t){const n=this._iter.reset(i),r=[];let c=this._root;for(;c;){const s=n.cmp(c.segment);if(s>0)r.push([1,c]),c=c.left;else if(s<0)r.push([-1,c]),c=c.right;else if(n.hasNext())n.next(),r.push([0,c]),c=c.mid;else{for(t?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;r.length>0&&c.isEmpty();){let[l,h]=r.pop();switch(l){case 1:h.left=void 0;break;case 0:h.mid=void 0;break;case-1:h.right=void 0;break}c=h}break}}}findSubstr(i){const t=this._iter.reset(i);let n=this._root,r;for(;n;){const c=t.cmp(n.segment);if(c>0)n=n.left;else if(c<0)n=n.right;else if(t.hasNext())t.next(),r=n.value||r,n=n.mid;else break}return n&&n.value||r}findSuperstr(i){const t=this._iter.reset(i);let n=this._root;for(;n;){const r=t.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[t,n]of this)i(n,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=D;class S{constructor(i,t){this[k]="ResourceMap",i instanceof S?(this.map=new Map(i.map),this.toKey=t!=null?t:S.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:S.defaultToKey)}set(i,t){return this.map.set(this.toKey(i),t),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,t){typeof t!="undefined"&&(i=i.bind(t));for(let[n,r]of this.map)i(r,v.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield v.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[v.URI.parse(i[0]),i[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[v.URI.parse(i[0]),i[1]]}}e.ResourceMap=S,S.defaultToKey=o=>o.toString();var w;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class y{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,t=0){const n=this._map.get(i);if(!!n)return t!==0&&this.touch(n,t),n.value}set(i,t,n=0){let r=this._map.get(i);if(r)r.value=t,n!==0&&this.touch(r,n);else{switch(r={key:i,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(r);break;case 1:this.addItemFirst(r);break;case 2:this.addItemLast(r);break;default:this.addItemLast(r);break}this._map.set(i,r),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const t=this._map.get(i);if(!!t)return this._map.delete(i),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,t){const n=this._state;let r=this._head;for(;r;){if(t?i.bind(t)(r.value,r.key,this):i(r.value,r.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const c={value:n.key,done:!1};return n=n.next,c}else return{value:void 0,done:!0}}};return r}values(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const c={value:n.value,done:!1};return n=n.next,c}else return{value:void 0,done:!0}}};return r}entries(){const i=this,t=this._state;let n=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const c={value:[n.key,n.value],done:!1};return n=n.next,c}else return{value:void 0,done:!0}}};return r}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let t=this._head,n=this.size;for(;t&&n>i;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const t=i.next,n=i.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}i.next=void 0,i.previous=void 0,this._state++}touch(i,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(i===this._head)return;const n=i.next,r=i.previous;i===this._tail?(r.next=void 0,this._tail=r):(n.previous=r,r.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(t===2){if(i===this._tail)return;const n=i.next,r=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=r,r.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((t,n)=>{i.push([n,t])}),i}fromJSON(i){this.clear();for(const[t,n]of i)this.set(t,n)}}e.LinkedMap=y;class m extends y{constructor(i,t=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,t=2){return super.get(i,t)}peek(i){return super.get(i,0)}set(i,t){return super.set(i,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m}),define(Q[89],Z([0,1,22,21,5]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(p){return JSON.stringify(p,P)}e.stringify=R;function L(p){let C=JSON.parse(p);return C=g(C),C}e.parse=L;function P(p,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,T.regExpFlags)(C)}:C}function g(p,C=0){if(!p||C>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return k.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof v.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let d=0;d<p.length;++d)p[d]=g(p[d],C+1);else for(const d in p)Object.hasOwnProperty.call(p,d)&&(p[d]=g(p[d],C+1))}return p}e.revive=g}),define(Q[16],Z([0,1,5,7]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.vscodeWebviewResource="vscode-webview-resource",P.extension="extension",P.vscodeFileResource="vscode-file"})(k=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}set(g,p,C){this._hosts[g]=p,this._ports[g]=C}setConnectionToken(g,p){this._connectionTokens[g]=p}rewrite(g){if(this._delegate)return this._delegate(g);const p=g.authority;let C=this._hosts[p];C&&C.indexOf(":")!==-1&&(C=`[${C}]`);const d=this._ports[p],b=this._connectionTokens[p];let I=`path=${encodeURIComponent(g.path)}`;return typeof b=="string"&&(I+=`&tkn=${encodeURIComponent(b)}`),v.URI.from({scheme:T.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${C}:${d}`,path:"/vscode-remote-resource",query:I})}}e.RemoteAuthorities=new R;class L{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(g,p,C){const d=this.toUri(g,p);return d.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(d):T.isNative&&(C||T.isPreferringBrowserCodeLoad)&&d.scheme===k.file?d.with({scheme:k.vscodeFileResource,authority:d.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):d}asFileUri(g,p){const C=this.toUri(g,p);return C.scheme===k.vscodeFileResource?C.with({scheme:k.file,authority:C.authority!==this.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(g,p){return v.URI.isUri(g)?g:v.URI.parse(p.toUrl(g))}}e.FileAccess=new L}),define(Q[65],Z([0,1,37]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const T=new v.LRUCache(1e4);function k(p){return g(p,"NFC",T)}e.normalizeNFC=k;const R=new v.LRUCache(1e4);function L(p){return g(p,"NFD",R)}e.normalizeNFD=L;const P=/[^\u0000-\u0080]/;function g(p,C,d){if(!e.canNormalize||!p)return p;const b=d.get(p);if(b)return b;let I;return P.test(p)?I=p.normalize(C):I=p,d.set(p,I),I}e.removeAccents=function(){if(e.canNormalize){const p=/[\u0300-\u036f]/g;return function(C){return L(C).replace(p,"")}}else return function(p){return p}}()}),define(Q[11],Z([0,1,42,8,5,21,16,7]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(I){return(0,k.uriToFsPath)(I,!0)}e.originalFSPath=g;class p{constructor(a){this._ignorePathCasing=a}compare(a,D,S=!1){return a===D?0:(0,R.compare)(this.getComparisonKey(a,S),this.getComparisonKey(D,S))}isEqual(a,D,S=!1){return a===D?!0:!a||!D?!1:this.getComparisonKey(a,S)===this.getComparisonKey(D,S)}getComparisonKey(a,D=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:D?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,D,S=!1){if(a.scheme===D.scheme){if(a.scheme===L.Schemas.file)return v.isEqualOrParent(g(a),g(D),this._ignorePathCasing(a))&&a.query===D.query&&(S||a.fragment===D.fragment);if((0,e.isEqualAuthority)(a.authority,D.authority))return v.isEqualOrParent(a.path,D.path,this._ignorePathCasing(a),"/")&&a.query===D.query&&(S||a.fragment===D.fragment)}return!1}joinPath(a,...D){return k.URI.joinPath(a,...D)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return T.posix.basename(a.path)}extname(a){return T.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let D;return a.scheme===L.Schemas.file?D=k.URI.file(T.dirname(g(a))).path:(D=T.posix.dirname(a.path),a.authority&&D.length&&D.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),D="/")),a.with({path:D})}normalizePath(a){if(!a.path.length)return a;let D;return a.scheme===L.Schemas.file?D=k.URI.file(T.normalize(g(a))).path:D=T.posix.normalize(a.path),a.with({path:D})}relativePath(a,D){if(!(a.scheme!==D.scheme||!(0,e.isEqualAuthority)(a.authority,D.authority))){if(a.scheme===L.Schemas.file){const y=T.relative(g(a),g(D));return P.isWindows?v.toSlashes(y):y}let S=a.path||"/",w=D.path||"/";if(this._ignorePathCasing(a)){let y=0;for(const m=Math.min(S.length,w.length);y<m&&!(S.charCodeAt(y)!==w.charCodeAt(y)&&S.charAt(y).toLowerCase()!==w.charAt(y).toLowerCase());y++);S=w.substr(0,y)+S.substr(y)}return T.posix.relative(S,w)}}resolvePath(a,D){if(a.scheme===L.Schemas.file){const S=k.URI.file(T.resolve(g(a),D));return a.with({authority:S.authority,path:S.path})}return D.indexOf("/")===-1&&(D=v.toSlashes(D),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D)),a.with({path:T.posix.resolve(a.path,D)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,D){return a===D||(0,R.equalsIgnoreCase)(a,D)}hasTrailingPathSeparator(a,D=T.sep){if(a.scheme===L.Schemas.file){const S=g(a);return S.length>v.getRoot(S).length&&S[S.length-1]===D}else{const S=a.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,D=T.sep){return(0,e.hasTrailingPathSeparator)(a,D)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,D=T.sep){let S=!1;if(a.scheme===L.Schemas.file){const w=g(a);S=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===D}else{D="/";const w=a.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(a,D)?a.with({path:a.path+"/"}):a}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(I=>I.scheme===L.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new p(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(I,a){const D=[];for(let S=0;S<I.length;S++){const w=a(I[S]);I.some((y,m)=>m===S?!1:(0,e.isEqualOrParent)(w,a(y)))||D.push(I[S])}return D}e.distinctParents=C;var d;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function a(D){const S=new Map;D.path.substring(D.path.indexOf(";")+1,D.path.lastIndexOf(";")).split(";").forEach(m=>{const[o,i]=m.split(":");o&&i&&S.set(o,i)});const y=D.path.substring(0,D.path.indexOf(";"));return y&&S.set(I.META_DATA_MIME,y),S}I.parseMetaData=a})(d=e.DataUri||(e.DataUri={}));function b(I,a,D){if(a){let S=I.path;return S&&S[0]!==T.posix.sep&&(S=T.posix.sep+S),I.with({scheme:D,authority:a,path:S})}return I.with({scheme:D})}e.toLocalResource=b}),define(Q[6],Z([0,1,29,15,3,2,64,11]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(F){return!!F&&typeof F.then=="function"}e.isThenable=g;function p(F){const A=new v.CancellationTokenSource,U=F(A.token),N=new Promise((z,H)=>{A.token.onCancellationRequested(()=>{H((0,T.canceled)())}),Promise.resolve(U).then(K=>{A.dispose(),z(K)},K=>{A.dispose(),H(K)})});return new class{cancel(){A.cancel()}then(z,H){return N.then(z,H)}catch(z){return this.then(void 0,z)}finally(z){return N.finally(z)}}}e.createCancelablePromise=p;function C(F,A,U){return Promise.race([F,new Promise(N=>A.onCancellationRequested(()=>N(U)))])}e.raceCancellation=C;async function d(F){let A=-1;const U=F.map((z,H)=>z.then(K=>(A=H,K))),N=await Promise.race(U);return F.forEach((z,H)=>{H!==A&&z.cancel()}),N}e.raceCancellablePromises=d;function b(F,A,U){let N;const z=setTimeout(()=>{N==null||N(void 0),U==null||U()},A);return Promise.race([F.finally(()=>clearTimeout(z)),new Promise(H=>N=H)])}e.raceTimeout=b;function I(F){return new Promise((A,U)=>{const N=F();g(N)?N.then(A,U):A(N)})}e.asPromise=I;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(U,U).then(N)})}return new Promise((U,N)=>{this.queuedPromise.then(U,N)})}return this.activePromise=A(),new Promise((U,N)=>{this.activePromise.then(z=>{this.activePromise=null,U(z)},z=>{this.activePromise=null,N(z)})})}}e.Throttler=a;class D{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=D;class S{constructor(){this.promiseMap=new Map}queue(A,U){var N;const H=((N=this.promiseMap.get(A))!==null&&N!==void 0?N:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(A)===H&&this.promiseMap.delete(A)});return this.promiseMap.set(A,H),H}}e.SequencerByKey=S;class w{constructor(A){this.defaultDelay=A,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,U=this.defaultDelay){return this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,z)=>{this.doResolve=N,this.doReject=z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,T.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class y{constructor(A){this.delayer=new w(A),this.throttler=new a}trigger(A,U){return this.delayer.trigger(()=>this.throttler.queue(A),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=y;class m{constructor(){this._isOpen=!1,this._promise=new Promise((A,U)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class o extends m{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function i(F,A){return A?new Promise((U,N)=>{const z=setTimeout(U,F);A.onCancellationRequested(()=>{clearTimeout(z),N((0,T.canceled)())})}):p(U=>i(F,U))}e.timeout=i;function t(F,A=0){const U=setTimeout(F,A);return(0,R.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function n(F){return F.then(void 0,A=>{})}e.ignoreErrors=n;function r(F){const A=[];let U=0;const N=F.length;function z(){return U<N?F[U++]():null}function H(K){K!=null&&A.push(K);const te=z();return te?te.then(H):Promise.resolve(A)}return Promise.resolve(null).then(H)}e.sequence=r;function c(F,A=N=>!!N,U=null){let N=0;const z=F.length,H=()=>{if(N>=z)return Promise.resolve(U);const K=F[N++];return Promise.resolve(K()).then(X=>A(X)?Promise.resolve(X):H())};return H()}e.first=c;function s(F,A=N=>!!N,U=null){if(F.length===0)return Promise.resolve(U);let N=F.length;const z=()=>{var H,K;N=-1;for(const te of F)(K=(H=te).cancel)===null||K===void 0||K.call(H)};return new Promise((H,K)=>{for(const te of F)te.then(X=>{--N>=0&&A(X)?(z(),H(X)):N===0&&H(U)}).catch(X=>{--N>=0&&(z(),K(X))})})}e.firstParallel=s;class l{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((U,N)=>{this.outstandingPromises.push({factory:A,c:U,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const U=A.factory();U.then(A.c,A.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class f{constructor(){this.queues=new Map}queueFor(A,U=P.extUri){const N=U.getComparisonKey(A);let z=this.queues.get(N);return z||(z=new h,k.Event.once(z.onFinished)(()=>{z==null||z.dispose(),this.queues.delete(N)}),this.queues.set(N,z)),z}dispose(){this.queues.forEach(A=>A.dispose()),this.queues.clear()}}e.ResourceQueue=f;class E{constructor(A,U){this._token=-1,typeof A=="function"&&typeof U=="number"&&this.setIfNotSet(A,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},U)}setIfNotSet(A,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},U))}}e.TimeoutTimer=E;class u{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,U){this.cancel(),this._token=setInterval(()=>{A()},U)}}e.IntervalTimer=u;class O{constructor(A,U){this.timeoutToken=-1,this.runner=A,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class _ extends O{constructor(A,U){super(A,U);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const F=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=A=>{const U=setTimeout(()=>A(F));let N=!1;return{dispose(){N||(N=!0,clearTimeout(U))}}}}else e.runWhenIdle=(F,A)=>{const U=requestIdleCallback(F,typeof A=="number"?{timeout:A}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(U))}}}}();class q{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=q;async function x(F,A,U){let N;for(let z=0;z<U;z++)try{return await F()}catch(H){N=H,await i(A)}throw N}e.retry=x;class j{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var A;(A=this._pending)===null||A===void 0||A.cancel()}setPending(A,U,N){return this._pending={taskId:A,cancel:()=>N==null?void 0:N(),promise:U},U.then(()=>this.donePending(A),()=>this.donePending(A)),U}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let U,N;const z=new Promise((H,K)=>{U=H,N=K});this._next={run:A,promise:z,promiseResolve:U,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=j;class ${constructor(A){this.interval=A,this.lastIncrementTime=0,this.value=0}increment(){const A=Date.now();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,U)=>{this.completeCallback=A,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(U=>{this.completeCallback(A),this.resolved=!0,U()})}error(A){return new Promise(U=>{this.errorCallback(A),this.rejected=!0,U()})}cancel(){new Promise(A=>{this.errorCallback((0,T.canceled)()),this.rejected=!0,A()})}}e.DeferredPromise=W;class B extends k.Emitter{async fireAsync(A,U,N){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const z of this._listeners)this._asyncDeliveryQueue.push([z,A]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[z,H]=this._asyncDeliveryQueue.shift(),K=[],te=Object.assign(Object.assign({},H),{waitUntil:X=>{if(Object.isFrozen(K))throw new Error("waitUntil can NOT be called asynchronous");N&&(X=N(X,typeof z=="function"?z:z[0])),K.push(X)}});try{typeof z=="function"?z.call(void 0,te):z[0].call(z[1],te)}catch(X){(0,T.onUnexpectedError)(X);continue}Object.freeze(K),await M.settled(K).catch(X=>(0,T.onUnexpectedError)(X))}}}}e.AsyncEmitter=B;var M;(function(F){async function A(H){return typeof Promise.allSettled=="function"?U(H):N(H)}F.allSettled=A;async function U(H){return Promise.allSettled(H)}async function N(H){return Promise.all(H.map(K=>K.then(te=>({status:"fulfilled",value:te}),te=>({status:"rejected",reason:te}))))}async function z(H){let K;const te=await Promise.all(H.map(X=>X.then(ie=>ie,ie=>{K||(K=ie)})));if(typeof K!="undefined")throw K;return te}F.settled=z})(M=e.Promises||(e.Promises={}))}),define(Q[90],Z([0,1,21,42,8,37,6]),function(G,e,v,T,k,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const g="**",p="/",C="[/\\\\]",d="[^/\\\\]",b=/\//g;function I(U){switch(U){case 0:return"";case 1:return`${d}*?`;default:return`(?:${C}|${d}+${C}|${C}${d}+)*?`}}function a(U,N){if(!U)return[];const z=[];let H=!1,K=!1,te="";for(const X of U){switch(X){case N:if(!H&&!K){z.push(te),te="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":K=!0;break;case"]":K=!1;break}te+=X}return te&&z.push(te),z}e.splitGlobAware=a;function D(U){if(!U)return"";let N="";const z=a(U,p);if(z.every(H=>H===g))N=".*";else{let H=!1;z.forEach((K,te)=>{if(K===g){H||(N+=I(2),H=!0);return}let X=!1,ie="",se=!1,ce="";for(const he of K){if(he!=="}"&&X){ie+=he;continue}if(se&&(he!=="]"||!ce)){let me;he==="-"?me=he:(he==="^"||he==="!")&&!ce?me="^":he===p?me="":me=v.escapeRegExpCharacters(he),ce+=me;continue}switch(he){case"{":X=!0;continue;case"[":se=!0;continue;case"}":N+=`(?:${a(ie,",").map(Ie=>D(Ie)).join("|")})`,X=!1,ie="";break;case"]":N+="["+ce+"]",se=!1,ce="";break;case"?":N+=d;continue;case"*":N+=I(1);continue;default:N+=v.escapeRegExpCharacters(he)}}te<z.length-1&&(z[te+1]!==g||te+2<z.length)&&(N+=C),H=!1})}return N}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),n=function(){return!1},r=function(){return null};function c(U,N){if(!U)return r;let z;typeof U!="string"?z=U.pattern:z=U,z=z.trim();const H=`${z}_${!!N.trimForExclusions}`;let K=t.get(H);if(K)return s(K,U);let te;if(S.test(z)){const X=z.substr(4);K=function(ie,se){return typeof ie=="string"&&ie.endsWith(X)?z:null}}else(te=w.exec(l(z,N)))?K=h(te[1],z):(N.trimForExclusions?m:y).test(z)?K=f(z,N):(te=o.exec(l(z,N)))?K=E(te[1].substr(1),z,!0):(te=i.exec(l(z,N)))?K=E(te[1],z,!1):K=u(z);return t.set(H,K),s(K,U)}function s(U,N){return typeof N=="string"?U:function(z,H){return T.isEqualOrParent(z,N.base)?U(k.relative(N.base,z),H):null}}function l(U,N){return N.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function h(U,N){const z=`/${U}`,H=`\\${U}`,K=function(X,ie){return typeof X!="string"?null:ie?ie===U?N:null:X===U||X.endsWith(z)||X.endsWith(H)?N:null},te=[U];return K.basenames=te,K.patterns=[N],K.allBasenames=te,K}function f(U,N){const z=A(U.slice(1,-1).split(",").map(ie=>c(ie,N)).filter(ie=>ie!==r),U),H=z.length;if(!H)return r;if(H===1)return z[0];const K=function(ie,se){for(let ce=0,he=z.length;ce<he;ce++)if(z[ce](ie,se))return U;return null},te=z.find(ie=>!!ie.allBasenames);te&&(K.allBasenames=te.allBasenames);const X=z.reduce((ie,se)=>se.allPaths?ie.concat(se.allPaths):ie,[]);return X.length&&(K.allPaths=X),K}function E(U,N,z){const H=k.sep===k.posix.sep,K=H?U:U.replace(b,k.sep),te=k.sep+K,X=k.posix.sep+U,ie=z?function(se,ce){return typeof se=="string"&&(se===K||se.endsWith(te)||!H&&(se===U||se.endsWith(X)))?N:null}:function(se,ce){return typeof se=="string"&&(se===K||!H&&se===U)?N:null};return ie.allPaths=[(z?"*/":"./")+U],ie}function u(U){try{const N=new RegExp(`^${D(U)}$`);return function(z){return N.lastIndex=0,typeof z=="string"&&N.test(z)?U:null}}catch(N){return r}}function O(U,N,z){return!U||typeof N!="string"?!1:_(U)(N,void 0,z)}e.match=O;function _(U,N={}){if(!U)return n;if(typeof U=="string"||$(U)){const z=c(U,N);if(z===r)return n;const H=function(K,te){return!!z(K,te)};return z.allBasenames&&(H.allBasenames=z.allBasenames),z.allPaths&&(H.allPaths=z.allPaths),H}return M(U,N)}e.parse=_;function q(U){if(!!U){let N;return z=>(N||(N=(U()||Promise.resolve([])).then(H=>H?j(H):{})),N.then(H=>!!H[z]))}}e.hasSiblingPromiseFn=q;function x(U){if(!!U){let N;return z=>{if(!N){const H=U();N=H?j(H):{}}return!!N[z]}}}e.hasSiblingFn=x;function j(U){const N={};for(const z of U)N[z]=!0;return N}function $(U){const N=U;return N&&typeof N.base=="string"&&typeof N.pattern=="string"}e.isRelativePattern=$;function W(U){return U.allBasenames||[]}e.getBasenameTerms=W;function B(U){return U.allPaths||[]}e.getPathTerms=B;function M(U,N){const z=A(Object.getOwnPropertyNames(U).map(ie=>F(ie,U[ie],N)).filter(ie=>ie!==r)),H=z.length;if(!H)return r;if(!z.some(ie=>!!ie.requiresSiblings)){if(H===1)return z[0];const ie=function(he,me){for(let we=0,Ie=z.length;we<Ie;we++){const Ae=z[we](he,me);if(Ae)return Ae}return null},se=z.find(he=>!!he.allBasenames);se&&(ie.allBasenames=se.allBasenames);const ce=z.reduce((he,me)=>me.allPaths?he.concat(me.allPaths):he,[]);return ce.length&&(ie.allPaths=ce),ie}const K=function(ie,se,ce){let he;for(let me=0,we=z.length;me<we;me++){const Ie=z[me];Ie.requiresSiblings&&ce&&(se||(se=k.basename(ie)),he||(he=se.substr(0,se.length-k.extname(ie).length)));const Ae=Ie(ie,se,he,ce);if(Ae)return Ae}return null},te=z.find(ie=>!!ie.allBasenames);te&&(K.allBasenames=te.allBasenames);const X=z.reduce((ie,se)=>se.allPaths?ie.concat(se.allPaths):ie,[]);return X.length&&(K.allPaths=X),K}function F(U,N,z){if(N===!1)return r;const H=c(U,z);if(H===r)return r;if(typeof N=="boolean")return H;if(N){const K=N.when;if(typeof K=="string"){const te=(X,ie,se,ce)=>{if(!ce||!H(X,ie))return null;const he=K.replace("$(basename)",se),me=ce(he);return(0,L.isThenable)(me)?me.then(we=>we?U:null):me?U:null};return te.requiresSiblings=!0,te}}return H}function A(U,N){const z=U.filter(ie=>!!ie.basenames);if(z.length<2)return U;const H=z.reduce((ie,se)=>{const ce=se.basenames;return ce?ie.concat(ce):ie},[]);let K;if(N){K=[];for(let ie=0,se=H.length;ie<se;ie++)K.push(N)}else K=z.reduce((ie,se)=>{const ce=se.patterns;return ce?ie.concat(ce):ie},[]);const te=function(ie,se){if(typeof ie!="string")return null;if(!se){let he;for(he=ie.length;he>0;he--){const me=ie.charCodeAt(he-1);if(me===47||me===92)break}se=ie.substr(he)}const ce=H.indexOf(se);return ce!==-1?K[ce]:null};te.basenames=H,te.patterns=K,te.allBasenames=H;const X=U.filter(ie=>!ie.basenames);return X.push(te),X}}),define(Q[91],Z([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(C){return C.toJSON()}class k{constructor(d){this._uriTransformer=d}transformIncoming(d){const b=this._uriTransformer.transformIncoming(d);return b===d?d:T(v.URI.from(b))}transformOutgoing(d){const b=this._uriTransformer.transformOutgoing(d);return b===d?d:T(v.URI.from(b))}transformOutgoingURI(d){const b=this._uriTransformer.transformOutgoing(d);return b===d?d:v.URI.from(b)}transformOutgoingScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,d,b){if(!C||b>200)return null;if(typeof C=="object"){if(C instanceof v.URI)return d.transformOutgoing(C);for(let I in C)if(Object.hasOwnProperty.call(C,I)){const a=R(C[I],d,b+1);a!==null&&(C[I]=a)}}return null}function L(C,d){const b=R(C,d,0);return b===null?C:b}e.transformOutgoingURIs=L;function P(C,d,b,I){if(!C||I>200)return null;if(typeof C=="object"){if(C.$mid===1)return b?v.URI.revive(d.transformIncoming(C)):d.transformIncoming(C);for(let a in C)if(Object.hasOwnProperty.call(C,a)){const D=P(C[a],d,b,I+1);D!==null&&(C[a]=D)}}return null}function g(C,d){const b=P(C,d,!1,0);return b===null?C:b}e.transformIncomingURIs=g;function p(C,d){const b=P(C,d,!0,0);return b===null?C:b}e.transformAndReviveIncomingURIs=p}),define(Q[30],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(g){return v.test(g)}e.isUUID=T;const k=new Uint8Array(16),R=[];for(let g=0;g<256;g++)R.push(g.toString(16).padStart(2,"0"));let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(g){for(let p=0;p<g.length;p++)g[p]=Math.floor(Math.random()*256);return g};function P(){L(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let g=0,p="";return p+=R[k[g++]],p+=R[k[g++]],p+=R[k[g++]],p+=R[k[g++]],p+="-",p+=R[k[g++]],p+=R[k[g++]],p+="-",p+=R[k[g++]],p+=R[k[g++]],p+="-",p+=R[k[g++]],p+=R[k[g++]],p+="-",p+=R[k[g++]],p+=R[k[g++]],p+=R[k[g++]],p+=R[k[g++]],p+=R[k[g++]],p+=R[k[g++]],p}e.generateUuid=P}),define(Q[66],Z([0,1,201]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class T{constructor(R="utf8"){this.stringDecoder=new v.StringDecoder(R),this.remaining=null}write(R){const L=[],P=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(P.length<1)return L;let g=0,p,C=g;for(;C<P.length;)if(p=P.charCodeAt(C),p===13||p===10){if(L.push(P.substring(g,C)),C++,C<P.length){const d=p;p=P.charCodeAt(C),(d===13&&p===10||d===10&&p===13)&&C++}g=C}else C++;return this.remaining=g<P.length?P.substr(g):null,L}end(){return this.remaining}}e.LineDecoder=T}),define(Q[92],Z([0,1,38]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(P){const g=P.replace(/\-/g,":").toLowerCase();return!T.has(g)}function R(){return new Promise(async(P,g)=>{const p=setTimeout(()=>g("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await L())}catch(C){g(C)}finally{clearTimeout(p)}})}e.getMac=R;function L(){return new Promise((P,g)=>{try{const p=(0,v.networkInterfaces)();for(const[,C]of Object.entries(p))for(const d of C)if(k(d.mac))return P(d.mac);g("Unable to retrieve mac address (unexpected format)")}catch(p){g(p)}})}}),define(Q[93],Z([0,1,15,30,38,37,92]),function(G,e,v,T,k,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,d=0;const b=(0,k.networkInterfaces)();for(let I in b)if(Object.prototype.hasOwnProperty.call(b,I))for(const{mac:a,internal:D}of b[I])D||(d+=1,this._isVirtualMachineMacAdress(a.toUpperCase())&&(C+=1));this._value=d>0?C/d:0}return this._value}};let P;async function g(){return P||(P=(async()=>await p()||T.generateUuid())()),P}e.getMachineId=g;async function p(){try{const C=await new Promise((b,I)=>{G(["crypto"],b,I)}),d=await(0,L.getMac)();return C.createHash("sha256").update(d,"utf8").digest("hex")}catch(C){v.onUnexpectedError(C);return}}}),define(Q[23],Z([0,1,27,38,8,6,7,42,30,65,11,5]),function(G,e,v,T,k,R,L,P,g,p,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var b;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function I(W,B=b.UNLINK){if((0,P.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return B===b.UNLINK?D(W):a(W)}e.rimraf=I;async function a(W){try{const B=(0,k.join)((0,T.tmpdir)(),(0,g.generateUuid)());try{await v.promises.rename(W,B)}catch(M){return D(W)}D(B).catch(M=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function D(W){return v.promises.rmdir(W,{recursive:!0,maxRetries:3})}function S(W){if((0,P.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(W,{recursive:!0})}e.rimrafSync=S;async function w(W,B){return o(await(B?y(W):v.promises.readdir(W)))}e.readdir=w;async function y(W){try{return await v.promises.readdir(W,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const B=[],M=await w(W);for(const F of M){let A=!1,U=!1,N=!1;try{const z=await v.promises.lstat((0,k.join)(W,F));A=z.isFile(),U=z.isDirectory(),N=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}B.push({name:F,isFile:()=>A,isDirectory:()=>U,isSymbolicLink:()=>N})}return B}function m(W){return o(v.readdirSync(W))}e.readdirSync=m;function o(W){return W.map(B=>typeof B=="string"?L.isMacintosh?(0,p.normalizeNFC)(B):B:(B.name=L.isMacintosh?(0,p.normalizeNFC)(B.name):B.name,B))}async function i(W){const B=await w(W),M=[];for(const F of B)await n.existsDirectory((0,k.join)(W,F))&&M.push(F);return M}e.readDirsInDir=i;function t(W,B=1e3){return new Promise(M=>{let F=!1;const A=setInterval(()=>{F||(F=!0,v.access(W,U=>{F=!1,U&&(clearInterval(A),M(void 0))}))},B)})}e.whenDeleted=t;var n;(function(W){async function B(A){let U;try{if(U=await v.promises.lstat(A),!U.isSymbolicLink())return{stat:U}}catch(N){}try{return{stat:await v.promises.stat(A),symbolicLink:(U==null?void 0:U.isSymbolicLink())?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(L.isWindows&&N.code==="EACCES")try{return{stat:await v.promises.stat(await v.promises.readlink(A)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw z}throw N}}W.stat=B;async function M(A){try{const{stat:U,symbolicLink:N}=await W.stat(A);return U.isFile()&&(N==null?void 0:N.dangling)!==!0}catch(U){}return!1}W.existsFile=M;async function F(A){try{const{stat:U,symbolicLink:N}=await W.stat(A);return U.isDirectory()&&(N==null?void 0:N.dangling)!==!0}catch(U){}return!1}W.existsDirectory=F})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function c(W,B,M){return r.queueFor(d.URI.file(W),C.extUriBiasedIgnorePathCase).queue(()=>{const F=f(M);return new Promise((A,U)=>l(W,B,F,N=>N?U(N):A()))})}e.writeFile=c;let s=!0;function l(W,B,M,F){if(!s)return v.writeFile(W,B,{mode:M.mode,flag:M.flag},F);v.open(W,M.flag,M.mode,(A,U)=>{if(A)return F(A);v.writeFile(U,B,N=>{if(N)return v.close(U,()=>F(N));v.fdatasync(U,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),s=!1),v.close(U,H=>F(H))))})})}function h(W,B,M){const F=f(M);if(!s)return v.writeFileSync(W,B,{mode:F.mode,flag:F.flag});const A=v.openSync(W,F.flag,F.mode);try{v.writeFileSync(A,B);try{v.fdatasyncSync(A)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),s=!1}}finally{v.closeSync(A)}}e.writeFileSync=h;function f(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function E(W,B){if(W!==B){async function M(F){try{const A=await v.promises.lstat(F);if(A.isDirectory()||A.isSymbolicLink())return;const U=await v.promises.open(F,"a");try{await U.utimes(A.atime,new Date)}finally{await U.close()}}catch(A){}}try{await v.promises.rename(W,B),await M(B)}catch(F){if(W.toLowerCase()!==B.toLowerCase()&&F.code==="EXDEV"||W.endsWith("."))await u(W,B,{preserveSymlinks:!1}),await I(W,b.MOVE),await M(B);else throw F}}}e.move=E;async function u(W,B,M){return _(W,B,{root:{source:W,target:B},options:M,handledSourcePaths:new Set})}e.copy=u;const O=511;async function _(W,B,M){if(!M.handledSourcePaths.has(W)){M.handledSourcePaths.add(W);const{stat:F,symbolicLink:A}=await n.stat(W);if(A){if(M.options.preserveSymlinks)try{return await j(W,B,M)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(A.dangling)return}return F.isDirectory()?q(W,B,F.mode&O,M):x(W,B,F.mode&O)}}async function q(W,B,M,F){await v.promises.mkdir(B,{recursive:!0,mode:M});const A=await w(W);for(const U of A)await _((0,k.join)(W,U),(0,k.join)(B,U),F)}async function x(W,B,M){await v.promises.copyFile(W,B),await v.promises.chmod(B,M)}async function j(W,B,M){let F=await v.promises.readlink(W);(0,P.isEqualOrParent)(F,M.root.source,!L.isLinux)&&(F=(0,k.join)(M.root.target,F.substr(M.root.source.length+1))),await v.promises.symlink(F,B)}async function $(W){try{return await v.promises.access(W),!0}catch(B){return!1}}e.exists=$}),define(Q[94],Z([0,1,27,21,8,23]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function L(C){const d=(0,k.dirname)(C);if(C===d)return C;const b=((0,k.basename)(C)||C).toLowerCase();try{const a=(0,R.readdirSync)(d).filter(D=>D.toLowerCase()===b);if(a.length===1){const D=L(d);if(D)return(0,k.join)(D,a[0])}else if(a.length>1){const D=a.indexOf(b);if(D>=0){const S=L(d);if(S)return(0,k.join)(S,a[D])}}}catch(I){}return null}e.realcaseSync=L;async function P(C){try{return await v.promises.realpath(C)}catch(d){const b=p(C);return await v.promises.access(b,v.constants.R_OK),b}}e.realpath=P;function g(C){try{return v.realpathSync(C)}catch(d){const b=p(C);return v.accessSync(b,v.constants.R_OK),b}}e.realpathSync=g;function p(C){return(0,T.rtrim)((0,k.normalize)(C),k.sep)}}),define(Q[95],Z([0,1,48,16]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(L){return new Promise((P,g)=>{let p;const C=new Map;function d(a,D,S,w,y){const m=C.get(D);if(a===L||m){const o={name:b(S),cmd:S,pid:a,ppid:D,load:w,mem:y};C.set(a,o),a===L&&(p=o),m&&(m.children||(m.children=[]),m.children.push(o),m.children.length>1&&(m.children=m.children.sort((i,t)=>i.pid-t.pid)))}}function b(a){const D=/--disable-blink-features=Auxclick/,S=/\\watcher\\win32\\CodeHelper\.exe/,w=/--crashes-directory/,y=/\\pipe\\winpty-control/,m=/conhost\.exe/,o=/--type=([a-zA-Z-]+)/;if(S.exec(a))return"watcherService ";if(w.exec(a))return"electron-crash-reporter";if(y.exec(a))return"winpty-process";if(m.exec(a))return"console-window-host (Windows internal process)";let i=o.exec(a);if(i&&i.length===2)return i[1]==="renderer"?D.exec(a)?"shared-process":"window":i[1];const t=/[a-zA-Z-]+\.js/g;let n="";do i=t.exec(a),i&&(n+=i+" ");while(i);return n&&a.indexOf("node ")<0&&a.indexOf("node.exe")<0?`electron_node ${n}`:a}if(process.platform==="win32"){const a=D=>D.indexOf("\\\\?\\")===0||D.indexOf("\\??\\")===0?D.substr(4):D.indexOf('"\\\\?\\')===0||D.indexOf('"\\??\\')===0?'"'+D.substr(5):D;new Promise((D,S)=>{G(["windows-process-tree"],D,S)}).then(D=>{D.getProcessList(L,S=>{D.getProcessCpuUsage(S,w=>{const y=new Map;w.forEach(m=>{const o=a(m.commandLine||"");y.set(m.pid,{name:b(o),cmd:o,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),p=y.get(L),p?(y.forEach(m=>{const o=y.get(m.ppid);o&&(o.children||(o.children=[]),o.children.push(m))}),y.forEach(m=>{m.children&&(m.children=m.children.sort((o,i)=>o.pid-i.pid))}),P(p)):g(new Error(`Root process ${L} not found`))})},D.ProcessDataFlag.CommandLine|D.ProcessDataFlag.Memory)})}else{function I(){let a=[p];const D=[];for(;a.length;){const w=a.shift();w&&(D.push(w.pid),w.children&&(a=a.concat(w.children)))}let S=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);S+=" "+D.join(" "),(0,v.exec)(S,{},(w,y,m)=>{if(w||m)g(w||new Error(m.toString()));else{const o=y.toString().split(`
`);for(let i=0;i<D.length;i++){const t=C.get(D[i]);t.load=parseFloat(o[i])}if(!p){g(new Error(`Root process ${L} not found`));return}P(p)}})}(0,v.exec)("which ps",{},(a,D,S)=>{if(a||S)if(process.platform!=="linux")g(a||new Error(S.toString()));else{const w=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);(0,v.exec)(w,{},(y,m,o)=>{y||o?g(y||new Error(o.toString())):(R(m,d),I())})}else{const w=D.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${w} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,o,i)=>{m||i&&!i.includes("screen size is bogus")?g(m||new Error(i.toString())):(R(o,d),process.platform==="linux"?I():p?P(p):g(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=k;function R(L,P){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=L.toString().split(`
`);for(const C of p){const d=g.exec(C.trim());d&&d.length===6&&P(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}}),function(){"use strict";function G(e,v,T){function k(){let R=process.env.VSCODE_APPDATA;if(!R)switch(process.platform){case"win32":if(R=process.env.APPDATA,!R){const L=process.env.USERPROFILE;if(typeof L!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");R=e.join(L,"AppData","Roaming")}break;case"darwin":R=e.join(v.homedir(),"Library","Application Support");break;case"linux":R=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(R,T)}return{getDefaultUserDataPath:k}}if(typeof define=="function")define(Q[96],Z([0,202,38,16,11]),function(e,v,T,k,R){const L=R.dirname(k.FileAccess.asFileUri("",e)),P=e.__$__nodeRequire(R.joinPath(L,"package.json").fsPath);return G(v,T,P.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../package.json"),v=require("path"),T=require("os");module.exports=G(v,T,e.name)}else throw new Error("Unknown context")}(),define(Q[97],Z([0,1,8,27,7,65,2,23]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function g(d,b,I){return C({path:d,isDirectory:!1},b,I)}e.watchFile=g;function p(d,b,I){return C({path:d,isDirectory:!0},b,I)}e.watchFolder=p,e.CHANGE_BUFFER_DELAY=100;function C(d,b,I){const a=(0,v.basename)(d.path),D=new Map;let S=!1,w=[(0,L.toDisposable)(()=>{D.forEach(y=>(0,L.dispose)(y)),D.clear()})];try{const y=(0,T.watch)(d.path);w.push((0,L.toDisposable)(()=>{y.removeAllListeners(),y.close()}));const m=new Set;d.isDirectory&&(0,P.readdir)(d.path).then(o=>o.forEach(i=>m.add(i))),y.on("error",(o,i)=>{S||I(`Failed to watch ${d.path} for changes using fs.watch() (${o}, ${i})`)}),y.on("change",(o,i)=>{if(!S){let t="";if(i&&(t=i.toString(),k.isMacintosh&&(t=(0,R.normalizeNFC)(t))),!(!t||o!=="change"&&o!=="rename")){const n=d.isDirectory?(0,v.join)(d.path,t):d.path;if(d.isDirectory)if(o==="rename"){const r=D.get(n);r&&(0,L.dispose)(r);const c=setTimeout(async()=>{D.delete(n);const s=await(0,P.exists)(n);if(!S){let l;s?m.has(t)?l="changed":(l="added",m.add(t)):(m.delete(t),l="deleted"),b(l,n)}},e.CHANGE_BUFFER_DELAY);D.set(n,(0,L.toDisposable)(()=>clearTimeout(c)))}else{let r;m.has(t)?r="changed":(r="added",m.add(t)),b(r,n)}else if(o==="rename"||t!==a){const r=setTimeout(async()=>{const c=await(0,P.exists)(n);S||(c?(b("changed",n),w=[C(d,b,I)]):b("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,L.dispose)(w),w=[(0,L.toDisposable)(()=>clearTimeout(r))]}else b("changed",n)}}})}catch(y){(0,P.exists)(d.path).then(m=>{m&&!S&&I(`Failed to watch ${d.path} for changes using fs.watch() (${y.toString()})`)})}return(0,L.toDisposable)(()=>{S=!0,w=(0,L.dispose)(w)})}}),define(Q[33],Z([0,1,3,2,6,29,15,22,18,17,89,21]),function(G,e,v,T,k,R,L,P,g,p,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function I(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function D(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(S||(S={}));class w{constructor(A){this.buffer=A,this.pos=0}read(A){const U=this.buffer.slice(this.pos,this.pos+A);return this.pos+=U.byteLength,U}}class y{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var m;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(m||(m={}));function o(F){const A=P.VSBuffer.alloc(4);return A.writeUInt32BE(F,0),A}function i(F){return F.read(4).readUInt32BE(0)}function t(F){const A=P.VSBuffer.alloc(1);return A.writeUInt8(F,0),A}const n={Undefined:t(m.Undefined),String:t(m.String),Buffer:t(m.Buffer),VSBuffer:t(m.VSBuffer),Array:t(m.Array),Object:t(m.Object)},r=typeof Buffer!="undefined";function c(F,A){if(typeof A=="undefined")F.write(n.Undefined);else if(typeof A=="string"){const U=P.VSBuffer.fromString(A);F.write(n.String),F.write(o(U.byteLength)),F.write(U)}else if(r&&Buffer.isBuffer(A)){const U=P.VSBuffer.wrap(A);F.write(n.Buffer),F.write(o(U.byteLength)),F.write(U)}else if(A instanceof P.VSBuffer)F.write(n.VSBuffer),F.write(o(A.byteLength)),F.write(A);else if(Array.isArray(A)){F.write(n.Array),F.write(o(A.length));for(const U of A)c(F,U)}else{const U=P.VSBuffer.fromString(JSON.stringify(A));F.write(n.Object),F.write(o(U.byteLength)),F.write(U)}}function s(F){switch(F.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return F.read(i(F)).toString();case m.Buffer:return F.read(i(F)).buffer;case m.VSBuffer:return F.read(i(F));case m.Array:{const U=i(F),N=[];for(let z=0;z<U;z++)N.push(s(F));return N}case m.Object:return JSON.parse(F.read(i(F)).toString())}}class l{constructor(A,U,N=null,z=1e3){this.protocol=A,this.ctx=U,this.logger=N,this.timeoutDelay=z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(A,U){this.channels.set(A,U),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const U=this.send([A.type]);this.logger&&this.logger.logOutgoing(U,0,1,D(A.type));return}case 201:case 202:case 204:case 203:{const U=this.send([A.type,A.id],A.data);this.logger&&this.logger.logOutgoing(U,A.id,1,D(A.type),A.data);return}}}send(A,U=void 0){const N=new y;return c(N,A),c(N,U),this.sendBuffer(N.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(U){return 0}}onRawMessage(A){const U=new w(A),N=s(U),z=s(U),H=N[0];switch(H){case 100:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${I(H)}: ${N[2]}.${N[3]}`,z),this.onPromise({type:H,id:N[1],channelName:N[2],name:N[3],arg:z});case 102:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${I(H)}: ${N[2]}.${N[3]}`,z),this.onEventListen({type:H,id:N[1],channelName:N[2],name:N[3],arg:z});case 101:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${I(H)}`),this.disposeActiveRequest({type:H,id:N[1]});case 103:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${I(H)}`),this.disposeActiveRequest({type:H,id:N[1]})}}onPromise(A){const U=this.channels.get(A.channelName);if(!U){this.collectPendingRequest(A);return}const N=new R.CancellationTokenSource;let z;try{z=U.call(this.ctx,A.name,A.arg,N.token)}catch(te){z=Promise.reject(te)}const H=A.id;z.then(te=>{this.sendResponse({id:H,data:te,type:201}),this.activeRequests.delete(A.id)},te=>{te instanceof Error?this.sendResponse({id:H,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.sendResponse({id:H,data:te,type:203}),this.activeRequests.delete(A.id)});const K=(0,T.toDisposable)(()=>N.cancel());this.activeRequests.set(A.id,K)}onEventListen(A){const U=this.channels.get(A.channelName);if(!U){this.collectPendingRequest(A);return}const N=A.id,H=U.listen(this.ctx,A.name,A.arg)(K=>this.sendResponse({id:N,data:K,type:204}));this.activeRequests.set(A.id,H)}disposeActiveRequest(A){const U=this.activeRequests.get(A.id);U&&(U.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let U=this.pendingRequests.get(A.channelName);U||(U=[],this.pendingRequests.set(A.channelName,U));const N=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);U.push({request:A,timeoutTimer:N})}flushPendingRequests(A){const U=this.pendingRequests.get(A);if(U){for(const N of U)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var h;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor(A,U=null){this.protocol=A,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=U}getChannel(A){const U=this;return{call(N,z,H){return U.isDisposed?Promise.reject(L.canceled()):U.requestPromise(A,N,z,H)},listen(N,z){return U.isDisposed?Promise.reject(L.canceled()):U.requestEvent(A,N,z)}}}requestPromise(A,U,N,z=R.CancellationToken.None){const H=this.lastRequestId++,te={id:H,type:100,channelName:A,name:U,arg:N};if(z.isCancellationRequested)return Promise.reject(L.canceled());let X;return new Promise((se,ce)=>{if(z.isCancellationRequested)return ce(L.canceled());const he=()=>{const Ae=ke=>{switch(ke.type){case 201:this.handlers.delete(H),se(ke.data);break;case 202:this.handlers.delete(H);const Fe=new Error(ke.data.message);Fe.stack=ke.data.stack,Fe.name=ke.data.name,ce(Fe);break;case 203:this.handlers.delete(H),ce(ke.data);break}};this.handlers.set(H,Ae),this.sendRequest(te)};let me=null;this.state===S.Idle?he():(me=(0,k.createCancelablePromise)(Ae=>this.whenInitialized()),me.then(()=>{me=null,he()}));const we=()=>{me?(me.cancel(),me=null):this.sendRequest({id:H,type:101}),ce(L.canceled())},Ie=z.onCancellationRequested(we);X=(0,T.combinedDisposable)((0,T.toDisposable)(we),Ie),this.activeRequests.add(X)}).finally(()=>{this.activeRequests.delete(X)})}requestEvent(A,U,N){const z=this.lastRequestId++,K={id:z,type:102,channelName:A,name:U,arg:N};let te=null;const X=new v.Emitter({onFirstListenerAdd:()=>{te=(0,k.createCancelablePromise)(se=>this.whenInitialized()),te.then(()=>{te=null,this.activeRequests.add(X),this.sendRequest(K)})},onLastListenerRemove:()=>{te?(te.cancel(),te=null):(this.activeRequests.delete(X),this.sendRequest({id:z,type:103}))}}),ie=se=>X.fire(se.data);return this.handlers.set(z,ie),X.event}sendRequest(A){switch(A.type){case 100:case 102:{const U=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger&&this.logger.logOutgoing(U,A.id,0,`${I(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const U=this.send([A.type,A.id]);this.logger&&this.logger.logOutgoing(U,A.id,0,I(A.type));return}}}send(A,U=void 0){const N=new y;return c(N,A),c(N,U),this.sendBuffer(N.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(U){return 0}}onBuffer(A){const U=new w(A),N=s(U),z=s(U),H=N[0];switch(H){case 200:return this.logger&&this.logger.logIncoming(A.byteLength,0,0,D(H)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],0,D(H),z),this.onResponse({type:N[0],id:N[1],data:z})}}onResponse(A){if(A.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const U=this.handlers.get(A.id);U&&U(A)}whenInitialized(){return this.state===S.Idle?Promise.resolve():v.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}e.ChannelClient=f;class E{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:U,onDidClientDisconnect:N})=>{v.Event.once(U.onMessage)(H=>{const K=new w(H),te=s(K),X=new l(U,te),ie=new f(U);this.channels.forEach((ce,he)=>X.registerChannel(he,ce));const se={channelServer:X,channelClient:ie,ctx:te};this._connections.add(se),this._onDidAddConnection.fire(se),N(()=>{X.dispose(),ie.dispose(),this._connections.delete(se),this._onDidRemoveConnection.fire(se)})})})}get connections(){const A=[];return this._connections.forEach(U=>A.push(U)),A}getChannel(A,U){const N=this;return{call(z,H,K){let te;if((0,p.isFunction)(U)){let ie=(0,g.getRandomElement)(N.connections.filter(U));te=ie?Promise.resolve(ie):v.Event.toPromise(v.Event.filter(N.onDidAddConnection,U))}else te=U.routeCall(N,z,H);const X=te.then(ie=>ie.channelClient.getChannel(A));return O(X).call(z,H,K)},listen(z,H){if((0,p.isFunction)(U))return N.getMulticastEvent(A,U,z,H);const K=U.routeEvent(N,z,H).then(te=>te.channelClient.getChannel(A));return O(K).listen(z,H)}}}getMulticastEvent(A,U,N,z){const H=this;let K=new T.DisposableStore;const te=new v.Emitter({onFirstListenerAdd:()=>{K=new T.DisposableStore;const X=new v.EventMultiplexer,ie=new Map,se=he=>{const we=he.channelClient.getChannel(A).listen(N,z),Ie=X.add(we);ie.set(he,Ie)},ce=he=>{const me=ie.get(he);!me||(me.dispose(),ie.delete(he))};H.connections.filter(U).forEach(se),v.Event.filter(H.onDidAddConnection,U)(se,void 0,K),H.onDidRemoveConnection(ce,void 0,K),X.event(te.fire,te,K),K.add(X)},onLastListenerRemove:()=>{K.dispose()}});return te.event}registerChannel(A,U){this.channels.set(A,U),this._connections.forEach(N=>{N.channelServer.registerChannel(A,U)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class u{constructor(A,U,N=null){const z=new y;c(z,U),A.send(z.buffer),this.channelClient=new f(A,N),this.channelServer=new l(A,U,N)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,U){this.channelServer.registerChannel(A,U)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=u;function O(F){return{call(A,U,N){return F.then(z=>z.call(A,U,N))},listen(A,U){const N=new v.Relay;return F.then(z=>N.input=z.listen(A,U)),N.event}}}e.getDelayedChannel=O;function _(F){let A=!1;return{call(U,N,z){return A?F.call(U,N,z):(0,k.timeout)(0).then(()=>A=!0).then(()=>F.call(U,N,z))},listen(U,N){if(A)return F.listen(U,N);const z=new v.Relay;return(0,k.timeout)(0).then(()=>A=!0).then(()=>z.input=F.listen(U,N)),z.event}}}e.getNextTickChannel=_;class q{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const U of A.connections)if(await Promise.resolve(this.fn(U.ctx)))return Promise.resolve(U);return await v.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=q;var x;(function(F){function A(z,H){const K=z,te=H&&H.disableMarshalling,X=new Map;for(const ie in K)N(ie)&&X.set(ie,v.Event.buffer(K[ie],!0));return new class{listen(ie,se){const ce=X.get(se);if(ce)return ce;throw new Error(`Event not found: ${se}`)}call(ie,se,ce){const he=K[se];if(typeof he=="function"){if(!te&&Array.isArray(ce))for(let me=0;me<ce.length;me++)ce[me]=(0,C.revive)(ce[me]);return he.apply(K,ce)}throw new Error(`Method not found: ${se}`)}}}F.fromService=A;function U(z,H){const K=H&&H.disableMarshalling;return new Proxy({},{get(te,X){var ie;if(typeof X=="string")return((ie=H==null?void 0:H.properties)===null||ie===void 0?void 0:ie.has(X))?H.properties.get(X):N(X)?z.listen(X):async function(...se){let ce;H&&!(0,p.isUndefinedOrNull)(H.context)?ce=[H.context,...se]:ce=se;const he=await z.call(X,ce);return K?he:(0,C.revive)(he)};throw new Error(`Property not found: ${String(X)}`)}})}F.toService=U;function N(z){return z[0]==="o"&&z[1]==="n"&&d.isUpperAsciiLetter(z.charCodeAt(2))}})(x=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let A=F.toString();if(A!=="[object Object]")return A}return F}function W(F){return Array.isArray(F)?F.map($):$(F)}function B(F,A,U,N,z,H,K){K=W(K);const te=j[z],X=te[N%te.length];let ie=[`%c[${F}]%c[${String(A).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${X}`];/\($/.test(H)?(ie=ie.concat(K),ie.push(")")):ie.push(K),console.log.apply(console,ie)}e.logWithColors=B;class M{constructor(A,U){this._outgoingPrefix=A,this._incomingPrefix=U,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,U,N,z,H){this._totalOutgoing+=A,B(this._outgoingPrefix,this._totalOutgoing,A,U,N,z,H)}logIncoming(A,U,N,z,H){this._totalIncoming+=A,B(this._incomingPrefix,this._totalIncoming,A,U,N,z,H)}}e.IPCLogger=M}),define(Q[98],Z([0,1,3,33,22]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(g){this.port=g,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",p=>k.VSBuffer.wrap(p.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class L extends T.IPCClient{constructor(g,p){const C=new R(g);super(C,p);this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=L}),define(Q[99],Z([0,1,100,3,33,98]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class L extends k.IPCServer{static getOnDidClientConnect(){const g=T.Event.fromNodeEventEmitter(v.ipcRenderer,"vscode:createMessageChannel",(p,C)=>C);return T.Event.map(g,p=>{const{port1:C,port2:d}=new MessageChannel,I={protocol:new R.Protocol(C),onDidClientDisconnect:T.Event.fromDOMEventEmitter(C,"close")};return v.ipcRenderer.postMessage("vscode:createMessageChannelResult",p,[d]),I})}constructor(){super(L.getOnDidClientConnect())}}e.Server=L}),define(Q[101],Z([0,1,15,22]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(P,g){P.proxyAuthorization&&(P.headers=Object.assign(Object.assign({},P.headers||{}),{"Proxy-Authorization":P.proxyAuthorization}));const p=new XMLHttpRequest;return new Promise((C,d)=>{p.open(P.type||"GET",P.url||"",!0,P.user,P.password),R(p,P),p.responseType="arraybuffer",p.onerror=b=>d(new Error(p.statusText&&"XHR failed: "+p.statusText||"XHR failed")),p.onload=b=>{C({res:{statusCode:p.status,headers:L(p)},stream:(0,T.bufferToStream)(T.VSBuffer.wrap(new Uint8Array(p.response)))})},p.ontimeout=b=>d(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(p.timeout=P.timeout),p.send(P.data),g.onCancellationRequested(()=>{p.abort(),d((0,v.canceled)())})})}e.request=k;function R(P,g){if(g.headers){e:for(let p in g.headers){switch(p){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(p,g.headers[p])}}}function L(P){const g=Object.create(null);for(const p of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(p){const C=p.indexOf(":");g[p.substr(0,C).trim().toLowerCase()]=p.substr(C+1).trim()}return g}}),define(Q[102],Z([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.context=e.process=e.crashReporter=e.webFrame=e.ipcMessagePort=e.ipcRenderer=void 0,e.ipcRenderer=v.globals.vscode.ipcRenderer,e.ipcMessagePort=v.globals.vscode.ipcMessagePort,e.webFrame=v.globals.vscode.webFrame,e.crashReporter=v.globals.vscode.crashReporter,e.process=v.globals.vscode.process,e.context=v.globals.vscode.context}),define(Q[67],Z([0,1,2,3,6,17]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var L;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=e.StorageHint||(e.StorageHint={}));var P;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(P||(P={}));class g extends v.Disposable{constructor(d,b=Object.create(null)){super();this.database=d,this.options=b,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){var b,I;(b=d.changed)===null||b===void 0||b.forEach((a,D)=>this.accept(D,a)),(I=d.deleted)===null||I===void 0||I.forEach(a=>this.accept(a,void 0))}accept(d,b){if(this.state!==P.Closed){let I=!1;(0,R.isUndefinedOrNull)(b)?I=this.cache.delete(d):this.cache.get(d)!==b&&(this.cache.set(d,b),I=!0),I&&this._onDidChangeStorage.fire(d)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,b){const I=this.cache.get(d);return(0,R.isUndefinedOrNull)(I)?b:I}getBoolean(d,b){const I=this.get(d);return(0,R.isUndefinedOrNull)(I)?b:I==="true"}getNumber(d,b){const I=this.get(d);return(0,R.isUndefinedOrNull)(I)?b:parseInt(I,10)}async set(d,b){if(this.state!==P.Closed){if((0,R.isUndefinedOrNull)(b))return this.delete(d);const I=String(b);if(this.cache.get(d)!==I)return this.cache.set(d,I),this.pendingInserts.set(d,I),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(d){if(this.state!==P.Closed&&!!this.cache.delete(d))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{var b;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(b=this.whenFlushedCallbacks.pop())===null||b===void 0||b()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((b,I)=>this.items.set(I,b)),d.delete&&d.delete.forEach(b=>this.items.delete(b))}async close(){}}e.InMemoryStorageDatabase=p}),define(Q[103],Z([12,13]),function(G,e){return G.create("vs/base/common/date",e)}),define(Q[54],Z([0,1,103]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,k=T*60,R=k*24,L=R*7,P=R*30,g=R*365;function p(d,b){typeof d!="number"&&(d=d.getTime());const I=Math.round((new Date().getTime()-d)/1e3);if(I<-30)return(0,v.localize)(0,null,p(new Date().getTime()+I*1e3,!1));if(I<30)return(0,v.localize)(1,null);let a;return I<T?(a=I,b?a===1?(0,v.localize)(2,null,a):(0,v.localize)(3,null,a):a===1?(0,v.localize)(4,null,a):(0,v.localize)(5,null,a)):I<k?(a=Math.floor(I/T),b?a===1?(0,v.localize)(6,null,a):(0,v.localize)(7,null,a):a===1?(0,v.localize)(8,null,a):(0,v.localize)(9,null,a)):I<R?(a=Math.floor(I/k),b?a===1?(0,v.localize)(10,null,a):(0,v.localize)(11,null,a):a===1?(0,v.localize)(12,null,a):(0,v.localize)(13,null,a)):I<L?(a=Math.floor(I/R),b?a===1?(0,v.localize)(14,null,a):(0,v.localize)(15,null,a):a===1?(0,v.localize)(16,null,a):(0,v.localize)(17,null,a)):I<P?(a=Math.floor(I/L),b?a===1?(0,v.localize)(18,null,a):(0,v.localize)(19,null,a):a===1?(0,v.localize)(20,null,a):(0,v.localize)(21,null,a)):I<g?(a=Math.floor(I/P),b?a===1?(0,v.localize)(22,null,a):(0,v.localize)(23,null,a):a===1?(0,v.localize)(24,null,a):(0,v.localize)(25,null,a)):(a=Math.floor(I/g),b?a===1?(0,v.localize)(26,null,a):(0,v.localize)(27,null,a):a===1?(0,v.localize)(28,null,a):(0,v.localize)(29,null,a))}e.fromNow=p;function C(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(Q[104],Z([12,13]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(Q[43],Z([0,1,104,17,18]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(p,C){return C&&(p.stack||p.stacktrace)?v.localize(0,null,P(p),L(p.stack)||L(p.stacktrace)):P(p)}function L(p){return Array.isArray(p)?p.join(`
`):p}function P(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?v.localize(1,null,p.message):p.message||v.localize(2,null)}function g(p=null,C=!1){if(!p)return v.localize(3,null);if(Array.isArray(p)){const d=k.coalesce(p),b=g(d[0],C);return d.length>1?v.localize(4,null,b,d.length):b}if(T.isString(p))return p;if(p.detail){const d=p.detail;if(d.error)return R(d.error,C);if(d.exception)return R(d.exception,C)}return p.stack?R(p,C):p.message?p.message:v.localize(5,null)}e.toErrorMessage=g}),define(Q[105],Z([12,13]),function(G,e){return G.create("vs/base/node/processes",e)}),define(Q[106],Z([0,1,8,27,23,48,105,17,26,42,7,66,16]),function(G,e,v,T,k,R,L,P,g,p,C,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function I(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(o,i){if(C.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};i&&(t.cwd=i);const n=R.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(r=>{n.once("error",c=>{r({success:!1,error:c})}),n.once("exit",(c,s)=>{r(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?I(t.status):1})}else if(C.isLinux||C.isMacintosh)try{const t=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(n=>{R.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,c,s)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function D(o=process.env){return o.comspec||"cmd.exe"}e.getWindowsShell=D;class S{constructor(i,t,n,r){if(t!==void 0&&n!==void 0&&r!==void 0)this.cmd=i,this.args=t,this.shell=n,this.options=r;else{const c=i;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(process.env).forEach(s=>{c[s]=process.env[s]}),Object.keys(this.options.env).forEach(s=>{c[s]=this.options.env[s]}),this.options.env=c}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const t=i.lastIndexOf(v.sep);return t!==-1&&(i=i.substring(t+1)),S.WellKnowCommands[i]?i:"other"}start(i){return C.isWindows&&(this.options&&this.options.cwd&&p.isUNC(this.options.cwd)||!this.options&&p.isUNC(process.cwd()))?Promise.reject(new Error(L.localize(0,null))):this.useExec().then(t=>{let n,r;const c=new Promise((s,l)=>{n=s,r=l});if(t){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=R.exec(s,this.options,(l,h,f)=>{this.childProcess=null;const E=l;E&&E.killed?r({killed:this.terminateRequested,stdout:h.toString(),stderr:f.toString()}):this.handleExec(n,i,l,h,f)})}else{let s=null;const l=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,n,i,r);const f={terminated:this.terminateRequested};P.isNumber(h)&&(f.cmdCode=h),n(f)};if(this.shell&&C.isWindows){const h=g.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let f=!1,E=!1;const u=[];let O=this.ensureQuotes(this.cmd);u.push(O.value),f=O.quoted,this.args&&this.args.forEach(q=>{O=this.ensureQuotes(q),u.push(O.value),E=E&&O.quoted});const _=["/s","/c"];f?E?_.push('"'+u.join(" ")+'"'):u.length>1?_.push('"'+u[0]+'" '+u.slice(1).join(" ")):_.push('"'+u[0]+'"'):_.push(u.join(" ")),s=R.spawn(D(),_,h)}else this.cmd&&(s=R.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(P.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",h=>{this.childProcess=null,r({terminated:this.terminateRequested,error:h})}),s.pid&&(this.childProcess.on("close",l),this.handleSpawn(s,n,i,r,!0)))}return c})}handleClose(i,t,n,r){}ensureQuotes(i){return S.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,a(i,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!C.isWindows)return i(!1);const t=R.spawn(D(),["/s","/c"]);t.on("error",n=>i(!0)),t.on("exit",n=>i(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class w extends S{constructor(i,t,n,r){super(i,t,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,t,n,r,c){[r,c].forEach((s,l)=>{const h=new d.LineDecoder;h.write(s).forEach(u=>{t({line:u,source:l===0?0:1})});const E=h.end();E&&t({line:E,source:l===0?0:1})}),i({terminated:this.terminateRequested,error:n})}handleSpawn(i,t,n,r,c){const s=new d.LineDecoder,l=new d.LineDecoder;i.stdout.on("data",h=>{s.write(h).forEach(E=>n({line:E,source:0}))}),i.stderr.on("data",h=>{l.write(h).forEach(E=>n({line:E,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=l}handleClose(i,t,n,r){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&n({line:c,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&n({line:s,source:1})}}e.LineProcess=w;function y(o){let i=[],t=!1;const n=function(r){if(t){i.push(r);return}(!o.send(r,s=>{if(s&&console.error(s),t=!1,i.length>0){const l=i.slice(0);i=[],l.forEach(h=>n(h))}})||C.isWindows)&&(t=!0)};return{send:n}}e.createQueuedSender=y;var m;(function(o){async function i(t,n,r){if(v.isAbsolute(t))return t;if(n===void 0&&(n=process.cwd()),v.dirname(t)!=="."||(r===void 0&&P.isString(process.env.PATH)&&(r=process.env.PATH.split(v.delimiter)),r===void 0||r.length===0))return v.join(n,t);async function s(l){return await k.exists(l)?!(await T.promises.stat(l)).isDirectory():!1}for(let l of r){let h;if(v.isAbsolute(l)?h=v.join(l,t):h=v.join(n,l,t),await s(h))return h;let f=h+".com";if(await s(f)||(f=h+".exe",await s(f)))return f}return v.join(n,t)}o.findExecutable=i})(m=e.win32||(e.win32={}))}),define(Q[49],Z([0,1,48,2,6,26,3,106,33,88,29,15,22,7]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class a extends g.ChannelServer{constructor(w){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch(m){}},onMessage:L.Event.fromNodeEventEmitter(process,"message",y=>b.VSBuffer.wrap(Buffer.from(y,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=a;class D{constructor(w,y){this.modulePath=w,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new L.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new k.Delayer(m),this.child=null,this._client=null}getChannel(w){const y=this;return{call(m,o,i){return y.requestPromise(w,m,o,i)},listen(m,o){return y.requestEvent(w,m,o)}}}requestPromise(w,y,m,o=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(d.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(w),t=(0,k.createCancelablePromise)(c=>i.call(y,m,c)),n=o.onCancellationRequested(()=>t.cancel()),r=(0,T.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(w,y,m){if(!this.disposeDelayer)return L.Event.None;this.disposeDelayer.cancel();let o;const i=new L.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(w).listen(y,m)(i.fire,i),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env=Object.assign(Object.assign({},(0,R.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(y.env=Object.assign(Object.assign({},y.env),this.options.env)),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),I.isMacintosh&&y.env&&delete y.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,w,y);const m=new L.Emitter;L.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,p.isRemoteConsoleLog)(s)){(0,p.log)(s,`IPC Library: ${this.options.serverName}`);return}m.fire(b.VSBuffer.wrap(Buffer.from(s,"base64")))});const i=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,t=s=>this.child&&this.child.connected&&i.send(s.buffer.toString("base64")),n=m.event,r={send:t,onMessage:n};this._client=new g.ChannelClient(r);const c=()=>this.disposeClient();process.once("exit",c),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,l)=>{process.removeListener("exit",c),this.activeRequests.forEach(h=>(0,T.dispose)(h)),this.activeRequests.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:l})})}return this._client}getCachedChannel(w){let y=this.channels.get(w);return y||(y=this.client.getChannel(w),this.channels.set(w,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=D}),define(Q[107],Z([12,13]),function(G,e){return G.create("vs/base/node/zip",e)}),define(Q[108],Z([12,13]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[109],Z([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[110],Z([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Q[111],Z([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Q[112],Z([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Q[113],Z([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Q[114],Z([12,13]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[115],Z([12,13]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(Q[116],Z([12,13]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(Q[117],Z([12,13]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(Q[118],Z([12,13]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[119],Z([12,13]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(Q[120],Z([12,13]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[121],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Q[122],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Q[123],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Q[124],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Q[125],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Q[126],Z([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Q[127],Z([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const T=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,R=/^([^@]+@)?([^:]+)(:\d+)?$/,L=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,g=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function p(S){const w=S.match(L);return w?w[1]:null}function C(S){if(S.indexOf("://")===-1){const w=S.match(T);return w?p(w[2]):null}try{const w=v.URI.parse(S);if(w.authority)return p(w.authority)}catch(w){}return null}function d(S,w){const y=new Set;let m;for(;m=P.exec(S);){const i=C(m[1]);i&&y.add(i)}const o=new Set(w);return Array.from(y).map(i=>o.has(i)?i:i.replace(g,"a"))}e.getDomainsOfRemotes=d;function b(S){const w=S.match(R);return w?w[2]:null}function I(S,w,y){return S&&w?(y&&w.endsWith(".git")&&(w=w.substr(0,w.length-4)),w.indexOf("/")===0?`${S}${w}`:`${S}/${w}`):null}function a(S,w){if(S.indexOf("://")===-1){const y=S.match(k);if(y)return I(y[2],y[3],w)}try{const y=v.URI.parse(S);if(y.authority)return I(b(y.authority),y.path,w)}catch(y){}return null}function D(S,w=!1){const y=[];let m;for(;m=P.exec(S);){const o=a(m[1],w);o&&y.push(o)}return y}e.getRemotes=D}),define(Q[128],Z([0,1,3,5,91,26,2]),function(G,e,v,T,k,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(a,D){return T.URI.revive(D?D.transformIncoming(a):a)}function g(a,D){return D?D.transformOutgoingURI(a):a}function p(a,D){D=D||k.DefaultURITransformer;const S=a.manifest,w=(0,k.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},a),{manifest:void 0}),D);return Object.assign(Object.assign({},w),{manifest:S})}function C(a,D){return D?(0,R.cloneAndChange)(a,S=>S instanceof T.URI?D.transformOutgoingURI(S):void 0):a}class d{constructor(D,S){this.service=D,this.getUriTransformer=S,this.onInstallExtension=v.Event.buffer(D.onInstallExtension,!0),this.onDidInstallExtension=v.Event.buffer(D.onDidInstallExtension,!0),this.onUninstallExtension=v.Event.buffer(D.onUninstallExtension,!0),this.onDidUninstallExtension=v.Event.buffer(D.onDidUninstallExtension,!0)}listen(D,S){const w=this.getUriTransformer(D);switch(S){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return v.Event.map(this.onDidInstallExtension,y=>Object.assign(Object.assign({},y),{local:y.local?C(y.local,w):y.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(D,S,w){const y=this.getUriTransformer(D);switch(S){case"zip":return this.service.zip(p(w[0],y)).then(m=>g(m,y));case"unzip":return this.service.unzip(P(w[0],y));case"install":return this.service.install(P(w[0],y));case"getManifest":return this.service.getManifest(P(w[0],y));case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(p(w[0],y),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(p(w[0],y));case"getInstalled":return this.service.getInstalled(w[0]).then(m=>m.map(o=>C(o,y)));case"updateMetadata":return this.service.updateMetadata(p(w[0],y),w[1]).then(m=>C(m,y));case"updateExtensionScope":return this.service.updateExtensionScope(p(w[0],y),w[1]).then(m=>C(m,y));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class b extends L.Disposable{constructor(D){super();this.channel=D,this._onInstallExtension=this._register(new v.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new v.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new v.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new v.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(S=>this._onInstallExtension.fire(S))),this._register(this.channel.listen("onDidInstallExtension")(S=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},S),{local:S.local?p(S.local,null):S.local})))),this._register(this.channel.listen("onUninstallExtension")(S=>this._onUninstallExtension.fire(S))),this._register(this.channel.listen("onDidUninstallExtension")(S=>this._onDidUninstallExtension.fire(S)))}zip(D){return Promise.resolve(this.channel.call("zip",[D]).then(S=>T.URI.revive(S)))}unzip(D){return Promise.resolve(this.channel.call("unzip",[D]))}install(D){return Promise.resolve(this.channel.call("install",[D])).then(S=>p(S,null))}getManifest(D){return Promise.resolve(this.channel.call("getManifest",[D]))}async canInstall(D){return!0}installFromGallery(D,S){return Promise.resolve(this.channel.call("installFromGallery",[D,S])).then(w=>p(w,null))}uninstall(D,S){return Promise.resolve(this.channel.call("uninstall",[D,S]))}reinstallFromGallery(D){return Promise.resolve(this.channel.call("reinstallFromGallery",[D]))}getInstalled(D=null){return Promise.resolve(this.channel.call("getInstalled",[D])).then(S=>S.map(w=>p(w,null)))}updateMetadata(D,S){return Promise.resolve(this.channel.call("updateMetadata",[D,S])).then(w=>p(w,null))}updateExtensionScope(D,S){return Promise.resolve(this.channel.call("updateExtensionScope",[D,S])).then(w=>p(w,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=b;class I{constructor(D){this.service=D}listen(D,S){throw new Error("Invalid listen")}call(D,S,w){switch(S){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=I}),define(Q[129],Z([0,1,26]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function k(R,L){const P=g=>{if(typeof g=="string"){const p=T.exec(g);if(!!p)return L[p[1]]||g}};return(0,v.cloneAndChange)(R,P)}e.localizeManifest=k}),define(Q[130],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class v{constructor(R){this.channel=R}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(R,L,P,g){return this.channel.call("promptImportantExtensionsInstallNotification",[R,L,P,g])}promptWorkspaceRecommendations(R){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=v;class T{constructor(R){this.service=R}listen(R,L){throw new Error(`Event not found: ${L}`)}call(R,L,P){switch(L){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=T}),define(Q[68],Z([0,1,114]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function k(d){return d=d.trim(),d==="*"||T.test(d)}e.isValidVersionStr=k;function R(d){if(!k(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=d.match(T);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=R;function L(d){if(!d)return null;let b=d.majorBase,I=d.majorMustEqual,a=d.minorBase,D=d.minorMustEqual,S=d.patchBase,w=d.patchMustEqual;return d.hasCaret&&(b===0||(D=!1),w=!1),{majorBase:b,majorMustEqual:I,minorBase:a,minorMustEqual:D,patchBase:S,patchMustEqual:w,isMinimum:d.hasGreaterEquals}}e.normalizeVersion=L;function P(d,b){let I;typeof d=="string"?I=L(R(d)):I=d;let a;if(typeof b=="string"?a=L(R(b)):a=b,!I||!a)return!1;let D=I.majorBase,S=I.minorBase,w=I.patchBase,y=a.majorBase,m=a.minorBase,o=a.patchBase,i=a.majorMustEqual,t=a.minorMustEqual,n=a.patchMustEqual;return a.isMinimum?D>y?!0:D<y?!1:S>m?!0:S<m?!1:w>=o:(D===1&&y===0&&(!i||!t||!n)&&(y=1,m=0,o=0,i=!0,t=!1,n=!1),D<y?!1:D>y?!i:S<m?!1:S>m?!t:w<o?!1:w>o?!n:!0)}e.isValidVersion=P;function g(d,b,I){return b.isBuiltin||typeof b.main=="undefined"?!0:C(d,b.engines.vscode,I)}e.isValidExtensionVersion=g;function p(d,b){return d==="*"||C(b,d)}e.isEngineValid=p;function C(d,b,I=[]){let a=L(R(b));if(!a)return I.push(v.localize(0,null,b)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return I.push(v.localize(1,null,b)),!1}else if(!a.majorMustEqual)return I.push(v.localize(2,null,b)),!1;return P(d,a)?!0:(I.push(v.localize(3,null,d,b)),!1)}e.isVersionValid=C}),define(Q[131],Z([0,1,33,49,2,16]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L extends k.Disposable{constructor(g,p,C,d){super();this.folders=g,this.onDidFilesChange=p,this.onLogMessage=C,this.verboseLogging=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new T.Client(R.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(g.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.setFolders(this.folders)}setVerboseLogging(g){this.verboseLogging=g,!this.isDisposed&&this.service&&this.service.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${g}`})}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=L,L.MAX_RESTARTS=5}),define(Q[132],Z([0,1,33,49,2,16]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L extends k.Disposable{constructor(g,p,C,d,b={}){super();this.folders=g,this.onDidFilesChange=p,this.onLogMessage=C,this.verboseLogging=d,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new T.Client(R.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(g.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.service.setRoots(this.folders)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${g}`})}setVerboseLogging(g){this.verboseLogging=g,this.service&&this.service.setVerboseLogging(g)}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=L,L.MAX_RESTARTS=5}),define(Q[133],Z([0,1,48,66,90,16]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class L{constructor(g,p,C,d,b){this.watchedFolder=g,this.eventCallback=C,this.logCallback=d,this.verboseLogging=b,this.restartCounter=0,Array.isArray(p)?this.ignored=p.map(I=>k.parse(I)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${g}`),this.startWatcher()}startWatcher(){const g=[this.watchedFolder];this.verboseLogging&&g.push("-verbose"),this.handle=v.spawn(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,g);const p=new T.LineDecoder;this.handle.stdout.on("data",C=>{const d=[];p.write(C).forEach(b=>{const I=b.split("|");if(I.length===2){const a=Number(I[0]),D=I[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(S=>S(D))){this.verboseLogging&&this.log(D);return}d.push({type:L.changeTypeMap[a],path:D})}else this.log(I[1])}}),d.length>0&&this.eventCallback(d)}),this.handle.on("error",C=>this.onError(C)),this.handle.stderr.on("data",C=>this.onError(C)),this.handle.on("exit",(C,d)=>this.onExit(C,d))}onError(g){this.error("process error: "+g.toString())}onExit(g,p){this.handle&&(this.error(`terminated unexpectedly (code: ${g}, signal: ${p})`),this.restartCounter<=L.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(g){this.logCallback({type:"error",message:`[File Watcher (C#)] ${g}`})}log(g){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${g}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=L,L.MAX_RESTARTS=5,L.changeTypeMap=[0,1,2]}),define(Q[134],Z([0,1,133,8,21]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class R{constructor(P,g,p,C){this.onDidFilesChange=g,this.onLogMessage=p,this.verboseLogging=C,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,k.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=R}),define(Q[50],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(R,L=[],P=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=v;const T=(k,...R)=>new v(k,R);e.createSyncDescriptor=T}),define(Q[135],Z([0,1,50]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function k(L,P,g){P instanceof v.SyncDescriptor||(P=new v.SyncDescriptor(P,[],g)),T.push([L,P])}e.registerSingleton=k;function R(){return T}e.getSingletonServiceDescriptors=R}),define(Q[136],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=v;class T{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let L of this._nodes.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const P=this.lookupOrInsertNode(R),g=this.lookupOrInsertNode(L);P.outgoing.set(this._hashFn(L),g),g.incoming.set(this._hashFn(R),P)}removeNode(R){const L=this._hashFn(R);this._nodes.delete(L);for(let P of this._nodes.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(R){const L=this._hashFn(R);let P=this._nodes.get(L);return P||(P=new v(R),this._nodes.set(L,P)),P}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[L,P]of this._nodes)R.push(`${L}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return R.join(`
`)}}e.Graph=T}),define(Q[4],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function g(p){return p[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=g})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function T(P,g,p,C){g[v.DI_TARGET]===g?g[v.DI_DEPENDENCIES].push({id:P,index:p,optional:C}):(g[v.DI_DEPENDENCIES]=[{id:P,index:p,optional:C}],g[v.DI_TARGET]=g)}function k(P){if(v.serviceIds.has(P))return v.serviceIds.get(P);const g=function(p,C,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(g,p,d,!1)};return g.toString=()=>P,v.serviceIds.set(P,g),g}e.createDecorator=k;function R(P){return P}e.refineServiceDecorator=R;function L(P){return function(g,p,C){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(P,g,C,!0)}}e.optional=L}),define(Q[137],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,v.createDecorator)("checksumService")}),define(Q[138],Z([0,1,21,4,7]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=k.userAgent||"";const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",k.isMacintosh),L.set("isLinux",k.isLinux),L.set("isWindows",k.isWindows),L.set("isWeb",k.isWeb),L.set("isMacNative",k.isMacintosh&&!k.isWeb),L.set("isEdge",R.indexOf("Edg/")>=0),L.set("isFirefox",R.indexOf("Firefox")>=0),L.set("isChrome",R.indexOf("Chrome")>=0),L.set("isSafari",R.indexOf("Safari")>=0),L.set("isIPad",R.indexOf("iPad")>=0);const P=Object.prototype.hasOwnProperty;var g;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(g=e.ContextKeyExprType||(e.ContextKeyExprType={}));class p{static false(){return d.INSTANCE}static true(){return b.INSTANCE}static has(u){return I.create(u)}static equals(u,O){return a.create(u,O)}static notEquals(u,O){return w.create(u,O)}static regex(u,O){return n.create(u,O)}static in(u,O){return D.create(u,O)}static not(u){return y.create(u)}static and(...u){return c.create(u)}static or(...u){return s.create(u)}static greater(u,O){return m.create(u,O)}static less(u,O){return i.create(u,O)}static deserialize(u,O=!1){if(!!u)return this._deserializeOrExpression(u,O)}static _deserializeOrExpression(u,O){let _=u.split("||");return s.create(_.map(q=>this._deserializeAndExpression(q,O)))}static _deserializeAndExpression(u,O){let _=u.split("&&");return c.create(_.map(q=>this._deserializeOne(q,O)))}static _deserializeOne(u,O){if(u=u.trim(),u.indexOf("!=")>=0){let _=u.split("!=");return w.create(_[0].trim(),this._deserializeValue(_[1],O))}if(u.indexOf("==")>=0){let _=u.split("==");return a.create(_[0].trim(),this._deserializeValue(_[1],O))}if(u.indexOf("=~")>=0){let _=u.split("=~");return n.create(_[0].trim(),this._deserializeRegexValue(_[1],O))}if(u.indexOf(" in ")>=0){let _=u.split(" in ");return D.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const _=u.split(">=");return o.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const _=u.split(">");return m.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const _=u.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const _=u.split("<");return i.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(u)?y.create(u.substr(1).trim()):I.create(u)}static _deserializeValue(u,O){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let _=/^'([^']*)'$/.exec(u);return _?_[1].trim():u}static _deserializeRegexValue(u,O){if((0,v.isFalsyOrWhitespace)(u)){if(O)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=u.indexOf("/"),q=u.lastIndexOf("/");if(_===q||_<0){if(O)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let x=u.slice(_+1,q),j=u[q+1]==="i"?"i":"";try{return new RegExp(x,j)}catch($){if(O)throw new Error(`bad regexp-value '${u}', parse error: ${$}`);return console.warn(`bad regexp-value '${u}', parse error: ${$}`),null}}}e.ContextKeyExpr=p;function C(E,u){return E.cmp(u)}class d{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class b{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class I{constructor(u){this.key=u,this.type=2}static create(u){const O=L.get(u);return typeof O=="boolean"?O?b.INSTANCE:d.INSTANCE:new I(u)}cmp(u){return u.type!==this.type?this.type-u.type:h(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return y.create(this.key)}}e.ContextKeyDefinedExpr=I;class a{constructor(u,O){this.key=u,this.value=O,this.type=4}static create(u,O){if(typeof O=="boolean")return O?I.create(u):y.create(u);const _=L.get(u);return typeof _=="boolean"?O===(_?"true":"false")?b.INSTANCE:d.INSTANCE:new a(u,O)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class D{constructor(u,O){this.key=u,this.valueKey=O,this.type=10}static create(u,O){return new D(u,O)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}evaluate(u){const O=u.getValue(this.valueKey),_=u.getValue(this.key);return Array.isArray(O)?O.indexOf(_)>=0:typeof _=="string"&&typeof O=="object"&&O!==null?P.call(O,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=D;class S{constructor(u){this._actual=u,this.type=11}static create(u){return new S(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new S(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(u,O){this.key=u,this.value=O,this.type=5}static create(u,O){if(typeof O=="boolean")return O?y.create(u):I.create(u);const _=L.get(u);return typeof _=="boolean"?O===(_?"true":"false")?d.INSTANCE:b.INSTANCE:new w(u,O)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class y{constructor(u){this.key=u,this.type=3}static create(u){const O=L.get(u);return typeof O=="boolean"?O?d.INSTANCE:b.INSTANCE:new y(u)}cmp(u){return u.type!==this.type?this.type-u.type:h(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return I.create(this.key)}}e.ContextKeyNotExpr=y;class m{constructor(u,O){this.key=u,this.value=O,this.type=12}static create(u,O){return new m(u,O)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=m;class o{constructor(u,O){this.key=u,this.value=O,this.type=13}static create(u,O){return new o(u,O)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return i.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class i{constructor(u,O){this.key=u,this.value=O,this.type=14}static create(u,O){return new i(u,O)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=i;class t{constructor(u,O){this.key=u,this.value=O,this.type=15}static create(u,O){return new t(u,O)}cmp(u){return u.type!==this.type?this.type-u.type:f(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(u,O){this.key=u,this.regexp=O,this.type=7}static create(u,O){return new n(u,O)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const O=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return O<_?-1:O>_?1:0}equals(u){if(u.type===this.type){const O=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return this.key===u.key&&O===_}return!1}evaluate(u){let O=u.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=n;class r{constructor(u){this._actual=u,this.type=8}static create(u){return new r(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new r(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class c{constructor(u){this.expr=u,this.type=6}static create(u){return c._normalizeArr(u)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let O=0,_=this.expr.length;O<_;O++){const q=C(this.expr[O],u.expr[O]);if(q!==0)return q}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let O=0,_=this.expr.length;O<_;O++)if(!this.expr[O].equals(u.expr[O]))return!1;return!0}return!1}evaluate(u){for(let O=0,_=this.expr.length;O<_;O++)if(!this.expr[O].evaluate(u))return!1;return!0}static _normalizeArr(u){const O=[];let _=!1;for(const q of u)if(!!q){if(q.type===1){_=!0;continue}if(q.type===0)return d.INSTANCE;if(q.type===6){O.push(...q.expr);continue}O.push(q)}if(O.length===0&&_)return b.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];for(O.sort(C);O.length>1;){const q=O[O.length-1];if(q.type!==9)break;O.pop();const x=O.pop(),j=s.create(q.expr.map($=>c.create([$,x])));j&&(O.push(j),O.sort(C))}return O.length===1?O[0]:new c(O)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let O of this.expr)u.push(...O.keys());return u}map(u){return new c(this.expr.map(O=>O.map(u)))}negate(){let u=[];for(let O of this.expr)u.push(O.negate());return s.create(u)}}e.ContextKeyAndExpr=c;class s{constructor(u){this.expr=u,this.type=9}static create(u){const O=s._normalizeArr(u);if(O.length!==0)return O.length===1?O[0]:new s(O)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let O=0,_=this.expr.length;O<_;O++){const q=C(this.expr[O],u.expr[O]);if(q!==0)return q}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let O=0,_=this.expr.length;O<_;O++)if(!this.expr[O].equals(u.expr[O]))return!1;return!0}return!1}evaluate(u){for(let O=0,_=this.expr.length;O<_;O++)if(this.expr[O].evaluate(u))return!0;return!1}static _normalizeArr(u){let O=[],_=!1;if(u){for(let q=0,x=u.length;q<x;q++){const j=u[q];if(!!j){if(j.type===0){_=!0;continue}if(j.type===1)return[b.INSTANCE];if(j.type===9){O=O.concat(j.expr);continue}O.push(j)}}if(O.length===0&&_)return[d.INSTANCE];O.sort(C)}return O}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let O of this.expr)u.push(...O.keys());return u}map(u){return new s(this.expr.map(O=>O.map(u)))}negate(){let u=[];for(let _ of this.expr)u.push(_.negate());const O=_=>_.type===9?_.expr:[_];for(;u.length>1;){const _=u.shift(),q=u.shift(),x=[];for(const j of O(_))for(const $ of O(q))x.push(p.and(j,$));u.unshift(p.or(...x))}return u[0]}}e.ContextKeyOrExpr=s;class l extends I{constructor(u,O,_){super(u);this.key=u,this._defaultValue=O,typeof _=="object"?l._info.push(Object.assign(Object.assign({},_),{key:u})):_!==!0&&l._info.push({key:u,description:_,type:O!=null?typeof O:void 0})}static all(){return l._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return p.not(this.key)}isEqualTo(u){return p.equals(this.key,u)}notEqualsTo(u){return p.notEquals(this.key,u)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(E,u){return E<u?-1:E>u?1:0}function f(E,u,O,_){return E<O?-1:E>O?1:u<_?-1:u>_?1:0}}),define(Q[69],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function T(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=T}),define(Q[70],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,v.createDecorator)("downloadService")}),define(Q[10],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)});var ue=this&&this.__decorate||function(G,e,v,T){var k=arguments.length,R=k<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,v):T,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(G,e,v,T);else for(var P=G.length-1;P>=0;P--)(L=G[P])&&(R=(k<3?L(R):k>3?L(e,v,R):L(e,v))||R);return k>3&&R&&Object.defineProperty(e,v,R),R},Y=this&&this.__param||function(G,e){return function(v,T){e(v,T,G)}};define(Q[139],Z([0,1,10,8,23,15,2,6]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let g=class extends L.Disposable{constructor(C){super();this.environmentService=C,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let C=setTimeout(()=>{C=void 0;const d=(0,T.basename)(this.environmentService.logsPath),b=(0,T.dirname)(this.environmentService.logsPath);(0,k.readdir)(b).then(I=>{const D=I.filter(w=>/^\d{8}T\d{6}$/.test(w)).sort().filter((w,y)=>w!==d),S=D.slice(0,Math.max(0,D.length-9));return P.Promises.settled(S.map(w=>(0,k.rimraf)((0,T.join)(b,w))))}).then(null,R.onUnexpectedError)},10*1e3);this._register((0,L.toDisposable)(()=>{C&&(clearTimeout(C),C=void 0)}))}};g=ue([Y(0,v.IEnvironmentService)],g),e.LogsDataCleaner=g}),define(Q[140],Z([0,1,27,10,8,23,15,2]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let g=class ot extends P.Disposable{constructor(C,d){super();this.backupWorkspacesPath=C,this.environmentService=d,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let C=setTimeout(()=>{C=void 0,(async()=>{try{const d=await v.promises.readFile(this.backupWorkspacesPath,"utf8"),I=JSON.parse(d).emptyWorkspaceInfos.map(S=>S.backupFolder),a=await(0,R.readdir)(this.environmentService.workspaceStorageHome.fsPath),D=[];a.forEach(S=>{S.length!==ot.NON_EMPTY_WORKSPACE_ID_LENGTH&&I.indexOf(S)===-1&&D.push((0,R.rimraf)((0,k.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}),await Promise.all(D)}catch(d){(0,L.onUnexpectedError)(d)}})()},30*1e3);this._register((0,P.toDisposable)(()=>{C&&(clearTimeout(C),C=void 0)}))}};g.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,g=ue([Y(1,T.INativeEnvironmentService)],g),e.StorageDataCleaner=g}),define(Q[28],Z([0,1,109,4,16]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function R(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=R;var L;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=5]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(L=e.SortBy||(e.SortBy={}));var P;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var g;(function(d){d.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var p;(function(d){d[d.None=0]="None",d[d.Install=1]="Install",d[d.Update=2]="Update"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class C extends Error{constructor(b,I){super(b);this.code=I}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(Q[141],Z([0,1,2,28]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let k=class extends v.Disposable{constructor(L){super();this.extensionManagementService=L,this._register(L),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};k=ue([Y(0,T.IExtensionManagementService)],k),e.DeprecatedExtensionsCleaner=k}),define(Q[71],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var T;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(T=e.RecommendationSource||(e.RecommendationSource={}));function k(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var R;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(R=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,v.createDecorator)("IExtensionRecommendationNotificationService")}),define(Q[72],Z([0,1,21,4]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class L{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,d){if(typeof C=="undefined"||C===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof C=="string"||typeof d=="string"){let b=typeof C=="string"?C:C.value,I=typeof d=="string"?d:d.value;return v.equalsIgnoreCase(b,I)}return C._lower===d._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=L;function P(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function g(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=g,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[34],Z([0,1,21,72]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(I,a){return I.uuid&&a.uuid?I.uuid===a.uuid:I.id===a.id?!0:(0,v.compareIgnoreCase)(I.id,a.id)===0}e.areSameExtensions=k;class R{constructor(a,D){this.version=D,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof R?k(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=R;function L(I,a){return`${I}.${a}`}e.getExtensionId=L;function P(I){return I.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function g(I,a){return P(L(I,a))}e.getGalleryExtensionId=g;function p(I,a){const D=[],S=w=>{for(const y of D)if(y.some(m=>k(a(m),a(w))))return y;return null};for(const w of I){const y=S(w);y?y.push(w):D.push([w])}return D}e.groupByExtension=p;function C(I){return{id:I.identifier.id,name:I.manifest.name,galleryId:null,publisherId:I.publisherId,publisherName:I.manifest.publisher,publisherDisplayName:I.publisherDisplayName,dependencies:I.manifest.extensionDependencies&&I.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=C;function d(I){return Object.assign({id:I.identifier.id,name:I.name,galleryId:I.identifier.uuid,publisherId:I.publisherId,publisherName:I.publisher,publisherDisplayName:I.publisherDisplayName,dependencies:!!(I.properties.dependencies&&I.properties.dependencies.length>0)},I.telemetryData)}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function b(I){const a=new Set;for(const D of I)D.malicious&&a.add(D.id.id);return a}e.getMaliciousExtensionsSet=b}),define(Q[142],Z([0,1,2,8,72,23]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends v.Disposable{constructor(g,p){super();this.environmentService=g,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(p.onDidInstallExtension(C=>this.onDidInstallExtension(C))),this._register(p.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtension(g){g.error||this.invalidate()}onDidUnInstallExtension(g){g.error||this.invalidate()}invalidate(){R.rimraf(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(Q[9],Z([0,1,116,8,5,4,21,17,37]),function(G,e,v,T,k,R,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,R.createDecorator)("fileService");function p(j){return j.create===!0}e.isFileOpenForWriteOptions=p;var C;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var d;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=b;function I(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=I;function a(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function D(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=D;var S;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor($,W){super($);this.code=W}}e.FileSystemProviderError=w;function y(j,$){const W=new w(j.toString(),$);return o(W,$),W}e.createFileSystemProviderError=y;function m(j){return j||y((0,v.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=m;function o(j,$){return j.name=$?`${$} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=o;function i(j){if(!j)return S.Unknown;if(j instanceof w)return j.code;const $=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!$)return S.Unknown;switch($[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=i;function t(j){if(j instanceof h)return j.fileOperationResult;switch(i(j)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor($,W,B){this.resource=$,this.operation=W,this.target=B}isOperation($){return this.operation===$}}e.FileOperationEvent=r;var c;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class s{constructor($,W){this.ignorePathCasing=W,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const B of $)switch(B.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(B.resource,B);break}}contains($,...W){return this.doContains($,{includeChildren:!1},...W)}affects($,...W){return this.doContains($,{includeChildren:!0},...W)}doContains($,W,...B){var M,F,A,U,N,z;if(!$)return!1;const H=B.length>0;return!!((!H||B.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get($))||W.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr($)))||(!H||B.includes(0))&&(((A=this.updated)===null||A===void 0?void 0:A.get($))||W.includeChildren&&((U=this.updated)===null||U===void 0?void 0:U.findSuperstr($)))||(!H||B.includes(2))&&(((N=this.deleted)===null||N===void 0?void 0:N.findSubstr($))||W.includeChildren&&((z=this.deleted)===null||z===void 0?void 0:z.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const W=[],B=$===1?this.added:$===0?this.updated:this.deleted;if(B)for(const[,M]of B)W.push(M);return W}filter($){return new s(this.changes.filter(W=>$(W)),this.ignorePathCasing)}}e.FileChangesEvent=s;function l(j,$,W){return!j||!$||j===$||$.length>j.length?!1:($.charAt($.length-1)!==T.sep&&($+=T.sep),W?(0,L.startsWithIgnoreCase)(j,$):j.indexOf($)===0)}e.isParent=l;class h extends Error{constructor($,W,B){super($);this.fileOperationResult=W,this.options=B}static isFileOperationError($){return $ instanceof Error&&!(0,P.isUndefinedOrNull)($.fileOperationResult)}}e.FileOperationError=h;var f;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(f=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var E;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(E=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function u(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=u;async function O(j,$){if(!$.canHandleResource(k.URI.from({scheme:j.scheme})))return new Promise(W=>{const B=$.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===j.scheme&&M.added&&(B.dispose(),W())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class _{static formatSize($){return(0,P.isNumber)($)||($=0),$<_.KB?(0,v.localize)(1,null,$.toFixed(0)):$<_.MB?(0,v.localize)(2,null,($/_.KB).toFixed(2)):$<_.GB?(0,v.localize)(3,null,($/_.MB).toFixed(2)):$<_.TB?(0,v.localize)(4,null,($/_.GB).toFixed(2)):(0,v.localize)(5,null,($/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;var q;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function x(j){return{maxFileSize:j===0?300*_.MB:16*_.GB,maxHeapSize:j===0?700*_.MB:2*700*_.MB}}e.getPlatformLimits=x}),define(Q[143],Z([0,1,144,47,9]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let R=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(g,p)=>{const C=(0,v.createHash)("md5"),d=(await this.fileService.readFileStream(P)).value;(0,T.listenStream)(d,{onData:b=>C.update(b.buffer),onError:b=>p(b),onEnd:()=>g(C.digest("base64").replace(/=+$/,""))})})}};R=ue([Y(0,k.IFileService)],R),e.ChecksumService=R}),define(Q[73],Z([0,1,117,22,9,15]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(C,d,b,I,a,D){let S;try{await P(C,d,b,I,a,D)}catch(w){S=w}finally{S&&a.errorTransformer&&(S=a.errorTransformer(S)),typeof S!="undefined"&&b.error(S),b.end()}}e.readFileIntoStream=L;async function P(C,d,b,I,a,D){g(D);const S=await C.open(d,{create:!1});try{g(D);let w=0,y=0,m=a&&typeof a.length=="number"?a.length:void 0,o=T.VSBuffer.alloc(Math.min(a.bufferSize,typeof m=="number"?m:a.bufferSize)),i=a&&typeof a.position=="number"?a.position:0,t=0;do y=await C.read(S,i,o.buffer,t,o.byteLength-t),i+=y,t+=y,w+=y,typeof m=="number"&&(m-=y),t===o.byteLength&&(await b.write(I(o)),o=T.VSBuffer.alloc(Math.min(a.bufferSize,typeof m=="number"?m:a.bufferSize)),t=0);while(y>0&&(typeof m!="number"||m>0)&&g(D)&&p(w,a));if(t>0){let n=t;typeof m=="number"&&(n=Math.min(t,m)),b.write(I(o.slice(0,n)))}}catch(w){throw(0,k.ensureFileSystemProviderError)(w)}finally{await C.close(S)}}function g(C){if(C.isCancellationRequested)throw(0,R.canceled)();return!0}function p(C,d){if(d==null?void 0:d.limits){if(typeof d.limits.memory=="number"&&C>d.limits.memory)throw(0,k.createFileSystemProviderError)((0,v.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&C>d.limits.size)throw(0,k.createFileSystemProviderError)((0,v.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[74],Z([0,1,5,9,7]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function R(g){return g.map(p=>({type:p.type,resource:v.URI.file(p.path)}))}e.toFileChanges=R;function L(g){const p=new P;for(const C of g)p.processEvent(C);return p.normalize()}e.normalizeFileChanges=L;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(p){const C=this.mapPathToChange.get(p.path);if(C){const d=C.type,b=p.type;d===1&&b===2?(this.mapPathToChange.delete(p.path),this.normalized.splice(this.normalized.indexOf(C),1)):d===2&&b===1?C.type=0:d===1&&b===0||(C.type=b)}else this.normalized.push(p),this.mapPathToChange.set(p.path,p)}normalize(){const p=[],C=[];return this.normalized.filter(d=>d.type!==2?(p.push(d),!1):!0).sort((d,b)=>d.path.length-b.path.length).filter(d=>C.some(b=>(0,T.isParent)(d.path,b,!k.isLinux))?!1:(C.push(d.path),!0)).concat(p)}}}),define(Q[145],Z([0,1,74,2,23,94,97,6,8]),function(G,e,v,T,k,R,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class p extends T.Disposable{constructor(d,b,I,a){super();this.path=d,this.onDidFilesChange=b,this.onLogMessage=I,this.verboseLogging=a,this.fileChangesDelayer=this._register(new P.ThrottledDelayer(L.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(d){this.verboseLogging=d}async startWatching(){try{const{stat:d,symbolicLink:b}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let I=this.path;if(b)try{I=await(0,R.realpath)(I)}catch(a){if(this.onError(a),b.dangling)return}d.isDirectory()?this._register((0,L.watchFolder)(I,(a,D)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,g.join)(this.path,(0,g.basename)(D))})},a=>this.onError(a))):this._register((0,L.watchFile)(I,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(d){d.code!=="ENOENT"&&this.onError(d)}}onFileChange(d){this.fileChangesBuffer.push(d),this.verboseLogging&&this.onVerbose(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const I=(0,v.normalizeFileChanges)(b);this.verboseLogging&&I.forEach(a=>{this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`)}),I.length>0&&this.onDidFilesChange(I)})}onError(d){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${d}`})}onVerbose(d){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=p}),define(Q[75],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(let[R,L]of k)this.set(R,L)}set(k,R){const L=this._entries.get(k);return this._entries.set(k,R),L}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(Q[146],Z([0,1,15,136,50,4,75,6]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const g=!1;class p extends Error{constructor(a){super("cyclic dependency between services");this.message=a.toString()}}class C{constructor(a=new L.ServiceCollection,D=!1,S){this._activeInstantiations=new Set,this._services=a,this._strict=D,this._parent=S,this._services.set(R.IInstantiationService,this)}createChild(a){return new C(a,this._strict,this)}invokeFunction(a,...D){let S=b.traceInvocation(a),w=!1;try{return a({get:(m,o)=>{if(w)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(m,S);if(!i&&o!==R.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return i}},...D)}finally{w=!0,S.stop()}}createInstance(a,...D){let S,w;return a instanceof k.SyncDescriptor?(S=b.traceCreation(a.ctor),w=this._createInstance(a.ctor,a.staticArguments.concat(D),S)):(S=b.traceCreation(a),w=this._createInstance(a,D,S)),S.stop(),w}_createInstance(a,D=[],S){let w=R._util.getServiceDependencies(a).sort((o,i)=>o.index-i.index),y=[];for(const o of w){let i=this._getOrCreateServiceInstance(o.id,S);if(!i&&this._strict&&!o.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${o.id}.`);y.push(i)}let m=w.length>0?w[0].index:D.length;if(D.length!==m){console.warn(`[createInstance] First service dependency of ${a.name} at position ${m+1} conflicts with ${D.length} static arguments`);let o=m-D.length;o>0?D=D.concat(new Array(o)):D=D.slice(0,m)}return new a(...[...D,...y])}_setServiceInstance(a,D){if(this._services.get(a)instanceof k.SyncDescriptor)this._services.set(a,D);else if(this._parent)this._parent._setServiceInstance(a,D);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let D=this._services.get(a);return!D&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):D}_getOrCreateServiceInstance(a,D){let S=this._getServiceInstanceOrDescriptor(a);return S instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,S,D.branch(a,!0)):(D.branch(a,!1),S)}_safeCreateAndCacheServiceInstance(a,D,S){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,D,S)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,D,S){const w=new T.Graph(o=>o.id.toString());let y=0;const m=[{id:a,desc:D,_trace:S}];for(;m.length;){const o=m.pop();if(w.lookupOrInsertNode(o),y++>1e3)throw new p(w);for(let i of R._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(i.id);if(!t&&!i.optional&&console.warn(`[createInstance] ${a} depends on ${i.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const n={id:i.id,desc:t,_trace:o._trace.branch(i.id,!0)};w.insertEdge(o,n),m.push(n)}}}for(;;){const o=w.roots();if(o.length===0){if(!w.isEmpty())throw new p(w);break}for(const{data:i}of o){if(this._getServiceInstanceOrDescriptor(i.id)instanceof k.SyncDescriptor){const n=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setServiceInstance(i.id,n)}w.removeNode(i)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,D,S=[],w,y){if(this._services.get(a)instanceof k.SyncDescriptor)return this._createServiceInstance(D,S,w,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,D,S,w,y);throw new Error(`illegalState - creating UNKNOWN service instance ${D.name}`)}_createServiceInstance(a,D=[],S,w){if(S){const y=new P.IdleValue(()=>this._createInstance(a,D,w));return new Proxy(Object.create(null),{get(m,o){if(o in m)return m[o];let i=y.value,t=i[o];return typeof t!="function"||(t=t.bind(i),m[o]=t),t},set(m,o,i){return y.value[o]=i,!0}})}else return this._createInstance(a,D,w)}}e.InstantiationService=C;var d;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(d||(d={}));class b{constructor(a,D){this.type=a,this.name=D,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return g?new b(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(a){return g?new b(0,a.name):b._None}branch(a,D){let S=new b(2,a.toString());return this._dep.push([a,D,S]),S}stop(){let a=Date.now()-this._start;b._totals+=a;let D=!1;function S(y,m){let o=[],i=new Array(y+1).join("	");for(const[t,n,r]of m._dep)if(n&&r){D=!0,o.push(`${i}CREATES -> ${t}`);let c=S(y+1,r);c&&o.push(c)}else o.push(`${i}uses -> ${t}`);return o.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(a>2||D)&&console.log(w.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(Q[147],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class v{constructor(k,R){this.server=k,this.router=R}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,R){this.server.registerChannel(k,R)}}e.MessagePortMainProcessService=v}),define(Q[148],Z([0,1,33,50,135,4]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class L{constructor(I,a,D){const S=D.getChannel(I);return P(a)?new a.channelClientCtor(S):v.ProxyChannel.toService(S,a==null?void 0:a.proxyOptions)}}function P(b){const I=b;return!!(I==null?void 0:I.channelClientCtor)}e.IMainProcessService=(0,R.createDecorator)("mainProcessService");let g=class extends L{constructor(I,a,D){super(I,a,D)}};g=ue([Y(2,e.IMainProcessService)],g);function p(b,I,a){(0,k.registerSingleton)(b,new T.SyncDescriptor(g,[I,a],a==null?void 0:a.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=p,e.ISharedProcessService=(0,R.createDecorator)("sharedProcessService");let C=class extends L{constructor(I,a,D){super(I,a,D)}};C=ue([Y(2,e.ISharedProcessService)],C);function d(b,I,a){(0,k.registerSingleton)(b,new T.SyncDescriptor(C,[I,a],a==null?void 0:a.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=d}),define(Q[55],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,v.createDecorator)("localizationsService");function T(k){if(typeof k.languageId!="string"||!Array.isArray(k.translations)||k.translations.length===0)return!1;for(const R of k.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(k.languageName&&typeof k.languageName!="string"||k.localizedLanguageName&&typeof k.localizedLanguageName!="string")}e.isValidLocalization=T}),define(Q[149],Z([0,1,2,55]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends v.Disposable{constructor(L){super();this.localizationsService=L,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=ue([Y(0,T.ILocalizationsService)],k),e.LocalizationsUpdater=k}),define(Q[14],Z([0,1,4,2,7,3,43]),function(G,e,v,T,k,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function P(){return new Date().toISOString()}var g;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;class p extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=p;class C extends p{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(g.Trace)&&this.log(g.Trace,this.format([i,...t]))}debug(i,...t){this.checkLogLevel(g.Debug)&&this.log(g.Debug,this.format([i,...t]))}info(i,...t){this.checkLogLevel(g.Info)&&this.log(g.Info,this.format([i,...t]))}warn(i,...t){this.checkLogLevel(g.Warning)&&this.log(g.Warning,this.format([i,...t]))}error(i,...t){if(this.checkLogLevel(g.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(g.Error,this.format(n))}else this.log(g.Error,this.format([i,...t]))}critical(i,...t){this.checkLogLevel(g.Critical)&&this.log(g.Critical,this.format([i,...t]))}flush(){}format(i){let t="";for(let n=0;n<i.length;n++){let r=i[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(c){}t+=(n>0?" ":"")+r}return t}}e.AbstractMessageLogger=C;class d extends p{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!k.isWindows}trace(i,...t){this.getLevel()<=g.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}debug(i,...t){this.getLevel()<=g.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}info(i,...t){this.getLevel()<=g.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}warn(i,...t){this.getLevel()<=g.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...t):console.warn(`[main ${P()}]`,i,...t))}error(i,...t){this.getLevel()<=g.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...t):console.error(`[main ${P()}]`,i,...t))}critical(i,...t){this.getLevel()<=g.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...t):console.error(`[main ${P()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class b extends p{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=g.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=g.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=g.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=g.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=g.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=g.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=b;class I extends p{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=g.Trace&&this.adapter.log(g.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=g.Debug&&this.adapter.log(g.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=g.Info&&this.adapter.log(g.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=g.Warning&&this.adapter.log(g.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=g.Error&&this.adapter.log(g.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=g.Critical&&this.adapter.log(g.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,L.toErrorMessage)(i,this.getLevel()<=g.Trace)}dispose(){}flush(){}}e.AdapterLogger=I;class a extends p{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const n of this.logServices)n.trace(i,...t)}debug(i,...t){for(const n of this.logServices)n.debug(i,...t)}info(i,...t){for(const n of this.logServices)n.info(i,...t)}warn(i,...t){for(const n of this.logServices)n.warn(i,...t)}error(i,...t){for(const n of this.logServices)n.error(i,...t)}critical(i,...t){for(const n of this.logServices)n.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=a;class D extends T.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=D;class S{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(i){}getLevel(){return g.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=S;function w(o){if(o.verbose)return g.Trace;if(typeof o.logLevel=="string"){const i=y(o.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function y(o){switch(o){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Critical;case"off":return g.Off}}e.parseLogLevel=y;function m(o){switch(o){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Critical:return"critical";case g.Off:return"off"}}e.LogLevelToString=m}),define(Q[150],Z([0,1,27,2,9,28,10,5,11,34,14,30,56,7,6]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let S=class extends T.Disposable{constructor(y,m,o,i){super();this.fileService=m,this.extensionGalleryService=o,this.logService=i,this.extensionsDownloadDir=P.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,m){await this.cleanUpPromise;const o=this.getName(y),i=(0,g.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(i)){const t=(0,g.joinPath)(this.extensionsDownloadDir,`.${o}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(y,t,m),await this.rename(t,i,Date.now()+2*60*1e3)}return i}async delete(y){}async rename(y,m,o){try{await v.promises.rename(y.fsPath,m.fsPath)}catch(i){if(I.isWindows&&i&&i.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${y} to ${m} with 'EPERM' error. Trying again...`),this.rename(y,m,o);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const m=[],o=[];for(const n of y.children){const r=this.parse(n.name);r&&o.push([r,n])}const i=(0,p.groupByExtension)(o,([n])=>n),t=[];for(const n of i)n.sort((r,c)=>b.rcompare(r[0].version,c[0].version)),m.push(...n.slice(1).map(r=>r[1].resource)),t.push(n[0][1]);t.sort((n,r)=>n.mtime-r.mtime),m.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(n=>n.resource)),await a.Promises.settled(m.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?new p.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase():(0,d.generateUuid)()}parse(y){const m=D.exec(y);return m&&m[1]&&m[2]?new p.ExtensionIdentifierWithVersion({id:m[1]},m[2]):null}};S=ue([Y(0,L.INativeEnvironmentService),Y(1,k.IFileService),Y(2,R.IExtensionGalleryService),Y(3,C.ILogService)],S),e.ExtensionsDownloader=S}),define(Q[151],Z([0,1,2,14,48,43,8,6,3,16,23,10]),function(G,e,v,T,k,R,L,P,g,p,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let b=class extends v.Disposable{constructor(a,D){super();this.environmentService=a,this.logService=D,this.processesLimiter=new P.Limiter(5)}async postUninstall(a){const D=this.parseScript(a,"uninstall");return D&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(D.script,"uninstall",D.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${S}`)))),(0,C.rimraf)(this.getExtensionStoragePath(a)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(a,D){const S=`vscode:${D}`;if(a.location.scheme===p.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[S]=="string"){const w=a.manifest.scripts[S].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${S} should be a node script`),null):{script:(0,L.join)(a.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}runLifecycleHook(a,D,S,w,y){return new Promise((m,o)=>{const i=this.start(a,D,S,y);let t;const n=r=>{t&&(clearTimeout(t),t=null),r?o(r):m(void 0)};i.on("error",r=>{n((0,R.toErrorMessage)(r)||"Unknown")}),i.on("exit",(r,c)=>{n(r?`post-${D} process exited with code ${r}`:void 0)}),w&&(t=setTimeout(()=>{t=null,i.kill(),o("timed out")},5e3))})}start(a,D,S,w){const y={silent:!0,execArgv:void 0},m=(0,k.fork)(a,[`--type=extension-post-${D}`,...S],y);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const o=g.Event.fromNodeEventEmitter(m.stdout,"data"),i=g.Event.fromNodeEventEmitter(m.stderr,"data");o(r=>this.logService.info(w.identifier.id,w.manifest.version,`post-${D}`,r)),i(r=>this.logService.error(w.identifier.id,w.manifest.version,`post-${D}`,r));const t=g.Event.any(g.Event.map(o,r=>({data:`%c${r}`,format:[""]})),g.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]})));return g.Event.debounce(t,(r,c)=>r?{data:r.data+c.data,format:[...r.format,...c.format]}:{data:c.data,format:c.format},100)(r=>{console.group(w.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),m}getExtensionStoragePath(a){return(0,L.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};b=ue([Y(0,d.IEnvironmentService),Y(1,T.ILogService)],b),e.ExtensionsLifecycle=b}),define(Q[152],Z([0,1,115,153,2,9,3,11,37,18,14,22,47,6,29,16,73,52]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends k.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(o,i){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,T.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:i});const t=new k.DisposableStore;return t.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new R.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),t.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:o}))),typeof i.onDidErrorOccur=="function"&&t.add(i.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,k.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:i}),this.provider.delete(o),(0,k.dispose)(t)})}async activateProvider(o){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){i.push(t)}}),!this.provider.has(o)&&await I.Promises.settled(i)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,i){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&i)}listCapabilities(){return w.Iterable.map(this.provider,([o,i])=>({scheme:o,capabilities:i.capabilities}))}async withProvider(o){if(!(0,P.isAbsolutePath)(o))throw new R.FileOperationError((0,v.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const i=this.provider.get(o.scheme);if(!i){const t=new Error;throw t.name="ENOPRO",t.message=(0,v.localize)(1,null,o.toString()),t}return i}async withReadProvider(o){const i=await this.withProvider(o);if((0,R.hasOpenReadWriteCloseCapability)(i)||(0,R.hasReadWriteCapability)(i)||(0,R.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const i=await this.withProvider(o);if((0,R.hasOpenReadWriteCloseCapability)(i)||(0,R.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,i){try{return await this.doResolveFile(o,i)}catch(t){throw(0,R.toFileSystemProviderErrorCode)(t)===R.FileSystemProviderErrorCode.FileNotFound?new R.FileOperationError((0,v.localize)(2,null,this.resourceForError(o)),1):(0,R.ensureFileSystemProviderError)(t)}}async doResolveFile(o,i){const t=await this.withProvider(o),n=this.isPathCaseSensitive(t),r=i==null?void 0:i.resolveTo,c=i==null?void 0:i.resolveSingleChildDescendants,s=i==null?void 0:i.resolveMetadata,l=await t.stat(o);let h;return this.toFileStat(t,o,l,void 0,!!s,(f,E)=>(h||(h=g.TernarySearchTree.forUris(()=>!n),h.set(o,!0),(0,p.isNonEmptyArray)(r)&&r.forEach(u=>h.set(u,!0))),Boolean(h.findSuperstr(f.resource)||h.get(f.resource))?!0:f.isDirectory&&c?E===1:!1))}async toFileStat(o,i,t,n,r,c){const{providerExtUri:s}=this.getExtUri(o),l={resource:i,name:s.basename(i),isFile:(t.type&R.FileType.File)!=0,isDirectory:(t.type&R.FileType.Directory)!=0,isSymbolicLink:(t.type&R.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,R.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&c(l,n)){try{const h=await o.readdir(i),f=await I.Promises.settled(h.map(async([E,u])=>{try{const O=s.joinPath(i,E),_=r?await o.stat(O):{type:u};return await this.toFileStat(o,O,_,h.length,r,c)}catch(O){return this.logService.trace(O),null}}));l.children=(0,p.coalesce)(f)}catch(h){this.logService.trace(h),l.children=[]}return l}return l}async resolveAll(o){return I.Promises.settled(o.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const i=await this.withProvider(o);try{return!!await i.stat(o)}catch(t){return!1}}async canCreateFile(o,i){try{await this.doValidateCreateFile(o,i)}catch(t){return t}return!0}async doValidateCreateFile(o,i){if(!(i==null?void 0:i.overwrite)&&await this.exists(o))throw new R.FileOperationError((0,v.localize)(3,null,this.resourceForError(o)),3,i)}async createFile(o,i=d.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const n=await this.writeFile(o,i);return this._onDidRunOperation.fire(new R.FileOperationEvent(o,0,n)),n}async writeFile(o,i,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,o,t)||await this.mkdirp(n,r.dirname(o));let s;if((0,R.hasReadWriteCapability)(n)&&!(i instanceof d.VSBuffer))if((0,b.isReadableStream)(i)){const l=await(0,b.peekStream)(i,3);l.ended?s=d.VSBuffer.concat(l.buffer):s=l}else s=(0,b.peekReadable)(i,l=>d.VSBuffer.concat(l),3);else s=i;!(0,R.hasOpenReadWriteCloseCapability)(n)||(0,R.hasReadWriteCapability)(n)&&s instanceof d.VSBuffer?await this.doWriteUnbuffered(n,o,t,s):await this.doWriteBuffered(n,o,t,s instanceof d.VSBuffer?(0,d.bufferToReadable)(s):s)}catch(c){throw new R.FileOperationError((0,v.localize)(4,null,this.resourceForError(o),(0,R.ensureFileSystemProviderError)(c).toString()),(0,R.toFileOperationResult)(c),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,i,t){if(!!(t==null?void 0:t.unlock)&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(i)));let r;try{r=await o.stat(i)}catch(c){return}if((r.type&R.FileType.Directory)!=0)throw new R.FileOperationError((0,v.localize)(6,null,this.resourceForError(i)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,R.etag)({mtime:t.mtime,size:r.size}))throw new R.FileOperationError((0,v.localize)(7,null),3,t);return r}async readFile(o,i){const t=await this.withReadProvider(o);return(i==null?void 0:i.atomic)?this.doReadFileAtomic(t,o,i):this.doReadFile(t,o,i)}async doReadFileAtomic(o,i,t){return new Promise((n,r)=>{this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(o,i,t);n(c)}catch(c){r(c)}})})}async doReadFile(o,i,t){const n=await this.doReadFileStream(o,i,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,d.streamToBuffer)(n.value)})}async readFileStream(o,i){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,i)}async doReadFileStream(o,i,t){const n=new a.CancellationTokenSource,r=this.validateReadFile(i,t).then(s=>s,s=>{throw n.cancel(),s});let c;try{t&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&await r,!((0,R.hasOpenReadWriteCloseCapability)(o)||(0,R.hasFileReadStreamCapability)(o))||(0,R.hasReadWriteCapability)(o)&&(t==null?void 0:t.preferUnbuffered)?c=this.readFileUnbuffered(o,i,t):(0,R.hasFileReadStreamCapability)(o)?c=this.readFileStreamed(o,i,n.token,t):c=this.readFileBuffered(o,i,n.token,t);const s=await r;return Object.assign(Object.assign({},s),{value:c})}catch(s){throw c&&await(0,b.consumeStream)(c),new R.FileOperationError((0,v.localize)(8,null,this.resourceForError(i),(0,R.ensureFileSystemProviderError)(s).toString()),(0,R.toFileOperationResult)(s),t)}}readFileStreamed(o,i,t,n=Object.create(null)){const r=o.readFileStream(i,n,t);return(0,b.transform)(r,{data:c=>c instanceof d.VSBuffer?c:d.VSBuffer.wrap(c),error:c=>new R.FileOperationError((0,v.localize)(9,null,this.resourceForError(i),(0,R.ensureFileSystemProviderError)(c).toString()),(0,R.toFileOperationResult)(c),n)},c=>d.VSBuffer.concat(c))}readFileBuffered(o,i,t,n=Object.create(null)){const r=(0,d.newWriteableBufferStream)();return(0,S.readFileIntoStream)(o,i,r,c=>c,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:c=>new R.FileOperationError((0,v.localize)(10,null,this.resourceForError(i),(0,R.ensureFileSystemProviderError)(c).toString()),(0,R.toFileOperationResult)(c),n)}),t),r}readFileUnbuffered(o,i,t){const n=(0,b.newWriteableStream)(r=>d.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(i);t&&typeof t.position=="number"&&(r=r.slice(t.position)),t&&typeof t.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(i,r.byteLength,t),n.end(d.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(o,i){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new R.FileOperationError((0,v.localize)(11,null,this.resourceForError(o)),0,i);if(i&&typeof i.etag=="string"&&i.etag!==R.ETAG_DISABLED&&i.etag===t.etag)throw new R.FileOperationError((0,v.localize)(12,null),2,i);return this.validateReadFileLimits(o,t.size,i),t}validateReadFileLimits(o,i,t){if(t==null?void 0:t.limits){let n;if(typeof t.limits.memory=="number"&&i>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&i>t.limits.size&&(n=7),typeof n=="number")throw new R.FileOperationError((0,v.localize)(13,null,this.resourceForError(o)),n)}}async canMove(o,i,t){return this.doCanMoveCopy(o,i,"move",t)}async canCopy(o,i,t){return this.doCanMoveCopy(o,i,"copy",t)}async doCanMoveCopy(o,i,t,n){if(o.toString()!==i.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,o,c,i,t,n)}catch(r){return r}return!0}async move(o,i,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),c=await this.doMoveCopy(n,o,r,i,"move",!!t),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,c==="move"?2:3,s)),s}async copy(o,i,t){const n=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),c=await this.doMoveCopy(n,o,r,i,"copy",!!t),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,c==="copy"?3:2,s)),s}async doMoveCopy(o,i,t,n,r,c){if(i.toString()===n.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(o,i,t,n,r,c);if(s&&!l&&c&&await this.del(n,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),r==="copy"){if(o===t&&(0,R.hasFileFolderCopyCapability)(o))await o.copy(i,n,{overwrite:c});else{const h=await this.resolve(i);h.isDirectory?await this.doCopyFolder(o,h,t,n):await this.doCopyFile(o,i,t,n)}return r}else return o===t?(await o.rename(i,n,{overwrite:c}),r):(await this.doMoveCopy(o,i,t,n,"copy",c),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(o,i,t,n){if((0,R.hasOpenReadWriteCloseCapability)(o)&&(0,R.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,i,t,n);if((0,R.hasOpenReadWriteCloseCapability)(o)&&(0,R.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,i,t,n);if((0,R.hasReadWriteCapability)(o)&&(0,R.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,i,t,n);if((0,R.hasReadWriteCapability)(o)&&(0,R.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,i,t,n)}async doCopyFolder(o,i,t,n){await t.mkdir(n),Array.isArray(i.children)&&await I.Promises.settled(i.children.map(async r=>{const c=this.getExtUri(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),t,c):this.doCopyFile(o,r.resource,t,c)}))}async doValidateMoveCopy(o,i,t,n,r,c){let s=!1;if(o===t){const{providerExtUri:h,isPathCaseSensitive:f}=this.getExtUri(o);if(f||(s=h.isEqual(i,n)),s&&r==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!s&&h.isEqualOrParent(n,i))throw new Error((0,v.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const l=await this.exists(n);if(l&&!s){if(!c)throw new R.FileOperationError((0,v.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(o===t){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(i,n))throw new Error((0,v.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:s}}getExtUri(o){const i=this.isPathCaseSensitive(o);return{providerExtUri:i?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(i,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(o,0,t)),t}async mkdirp(o,i){const t=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(i,n.dirname(i));)try{if(((await o.stat(i)).type&R.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,R.toFileSystemProviderErrorCode)(r)!==R.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(i)),i=n.dirname(i)}for(let r=t.length-1;r>=0;r--){i=n.joinPath(i,t[r]);try{await o.mkdir(i)}catch(c){if((0,R.toFileSystemProviderErrorCode)(c)!==R.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(o,i){try{await this.doValidateDelete(o,i)}catch(t){return t}return!0}async doValidateDelete(o,i){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(i==null?void 0:i.useTrash)&&!(t.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(o)));const r=await this.exists(o);if(!r)throw new R.FileOperationError((0,v.localize)(20,null,this.resourceForError(o)),1);if(!!!(i==null?void 0:i.recursive)&&r){const s=await this.resolve(o);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(o)))}return t}async del(o,i){const t=await this.doValidateDelete(o,i),n=!!(i==null?void 0:i.useTrash),r=!!(i==null?void 0:i.recursive);await t.delete(o,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new R.FileOperationEvent(o,1))}watch(o,i={recursive:!1,excludes:[]}){let t=!1,n=()=>{t=!0};return this.doWatch(o,i).then(r=>{t?(0,k.dispose)(r):n=()=>(0,k.dispose)(r)},r=>this.logService.error(r)),(0,k.toDisposable)(()=>n())}async doWatch(o,i){const t=await this.withProvider(o),n=this.toWatchKey(t,o,i),r=this.activeWatchers.get(n)||{count:0,disposable:t.watch(o,i)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,r),r.count+=1,(0,k.toDisposable)(()=>{r.count--,r.count===0&&((0,k.dispose)(r.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,i,t){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(i),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,k.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,i,t,n){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{var r;const c=await o.open(i,{create:!0,unlock:(r=t==null?void 0:t.unlock)!==null&&r!==void 0?r:!1});try{(0,b.isReadableStream)(n)||(0,b.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,c,n):await this.doWriteReadableBufferedQueued(o,c,n)}catch(s){throw(0,R.ensureFileSystemProviderError)(s)}finally{await o.close(c)}})}async doWriteStreamBufferedQueued(o,i,t){let n=0,r;if((0,b.isReadableBufferedStream)(t)){if(t.buffer.length>0){const c=d.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,i,c,c.byteLength,n,0),n+=c.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(c,s)=>{(0,b.listenStream)(r,{onData:async l=>{r.pause();try{await this.doWriteBuffer(o,i,l,l.byteLength,n,0)}catch(h){return s(h)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>s(l),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(o,i,t){let n=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(o,i,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(o,i,t,n,r,c){let s=0;for(;s<n;)s+=await o.write(i,r+s,t.buffer,c+s,n-s)}async doWriteUnbuffered(o,i,t,n){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,i,t,n))}async doWriteUnbufferedQueued(o,i,t,n){var r;let c;n instanceof d.VSBuffer?c=n:(0,b.isReadableStream)(n)?c=await(0,d.streamToBuffer)(n):(0,b.isReadableBufferedStream)(n)?c=await(0,d.bufferedStreamToBuffer)(n):c=(0,d.readableToBuffer)(n),await o.writeFile(i,c.buffer,{create:!0,overwrite:!0,unlock:(r=t==null?void 0:t.unlock)!==null&&r!==void 0?r:!1})}async doPipeBuffered(o,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,i,t,n))}async doPipeBufferedQueued(o,i,t,n){let r,c;try{r=await o.open(i,{create:!1}),c=await t.open(n,{create:!0,unlock:!1});const s=d.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,h=0,f=0;do f=await o.read(r,l,s.buffer,h,s.byteLength-h),await this.doWriteBuffer(t,c,s,f,l,h),l+=f,h+=f,h===s.byteLength&&(h=0);while(f>0)}catch(s){throw(0,R.ensureFileSystemProviderError)(s)}finally{await I.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof c=="number"?t.close(c):Promise.resolve()])}}async doPipeUnbuffered(o,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,i,t,n))}async doPipeUnbufferedQueued(o,i,t,n){return t.writeFile(n,await o.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,i,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,i,t,n))}async doPipeUnbufferedToBufferedQueued(o,i,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const c=await o.readFile(i);await this.doWriteBuffer(t,r,d.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,R.ensureFileSystemProviderError)(c)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(o,i,t,n){const r=await(0,d.streamToBuffer)(this.readFileBuffered(o,i,a.CancellationToken.None));await this.doWriteUnbuffered(t,n,void 0,r)}throwIfFileSystemIsReadonly(o,i){if(o.capabilities&2048)throw new R.FileOperationError((0,v.localize)(22,null,this.resourceForError(i)),6);return o}resourceForError(o){return o.scheme===D.Schemas.file?o.fsPath:o.toString(!0)}};y=ue([Y(0,C.ILogService)],y),e.FileService=y}),define(Q[154],Z([0,1,27,203,2,9,3,7,23,8,11,42,6,14,118,74,132,134,131,145,47,73,18,22]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w,y,m,o,i,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class r extends k.Disposable{constructor(s,l){var h;super();this.logService=s,this.options=l,this.BUFFER_SIZE=((h=this.options)===null||h===void 0?void 0:h.bufferSize)||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:l,symbolicLink:h}=await g.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(l,h),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(s){try{const l=await(0,g.readdir)(this.toFilePath(s),{withFileTypes:!0}),h=[];return await Promise.all(l.map(async f=>{try{let E;f.isSymbolicLink()?E=(await this.stat((0,C.joinPath)(s,f.name))).type:E=this.toType(f),h.push([f.name,E])}catch(E){this.logService.trace(E)}})),h}catch(l){throw this.toFileSystemProviderError(l)}}toType(s,l){let h;return(l==null?void 0:l.dangling)?h=R.FileType.Unknown:s.isFile()?h=R.FileType.File:s.isDirectory()?h=R.FileType.Directory:h=R.FileType.Unknown,l&&(h|=R.FileType.SymbolicLink),h}async readFile(s){try{const l=this.toFilePath(s);return await v.promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(s,l,h){const f=(0,o.newWriteableStream)(E=>n.VSBuffer.concat(E.map(u=>n.VSBuffer.wrap(u))).buffer);return(0,i.readFileIntoStream)(this,s,f,E=>E.buffer,Object.assign(Object.assign({},l),{bufferSize:this.BUFFER_SIZE}),h),f}async writeFile(s,l,h){let f;try{const E=this.toFilePath(s);if(!h.create||!h.overwrite){if(await(0,g.exists)(E)){if(!h.overwrite)throw(0,R.createFileSystemProviderError)((0,a.localize)(0,null),R.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,R.createFileSystemProviderError)((0,a.localize)(1,null),R.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(s,{create:!0,unlock:h.unlock}),await this.write(f,0,l,0,l.byteLength)}catch(E){throw await this.toFileSystemProviderWriteError(s,E)}finally{typeof f=="number"&&await this.close(f)}}async open(s,l){try{const h=this.toFilePath(s);if((0,R.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:u}=await g.SymlinkSupport.stat(h);u.mode&128||await v.promises.chmod(h,u.mode|128)}catch(u){this.logService.trace(u)}let f;if((0,R.isFileOpenForWriteOptions)(l)){if(P.isWindows)try{await v.promises.truncate(h,0),f="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}f||(f="w")}else f="r";const E=await(0,T.promisify)(v.open)(h,f);return this.mapHandleToPos.set(E,0),(0,R.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(E,s),E}catch(h){throw(0,R.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(s,h):this.toFileSystemProviderError(h)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await(0,T.promisify)(v.fdatasync)(s)}catch(l){this.canFlush=!1,this.logService.error(l)}return await(0,T.promisify)(v.close)(s)}catch(l){throw this.toFileSystemProviderError(l)}}async read(s,l,h,f,E){const u=this.normalizePos(s,l);let O=null;try{const _=await(0,T.promisify)(v.read)(s,h,f,E,u);return typeof _=="number"?O=_:O=_.bytesRead,O}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(s,u,O)}}normalizePos(s,l){return l===this.mapHandleToPos.get(s)?null:l}updatePos(s,l,h){const f=this.mapHandleToPos.get(s);typeof f=="number"&&(typeof l=="number"||(typeof h=="number"?this.mapHandleToPos.set(s,f+h):this.mapHandleToPos.delete(s)))}async write(s,l,h,f,E){return(0,b.retry)(()=>this.doWrite(s,l,h,f,E),100,3)}async doWrite(s,l,h,f,E){const u=this.normalizePos(s,l);let O=null;try{const _=await(0,T.promisify)(v.write)(s,h,f,E,u);return typeof _=="number"?O=_:O=_.bytesWritten,O}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),_)}finally{this.updatePos(s,u,O)}}async mkdir(s){try{await v.promises.mkdir(this.toFilePath(s))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(s,l){try{const h=this.toFilePath(s);await this.doDelete(h,l)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(s,l){l.recursive?await(0,g.rimraf)(s,g.RimRafMode.MOVE):await v.promises.unlink(s)}async rename(s,l,h){const f=this.toFilePath(s),E=this.toFilePath(l);if(f!==E)try{await this.validateTargetDeleted(s,l,"move",h.overwrite),await(0,g.move)(f,E)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,a.localize)(2,null,(0,p.basename)(f),(0,p.basename)((0,p.dirname)(E)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(s,l,h){const f=this.toFilePath(s),E=this.toFilePath(l);if(f!==E)try{await this.validateTargetDeleted(s,l,"copy",h.overwrite),await(0,g.copy)(f,E,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,a.localize)(3,null,(0,p.basename)(f),(0,p.basename)((0,p.dirname)(E)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(s,l,h,f){const E=this.toFilePath(s),u=this.toFilePath(l);let O=!1;if(!!(this.capabilities&1024)||(O=(0,d.isEqual)(E,u,!0)),O&&h==="copy")throw(0,R.createFileSystemProviderError)((0,a.localize)(4,null),R.FileSystemProviderErrorCode.FileExists);if(!O&&await(0,g.exists)(u)){if(!f)throw(0,R.createFileSystemProviderError)((0,a.localize)(5,null),R.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(s,l){return l.recursive?this.watchRecursive(s,l.excludes):this.watchNonRecursive(s)}watchRecursive(s,l){const h={path:this.toFilePath(s),excludes:l},f=(0,t.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{f(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,l,h;if(this.recursiveWatcher instanceof y.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,k.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let f,E;((l=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||l===void 0?void 0:l.usePolling)?(f=S.FileWatcher,E=(h=this.options)===null||h===void 0?void 0:h.watcher):this.recursiveFoldersToWatch.length===1?P.isWindows?f=w.FileWatcher:f=S.FileWatcher:f=y.FileWatcher,this.recursiveWatcher=new f(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,D.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===I.LogLevel.Trace,E),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))}}watchNonRecursive(s){const l=new m.FileWatcher(this.toFilePath(s),f=>this._onDidChangeFile.fire((0,D.toFileChanges)(f)),f=>{f.type==="error"&&this._onDidWatchErrorOccur.fire(f.message),this.logService[f.type](f.message)},this.logService.getLevel()===I.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return(0,k.combinedDisposable)(l,h)}toFilePath(s){return(0,p.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof R.FileSystemProviderError)return s;let l;switch(s.code){case"ENOENT":l=R.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=R.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=R.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=R.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=R.FileSystemProviderErrorCode.NoPermissions;break;default:l=R.FileSystemProviderErrorCode.Unknown}return(0,R.createFileSystemProviderError)(s,l)}async toFileSystemProviderWriteError(s,l){let h=this.toFileSystemProviderError(l);if(s&&h.code===R.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await g.SymlinkSupport.stat(this.toFilePath(s));f.mode&128||(h=(0,R.createFileSystemProviderError)(l,R.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.logService.trace(f)}return h}dispose(){super.dispose(),(0,k.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,k.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=r}),define(Q[155],Z([0,1,23,27,144,28,2,10,6,34,14,55,18,3,16,8]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let S=class extends L.Disposable{constructor(m,o,i){super();this.extensionManagementService=m,this.logService=i,this._onDidLanguagesChange=this._register(new I.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new w(o,i)),this._register(m.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(m.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(m=>{const o=["en",...Object.keys(m)];return(0,b.distinct)(o)})}onDidInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",m.identifier.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(m){this.cache.getLanguagePacks().then(o=>{Object.keys(o).some(i=>o[i]&&o[i].extensions.some(t=>(0,p.areSameExtensions)(t.extensionIdentifier,m)))&&(this.logService.debug("Removing language packs from the extension",m.id),this.update().then(i=>{i&&this._onDidLanguagesChange.fire()}))})}async update(){const[m,o]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(o);return!(0,b.equals)(Object.keys(m),Object.keys(i))}};S=ue([Y(0,R.IExtensionManagementService),Y(1,P.INativeEnvironmentService),Y(2,C.ILogService)],S),e.LocalizationsService=S;let w=class extends L.Disposable{constructor(m,o){super();this.logService=o,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new g.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(o=>{Object.keys(o).forEach(i=>delete o[i]),this.createLanguagePacksFromExtensions(o,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...o){for(const i of o)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,i);Object.keys(m).forEach(i=>this.updateHash(m[i]))}createLanguagePacksFromExtension(m,o){const i=o.identifier,t=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const n of t)if(o.location.scheme===a.Schemas.file&&(0,d.isValidLocalization)(n)){let r=m[n.languageId];r||(r={hash:"",extensions:[],translations:{}},m[n.languageId]=r);let c=r.extensions.filter(s=>(0,p.areSameExtensions)(s.extensionIdentifier,i))[0];c?c.version=o.manifest.version:r.extensions.push({extensionIdentifier:i,version:o.manifest.version});for(const s of n.translations)r.translations[s.id]=(0,D.join)(o.location.fsPath,s.path)}}updateHash(m){if(m){const o=(0,k.createHash)("md5");for(const i of m.extensions)o.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);m.hash=o.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let o=null;return T.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch(t){return{}}}).then(i=>(o=m(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,v.writeFile)(this.languagePacksFilePath,t)}).then(()=>o,i=>this.logService.error(i))})}};w=ue([Y(0,P.INativeEnvironmentService),Y(1,C.ILogService)],w)}),define(Q[156],Z([0,1,14]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function T(R,L){switch(L){case v.LogLevel.Trace:return R.trace;case v.LogLevel.Debug:return R.debug;case v.LogLevel.Info:return R.info;case v.LogLevel.Warning:return R.warn;case v.LogLevel.Error:return R.error;case v.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends v.AbstractLogger{constructor(L=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(L),this._register(this.onDidChangeLogLevel(P=>{this._logger&&this._logger.setLevel(P)}))}set logger(L){this._logger=L;for(const{level:P,args:g}of this.buffer)T(L,P).apply(L,g);this.buffer=[]}_log(L,...P){this._logger?T(this._logger,L).apply(this._logger,P):this.getLevel()<=L&&this.buffer.push({level:L,args:P})}trace(L,...P){this._log(v.LogLevel.Trace,L,...P)}debug(L,...P){this._log(v.LogLevel.Debug,L,...P)}info(L,...P){this._log(v.LogLevel.Info,L,...P)}warn(L,...P){this._log(v.LogLevel.Warning,L,...P)}error(L,...P){this._log(v.LogLevel.Error,L,...P)}critical(L,...P){this._log(v.LogLevel.Critical,L,...P)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(Q[157],Z([0,1,14,9,6,22,11,2,4,156]),function(G,e,v,T,k,R,L,P,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const C=5*T.ByteSize.MB;let d=class extends v.AbstractLogger{constructor(a,D,S,w){super();this.name=a,this.resource=D,this.fileService=w,this.backupIndex=1,this.setLevel(S),this.queue=this._register(new k.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=v.LogLevel.Trace&&this._log(v.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=v.LogLevel.Debug&&this._log(v.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=v.LogLevel.Info&&this._log(v.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=v.LogLevel.Warning&&this._log(v.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=v.LogLevel.Error){const a=arguments[0];if(a instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=a.stack,this._log(v.LogLevel.Error,this.format(D))}else this._log(v.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=v.LogLevel.Critical&&this._log(v.LogLevel.Critical,this.format(arguments))}flush(){}log(a,D){this._log(a,this.format(D))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(a){if(a.fileOperationResult!==3)throw a}}_log(a,D){this.queue.queue(async()=>{await this.initializePromise;let S=await this.loadContent();S.length>C&&(await this.fileService.writeFile(this.getBackupResource(),R.VSBuffer.fromString(S)),S=""),S+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(a)}] ${D}
`,await this.fileService.writeFile(this.resource,R.VSBuffer.fromString(S))})}getCurrentTimestamp(){const a=w=>w<10?`0${w}`:w,D=w=>w<10?`00${w}`:w<100?`0${w}`:w,S=new Date;return`${S.getFullYear()}-${a(S.getMonth()+1)}-${a(S.getDate())} ${a(S.getHours())}:${a(S.getMinutes())}:${a(S.getSeconds())}.${D(S.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,L.joinPath)((0,L.dirname)(this.resource),`${(0,L.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(a){return""}}stringifyLogLevel(a){switch(a){case v.LogLevel.Critical:return"critical";case v.LogLevel.Debug:return"debug";case v.LogLevel.Error:return"error";case v.LogLevel.Info:return"info";case v.LogLevel.Trace:return"trace";case v.LogLevel.Warning:return"warning"}return""}format(a){let D="";for(let S=0;S<a.length;S++){let w=a[S];if(typeof w=="object")try{w=JSON.stringify(w)}catch(y){}D+=(S>0?" ":"")+w}return D}};d=ue([Y(3,T.IFileService)],d),e.FileLogger=d;let b=class extends P.Disposable{constructor(a,D,S){super();this.logService=a,this.instantiationService=D,this.fileService=S,this.loggers=new Map,this._register(a.onDidChangeLogLevel(w=>this.loggers.forEach(y=>y.setLevel(w))))}createLogger(a){let D=this.loggers.get(a.toString());return D||(D=new p.BufferLogService(this.logService.getLevel()),this.loggers.set(a.toString(),D),(0,T.whenProviderRegistered)(a,this.fileService).then(()=>D.logger=this.instantiationService.createInstance(d,(0,L.basename)(a),a,this.logService.getLevel()))),D}dispose(){this.loggers.forEach(a=>a.dispose()),this.loggers.clear(),super.dispose()}};b=ue([Y(0,v.ILogService),Y(1,g.IInstantiationService),Y(2,T.IFileService)],b),e.FileLoggerService=b}),define(Q[76],Z([0,1,14,3,5]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(b){this.service=b,this.onDidChangeLogLevel=T.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,I){switch(I){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${I}`)}async call(b,I,a){switch(I){case"setLevel":return this.service.setLevel(a)}throw new Error(`Call not found: ${I}`)}}e.LogLevelChannel=R;class L{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){L.setLevel(this.channel,b)}static setLevel(b,I){return b.call("setLevel",I)}}e.LogLevelChannelClient=L;class P{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,I){throw new Error(`Event not found: ${I}`)}async call(b,I,a){switch(I){case"createLogger":this.createLogger(k.URI.revive(a[0]),a[1]);return;case"log":return this.log(k.URI.revive(a[0]),a[1]);case"consoleLog":return this.consoleLog(a[0],a[1])}throw new Error(`Call not found: ${I}`)}createLogger(b,I){this.loggers.set(b.toString(),this.loggerService.createLogger(b,I))}consoleLog(b,I){let a=console.log;switch(b){case v.LogLevel.Error:a=console.error;break;case v.LogLevel.Warning:a=console.warn;break;case v.LogLevel.Info:a=console.info;break}a.call(console,...I)}log(b,I){const a=this.loggers.get(b.toString());if(!a)throw new Error("Create the logger before logging");for(const[D,S]of I)switch(D){case v.LogLevel.Trace:a.trace(S);break;case v.LogLevel.Debug:a.debug(S);break;case v.LogLevel.Info:a.info(S);break;case v.LogLevel.Warning:a.warn(S);break;case v.LogLevel.Error:a.error(S);break;case v.LogLevel.Critical:a.critical(S);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class g{constructor(b){this.channel=b}createConsoleMainLogger(){return new v.AdapterLogger({log:(b,I)=>{this.channel.call("consoleLog",[b,I])}})}createLogger(b,I){return new p(this.channel,b,I)}}e.LoggerChannelClient=g;class p extends v.AbstractMessageLogger{constructor(b,I,a){super(a==null?void 0:a.always);this.channel=b,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.channel.call("createLogger",[I,a]).then(()=>{this._log(this.buffer),this.isLoggerCreated=!0})}log(b,I){this._log([[b,I]])}_log(b){this.isLoggerCreated?this.channel.call("log",[this.file,b]):this.buffer.push(...b)}}class C extends v.LogService{constructor(b,I){super(I);this.parent=b,this._register(b.onDidChangeLogLevel(a=>I.setLevel(a)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=C}),define(Q[77],Z([0,1,14,9]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(g,p,C,d){try{const b=await new Promise((I,a)=>{G(["spdlog"],I,a)});return b.setAsyncMode(8192,500),b.createRotatingLoggerAsync(g,p,C,d)}catch(b){console.error(b)}return null}function R(g,p,C,d){return G.__$__nodeRequire("spdlog").createRotatingLogger(g,p,C,d)}e.createRotatingLogger=R;function L(g,p,C){switch(p){case v.LogLevel.Trace:g.trace(C);break;case v.LogLevel.Debug:g.debug(C);break;case v.LogLevel.Info:g.info(C);break;case v.LogLevel.Warning:g.warn(C);break;case v.LogLevel.Error:g.error(C);break;case v.LogLevel.Critical:g.critical(C);break;default:throw new Error("Invalid log level")}}class P extends v.AbstractMessageLogger{constructor(p,C,d,b){super();this.name=p,this.filepath=C,this.rotating=d,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}_createSpdLogLogger(){const p=this.rotating?6:1,C=30/p*T.ByteSize.MB;return k(this.name,this.filepath,C,p).then(d=>{if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:b,message:I}of this.buffer)L(this._logger,b,I);this.buffer=[]}})}log(p,C){this._logger?L(this._logger,p,C):this.getLevel()<=p&&this.buffer.push({level:p,message:C})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(Q[158],Z([0,1,14,2,11,16,157,77,9,30]),function(G,e,v,T,k,R,L,P,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let C=class extends T.Disposable{constructor(b,I){super();this.logService=b,this.fileService=I,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(b.onDidChangeLogLevel(a=>this.logLevelChangeableLoggers.forEach(D=>D.setLevel(a))))}createLogger(b,I){var a;let D=this.loggers.get(b.toString());return D||(b.scheme===R.Schemas.file?(D=new P.SpdLogLogger((I==null?void 0:I.name)||(0,p.generateUuid)(),b.fsPath,!(I==null?void 0:I.donotRotate),this.logService.getLevel()),(I==null?void 0:I.donotUseFormatters)&&D.clearFormatters()):D=new L.FileLogger((a=I==null?void 0:I.name)!==null&&a!==void 0?a:(0,k.basename)(b),b,this.logService.getLevel(),this.fileService),this.loggers.set(b.toString(),D),(I==null?void 0:I.always)?D.setLevel(v.LogLevel.Trace):this.logLevelChangeableLoggers.push(D)),D}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(b=>b.dispose()),this.loggers.clear(),super.dispose()}};C=ue([Y(0,v.ILogService),Y(1,g.IFileService)],C),e.LoggerService=C}),define(Q[57],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,v.createDecorator)("nativeHostService")}),define(Q[36],Z([0,1,7,53,16,11]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(v.isWeb||typeof G=="undefined"||typeof G.__$__nodeRequire!="function")L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.55.0-dev",nameShort:v.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:v.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});else{const P=(0,R.dirname)(k.FileAccess.asFileUri("",G));L=G.__$__nodeRequire((0,R.joinPath)(P,"product.json").fsPath);const g=G.__$__nodeRequire((0,R.joinPath)(P,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`}),Object.assign(L,{version:g.version})}e.default=L}),define(Q[159],Z([0,1,27,8,23,36,2,15,14,10]),function(G,e,v,T,k,R,L,P,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends L.Disposable{constructor(b,I){super();this._environmentService=b,this._logService=I,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let b=setTimeout(async()=>{b=void 0,this._logService.info("Starting to clean up unused language packs.");const I=R.default.nameLong.indexOf("Insiders")>=0?1e3*60*60*24*7:1e3*60*60*24*30*3;try{const a=Object.create(null),D=JSON.parse(await v.promises.readFile(T.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let m of Object.keys(D)){const o=D[m];a[`${o.hash}.${m}`]=!0}const S=T.join(this._environmentService.userDataPath,"clp");if(!await k.exists(S))return;for(let m of await k.readdir(S)){if(a[m]){this._logService.info(`Skipping directory ${m}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",m),await k.rimraf(T.join(S,m))}const y=Date.now();for(let m of Object.keys(a)){const o=T.join(S,m);for(let i of await k.readdir(o))if(i!=="tcf.json"){const t=T.join(o,i),n=await v.promises.stat(t);n.isDirectory()&&y-n.mtime.getTime()>I&&(this._logService.info("Removing language pack cache entry: ",T.join(m,i)),await k.rimraf(t))}}}catch(a){(0,P.onUnexpectedError)(a)}},40*1e3);this._register((0,L.toDisposable)(()=>{b!==void 0&&clearTimeout(b)}))}};C=ue([Y(0,p.INativeEnvironmentService),Y(1,g.ILogService)],C),e.LanguagePackCachedDataCleaner=C}),define(Q[160],Z([0,1,27,8,15,2,23,36]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;class g{constructor(C){this.nodeCachedDataDir=C,this._disposables=new R.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const C=(0,T.dirname)(this.nodeCachedDataDir),d=(0,T.basename)(this.nodeCachedDataDir);let b=setTimeout(()=>{b=void 0,(0,L.readdir)(C).then(I=>{const a=Date.now(),D=[];return I.forEach(S=>{if(S!==d){const w=(0,T.join)(C,S);D.push(v.promises.stat(w).then(y=>{if(y.isDirectory()&&a-y.mtime.getTime()>g._DataMaxAge)return(0,L.rimraf)(w)}))}}),Promise.all(D)}).then(void 0,k.onUnexpectedError)},30*1e3);this._disposables.add((0,R.toDisposable)(()=>{b&&(clearTimeout(b),b=void 0)}))}}}e.NodeCachedDataCleaner=g,g._DataMaxAge=P.default.nameLong.indexOf("Insiders")>=0?1e3*60*60*24*7:1e3*60*60*24*30*3}),define(Q[161],Z([0,1,38,36,96,8,11,86,54,16,5]),function(G,e,v,T,k,R,L,P,g,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataDir=e.parsePathArg=e.parseSearchPort=e.parseExtensionHostPort=e.NativeEnvironmentService=void 0;class d{constructor(y){if(this._args=y,!y.logsPath){const m=(0,g.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");y.logsPath=(0,R.join)(this.userDataPath,"logs",m)}this.logsPath=y.logsPath}get args(){return this._args}get appRoot(){return(0,R.dirname)(p.FileAccess.asFileUri("",G).fsPath)}get userHome(){return C.URI.file((0,v.homedir)())}get userDataPath(){const y=process.env.VSCODE_PORTABLE;return y?(0,R.join)(y,"user-data"):S(this._args,process)}get appSettingsHome(){return C.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file((0,v.tmpdir)())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return C.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(C.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=process.env.VSCODE_PORTABLE;return y?C.URI.file((0,R.join)(y,"argv.json")):(0,L.joinPath)(this.userHome,T.default.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=D(this._args["builtin-extensions-dir"],process);return y||(0,R.normalize)((0,R.join)(p.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=D(this._args["extensions-download-dir"],process);return y||(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=D(this._args["extensions-dir"],process);if(y)return y;const m=process.env.VSCODE_EXTENSIONS;if(m)return m;const o=process.env.VSCODE_PORTABLE;return o?(0,R.join)(o,"extensions"):(0,L.joinPath)(this.userHome,T.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this._args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(m=>/^[^:/?#]+?:\/\//.test(m)?C.URI.parse(m):C.URI.file((0,R.normalize)(m)))}get extensionDevelopmentKind(){var y;return(y=this._args.extensionDevelopmentKind)===null||y===void 0?void 0:y.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const y=this._args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?C.URI.parse(y):C.URI.file((0,R.normalize)(y))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const y=this._args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return b(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get serviceMachineIdResource(){return(0,L.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return C.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}ue([P.memoize],d.prototype,"appRoot",null),ue([P.memoize],d.prototype,"userHome",null),ue([P.memoize],d.prototype,"userDataPath",null),ue([P.memoize],d.prototype,"appSettingsHome",null),ue([P.memoize],d.prototype,"tmpDir",null),ue([P.memoize],d.prototype,"userRoamingDataHome",null),ue([P.memoize],d.prototype,"settingsResource",null),ue([P.memoize],d.prototype,"userDataSyncHome",null),ue([P.memoize],d.prototype,"userDataSyncLogResource",null),ue([P.memoize],d.prototype,"sync",null),ue([P.memoize],d.prototype,"machineSettingsResource",null),ue([P.memoize],d.prototype,"globalStorageHome",null),ue([P.memoize],d.prototype,"workspaceStorageHome",null),ue([P.memoize],d.prototype,"keybindingsResource",null),ue([P.memoize],d.prototype,"keyboardLayoutResource",null),ue([P.memoize],d.prototype,"argvResource",null),ue([P.memoize],d.prototype,"snippetsHome",null),ue([P.memoize],d.prototype,"isExtensionDevelopment",null),ue([P.memoize],d.prototype,"untitledWorkspacesHome",null),ue([P.memoize],d.prototype,"installSourcePath",null),ue([P.memoize],d.prototype,"builtinExtensionsPath",null),ue([P.memoize],d.prototype,"extensionsPath",null),ue([P.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ue([P.memoize],d.prototype,"extensionDevelopmentKind",null),ue([P.memoize],d.prototype,"extensionTestsLocationURI",null),ue([P.memoize],d.prototype,"debugExtensionHost",null),ue([P.memoize],d.prototype,"serviceMachineIdResource",null),ue([P.memoize],d.prototype,"telemetryLogResource",null),e.NativeEnvironmentService=d;function b(w,y){return a(w["inspect-extensions"],w["inspect-brk-extensions"],5870,y,w.debugId)}e.parseExtensionHostPort=b;function I(w,y){return a(w["inspect-search"],w["inspect-brk-search"],5876,y)}e.parseSearchPort=I;function a(w,y,m,o,i){const n=Number(y||w)||(o?null:m),r=n?Boolean(!!y):!1;return{port:n,break:r,debugId:i}}function D(w,y){if(!!w){const m=(0,R.resolve)(w);return(0,R.normalize)(w)===m?m:(0,R.resolve)(y.env.VSCODE_CWD||y.cwd(),w)}}e.parsePathArg=D;function S(w,y){return D(w["user-data-dir"],y)||(0,R.resolve)((0,k.getDefaultUserDataPath)())}e.parseUserDataDir=S}),define(Q[31],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Q[35],Z([0,1,17,85]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(L,P){T.ok(v.isString(L)),T.ok(v.isObject(P)),T.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,P)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new k}),define(Q[78],Z([0,1,35,3]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,p){this.schemasById[k(g)]=p,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new R;v.Registry.add(e.Extensions.JSONContribution,L)}),define(Q[39],Z([0,1,108,3,35,17,78]),function(G,e,v,T,k,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=k.Registry.as(L.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,y=!0){this.registerConfigurations([w],y)}registerConfigurations(w,y=!0){const m=[];w.forEach(o=>{m.push(...this.validateAndRegisterProperties(o,y)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(w){const y=[],m=o=>{if(o.properties)for(const i in o.properties)y.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>m(i))};for(const o of w){m(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}registerDefaultConfigurations(w){const y=[],m=[];for(const o of w)for(const i in o)if(y.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]=Object.assign(Object.assign({},this.defaultValues[i]||{}),o[i]);const t={type:"object",default:this.defaultValues[i],description:v.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};m.push(d(i)),this.configurationProperties[i]=t,this.defaultLanguageConfigurationOverridesNode.properties[i]=t}else{this.defaultValues[i]=o[i];const t=this.configurationProperties[i];t&&(this.updatePropertyDefaultValue(i,t),this.updateSchema(i,t))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}deregisterDefaultConfigurations(w){const y=[];for(const m of w)for(const o in m)if(y.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const i=this.configurationProperties[o];i&&(this.updatePropertyDefaultValue(o,i),this.updateSchema(o,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const y of w)this.overrideIdentifiers.add(y);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,y=!0,m=3){m=R.isUndefinedOrNull(w.scope)?m:w.scope;let o=[],i=w.properties;if(i)for(let n in i){if(y&&a(n)){delete i[n];continue}const r=i[n];if(this.updatePropertyDefaultValue(n,r),e.OVERRIDE_PROPERTY_PATTERN.test(n)?r.scope=void 0:r.scope=R.isUndefinedOrNull(r.scope)?m:r.scope,i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),o.push(n)}let t=w.allOf;if(t)for(let n of t)o.push(...this.validateAndRegisterProperties(n,y,m));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const y=m=>{let o=m.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let i=m.allOf;i&&i.forEach(y)};y(w)}updateSchema(w,y){switch(e.allSettings.properties[w]=y,y.scope){case 1:e.applicationSettings.properties[w]=y;break;case 2:e.machineSettings.properties[w]=y;break;case 6:e.machineOverridableSettings.properties[w]=y;break;case 3:e.windowSettings.properties[w]=y;break;case 4:e.resourceSettings.properties[w]=y;break;case 5:e.resourceSettings.properties[w]=y,this.resourceLanguageSettingsSchema.properties[w]=y;break}}removeFromSchema(w,y){switch(delete e.allSettings.properties[w],y.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const y=`[${w}]`,m={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(y,m),e.allSettings.properties[y]=m,e.applicationSettings.properties[y]=m,e.machineSettings.properties[y]=m,e.machineOverridableSettings.properties[y]=m,e.windowSettings.properties[y]=m,e.resourceSettings.properties[y]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,y){let m=this.defaultValues[w];R.isUndefined(m)&&(m=y.default),R.isUndefined(m)&&(m=b(y.type)),y.default=m}}const C="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(C);function d(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=d;function b(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const I=new p;k.Registry.add(e.Extensions.Configuration,I);function a(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?v.localize(5,null,S):I.getConfigurationProperties()[S]!==void 0?v.localize(6,null,S):null:v.localize(4,null)}e.validateProperty=a;function D(){const S=[],w=I.getConfigurationProperties();for(const y of Object.keys(w))S.push([y,w[y].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=D}),define(Q[24],Z([0,1,26,17,5,35,4,39]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function g(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof k.URI)}e.isConfigurationOverrides=g;var p;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(p=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function d(n,r){const c=r?n?r.keys.filter(O=>n.keys.indexOf(O)===-1):[...r.keys]:[],s=n?r?n.keys.filter(O=>r.keys.indexOf(O)===-1):[...n.keys]:[],l=[];if(r&&n){for(const O of n.keys)if(r.keys.indexOf(O)!==-1){const _=w(n.contents,O),q=w(r.contents,O);v.equals(_,q)||l.push(O)}}const h=[],f=O=>{const _={};for(const q of O)for(const x of q.identifiers)_[i(x)]=q;return _},E=r?f(r.overrides):{},u=n?f(n.overrides):{};if(Object.keys(E).length)for(const O of c){const _=E[O];_&&h.push([(0,P.overrideIdentifierFromKey)(O),_.keys])}if(Object.keys(u).length)for(const O of s){const _=u[O];_&&h.push([(0,P.overrideIdentifierFromKey)(O),_.keys])}if(Object.keys(E).length&&Object.keys(u).length)for(const O of l){const _=u[O],q=E[O];if(_&&q){const x=d({contents:_.contents,keys:_.keys,overrides:[]},{contents:q.contents,keys:q.keys,overrides:[]});h.push([(0,P.overrideIdentifierFromKey)(O),[...x.added,...x.removed,...x.updated]])}}return{added:c,removed:s,updated:l,overrides:h}}e.compare=d;function b(n,r){const c=[];for(const s of Object.keys(n))if(P.OVERRIDE_PROPERTY_PATTERN.test(s)){const l={};for(const h in n[s])l[h]=n[s][h];c.push({identifiers:[(0,P.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(l),contents:I(l,r)})}return c}e.toOverrides=b;function I(n,r){const c=Object.create(null);for(let s in n)a(c,s,n[s],r);return c}e.toValuesTree=I;function a(n,r,c,s){const l=r.split("."),h=l.pop();let f=n;for(let E=0;E<l.length;E++){let u=l[E],O=f[u];switch(typeof O){case"undefined":O=f[u]=Object.create(null);break;case"object":break;default:s(`Ignoring ${r} as ${l.slice(0,E+1).join(".")} is ${JSON.stringify(O)}`);return}f=O}if(typeof f=="object"&&f!==null)try{f[h]=c}catch(E){s(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(f)}`)}else s(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(f)}`)}e.addToValueTree=a;function D(n,r){const c=r.split(".");S(n,c)}e.removeFromValueTree=D;function S(n,r){const c=r.shift();if(r.length===0){delete n[c];return}if(Object.keys(n).indexOf(c)!==-1){const s=n[c];typeof s=="object"&&!Array.isArray(s)&&(S(s,r),Object.keys(s).length===0&&delete n[c])}}function w(n,r,c){function s(f,E){let u=f;for(const O of E){if(typeof u!="object"||u===null)return;u=u[O]}return u}const l=r.split("."),h=s(n,l);return typeof h=="undefined"?c:h}e.getConfigurationValue=w;function y(n,r,c){Object.keys(r).forEach(s=>{s!=="__proto__"&&(s in n?T.isObject(n[s])&&T.isObject(r[s])?y(n[s],r[s],c):c&&(n[s]=r[s]):n[s]=r[s])})}e.merge=y;function m(){const n=R.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=m;function o(){const n=Object.create(null),r=R.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let c in r){let s=r[c].default;a(n,c,s,l=>console.error(`Conflict in default settings: ${l}`))}return n}e.getDefaultValues=o;function i(n){return`[${n}]`}e.keyFromOverrideIdentifier=i;function t(n,r,c){const s=n.inspect(r),l=n.inspect(c);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:s.defaultValue}e.getMigratedSettingValue=t}),define(Q[162],Z([0,1,32,37,18,17,26,5,39,24,35,2,3]),function(G,e,v,T,k,R,L,P,g,p,C,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class I{constructor(t={},n=[],r=[]){this._contents=t,this._keys=n,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,p.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?(0,p.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const c of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[c],l=n[c];l&&(typeof s=="object"&&typeof l=="object"?(s=L.deepClone(s),this.mergeContents(s,l)):s=l),r[c]=s}return new I(r,this.keys,this.overrides)}merge(...t){const n=L.deepClone(this.contents),r=L.deepClone(this.overrides),c=[...this.keys];for(const s of t){this.mergeContents(n,s.contents);for(const l of s.overrides){const[h]=r.filter(f=>k.equals(f.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):r.push(L.deepClone(l))}for(const l of s.keys)c.indexOf(l)===-1&&c.push(l)}return new I(n,c,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&R.isObject(t[r])&&R.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=L.deepClone(n[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?L.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,p.addToValueTree)(this.contents,t,n,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,p.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let r=0;r<n;r++)t.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=I;class a extends I{constructor(){const t=(0,p.getDefaultValues)(),n=(0,p.getConfigurationKeys)(),r=[];for(const c of Object.keys(t))g.OVERRIDE_PROPERTY_PATTERN.test(c)&&r.push({identifiers:[(0,g.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(t[c]),contents:(0,p.toValuesTree)(t[c],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,n,r)}}e.DefaultConfigurationModel=a;class D{constructor(t,n){this._name=t,this._scopes=n,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get errors(){return this._parseErrors}parseContent(t){if(!R.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n)}}parseRaw(t){this._raw=t;const n=this.doParseRaw(t);this._configurationModel=new I(n.contents,n.keys,n.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let n={},r=null,c=[],s=[],l=[];function h(E){Array.isArray(c)?c.push(E):r&&(c[r]=E)}let f={onObjectBegin:()=>{let E={};h(E),s.push(c),c=E,r=null},onObjectProperty:E=>{r=E},onObjectEnd:()=>{c=s.pop()},onArrayBegin:()=>{let E=[];h(E),s.push(c),c=E,r=null},onArrayEnd:()=>{c=s.pop()},onLiteralValue:h,onError:(E,u,O)=>{l.push({error:E,offset:u,length:O})}};if(t)try{v.visit(t,f),n=c[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return n}doParseRaw(t){if(this._scopes){const s=C.Registry.as(g.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,s,!0,this._scopes)}const n=(0,p.toValuesTree)(t,s=>console.error(`Conflict in settings file ${this._name}: ${s}`)),r=Object.keys(t),c=(0,p.toOverrides)(t,s=>console.error(`Conflict in settings file ${this._name}: ${s}`));return{contents:n,keys:r,overrides:c}}filterByScope(t,n,r,c){const s={};for(let l in t)if(g.OVERRIDE_PROPERTY_PATTERN.test(l)&&r)s[l]=this.filterByScope(t[l],n,!1,c);else{const h=this.getScope(l,n);(h===void 0||c.indexOf(h)!==-1)&&(s[l]=t[l])}return s}getScope(t,n){const r=n[t];return r?typeof r.scope!="undefined"?r.scope:3:void 0}}e.ConfigurationModelParser=D;class S extends d.Disposable{constructor(t,n,r,c){super();this.userSettingsResource=t,this.scopes=n,this.fileService=c,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new D(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(b.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new I}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=S;class w{constructor(t,n,r=new I,c=new I,s=new T.ResourceMap,l=new I,h=new T.ResourceMap,f=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=c,this._folderConfigurations=s,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(t)}updateValue(t,n,r={}){let c;r.resource?(c=this._memoryConfigurationByResource.get(r.resource),c||(c=new I,this._memoryConfigurationByResource.set(r.resource,c))):c=this._memoryConfiguration,n===void 0?c.removeValue(t):c.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const c=this.getConsolidateConfigurationModel(n,r),s=this.getFolderConfigurationModelForResource(n.resource,r),l=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,h=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),f=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),u=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),O=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,q=n.overrideIdentifier?l.override(n.overrideIdentifier).getValue(t):l.getValue(t),x=c.getValue(t),j=k.distinct(k.flatten(c.overrides.map($=>$.identifiers))).filter($=>c.getOverrideValue(t,$)!==void 0);return{defaultValue:h,userValue:f,userLocalValue:E,userRemoteValue:u,workspaceValue:O,workspaceFolderValue:_,memoryValue:q,value:x,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:f!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:u!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:q!==void 0?{value:l.getValue(t),override:n.overrideIdentifier?l.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=n.filter(c=>g.OVERRIDE_PROPERTY_PATTERN.test(c)).map(c=>{const s=(0,g.overrideIdentifierFromKey)(c),l=this._defaultConfiguration.getKeysForOverrideIdentifier(s),h=t.getKeysForOverrideIdentifier(s),f=[...h.filter(E=>l.indexOf(E)===-1),...l.filter(E=>h.indexOf(E)===-1),...l.filter(E=>!L.equals(this._defaultConfiguration.override(s).getValue(E),t.override(s).getValue(E)))];return[s,f]});return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:c,overrides:s}=(0,p.compare)(this.localUserConfiguration,t),l=[...n,...r,...c];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:c,overrides:s}=(0,p.compare)(this.remoteUserConfiguration,t);let l=[...n,...r,...c];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:c,overrides:s}=(0,p.compare)(this.workspaceConfiguration,t);let l=[...n,...r,...c];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:s}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:c,updated:s,removed:l,overrides:h}=(0,p.compare)(r,n);let f=[...c,...s,...l];return(f.length||!r)&&this.updateFolderConfiguration(t,n),{keys:f,overrides:h}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:c,removed:s,overrides:l}=(0,p.compare)(n,void 0);return{keys:[...r,...c,...s],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let r=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const c=n.getFolder(t);c&&(r=this.getFolderConsolidatedConfiguration(c.uri)||r);const s=this._memoryConfigurationByResource.get(t);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(t);c?(n=r.merge(c),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:c,keys:s}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:c,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(c=>n.add(c))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),c=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((l,h)=>(l.set(P.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new T.ResourceMap);return new w(n,r,new I,c,s,new I,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new I(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function y(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const t=new Set,n=new Map;for(const c of i)c.keys.forEach(s=>t.add(s)),c.overrides.forEach(([s,l])=>{const h=(0,T.getOrSet)(n,s,new Set);l.forEach(f=>h.add(f))});const r=[];return n.forEach((c,s)=>r.push([s,[...c.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=y;class m{constructor(t,n,r,c){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=c,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(h=>s.add(h)),t.overrides.forEach(([,h])=>h.forEach(f=>s.add(f))),this.affectedKeys=[...s.values()];const l=new I;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const c=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,s=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!L.equals(c,s)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let r=(0,p.toValuesTree)({[n]:!0},()=>{}),c;for(;typeof r=="object"&&(c=Object.keys(r)[0]);){if(t=t[c],!t)return!1;r=r[c]}return!0}}e.ConfigurationChangeEvent=m;class o extends m{constructor(t,n,r,c){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=r,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=o}),define(Q[163],Z([0,1,35,39,2,24,162,3,6,11]),function(G,e,v,T,k,R,L,P,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends k.Disposable{constructor(b,I){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new L.UserSettings(this.settingsResource,void 0,p.extUriBiasedIgnorePathCase,I)),this.configuration=new L.Configuration(new L.DefaultConfigurationModel,new L.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new g.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(T.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new L.Configuration(new L.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,I){const a=typeof b=="string"?b:void 0,D=(0,R.isConfigurationOverrides)(b)?b:(0,R.isConfigurationOverrides)(I)?I:{};return this.configuration.getValue(a,D,void 0)}updateValue(b,I,a,D){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const I=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(a,I,1)}onDidDefaultConfigurationChange(b){const I=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new L.DefaultConfigurationModel,b);this.trigger(a,I,6)}trigger(b,I,a){const D=new L.ConfigurationChangeEvent(b,{data:I},this.configuration);D.source=a,D.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(D)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(Q[164],Z([0,1,24,14,101]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let R=class{constructor(P,g){this.configurationService=P,this.logService=g}request(P,g){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,k.request)(P,g)}async resolveProxy(P){}};R=ue([Y(0,v.IConfigurationService),Y(1,T.ILogService)],R),e.RequestService=R}),define(Q[40],Z([0,1,119,4,39,35,22]),function(G,e,v,T,k,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=P;function g(d){return d.res.statusCode===204}async function p(d){if(!P(d))throw new Error("Server returned "+d.res.statusCode);return g(d)?null:(await(0,L.streamToBuffer)(d.stream)).toString()}e.asText=p;async function C(d){if(!P(d))throw new Error("Server returned "+d.res.statusCode);if(g(d))return null;const I=(await(0,L.streamToBuffer)(d.stream)).toString();try{return JSON.parse(I)}catch(a){throw a.message+=`:
`+I,a}}e.asJson=C,R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,v.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,v.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,v.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,v.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,v.localize)(4,null),(0,v.localize)(5,null),(0,v.localize)(6,null)],default:"override",description:(0,v.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,v.localize)(8,null)}}})}),define(Q[165],Z([0,1,40,29,9,16]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(g,p){this.requestService=g,this.fileService=p}async download(g,p,C=T.CancellationToken.None){if(g.scheme===R.Schemas.file||g.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(g,p);return}const d={type:"GET",url:g.toString()},b=await this.requestService.request(d,C);if(b.res.statusCode===200)await this.fileService.writeFile(p,b.stream);else{const I=await(0,v.asText)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${I}`)}}};L=ue([Y(0,v.IRequestService),Y(1,k.IFileService)],L),e.DownloadService=L}),define(Q[166],Z([0,1,31,9,18,62,40,29,14,11,127,2]),function(G,e,v,T,k,R,L,P,g,p,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends d.Disposable{constructor(a,D,S,w){super();this.fileService=a,this.productService=D,this.requestService=S,this.logService=w,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:y})=>this.allConfigBasedTips.set(y.configPath,y))}getConfigBasedTips(a){return this.getValidConfigBasedTips(a)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(a){const D=[];for(const[S,w]of this.allConfigBasedTips)try{const y=await this.fileService.readFile((0,p.joinPath)(a,S)),m=new Map;(0,R.forEach)(w.recommendations,({key:i,value:t})=>{if((0,k.isNonEmptyArray)(t.remotes))for(const n of t.remotes)m.set(n,{extensionId:i,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else D.push({extensionId:i,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,C.getDomainsOfRemotes)(y.value.toString(),[...m.keys()]);for(const i of o){const t=m.get(i);t&&D.push(t)}}catch(y){}return D}async fetchWorkspacesTips(){var a,D;if(!((a=this.productService.extensionsGallery)===null||a===void 0?void 0:a.recommendationsUrl))return[];try{const S=await this.requestService.request({type:"GET",url:(D=this.productService.extensionsGallery)===null||D===void 0?void 0:D.recommendationsUrl},P.CancellationToken.None);if(S.res.statusCode!==200)return[];const w=await(0,L.asJson)(S);return w?w.workspaceRecommendations||[]:[]}catch(S){return this.logService.error(S),[]}}};b=ue([Y(0,T.IFileService),Y(1,v.IProductService),Y(2,L.IRequestService),Y(3,g.ILogService)],b),e.ExtensionTipsService=b}),define(Q[44],Z([0,1,30,22]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,L,P){let g=P&&P.get("storage.serviceMachineId",0)||null;if(g)return g;try{const C=(await L.readFile(R.serviceMachineIdResource)).value.toString();g=(0,v.isUUID)(C)?C:null}catch(p){g=null}if(!g){g=(0,v.generateUuid)();try{await L.writeFile(R.serviceMachineIdResource,T.VSBuffer.fromString(g))}catch(p){}}return P&&P.store("storage.serviceMachineId",g,0,1),g}e.getServiceMachineId=k}),define(Q[19],Z([0,1,4,3,2,17,67,6]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var p;(function(D){D[D.NONE=0]="NONE",D[D.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(D){D[D.GLOBAL=0]="GLOBAL",D[D.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var d;(function(D){D[D.USER=0]="USER",D[D.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class b extends k.Disposable{constructor(S={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,P.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,w){w===g?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:w,target:this.getKeyTargets(S)[w]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,w,y){var m;return(m=this.getStorage(w))===null||m===void 0?void 0:m.get(S,y)}getBoolean(S,w,y){var m;return(m=this.getStorage(w))===null||m===void 0?void 0:m.getBoolean(S,y)}getNumber(S,w,y){var m;return(m=this.getStorage(w))===null||m===void 0?void 0:m.getNumber(S,y)}store(S,w,y,m){if((0,R.isUndefinedOrNull)(w)){this.remove(S,y);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(S,y,m),(o=this.getStorage(y))===null||o===void 0||o.set(S,w)})}remove(S,w){this.withPausedEmitters(()=>{var y;this.updateKeyTarget(S,w,void 0),(y=this.getStorage(w))===null||y===void 0||y.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,w){const y=[],m=this.getKeyTargets(S);for(const o of Object.keys(m))m[o]===w&&y.push(o);return y}updateKeyTarget(S,w,y){var m,o;const i=this.getKeyTargets(w);typeof y=="number"?i[S]!==y&&(i[S]=y,(m=this.getStorage(w))===null||m===void 0||m.set(g,JSON.stringify(i))):typeof i[S]=="number"&&(delete i[S],(o=this.getStorage(w))===null||o===void 0||o.set(g,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const w=this.get(g,S);if(w)try{return JSON.parse(w)}catch(y){}return Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(){var S,w,y,m;this._onWillSaveState.fire({reason:p.NONE}),await P.Promises.settled([(w=(S=this.getStorage(0))===null||S===void 0?void 0:S.whenFlushed())!==null&&w!==void 0?w:Promise.resolve(),(m=(y=this.getStorage(1))===null||y===void 0?void 0:y.whenFlushed())!==null&&m!==void 0?m:Promise.resolve()])}async logStorage(){var S,w,y,m,o,i;const t=(w=(S=this.getStorage(0))===null||S===void 0?void 0:S.items)!==null&&w!==void 0?w:new Map,n=(m=(y=this.getStorage(1))===null||y===void 0?void 0:y.items)!==null&&m!==void 0?m:new Map;return a(t,n,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(i=this.getLogDetails(1))!==null&&i!==void 0?i:"")}}e.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class I extends b{constructor(){super();this.globalStorage=new L.Storage(new L.InMemoryStorageDatabase),this.workspaceStorage=new L.Storage(new L.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}e.InMemoryStorageService=I;async function a(D,S,w,y){const m=s=>{try{return JSON.parse(s)}catch(l){return s}},o=new Map,i=new Map;D.forEach((s,l)=>{o.set(l,s),i.set(l,m(s))});const t=new Map,n=new Map;S.forEach((s,l)=>{t.set(l,s),n.set(l,m(s))}),console.group(`Storage: Global (path: ${w})`);let r=[];o.forEach((s,l)=>{r.push({key:l,value:s})}),console.table(r),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${y})`);let c=[];t.forEach((s,l)=>{c.push({key:l,value:s})}),console.table(c),console.groupEnd(),console.log(n)}e.logStorage=a}),define(Q[167],Z([0,1,3,2,28,34,19,17]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let g=class extends T.Disposable{constructor(d){super();this._onDidChangeEnablement=new v.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new p(d)),this._register(this.storageManger.onDidChange(b=>this._onDidChangeEnablement.fire({extensions:b,source:"storage"})))}async enableExtension(d,b){return this._removeFromDisabledExtensions(d)?(this._onDidChangeEnablement.fire({extensions:[d],source:b}),!0):!1}async disableExtension(d,b){return this._addToDisabledExtensions(d)?(this._onDidChangeEnablement.fire({extensions:[d],source:b}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(d){let b=this.getDisabledExtensions();return b.every(I=>!(0,R.areSameExtensions)(I,d))?(b.push(d),this._setDisabledExtensions(b),!0):!1}_removeFromDisabledExtensions(d){let b=this.getDisabledExtensions();for(let I=0;I<b.length;I++){const a=b[I];if((0,R.areSameExtensions)(a,d))return b.splice(I,1),this._setDisabledExtensions(b),!0}return!1}_setDisabledExtensions(d){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,d)}_getExtensions(d){return this.storageManger.get(d,0)}_setExtensions(d,b){this.storageManger.set(d,b,0)}};g=ue([Y(0,L.IStorageService)],g),e.GlobalExtensionEnablementService=g;class p extends T.Disposable{constructor(d){super();this.storageService=d,this.storage=Object.create(null),this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._register(d.onDidChangeValue(b=>this.onDidStorageChange(b)))}get(d,b){let I;return b===0?((0,P.isUndefinedOrNull)(this.storage[d])&&(this.storage[d]=this._get(d,b)),I=this.storage[d]):I=this._get(d,b),JSON.parse(I)}set(d,b,I){let a=JSON.stringify(b.map(({id:S,uuid:w})=>({id:S,uuid:w})));this._get(d,I)!==a&&(I===0&&(b.length?this.storage[d]=a:delete this.storage[d]),this._set(d,b.length?a:void 0,I))}onDidStorageChange(d){if(d.scope===0&&!(0,P.isUndefinedOrNull)(this.storage[d.key])&&this._get(d.key,d.scope)!==this.storage[d.key]){const I=this.get(d.key,d.scope);delete this.storage[d.key];const a=this.get(d.key,d.scope),D=I.filter(w=>!a.some(y=>(0,R.areSameExtensions)(w,y))),S=a.filter(w=>!I.some(y=>(0,R.areSameExtensions)(y,w)));(D.length||S.length)&&this._onDidChange.fire([...D,...S])}}_get(d,b){return this.storageService.get(d,b,"[]")}_set(d,b,I){b?this.storageService.store(d,b,I,1):this.storageService.remove(d,I)}}e.StorageManager=p}),define(Q[168],Z([0,1,3,2]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class k extends T.Disposable{constructor(p,C){super();this.channel=p,this.workspace=C}async getItems(){const p={workspace:this.workspace},C=await this.channel.call("getItems",p);return new Map(C)}updateItems(p){const C={workspace:this.workspace};return p.insert&&(C.insert=Array.from(p.insert.entries())),p.delete&&(C.delete=Array.from(p.delete.values())),this.channel.call("updateItems",C)}}class R extends k{constructor(p){super(p,void 0);this._onDidChangeItemsExternal=this._register(new v.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(p=>this.onDidChangeGlobalStorage(p)))}onDidChangeGlobalStorage(p){(Array.isArray(p.changed)||Array.isArray(p.deleted))&&this._onDidChangeItemsExternal.fire({changed:p.changed?new Map(p.changed):void 0,deleted:p.deleted?new Set(p.deleted):void 0})}async close(){this.dispose()}}class L extends k{constructor(p,C){super(p,C);this.onDidChangeItemsExternal=v.Event.None}async close(){const p={workspace:this.workspace};return this.channel.call("close",p)}}class P extends T.Disposable{constructor(p,C){super();this.channel=p,this.workspace=C,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new R(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new L(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Q[169],Z([0,1,2,19,67,6,153,168,11]),function(G,e,v,T,k,R,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class p extends T.AbstractStorageService{constructor(d,b,I){super();this.mainProcessService=b,this.environmentService=I,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new v.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(d)}createGlobalStorage(){const d=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),b=new k.Storage(d.globalStorage);return this._register(b.onDidChangeStorage(I=>this.emitDidChangeValue(0,I))),b}createWorkspaceStorage(d){const b=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),d);if(b.workspaceStorage){const I=new k.Storage(b.workspaceStorage);return this.workspaceStorageDisposable.value=I.onDidChangeStorage(a=>this.emitDidChangeValue(1,a)),this.workspaceStorageId=d==null?void 0:d.id,I}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var d,b;(0,L.mark)("code/willInitStorage");try{await R.Promises.settled([this.globalStorage.init(),(b=(d=this.workspaceStorage)===null||d===void 0?void 0:d.init())!==null&&b!==void 0?b:Promise.resolve()])}finally{(0,L.mark)("code/didInitStorage")}}getStorage(d){return d===0?this.globalStorage:this.workspaceStorage}getLogDetails(d){return d===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,g.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var d,b;this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),(b=(d=this.workspaceStorage)===null||d===void 0?void 0:d.close())!==null&&b!==void 0?b:Promise.resolve()])}async migrate(d){var b;const I=this.workspaceStorage,a=(b=I==null?void 0:I.items)!==null&&b!==void 0?b:new Map;I&&(await I.close(),I.dispose()),this.workspaceStorage=this.createWorkspaceStorage(d),await this.workspaceStorage.init();for(const[D,S]of a)this.workspaceStorage.set(D,S)}}e.NativeStorageService=p}),define(Q[170],Z([0,1,7,53,30,5]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function L(g,p,C,d,b,I,a,D,S){const w=Object.create(null);w["common.machineId"]=I,w.sessionID=(0,k.generateUuid)()+Date.now(),w.commitHash=d,w.version=b,w["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,v.PlatformToString)(v.platform),w["common.nodePlatform"]=T.platform,w["common.nodeArch"]=C,w["common.product"]=S||"desktop";const y=P(a||[]);y&&(w["common.msftInternal"]=y);let m=0;const o=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),v.isLinuxSnap&&(w["common.snap"]="true");try{const i=await g.readFile(R.URI.file(D));w["common.source"]=i.value.toString().slice(0,30)}catch(i){}return w}e.resolveCommonProperties=L;function P(g){const p=T.env.USERDNSDOMAIN;if(!p)return!1;const C=p.toLowerCase();return g.some(d=>C===d)}}),define(Q[25],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Q[171],Z([0,1,38,93,69,27,8,32,95,36,7,5,25,52,16,9,23]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function w(t,n){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],c=new Map,s=new Map,l=2e4;function h(u,O,_,q){const x=O.substring(u.length+1);return new Promise(async j=>{var $,W,B;let M;try{M=await(0,S.readdir)(O,{withFileTypes:!0})}catch(U){j();return}if(q.count>=l){q.count+=M.length,q.maxReached=!0,j();return}let F=M.length;if(F===0){j();return}let A=M;q.count+M.length>l&&(q.maxReached=!0,F=l-q.count,A=M.slice(0,F)),q.count+=M.length;for(const U of A)if(U.isDirectory()){if(_.includes(U.name)||await h(u,(0,L.join)(O,U.name),_,q),--F==0){j();return}}else{const N=U.name.lastIndexOf(".");if(N>=0){const z=U.name.substring(N+1);z&&c.set(z,(($=c.get(z))!==null&&$!==void 0?$:0)+1)}for(const z of r)((W=z.relativePathPattern)===null||W===void 0?void 0:W.test(x))!==!1&&z.filePattern.test(U.name)&&s.set(z.tag,((B=s.get(z.tag))!==null&&B!==void 0?B:0)+1);if(--F==0){j();return}}})}const f={count:0,maxReached:!1};await h(t,t,n,f);const E=await o(t);return{configFiles:y(s),fileTypes:y(c),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:E}}e.collectWorkspaceStats=w;function y(t){return[...I.Iterable.map(t.entries(),([n,r])=>({name:n,count:r}))].sort((n,r)=>r.count-n.count)}function m(){const t={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/D.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/D.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(T.virtualMachineHint.value()*100)}%`},n=v.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=m;function o(t){let n=new Map,r=(0,L.join)(t,".vscode","launch.json");return new Promise((c,s)=>{(0,R.exists)(r,l=>{if(l)(0,R.readFile)(r,(h,f)=>{if(h)return c([]);const E=[],u=(0,P.parse)(f.toString(),E);if(E.length)return console.log(`Unable to parse ${r}`),c([]);if((0,P.getNodeType)(u)==="object"&&u.configurations)for(const O of u.configurations){const _=O.type;_&&(n.has(_)?n.set(_,n.get(_)+1):n.set(_,1))}return c(y(n))});else return c([])})})}e.collectLaunchConfigs=o;let i=class{constructor(n){this.telemetryService=n}formatMachineInfo(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}formatEnvironment(n){const r=[];r.push(`Version:          ${p.default.nameShort} ${p.default.version} (${p.default.commit||"Commit unknown"}, ${p.default.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const c=v.cpus();return c&&c.length>0&&r.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/D.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/D.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||r.push(`Load (avg):       ${v.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(T.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,g.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async c=>{let[s,l]=c,h=this.formatProcessList(n,s);return r.forEach(f=>{if((0,k.isRemoteDiagnosticError)(f))h+=`
${f.errorMessage}`,l+=`
${f.errorMessage}`;else if(h+=`

Remote: ${f.hostName}`,f.processes&&(h+=`
${this.formatProcessList(n,f.processes)}`),f.workspaceMetadata){l+=`
|  Remote: ${f.hostName}`;for(const E of Object.keys(f.workspaceMetadata)){const u=f.workspaceMetadata[E];let O=`${u.fileCount} files`;u.maxFilesReached&&(O=`more than ${O}`),l+=`|    Folder (${E}): ${O}`,l+=this.formatWorkspaceStats(u)}}}),{processInfo:h,workspaceInfo:l}})}async getSystemInfo(n,r){const{memory:c,vmHint:s,os:l,cpus:h}=m(),f={os:l,memory:c,cpus:h,vmHint:s,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return C.isWindows||(f.load=`${v.loadavg().map(E=>Math.round(E)).join(", ")}`),C.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(n,r){const c=[];return(0,g.listProcesses)(n.mainPID).then(async s=>(c.push(""),c.push(this.formatEnvironment(n)),c.push(""),c.push(this.formatProcessList(n,s)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.formatWorkspaceMetadata(n))),r.forEach(l=>{if((0,k.isRemoteDiagnosticError)(l))c.push(`
${l.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${l.hostName}`),c.push(this.formatMachineInfo(l.machineInfo)),l.processes&&c.push(this.formatProcessList(n,l.processes)),l.workspaceMetadata)for(const h of Object.keys(l.workspaceMetadata)){const f=l.workspaceMetadata[h];let E=`${f.fileCount} files`;f.maxFilesReached&&(E=`more than ${E}`),c.push(`Folder (${h}): ${E}`),c.push(this.formatWorkspaceStats(f))}}),c.push(""),c.push(""),c.join(`
`)))}formatWorkspaceStats(n){const r=[],c=60;let s=0;const l=(u,O)=>{const _=` ${u}(${O})`;s+_.length>c?(r.push(h),h="|                 ",s=h.length):s+=_.length,h+=_};let h="|      File types:";const f=10;let E=n.fileTypes.length>f?f:n.fileTypes.length;for(let u=0;u<E;u++){const O=n.fileTypes[u];l(O.name,O.count)}if(r.push(h),n.configFiles.length>=0&&(h="|      Conf files:",s=0,n.configFiles.forEach(u=>{l(u.name,u.count)}),r.push(h)),n.launchConfigFiles.length>0){let u="|      Launch Configs:";n.launchConfigFiles.forEach(O=>{u+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),r.push(u)}return r.join(`
`)}expandGPUFeatures(n){const r=Math.max(...Object.keys(n).map(c=>c.length));return Object.keys(n).map(c=>`${c}:  ${" ".repeat(r-c.length)}  ${n[c]}`).join(`
                  `)}formatWorkspaceMetadata(n){const r=[],c=[];return n.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const h=d.URI.revive(l);if(h.scheme===a.Schemas.file){const f=h.fsPath;c.push(w(f,["node_modules",".git"]).then(E=>{let u=`${E.fileCount} files`;E.maxFilesReached&&(u=`more than ${u}`),r.push(`|    Folder (${(0,L.basename)(f)}): ${u}`),r.push(this.formatWorkspaceStats(E))}).catch(E=>{r.push(`|      Error: Unable to collect workspace stats for folder ${f} (${E.toString()})`)}))}else r.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(n,r){const c=new Map;n.windows.forEach(l=>c.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(n.mainPID,c,s,r,0),s.join(`
`)}formatProcessItem(n,r,c,s,l){const h=l===0;let f;h?f=s.pid===n?`${p.default.applicationName} main`:"remote agent":(f=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(f=`${f} (${r.get(s.pid)})`));const E=process.platform==="win32"?s.mem:v.totalmem()*(s.mem/100);c.push(`${s.load.toFixed(0).padStart(5," ")}	${(E/D.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(s.children)&&s.children.forEach(u=>this.formatProcessItem(n,r,c,u,l+1))}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const c=d.URI.revive(r);if(c.scheme===a.Schemas.file){const s=c.fsPath;try{const l=await w(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})}),l.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})}),l.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})})}catch(l){}}}}};i=ue([Y(0,b.ITelemetryService)],i),e.DiagnosticsService=i}),define(Q[172],Z([0,1,15,28,34,26,25,40,68,10,29,14,9,5,31,19,44,4,11]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var m;(function(A){A[A.None=0]="None",A[A.IncludeVersions=1]="IncludeVersions",A[A.IncludeFiles=2]="IncludeFiles",A[A.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",A[A.IncludeSharedAccounts=8]="IncludeSharedAccounts",A[A.IncludeVersionProperties=16]="IncludeVersionProperties",A[A.ExcludeNonValidated=32]="ExcludeNonValidated",A[A.IncludeInstallationTargets=64]="IncludeInstallationTargets",A[A.IncludeAssetUri=128]="IncludeAssetUri",A[A.IncludeStatistics=256]="IncludeStatistics",A[A.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",A[A.Unpublished=4096]="Unpublished"})(m||(m={}));function o(...A){return String(A.reduce((U,N)=>U|N,0))}var i;(function(A){A[A.Tag=1]="Tag",A[A.ExtensionId=4]="ExtensionId",A[A.Category=5]="Category",A[A.ExtensionName=7]="ExtensionName",A[A.Target=8]="Target",A[A.Featured=9]="Featured",A[A.SearchText=10]="SearchText",A[A.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:m.None,criteria:[],assetTypes:[]};class s{constructor(U=c){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(U,N=this.state.pageSize){return new s(Object.assign(Object.assign({},this.state),{pageNumber:U,pageSize:N}))}withFilter(U,...N){const z=[...this.state.criteria,...N.length?N.map(H=>({filterType:U,value:H})):[{filterType:U}]];return new s(Object.assign(Object.assign({},this.state),{criteria:z}))}withSortBy(U){return new s(Object.assign(Object.assign({},this.state),{sortBy:U}))}withSortOrder(U){return new s(Object.assign(Object.assign({},this.state),{sortOrder:U}))}withFlags(...U){return new s(Object.assign(Object.assign({},this.state),{flags:U.reduce((N,z)=>N|z,0)}))}withAssetTypes(...U){return new s(Object.assign(Object.assign({},this.state),{assetTypes:U}))}get raw(){const{criteria:U,pageNumber:N,pageSize:z,sortBy:H,sortOrder:K,flags:te,assetTypes:X}=this.state;return{filters:[{criteria:U,pageNumber:N,pageSize:z,sortBy:H,sortOrder:K}],assetTypes:X,flags:te}}get searchText(){const U=this.state.criteria.filter(N=>N.filterType===i.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(A,U){const N=(A||[]).filter(z=>z.statisticName===U)[0];return N?N.value:0}function h(A){const U="Microsoft.VisualStudio.Code.Translation.";return A.files.filter(z=>z.assetType.indexOf(U)===0).reduce((z,H)=>{const K=O(A,H.assetType);return K&&z.push([H.assetType.substring(U.length),K]),z},[])}function f(A){if(A.properties){const U=A.properties.filter(H=>H.key===t.Repository),N=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),z=U.filter(H=>N.test(H.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return O(A,t.Repository)}function E(A){return{uri:`${A.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${A.fallbackAssetUri}/${t.VSIX}`}}function u(A){const U=O(A,t.Icon);if(U)return U;const N=T.DefaultIconPath;return{uri:N,fallbackUri:N}}function O(A,U){return A.files.filter(z=>z.assetType===U)[0]?{uri:`${A.assetUri}/${U}`,fallbackUri:`${A.fallbackAssetUri}/${U}`}:null}function _(A,U){const N=A.properties?A.properties.filter(H=>H.key===U):[],z=N.length>0&&N[0].value;return z?z.split(",").map(H=>(0,k.adoptToGalleryExtensionId)(H)):[]}function q(A){const U=A.properties?A.properties.filter(N=>N.key===n.Engine):[];return U.length>0&&U[0].value||""}function x(A){const U=A.properties?A.properties.filter(z=>z.key===n.LocalizedLanguages):[],N=U.length>0&&U[0].value||"";return N?N.split(","):[]}function j(A){return A.indexOf("preview")!==-1}function $(A){const U=A.properties?A.properties.find(N=>N.key===n.WebExtension):void 0;return!!U&&U.value==="true"}function W(A){return A.files.some(U=>U.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,y.joinPath)(I.URI.parse(A.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function B(A,U,N,z,H){const K={manifest:O(U,t.Manifest),readme:O(U,t.Details),changelog:O(U,t.Changelog),license:O(U,t.License),repository:f(U),download:E(U),icon:u(U),coreTranslations:h(U)};return{identifier:{id:(0,k.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},name:A.extensionName,version:U.version,date:U.lastUpdated,displayName:A.displayName,publisherId:A.publisher.publisherId,publisher:A.publisher.publisherName,publisherDisplayName:A.publisher.displayName,description:A.shortDescription||"",installCount:l(A.statistics,"install"),rating:l(A.statistics,"averagerating"),ratingCount:l(A.statistics,"ratingcount"),assetUri:I.URI.parse(U.assetUri),webResource:W(U),assetTypes:U.files.map(({assetType:te})=>te),assets:K,properties:{dependencies:_(U,n.Dependency),extensionPack:_(U,n.ExtensionPack),engine:q(U),localizedLanguages:x(U),webExtension:$(U)},telemetryData:{index:(z.pageNumber-1)*z.pageSize+N,searchText:z.searchText,querySource:H},preview:j(A.flags)}}let M=class{constructor(U,N,z,H,K,te,X){this.requestService=U,this.logService=N,this.environmentService=z,this.telemetryService=H,this.fileService=K,this.productService=te;const ie=te.extensionsGallery;this.extensionsGalleryUrl=ie&&ie.serviceUrl,this.extensionsControlUrl=ie&&ie.controlUrl,this.commonHeadersPromise=F(te.version,this.environmentService,this.fileService,X)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,N){const z=[];let{total:H,firstPage:K,getPage:te}=await this.query({names:U,pageSize:U.length},N);z.push(...K);for(let X=1;z.length<H&&(K=await te(X,N),K.length);X++)z.push(...K);return z}async getCompatibleExtension(U,N){const z=await this.getCompatibleExtensionByEngine(U,N);return(z==null?void 0:z.properties.webExtension)?z.webResource?z:null:z}async getCompatibleExtensionByEngine(U,N){const z=(0,T.isIExtensionIdentifier)(U)?null:U;if(z&&z.properties.engine&&(0,g.isEngineValid)(z.properties.engine,this.productService.version))return z;const{id:H,uuid:K}=z?z.identifier:U;let te=new s().withFlags(m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");K?te=te.withFilter(i.ExtensionId,K):te=te.withFilter(i.ExtensionName,H);const{galleryExtensions:X}=await this.queryGallery(te,C.CancellationToken.None),[ie]=X;if(!ie||!ie.versions.length)return null;if(N){const ce=ie.versions.filter(he=>he.version===N)[0];if(ce){const he=B(ie,ce,0,te);if(he.properties.engine&&(0,g.isEngineValid)(he.properties.engine,this.productService.version))return he}return null}const se=await this.getLastValidExtensionVersion(ie,ie.versions);return se?B(ie,se,0,te):null}async query(U,N){const z=C.CancellationToken.isCancellationToken(U)?{}:U,H=C.CancellationToken.isCancellationToken(U)?U:N;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let K=z.text||"";const te=(0,R.getOrDefault)(z,me=>me.pageSize,50);let X=new s().withFlags(m.IncludeLatestVersionOnly,m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,te).withFilter(i.Target,"Microsoft.VisualStudio.Code");K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,we,Ie)=>(X=X.withFilter(i.Category,Ie||we),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,we,Ie)=>(X=X.withFilter(i.Tag,Ie||we),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),X=X.withFilter(i.SearchText,K)),X=X.withSortBy(0)):z.ids?X=X.withFilter(i.ExtensionId,...z.ids):z.names?X=X.withFilter(i.ExtensionName,...z.names):X=X.withSortBy(4),typeof z.sortBy=="number"&&(X=X.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(X=X.withSortOrder(z.sortOrder));const{galleryExtensions:ie,total:se}=await this.queryGallery(X,H),ce=ie.map((me,we)=>B(me,me.versions[0],we,X,z.source)),he=async(me,we)=>{if(we.isCancellationRequested)throw(0,v.canceled)();const Ie=X.withPage(me+1),{galleryExtensions:Ae}=await this.queryGallery(Ie,we);return Ae.map((ke,Fe)=>B(ke,ke.versions[0],Fe,Ie,z.source))};return{firstPage:ce,total:se,pageSize:X.pageSize,getPage:he}}async queryGallery(U,N){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,m.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,o(m.Unpublished));const z=await this.commonHeadersPromise,H=JSON.stringify(U.raw),K=Object.assign(Object.assign({},z),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)}),te=new Date().getTime();let X,ie,se=0;try{if(X=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:K},N),X.res.statusCode&&X.res.statusCode>=400&&X.res.statusCode<500)return{galleryExtensions:[],total:se};const ce=await(0,P.asJson)(X);if(ce){const he=ce.results[0],me=he.extensions,we=he.resultMetadata&&he.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return se=we&&we.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:se}}return{galleryExtensions:[],total:se}}catch(ce){throw ie=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},U.telemetryData),{requestBodySize:String(H.length),duration:new Date().getTime()-te,success:!!X&&(0,P.isSuccess)(X),responseBodySize:X==null?void 0:X.res.headers["Content-Length"],statusCode:X?String(X.res.statusCode):void 0,errorCode:ie?(0,v.isPromiseCanceledError)(ie)?"canceled":(0,v.getErrorMessage)(ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(se)}))}}async reportStatistic(U,N,z,H){if(!!this.isEnabled()){const K=await this.commonHeadersPromise,te=Object.assign(Object.assign({},K),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${U}/extensions/${N}/${z}/stats?statType=${H}`),headers:te},C.CancellationToken.None)}catch(X){}}}async download(U,N,z){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const H=(0,k.getGalleryExtensionTelemetryData)(U),K=new Date().getTime(),te=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},H),{duration:ce})),X=z===1?"install":z===2?"update":"",ie=X?{uri:`${U.assets.download.uri}&${X}=true`,fallbackUri:`${U.assets.download.fallbackUri}?${X}=true`}:U.assets.download,se=await this.getAsset(ie);await this.fileService.writeFile(N,se.stream),te(new Date().getTime()-K)}async getReadme(U,N){if(U.assets.readme){const z=await this.getAsset(U.assets.readme,{},N);return await(0,P.asText)(z)||""}return""}async getManifest(U,N){if(U.assets.manifest){const z=await this.getAsset(U.assets.manifest,{},N),H=await(0,P.asText)(z);return H?JSON.parse(H):null}return null}async getCoreTranslation(U,N){const z=U.assets.coreTranslations.filter(H=>H[0]===N.toUpperCase())[0];if(z){const H=await this.getAsset(z[1]),K=await(0,P.asText)(H);return K?JSON.parse(K):null}return null}async getChangelog(U,N){if(U.assets.changelog){const z=await this.getAsset(U.assets.changelog,{},N);return await(0,P.asText)(z)||""}return""}async getAllVersions(U,N){let z=new s().withFlags(m.IncludeVersions,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");U.identifier.uuid?z=z.withFilter(i.ExtensionId,U.identifier.uuid):z=z.withFilter(i.ExtensionName,U.identifier.id);const H=[],{galleryExtensions:K}=await this.queryGallery(z,C.CancellationToken.None);return K.length&&(N?await Promise.all(K[0].versions.map(async te=>{let X;try{X=await this.getEngine(te)}catch(ie){}X&&(0,g.isEngineValid)(X,this.productService.version)&&H.push({version:te.version,date:te.lastUpdated})})):H.push(...K[0].versions.map(te=>({version:te.version,date:te.lastUpdated})))),H}async getAsset(U,N={},z=C.CancellationToken.None){const H=await this.commonHeadersPromise,K={type:"GET"},te=Object.assign(Object.assign({},H),N.headers||{});N=Object.assign(Object.assign(Object.assign({},N),K),{headers:te});const X=U.uri,ie=U.fallbackUri,se=Object.assign(Object.assign({},N),{url:X});try{const ce=await this.requestService.request(se,z);if(ce.res.statusCode===200)return ce;const he=await(0,P.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${he}`)}catch(ce){if((0,v.isPromiseCanceledError)(ce))throw ce;const he=(0,v.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:X,message:he});const me=Object.assign(Object.assign({},N),{url:ie});return this.requestService.request(me,z)}}async getLastValidExtensionVersion(U,N){const z=this.getLastValidExtensionVersionFromProperties(U,N);return z||this.getLastValidExtensionVersionRecursively(U,N)}getLastValidExtensionVersionFromProperties(U,N){for(const z of N){const H=q(z);if(!H)return null;if((0,g.isEngineValid)(H,this.productService.version))return z}return null}async getEngine(U){const N=q(U);if(N)return N;const z=O(U,t.Manifest);if(!z)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},K=await this.getAsset(z,{headers:H}),te=await(0,P.asJson)(K);if(te)return te.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(U,N){if(!N.length)return null;const z=N[0],H=await this.getEngine(z);return(0,g.isEngineValid)(H,this.productService.version)?(z.properties=z.properties||[],z.properties.push({key:n.Engine,value:H}),z):this.getLastValidExtensionVersionRecursively(U,N.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},C.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const N=await(0,P.asJson)(U),z=new Map;if(N)for(const H of N.malicious){const K=z.get(H)||{id:{id:H},malicious:!0,slow:!1};K.malicious=!0,z.set(H,K)}return[...z.values()]}};M=ue([Y(0,P.IRequestService),Y(1,d.ILogService),Y(2,p.IEnvironmentService),Y(3,L.ITelemetryService),Y(4,b.IFileService),Y(5,a.IProductService),Y(6,(0,w.optional)(D.IStorageService))],M),e.ExtensionGalleryService=M;async function F(A,U,N,z){const H={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A}`},K=await(0,S.getServiceMachineId)(U,N,z);return H["X-Market-User-Id"]=K,H}e.resolveMarketplaceHeaders=F}),define(Q[173],Z([0,1,5,8,31,10,102,9,7,18,28,62,40,14,166,6,25,71,110,19,3,57]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w,y,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",n="extensionTips/lastPromptedMediumImpExeTime";let r=class extends a.ExtensionTipsService{constructor(s,l,h,f,E,u,O,_,q,x){super(O,_,q,x);this.environmentService=s,this.telemetryService=l,this.extensionManagementService=h,this.storageService=f,this.nativeHostService=E,this.extensionRecommendationNotificationService=u,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&(0,d.forEach)(_.exeBasedExtensionTips,({key:j,value:$})=>{const W=[],B=[],M=[];(0,d.forEach)($.recommendations,({key:F,value:A})=>{A.important?$.important?W.push({extensionId:F,extensionName:A.name,isExtensionPack:!!A.isExtensionPack}):B.push({extensionId:F,extensionName:A.name,isExtensionPack:!!A.isExtensionPack}):M.push({extensionId:F,extensionName:A.name,isExtensionPack:!!A.isExtensionPack})}),W.length&&this.highImportanceExecutableTips.set(j,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:W}),B.length&&this.mediumImportanceExecutableTips.set(j,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:B}),M.length&&this.allOtherExecutableTips.set(j,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:M})}),(0,D.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,h)}groupImportantTipsByExe(s,l){const h=new Map;s.forEach(_=>h.set(_.extensionId.toLowerCase(),_));const{installed:f,uninstalled:E}=this.groupByInstalled([...h.keys()],l);for(const _ of f){const q=h.get(_);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:(0,T.basename)(q.windowsPath)})}for(const _ of E){const q=h.get(_);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:(0,T.basename)(q.windowsPath)})}const u=this.getPromptedExecutableTips(),O=new Map;for(const _ of E){const q=h.get(_);if(q&&(!u[q.exeName]||!u[q.exeName].includes(q.extensionId))){let x=O.get(q.exeName);x||(x=[],O.set(q.exeName,x)),x.push(q)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[s,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":const f=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const E=this._register((0,D.disposableTimeout)(()=>{E.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const s=this.getLastPromptedMediumExeTime(),l=Date.now()-s,h=7*24*60*60*1e3;if(l<h){const u=this._register((0,D.disposableTimeout)(()=>{u.dispose(),this.promptMediumImportanceExeBasedTip()},h-l));return}const[f,E]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(E).then(u=>{switch(u){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(E[0].exeName,E);const O=this._register((0,D.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const q=this._register((0,D.disposableTimeout)(()=>{q.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(s){const l=s.map(({extensionId:f})=>f.toLowerCase()),h=(0,y.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,h,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(n,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(n,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(s,l){const h=this.getPromptedExecutableTips();h[s]=l.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(s,l){const h=[],f=[],E=l.reduce((u,O)=>(u.add(O.identifier.id.toLowerCase()),u),new Set);return s.forEach(u=>{E.has(u.toLowerCase())?h.push(u):f.push(u)}),{installed:h,uninstalled:f}}async getValidExecutableBasedExtensionTips(s){const l=[],h=new Map;for(const f of s.keys()){const E=s.get(f);if(!(!E||!(0,p.isNonEmptyArray)(E.recommendations))){const u=[];g.isWindows?E.windowsPath&&u.push(E.windowsPath.replace("%USERPROFILE%",L.process.env.USERPROFILE).replace("%ProgramFiles(x86)%",L.process.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",L.process.env.ProgramFiles).replace("%APPDATA%",L.process.env.APPDATA).replace("%WINDIR%",L.process.env.WINDIR)):(u.push((0,T.join)("/usr/local/bin",f)),u.push((0,T.join)("/usr/bin",f)),u.push((0,T.join)(this.environmentService.userHome.fsPath,f)));for(const O of u){let _=h.get(O);if(_===void 0&&(_=await this.fileService.exists(v.URI.file(O)),h.set(O,_)),_)for(const{extensionId:q,extensionName:x,isExtensionPack:j}of E.recommendations)l.push({extensionId:q,extensionName:x,isExtensionPack:j,exeName:f,exeFriendlyName:E.exeFriendlyName,windowsPath:E.windowsPath})}}}return l}};r=ue([Y(0,R.INativeEnvironmentService),Y(1,S.ITelemetryService),Y(2,C.IExtensionManagementService),Y(3,m.IStorageService),Y(4,i.INativeHostService),Y(5,w.IExtensionRecommendationNotificationService),Y(6,P.IFileService),Y(7,k.IProductService),Y(8,b.IRequestService),Y(9,I.ILogService)],r),e.ExtensionTipsService=r}),define(Q[79],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(R){this.appender=R}listen(R,L){throw new Error(`Event not found: ${L}`)}call(R,L,{eventName:P,data:g}){return this.appender.log(P,g),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class T{constructor(R){this.channel=R}log(R,L){return this.channel.call("log",{eventName:R,data:L}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=T}),define(Q[80],Z([0,1,36,120,21,4,24,39,2,26,35]),function(G,e,v,T,k,R,L,P,g,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(a,D){this._configurationService=D,this._experimentProperties={},this._disposables=new g.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const w=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!w})}))}setExperimentProperty(a,D){this._experimentProperties[a]=D}setEnabled(a){this._enabled=a}_updateUserOptIn(){var a;const D=(a=this._configurationService)===null||a===void 0?void 0:a.getValue(b);this._userOptIn=D?D.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let D=a.sessionID,S=a["common.instanceId"],w=a["common.machineId"],y=a["common.firstSessionDate"],m=a["common.msftInternal"];return{sessionId:D,instanceId:S,machineId:w,firstSessionDate:y,msftInternal:m}}dispose(){this._disposables.dispose()}publicLog(a,D,S){return this.isOptedIn?this._commonProperties.then(w=>{D=(0,p.mixin)(D,w),D=(0,p.mixin)(D,this._experimentProperties),D=(0,p.cloneAndChange)(D,y=>{if(typeof y=="string")return this._cleanupInfo(y,S)}),this._appender.log(a,D)},w=>{console.error(w)}):Promise.resolve(void 0)}publicLog2(a,D,S){return this.publicLog(a,D,S)}publicLogError(a,D){return this.sendErrorTelemetry?this.publicLog(a,D,!0):Promise.resolve(void 0)}publicLogError2(a,D){return this.publicLogError(a,D)}_cleanupInfo(a,D){let S=a;if(D){const w=[];for(let i of this._cleanupPatterns)for(;;){const t=i.exec(a);if(!t)break;w.push([t.index,i.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(S="";;){const i=m.exec(a);if(!i)break;!y.test(i[0])&&w.every(([t,n])=>i.index<t||i.index>=n)&&(S+=a.substring(o,i.index)+"<REDACTED: user-file-path>",o=m.lastIndex)}o<a.length&&(S+=a.substr(o))}for(let w of this._cleanupPatterns)S=S.replace(w,"");return S}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=ue([Y(1,(0,R.optional)(L.IConfigurationService))],d),e.TelemetryService=d;const b="telemetry";C.Registry.as(P.Extensions.Configuration).registerConfiguration({id:b,order:110,type:"object",title:(0,T.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,T.localize)(2,null,v.default.privacyStatementUrl):(0,T.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Q[58],Z([0,1,24,26,17,6]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,D){return Promise.resolve(void 0)}publicLog2(a,D){return this.publicLog(a,D)}publicLogError(a,D){return Promise.resolve(void 0)}publicLogError2(a,D){return this.publicLogError(a,D)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class L{async publicLog(D,S,w){}async publicLogError(D,S,w){}}e.NullEndpointTelemetryService=L;function P(...a){return{log:(D,S)=>a.forEach(w=>w.log(D,S)),flush:()=>R.Promises.settled(a.map(D=>D.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(a,D){return D.onDidChangeConfiguration(S=>{S.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,v.ConfigurationTargetToString)(S.source),configurationKeys:b(S.sourceConfig)})})}e.configurationTelemetry=g;function p(a){const D=Object.create(null),S=Object.create(null),w=Object.create(null);d(a,w);for(let y in w){y=y.length>150?y.substr(y.length-149):y;const m=w[y];typeof m=="number"?S[y]=m:typeof m=="boolean"?S[y]=m?1:0:typeof m=="string"?D[y]=m.substring(0,1023):typeof m!="undefined"&&m!==null&&(D[y]=m)}return{properties:D,measurements:S}}e.validateTelemetryData=p;function C(a){if(!a)return"none";let D="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(w=>{a.indexOf(`${w}+`)===0&&(D=w)}),D}e.cleanRemoteAuthority=C;function d(a,D,S=0,w){if(!!a)for(let y of Object.getOwnPropertyNames(a)){const m=a[y],o=w?w+y:y;Array.isArray(m)?D[o]=(0,T.safeStringify)(m):m instanceof Date?D[o]=m.toISOString():(0,k.isObject)(m)?S<2?d(m,D,S+1,o+"."):D[o]=(0,T.safeStringify)(m):D[o]=m}}function b(a){if(!a)return[];const D=[];return I(D,"",a),D}function I(a,D,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(w=>I(a,D?`${D}.${w}`:w,S[w])):a.push(D)}}),define(Q[174],Z([0,1,2,10,14,58]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let L=class extends v.Disposable{constructor(g,p){super();this.logger=this._register(g.createLogger(p.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(g,p){this.logger.trace(`telemetry/${g}`,(0,R.validateTelemetryData)(p))}};L=ue([Y(0,k.ILoggerService),Y(1,T.IEnvironmentService)],L),e.TelemetryLogAppender=L}),define(Q[175],Z([0,1,15,26,58]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function R(P){const g=await new Promise((C,d)=>{G(["applicationinsights"],C,d)});let p;return g.defaultClient?(p=new g.TelemetryClient(P),p.channel.setUseDiskRetryCaching(!0)):(g.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),p=g.defaultClient),P.indexOf("AIF-")===0&&(p.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),p}class L{constructor(g,p,C){this._eventPrefix=g,this._defaultData=p,this._defaultData||(this._defaultData=Object.create(null)),typeof C=="function"?this._aiClient=C():this._aiClient=C,this._asyncAIClient=null}_withAIClient(g){if(!!this._aiClient){if(typeof this._aiClient!="string"){g(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(p=>{g(p)},p=>{(0,v.onUnexpectedError)(p),console.error(p)})}}log(g,p){!this._aiClient||(p=(0,T.mixin)(p,this._defaultData),p=(0,k.validateTelemetryData)(p),this._withAIClient(C=>C.trackEvent({name:this._eventPrefix+"/"+g,properties:p.properties,measurements:p.measurements})))}flush(){return this._aiClient?new Promise(g=>{this._withAIClient(p=>{p.flush({callback:()=>{this._aiClient=void 0,g(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=L}),define(Q[176],Z([0,1,49,79,16,80,24,25]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(C,d){this.configurationService=C,this.telemetryService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(C){if(!this.customTelemetryServices.has(C.id)){const{machineId:d,sessionId:b}=await this.telemetryService.getTelemetryInfo(),I=Object.create(null);I["common.vscodemachineid"]=d,I["common.vscodesessionid"]=b;const a=[C.id,JSON.stringify(I),C.aiKey],S=new v.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:a,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),w=new T.TelemetryAppenderClient(S);this.customTelemetryServices.set(C.id,new R.TelemetryService({appender:w,sendErrorTelemetry:C.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(C.id)}async publicLog(C,d,b){await(await this.getCustomTelemetryService(C)).publicLog(d,b)}async publicLogError(C,d,b){await(await this.getCustomTelemetryService(C)).publicLogError(d,b)}};g=ue([Y(0,L.IConfigurationService),Y(1,P.ITelemetryService)],g),e.CustomEndpointTelemetryService=g}),define(Q[81],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var T;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(k=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,v.createDecorator)("localTerminalService"),e.IPtyService=(0,v.createDecorator)("ptyService");var R;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var L;(function(g){g[g.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",g[g.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(L=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var P;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(P=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(Q[177],Z([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,v.createDecorator)("localPtyService")}),define(Q[178],Z([0,1,2,14,81,49,16,33,3,76]),function(G,e,v,T,k,R,L,P,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var C;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(C||(C={}));let d=0,b=class extends v.Disposable{constructor(a){super();this._logService=a,this._restartCount=0,this._isDisposed=!1,this._onPtyHostExit=this._register(new g.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new g.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new g.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new g.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new g.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new g.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new g.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new g.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new g.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new g.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new g.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new g.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new g.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,v.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new R.Client(L.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:d,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),P.ProxyChannel.toService(a.getChannel(k.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._register(a.onDidProcessExit(y=>{this._onPtyHostExit.fire(y.code),this._isDisposed||(this._restartCount<=C.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${y.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${y.code}, giving up`))}));const S=a.getChannel(k.TerminalIpcChannels.Log);this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(S,this._logService.getLevel())}));const w=P.ProxyChannel.toService(a.getChannel(k.TerminalIpcChannels.PtyHost));return this._register(w.onProcessData(y=>this._onProcessData.fire(y))),this._register(w.onProcessExit(y=>this._onProcessExit.fire(y))),this._register(w.onProcessReady(y=>this._onProcessReady.fire(y))),this._register(w.onProcessTitleChanged(y=>this._onProcessTitleChanged.fire(y))),this._register(w.onProcessShellTypeChanged(y=>this._onProcessShellTypeChanged.fire(y))),this._register(w.onProcessOverrideDimensions(y=>this._onProcessOverrideDimensions.fire(y))),this._register(w.onProcessResolvedShellLaunchConfig(y=>this._onProcessResolvedShellLaunchConfig.fire(y))),this._register(w.onProcessReplay(y=>this._onProcessReplay.fire(y))),this._register(w.onProcessOrphanQuestion(y=>this._onProcessOrphanQuestion.fire(y))),[a,w]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,D,S,w,y,m,o,i,t,n){const r=setTimeout(()=>this._handleUnresponsiveCreateProcess(),k.HeartbeatConstants.CreateProcessTimeout),c=await this._proxy.createProcess(a,D,S,w,y,m,o,i,t,n);return clearTimeout(r),d=Math.max(d,c),c}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(a){return this._proxy.listProcesses(a)}start(a){return this._proxy.start(a)}shutdown(a,D){return this._proxy.shutdown(a,D)}input(a,D){return this._proxy.input(a,D)}resize(a,D,S){return this._proxy.resize(a,D,S)}acknowledgeDataEvent(a,D){return this._proxy.acknowledgeDataEvent(a,D)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async restartPtyHost(){this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier+k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${k.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};b=ue([Y(0,T.ILogService)],b),e.PtyHostService=b}),define(Q[51],Z([0,1,41]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function T(L,P,g,p){const C=(0,v.setProperty)(L,P,g,p)[0];return C&&(L=L.substring(0,C.offset)+C.content+L.substring(C.offset+C.length)),L}e.edit=T;function k(L,P,g){let p=g;for(;p>=0;){if(L.charAt(p)===P.charAt(P.length-1)&&P.length===1)return p+1;if(p--,P.length===2&&p>=0&&L.charAt(p)===P.charAt(0))return p+2}return 0}e.getLineStartOffset=k;function R(L,P,g){let p=g;for(;p>=0;)if(L.charAt(p)===P.charAt(P.length-1)&&P.length===1||(p++,P.length===2&&p>=0&&L.charAt(p)===P.charAt(1)))return p;return L.length-1}e.getLineEndOffset=R}),define(Q[179],Z([0,1,26,56]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(d,b,I,a,D){var S,w;const y=[],m=[],o=[];if(!b){const q=d.filter(({identifier:x})=>D.every(j=>j.toLowerCase()!==x.id.toLowerCase()));return{added:y,removed:m,updated:o,remote:q.length>0?q:null}}d=d.map(p),b=b.map(p),I=I?I.map(p):null;const i=new Map,t=q=>{q.uuid&&i.set(q.id.toLowerCase(),q.uuid)};d.forEach(({identifier:q})=>t(q)),b.forEach(({identifier:q})=>t(q)),I&&I.forEach(({identifier:q})=>t(q));const n=q=>{const x=q.identifier.uuid||i.get(q.identifier.id.toLowerCase());return x?`uuid:${x}`:`id:${q.identifier.id.toLowerCase()}`},r=(q,x)=>(q.set(n(x),x),q),c=d.reduce(r,new Map),s=b.reduce(r,new Map),l=b.reduce((q,x)=>{const j=n(x);x=(0,v.deepClone)(x);const $=c.get(j);return $&&($.installed&&(x.installed=!0),x.version||(x.version=$.version)),r(q,x)},new Map),h=I?I.reduce(r,new Map):null,f=a.reduce(r,new Map),E=D.reduce((q,x)=>{const j=i.get(x.toLowerCase());return q.add(j?`uuid:${j}`:`id:${x.toLowerCase()}`)},new Set),u=R(c,s,E);if(u.added.size>0||u.removed.size>0||u.updated.size>0){const q=R(h,c,E),x=R(h,s,E),j=($,W)=>{const B=c.get($);if(B){const M=s.get($);return Object.assign(Object.assign({},W?M:B),{version:(M.version&&T.gt(M.version,B.version),B.version),state:L(B,M,h==null?void 0:h.get($))})}};for(const $ of x.removed.values()){const W=c.get($);W&&m.push(W.identifier)}for(const $ of x.added.values())if(q.added.has($)){if(u.updated.has($)){const W=j($,!0);W&&(o.push(C(W,$)),l.set($,W))}}else{const W=s.get($);W.installed&&y.push(C(W,$))}for(const $ of x.updated.values()){const W=j($,!0);W&&(o.push(C(W,$)),l.set($,W))}for(const $ of q.added.values())x.added.has($)||l.set($,c.get($));for(const $ of q.updated.values())if(!x.removed.has($)&&!x.updated.has($)){const W=j($,!1);W&&(((S=l.get($))===null||S===void 0?void 0:S.installed)&&(W.installed=!0),l.set($,W))}for(const $ of q.removed.values())!f.has($)&&!x.updated.has($)&&((w=h==null?void 0:h.get($))===null||w===void 0?void 0:w.installed)&&l.delete($)}const O=[],_=R(s,l,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&l.forEach((q,x)=>O.push(C(q,x))),{added:y,removed:m,updated:o,remote:O.length?O:null}}e.merge=k;function R(d,b,I,{checkInstalledProperty:a,checkVersionProperty:D}={checkInstalledProperty:!1,checkVersionProperty:!1}){const S=d?[...d.keys()].filter(i=>!I.has(i)):[],w=[...b.keys()].filter(i=>!I.has(i)),y=w.filter(i=>S.indexOf(i)===-1).reduce((i,t)=>(i.add(t),i),new Set),m=S.filter(i=>w.indexOf(i)===-1).reduce((i,t)=>(i.add(t),i),new Set),o=new Set;for(const i of S)if(!m.has(i)){const t=d.get(i),n=b.get(i);(!n||t.disabled!==n.disabled||!g(t.state,n.state)||D&&t.version!==n.version||a&&t.installed!==n.installed)&&o.add(i)}return{added:y,removed:m,updated:o}}function L(d,b,I){const a=d.state,D=b.state,S=I==null?void 0:I.state;if(!b.version||a&&T.gt(d.version,b.version))return a;if(D&&T.gt(b.version,d.version)||!a)return D;if(!D)return a;const w=(0,v.deepClone)(a),y=S?P(S,D):{added:Object.keys(D).reduce((o,i)=>(o.add(i),o),new Set),removed:new Set,updated:new Set},m=S?P(S,a):{added:Object.keys(a).reduce((o,i)=>(o.add(i),o),new Set),removed:new Set,updated:new Set};for(const o of[...y.added.values(),...y.updated.values()])w[o]=D[o];for(const o of y.removed.values())m.updated.has(o)||delete w[o];return w}function P(d,b){const I=Object.keys(d),a=Object.keys(b),D=a.filter(y=>I.indexOf(y)===-1).reduce((y,m)=>(y.add(m),y),new Set),S=I.filter(y=>a.indexOf(y)===-1).reduce((y,m)=>(y.add(m),y),new Set),w=new Set;for(const y of I)if(!S.has(y)){const m=d[y],o=b[y];(0,v.equals)(m,o)||w.add(y)}return{added:D,removed:S,updated:w}}function g(d={},b={}){const{added:I,removed:a,updated:D}=P(d,b);return I.size===0&&a.size===0&&D.size===0}function p(d){return Object.assign(Object.assign({},d),{disabled:!!d.disabled,installed:!!d.installed})}function C(d,b){const I={identifier:{id:d.identifier.id,uuid:b.startsWith("uuid:")?b.substring("uuid:".length):void 0}};return d.version&&(I.version=d.version),d.disabled&&(I.disabled=!0),d.installed&&(I.installed=!0),d.state&&(I.state=d.state),I}}),define(Q[82],Z([0,1,18,3,2,34,4,31,19]),function(G,e,v,T,k,R,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,L.createDecorator)("IExtensionsStorageSyncService");const p=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let C=class Ye extends k.Disposable{constructor(b,I){super();this.storageService=b,this.productService=I,this._onDidChangeExtensionsStorage=this._register(new T.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(a=>this.onDidChangeStorageValue(a)))}static toKey(b){return`extensionKeys/${(0,R.adoptToGalleryExtensionId)(b.id)}@${b.version}`}static fromKey(b){const I=p.exec(b);if(I&&I[1])return{id:I[1],version:I[2]}}initialize(){const b=this.storageService.keys(0,1);for(const I of b){const a=Ye.fromKey(I);a&&this.extensionsWithKeysForSync.add(a.id.toLowerCase())}}onDidChangeStorageValue(b){if(b.scope===0){if(this.extensionsWithKeysForSync.has(b.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const I=Ye.fromKey(b.key);if(I){this.extensionsWithKeysForSync.add(I.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(b,I){this.storageService.store(Ye.toKey(b),JSON.stringify(I),0,1)}getKeysForSync(b){var I;const a=(I=this.productService.extensionSyncedKeys)===null||I===void 0?void 0:I[b.id.toLowerCase()],D=this.storageService.get(Ye.toKey(b),0),S=D?JSON.parse(D):void 0;return S&&a?(0,v.distinct)([...S,...a]):S||a}};C=ue([Y(0,g.IStorageService),Y(1,P.IProductService)],C),e.ExtensionsStorageSyncService=C}),define(Q[83],Z([0,1,18,24,4]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let R=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,g){let p=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return p=p.filter(C=>C!==P&&C!==`-${P}`),g&&p.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",p.length?p:void 0,1)}updateSynchronizedExtensions(P,g){let p=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return p=p.filter(C=>C!==P&&C!==`-${P}`),g&&p.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",p.length?p:void 0,1)}getIgnoredExtensions(P){const g=P.filter(b=>b.isMachineScoped).map(b=>b.identifier.id.toLowerCase()),p=this.getConfiguredIgnoredExtensions().map(b=>b.toLowerCase()),C=[],d=[];if(Array.isArray(p))for(const b of p)b.startsWith("-")?d.push(b.substring(1)):C.push(b);return(0,v.distinct)([...g,...C].filter(b=>d.indexOf(b)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(g=>g.toLowerCase())}};R=ue([Y(0,T.IConfigurationService)],R),e.IgnoredExtensionsManagementService=R}),define(Q[180],Z([0,1,26,32,18,138,51]),function(G,e,v,T,k,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(o){return(0,T.parse)(o)||[]}e.parseKeybindings=P;async function g(o,i,t,n,r){const c=P(o),s=P(i),l=t?P(t):null,h=[...c,...s,...l||[]].map(B=>B.key),f=await r.resolveUserBindings(h);let E=C(c,s,l,f);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:i,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const u=b(c),O=b(s),_=l?b(l):null,q=a(u,O,f),x=_?a(_,u,f):{added:[...u.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set},j=_?a(_,O,f):{added:[...O.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set},$=p(q,x,j);let W=o;for(const B of $.removed.values())$.conflicts.has(B)||(W=y(W,B,n));for(const B of $.added.values())if(!$.conflicts.has(B)){const M=O.get(B);if(M.some(F=>F.command!==`-${B}`&&E.conflicts.has(f[F.key]))){$.conflicts.add(B);continue}W=w(W,M,n)}for(const B of $.updated.values())if(!$.conflicts.has(B)){const M=O.get(B);if(M.some(F=>F.command!==`-${B}`&&E.conflicts.has(f[F.key]))){$.conflicts.add(B);continue}W=m(W,B,M,n)}return{mergeContent:W,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=g;function p(o,i,t){const n=new Set,r=new Set,c=new Set,s=new Set;for(const l of i.removed.values())t.updated.has(l)&&s.add(l);for(const l of t.removed.values())s.has(l)||(i.updated.has(l)?s.add(l):r.add(l));for(const l of i.added.values())s.has(l)||t.added.has(l)&&o.updated.has(l)&&s.add(l);for(const l of t.added.values())s.has(l)||(i.added.has(l)?o.updated.has(l)&&s.add(l):n.add(l));for(const l of i.updated.values())s.has(l)||t.updated.has(l)&&o.updated.has(l)&&s.add(l);for(const l of t.updated.values())s.has(l)||(i.updated.has(l)?o.updated.has(l)&&s.add(l):c.add(l));return{added:n,removed:r,updated:c,conflicts:s}}function C(o,i,t,n){const r=new Set,c=d(o,n),s=d(i,n),l=t?d(t,n):null,h=I(c,s);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const f=l?I(l,c):{added:[...c.keys()].reduce((x,j)=>(x.add(j),x),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const E=l?I(l,s):{added:[...s.keys()].reduce((x,j)=>(x.add(j),x),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:u,removed:O,updated:_,conflicts:q}=p(h,f,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:O,updated:_,conflicts:q}}function d(o,i){const t=new Map;for(const n of o){const r=i[n.key];let c=t.get(r);c||(c=[],t.set(r,c)),c.push(n)}return t}function b(o){const i=new Map;for(const t of o){const n=t.command[0]==="-"?t.command.substring(1):t.command;let r=i.get(n);r||(r=[],i.set(n,r)),r.push(t)}return i}function I(o,i){const t=[...o.keys()],n=[...i.keys()],r=n.filter(l=>t.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),c=t.filter(l=>n.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),s=new Set;for(const l of t)if(!c.has(l)){const h=o.get(l).map(E=>Object.assign(Object.assign({},E),{key:l})),f=i.get(l).map(E=>Object.assign(Object.assign({},E),{key:l}));(0,k.equals)(h,f,(E,u)=>S(E,u))||s.add(l)}return{added:r,removed:c,updated:s}}function a(o,i,t){const n=[...o.keys()],r=[...i.keys()],c=r.filter(h=>n.indexOf(h)===-1).reduce((h,f)=>(h.add(f),h),new Set),s=n.filter(h=>r.indexOf(h)===-1).reduce((h,f)=>(h.add(f),h),new Set),l=new Set;for(const h of n)if(!s.has(h)){const f=o.get(h).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]})),E=i.get(h).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]}));D(f,E)||l.add(h)}return{added:c,removed:s,updated:l}}function D(o,i){return!(!(0,k.equals)(o.filter(({command:t})=>t[0]!=="-"),i.filter(({command:t})=>t[0]!=="-"),(t,n)=>S(t,n))||!(0,k.equals)(o.filter(({command:t})=>t[0]==="-"),i.filter(({command:t})=>t[0]==="-"),(t,n)=>S(t,n)))}function S(o,i){if(o.command!==i.command||o.key!==i.key)return!1;const t=R.ContextKeyExpr.deserialize(o.when),n=R.ContextKeyExpr.deserialize(i.when);return!(t&&!n||!t&&n||t&&n&&!t.equals(n)||!v.equals(o.args,i.args))}function w(o,i,t){for(const n of i)o=L.edit(o,[-1],n,t);return o}function y(o,i,t){const n=P(o);for(let r=n.length-1;r>=0;r--)(n[r].command===i||n[r].command===`-${i}`)&&(o=L.edit(o,[r],void 0,t));return o}function m(o,i,t,n){const r=P(o),c=r.findIndex(s=>s.command===i||s.command===`-${i}`);for(let s=r.length-1;s>=0;s--)(r[s].command===i||r[s].command===`-${i}`)&&(o=L.edit(o,[s],void 0,n));for(let s=t.length-1;s>=0;s--)o=L.edit(o,[c],t[s],n);return o}}),define(Q[181],Z([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function v(R,L,P){const g={},p={},C=new Set;if(!L)return{local:{added:g,updated:p,removed:[...C.values()]},remote:{added:R,updated:{},removed:[]},conflicts:[]};const d=T(R,L);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{local:{added:g,updated:p,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const b=T(P,R),I=T(P,L),a={},D={},S=new Set,w=new Set;for(const y of b.removed.values())I.updated.has(y)?g[y]=L[y]:S.add(y);for(const y of I.removed.values())w.has(y)||(b.updated.has(y)?w.add(y):C.add(y));for(const y of b.updated.values())w.has(y)||(I.updated.has(y)?d.updated.has(y)&&w.add(y):D[y]=R[y]);for(const y of I.updated.values())w.has(y)||(b.updated.has(y)?d.updated.has(y)&&w.add(y):R[y]!==void 0&&(p[y]=L[y]));for(const y of b.added.values())w.has(y)||(I.added.has(y)?d.updated.has(y)&&w.add(y):a[y]=R[y]);for(const y of I.added.values())w.has(y)||(b.added.has(y)?d.updated.has(y)&&w.add(y):g[y]=L[y]);return{local:{added:g,removed:[...C.values()],updated:p},remote:{added:a,removed:[...S.values()],updated:D},conflicts:[...w.values()]}}e.merge=v;function T(R,L){const P=R?Object.keys(R):[],g=L?Object.keys(L):[],p=g.filter(b=>P.indexOf(b)===-1).reduce((b,I)=>(b.add(I),b),new Set),C=P.filter(b=>g.indexOf(b)===-1).reduce((b,I)=>(b.add(I),b),new Set),d=new Set;for(const b of P)if(!C.has(b)){const I=R[b],a=L[b];I!==a&&d.add(b)}return{added:p,removed:C,updated:d}}function k(R,L){const{added:P,removed:g,updated:p}=T(R,L);return P.size===0&&g.size===0&&p.size===0}e.areSame=k}),define(Q[20],Z([0,1,4,28,35,39,125,78,11,18,17]),function(G,e,v,T,k,R,L,P,g,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function d(){const s=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(l=>!!s[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=d;function b(){const s=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(s).filter(E=>!!s[E].ignoreSync),h=Object.keys(s).filter(E=>s[E].scope===2||s[E].scope===6),f=d();return(0,p.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...h,...f])}e.getDefaultIgnoredSettings=b;function I(){const s="vscode://schemas/ignoredSettings",l=k.Registry.as(R.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=k.Registry.as(P.Extensions.JSONContribution),f=()=>{const E=d(),u=b().filter(x=>x!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(R.allSettings.properties).filter(x=>u.indexOf(x)===-1),_=u.filter(x=>E.indexOf(x)===-1),q={items:{type:"string",enum:[...O,..._.map(x=>`-${x}`)]}};h.registerSchema(s,q)};return l.onDidUpdateConfiguration(()=>f())}e.registerConfiguration=I;function a(s){return s&&(0,C.isObject)(s)&&(0,C.isString)(s.id)&&(0,C.isArray)(s.scopes)}e.isAuthenticationProvider=a;var D;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Extensions="extensions",s.GlobalState="globalState"})(D=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,v.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,v.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,v.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function S(s){const l={};return l[e.HEADER_EXECUTION_ID]=s,l}e.createSyncHeaders=S;var w;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.NoRef="NoRef",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(l,h,f,E){super(l);this.code=h,this.resource=f,this.operationId=E,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class m extends y{constructor(l,h,f,E){super(l,f,void 0,E);this.url=h,this.operationId=E}}e.UserDataSyncStoreError=m;class o extends y{constructor(l,h){super(l,h)}}e.UserDataAutoSyncError=o,function(s){function l(h){if(h instanceof s)return h;const f=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(f&&f[1]){const E=f[2]==="unknown"?void 0:f[2],u=f[3]==="unknown"?void 0:f[3];return new s(h.message,f[1],E,u)}return new s(h.message,w.Unknown)}s.toUserDataSyncError=l}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var t;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var n;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(s){return`sync.enable.${s}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,v.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,v.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,v.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,v.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,v.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,v.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(s,l){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,g.isEqualOrParent)(s,(0,g.joinPath)(l.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(Q[45],Z([0,1,2,9,22,5,20,10,11,6,3,25,32,121,24,17,21,18,44,19,29]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w,y,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function i(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=i;function t(l,h,f){return f.joinPath(h.userDataSyncHome,l,`lastSync${l}.json`)}let n=class extends v.Disposable{constructor(h,f,E,u,O,_,q,x,j,$){super();this.resource=h,this.fileService=f,this.environmentService=E,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=q,this.telemetryService=x,this.logService=j,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new C.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new C.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new p.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new C.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.syncHeaders={},this.syncResourceLogLabel=(0,S.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(E.userDataSyncHome,1024)?g.extUri:g.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(E.userDataSyncHome,h),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,L.PREVIEW_DIR_NAME),this.lastSyncResource=t(h,E,this.extUri),this.currentMachineIdPromise=(0,y.getServiceMachineId)(E,f,u)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const h=await this.syncPreviewPromise;this.syncPreviewPromise=null;const f=await this.performSync(h.remoteUserData,h.lastSyncUserData,!0);this.setStatus(f)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const h=await this.getLastSyncUserData();(h?(await this.doGenerateSyncResourcePreview(h,h,!0,o.CancellationToken.None)).resourcePreviews.some(({remoteChange:E})=>E!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(h){if(this._status!==h){const f=this._status;h==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),f==="hasConflicts"&&h==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=h,this._onDidChangStatus.fire(h)}}async sync(h,f={}){await this._sync(h,!0,f)}async preview(h,f={}){return this._sync(h,!1,f)}async apply(h,f={}){try{this.syncHeaders=Object.assign({},f);const E=await this.doApply(h);return this.setStatus(E),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(h,f,E){try{if(this.syncHeaders=Object.assign({},E),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let u="idle";try{const O=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(h,O);return u=await this.performSync(_,O,f),u==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):u==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(u)}}finally{this.syncHeaders={}}}async replace(h){const f=await this.resolveContent(h);if(!f)return!1;const E=this.parseSyncData(f);if(!E)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const u=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,u),_=await this.generateSyncPreview({ref:O.ref,syncData:E},u,o.CancellationToken.None),q=[];for(const x of _){const j=await this.getAcceptResult(x,x.remoteResource,void 0,o.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(x,x.previewResource,x.remoteContent,o.CancellationToken.None);q.push([x,Object.assign(Object.assign({},j),{remoteChange:$!==0?$:2})])}await this.applyResult(O,u,q,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(h,f){if(f){const E=h&&h.latest?h.latest[this.resource]:void 0;if(f.ref===E||E===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async performSync(h,f,E){if(h.syncData&&h.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new L.UserDataSyncError((0,I.localize)(0,null,this.resource,this.version,h.syncData.version),L.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(h,f,E)}catch(u){if(u instanceof L.UserDataSyncError)switch(u.code){case L.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(h,f,E);case L.UserDataSyncErrorCode.Conflict:case L.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),h=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.performSync(h,f,E)}throw u}}async doSync(h,f,E){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,p.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(h,f,E,O)));const u=await this.syncPreviewPromise;return this.updateConflicts(u.resourcePreviews),u.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":E?await this.doApply(!1):"syncing"}catch(u){throw this.syncPreviewPromise=null,u}}async merge(h){return await this.updateSyncResourcePreview(h,async f=>{const E=await this.getMergeResult(f,o.CancellationToken.None);await this.fileService.writeFile(f.previewResource,k.VSBuffer.fromString((E==null?void 0:E.content)||""));const u=E&&!E.hasConflicts?await this.getAcceptResult(f,f.previewResource,void 0,o.CancellationToken.None):void 0;return f.acceptResult=u,f.mergeState=E.hasConflicts?"conflict":u?"accepted":"preview",f.localChange=u?u.localChange:E.localChange,f.remoteChange=u?u.remoteChange:E.remoteChange,f}),this.syncPreviewPromise}async accept(h,f){return await this.updateSyncResourcePreview(h,async E=>{const u=await this.getAcceptResult(E,h,f,o.CancellationToken.None);return E.acceptResult=u,E.mergeState="accepted",E.localChange=u.localChange,E.remoteChange=u.remoteChange,E}),this.syncPreviewPromise}async discard(h){return await this.updateSyncResourcePreview(h,async f=>{const E=await this.getMergeResult(f,o.CancellationToken.None);return await this.fileService.writeFile(f.previewResource,k.VSBuffer.fromString(E.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=E.localChange,f.remoteChange=E.remoteChange,f}),this.syncPreviewPromise}async updateSyncResourcePreview(h,f){if(!!this.syncPreviewPromise){let E=await this.syncPreviewPromise;const u=E.resourcePreviews.findIndex(({localResource:O,remoteResource:_,previewResource:q})=>this.extUri.isEqual(O,h)||this.extUri.isEqual(_,h)||this.extUri.isEqual(q,h));u!==-1&&(this.syncPreviewPromise=(0,p.createCancelablePromise)(async O=>{const _=[...E.resourcePreviews];return _[u]=await f(_[u]),Object.assign(Object.assign({},E),{resourcePreviews:_})}),E=await this.syncPreviewPromise,this.updateConflicts(E.resourcePreviews),E.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(h){if(!this.syncPreviewPromise)return"idle";const f=await this.syncPreviewPromise;return f.resourcePreviews.some(({mergeState:E})=>E==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:E})=>E!=="accepted")?"syncing":(await this.applyResult(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(E=>[E,E.acceptResult]),h),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(h){}}updateConflicts(h){const f=h.filter(({mergeState:E})=>E==="conflict");(0,w.equals)(this._conflicts,f,(E,u)=>this.extUri.isEqual(E.previewResource,u.previewResource))||(this._conflicts=f,this._onDidChangeConflicts.fire(f))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:f,ref:E})=>({created:f,uri:this.toRemoteBackupResource(E)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:f,ref:E})=>({created:f,uri:this.toLocalBackupResource(E)}))}toRemoteBackupResource(h){return R.URI.from({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${h}`})}toLocalBackupResource(h){return R.URI.from({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${h}`})}async getMachineId({uri:h}){const f=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(f))){const{content:E}=await this.getUserData(f);if(E){const u=this.parseSyncData(E);return u==null?void 0:u.machineId}}}async resolveContent(h){const f=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(f))){const{content:E}=await this.getUserData(f);return E}return this.extUri.isEqual(h,this.toLocalBackupResource(f))?this.userDataSyncBackupStoreService.resolveContent(this.resource,f):null}async resolvePreviewContent(h){const f=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(f)for(const E of f.resourcePreviews){if(this.extUri.isEqual(E.acceptedResource,h))return E.acceptResult?E.acceptResult.content:null;if(this.extUri.isEqual(E.remoteResource,h))return E.remoteContent;if(this.extUri.isEqual(E.localResource,h))return E.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(h){}}async doGenerateSyncResourcePreview(h,f,E,u){var O;const _=await this.currentMachineIdPromise,q=!!((O=h.syncData)===null||O===void 0?void 0:O.machineId)&&h.syncData.machineId===_,x=f===null&&q?h:f,j=await this.generateSyncPreview(h,x,u),$=[];for(const W of j){const B=W.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(W.localChange===0&&W.remoteChange===0)$.push(Object.assign(Object.assign({},W),{acceptedResource:B,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const M=E?await this.getMergeResult(W,u):void 0;if(u.isCancellationRequested)break;await this.fileService.writeFile(W.previewResource,k.VSBuffer.fromString((M==null?void 0:M.content)||""));const F=M&&!M.hasConflicts?await this.getAcceptResult(W,W.previewResource,void 0,u):void 0;$.push(Object.assign(Object.assign({},W),{acceptResult:F,mergeState:(M==null?void 0:M.hasConflicts)?"conflict":F?"accepted":"preview",localChange:F?F.localChange:M?M.localChange:W.localChange,remoteChange:F?F.remoteChange:M?M.remoteChange:W.remoteChange}))}}return{remoteUserData:h,lastSyncUserData:f,resourcePreviews:$,isLastSyncFromCurrentMachine:q}}async getLastSyncUserData(){try{const h=await this.fileService.readFile(this.lastSyncResource),f=JSON.parse(h.value.toString()),E=f;if(E.content===null)return{ref:f.ref,syncData:null};const u=JSON.parse(E.content);if(i(u))return Object.assign(Object.assign({},f),{syncData:u,content:void 0})}catch(h){h instanceof T.FileOperationError&&h.fileOperationResult===1||this.logService.error(h)}return null}async updateLastSyncUserData(h,f={}){const E=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null},f);await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(E)))}async getRemoteUserData(h){const{ref:f,content:E}=await this.getUserData(h);let u=null;return E!==null&&(u=this.parseSyncData(E)),{ref:f,syncData:u}}parseSyncData(h){try{const f=JSON.parse(h);if(i(f))return f}catch(f){this.logService.error(f)}throw new L.UserDataSyncError((0,I.localize)(1,null),L.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(h){if((0,D.isString)(h)){const f=await this.userDataSyncStoreService.resolveContent(this.resource,h);return{ref:h,content:f}}else{const f=h?{ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,f,this.syncHeaders)}}async updateRemoteUserData(h,f){const E=await this.currentMachineIdPromise,u={version:this.version,machineId:E,content:h};return f=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(u),f,this.syncHeaders),{ref:f,syncData:u}}async backupLocal(h){const f={version:this.version,content:h};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};n=ue([Y(1,T.IFileService),Y(2,P.IEnvironmentService),Y(3,m.IStorageService),Y(4,L.IUserDataSyncStoreService),Y(5,L.IUserDataSyncBackupStoreService),Y(6,L.IUserDataSyncResourceEnablementService),Y(7,d.ITelemetryService),Y(8,L.IUserDataSyncLogService),Y(9,a.IConfigurationService)],n),e.AbstractSynchroniser=n;let r=class extends n{constructor(h,f,E,u,O,_,q,x,j,$,W){super(f,E,u,O,_,q,x,j,$,W);this.file=h,this._register(this.fileService.watch(this.extUri.dirname(h))),this._register(this.fileService.onDidFilesChange(B=>this.onFileChanges(B)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(h){return null}}async updateLocalFileContent(h,f,E){try{f?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(h),E?void 0:f):await this.fileService.createFile(this.file,k.VSBuffer.fromString(h),{overwrite:E})}catch(u){throw u instanceof T.FileOperationError&&u.fileOperationResult===1||u instanceof T.FileOperationError&&u.fileOperationResult===3?new L.UserDataSyncError(u.message,L.UserDataSyncErrorCode.LocalPreconditionFailed):u}}onFileChanges(h){!h.contains(this.file)||this.triggerLocalChange()}};r=ue([Y(2,T.IFileService),Y(3,P.IEnvironmentService),Y(4,m.IStorageService),Y(5,L.IUserDataSyncStoreService),Y(6,L.IUserDataSyncBackupStoreService),Y(7,L.IUserDataSyncResourceEnablementService),Y(8,d.ITelemetryService),Y(9,L.IUserDataSyncLogService),Y(10,a.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let c=class extends r{constructor(h,f,E,u,O,_,q,x,j,$,W,B){super(h,f,E,u,O,_,q,x,j,$,B);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(h){const f=[];return(0,b.parse)(h,f,{allowEmptyContent:!0,allowTrailingComma:!0}),f.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};c=ue([Y(2,T.IFileService),Y(3,P.IEnvironmentService),Y(4,m.IStorageService),Y(5,L.IUserDataSyncStoreService),Y(6,L.IUserDataSyncBackupStoreService),Y(7,L.IUserDataSyncResourceEnablementService),Y(8,d.ITelemetryService),Y(9,L.IUserDataSyncLogService),Y(10,L.IUserDataSyncUtilService),Y(11,a.IConfigurationService)],c),e.AbstractJsonFileSynchroniser=c;let s=class{constructor(h,f,E,u){this.resource=h,this.environmentService=f,this.logService=E,this.fileService=u,this.extUri=this.fileService.hasCapability(f.userDataSyncHome,1024)?g.extUri:g.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,f,g.extUri)}async initialize({ref:h,content:f}){if(!f){this.logService.info("Remote content does not exist.",this.resource);return}const E=this.parseSyncData(f);if(!!E){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:h,syncData:E})}catch(O){this.logService.error(O)}}}parseSyncData(h){try{const f=JSON.parse(h);if(i(f))return f}catch(f){this.logService.error(f)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(h,f={}){const E=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null},f);await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(E)))}};s=ue([Y(1,P.IEnvironmentService),Y(2,L.IUserDataSyncLogService),Y(3,T.IFileService)],s),e.AbstractInitializer=s}),define(Q[182],Z([0,1,20,3,10,28,34,9,24,179,45,25,5,46,41,21,19,29,83,15,82,6]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w,y,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(l,h){const f=JSON.parse(l.content);if(l.version===1||l.version===2){const E=(await h.getInstalled(0)).filter(u=>u.isBuiltin);for(const u of f)l.version===1&&(u.enabled===!1&&(u.disabled=!0),delete u.enabled),l.version===2&&E.every(O=>!(0,L.areSameExtensions)(O.identifier,u.identifier))&&(u.installed=!0)}return f}function n(l,h,f){const E=f.get((0,L.getExtensionId)(l,h),0)||"{}";return JSON.parse(E)}function r(l,h,f,E){E.store((0,L.getExtensionId)(l,h),JSON.stringify(f),0,1)}let c=class rt extends C.AbstractSynchroniser{constructor(h,f,E,u,O,_,q,x,j,$,W,B,M,F){super("extensions",f,h,E,u,O,B,M,j,W);this.storageService=E,this.extensionManagementService=_,this.extensionEnablementService=q,this.ignoredExtensionsManagementService=x,this.extensionGalleryService=$,this.extensionsStorageSyncService=F,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtension,A=>!!A.gallery),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,A=>!A.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(h,f){const E=h.syncData?await t(h.syncData,this.extensionManagementService):null,u=(f==null?void 0:f.skippedExtensions)||[],O=(f==null?void 0:f.syncData)?await t(f.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(),q=this.getLocalExtensions(_),x=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);E?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:j,removed:$,updated:W,remote:B}=(0,p.merge)(q,E,O,u,x),M={added:j,removed:$,updated:W,remote:B,content:this.getPreviewContent(q,j,W,$),localChange:j.length>0||$.length>0||W.length>0?2:0,remoteChange:B!==null?2:0};return[{skippedExtensions:u,localResource:this.localResource,localContent:this.format(q),localExtensions:q,remoteResource:this.remoteResource,remoteContent:E?this.format(E):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(h,f,E,u){const O=[...f,...E],_=new Set,q=x=>{_.add(x.id.toLowerCase()),x.uuid&&_.add(x.uuid)};O.forEach(({identifier:x})=>q(x)),u.forEach(q);for(const x of h)_.has(x.identifier.id.toLowerCase())||x.identifier.uuid&&_.has(x.identifier.uuid)||O.push(x);return this.format(O)}async getMergeResult(h,f){return Object.assign(Object.assign({},h.previewResult),{hasConflicts:!1})}async getAcceptResult(h,f,E,u){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(f,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(h){const f=await this.extensionManagementService.getInstalled(),E=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),u=(0,p.merge)(h.localExtensions,null,null,h.skippedExtensions,E),{added:O,removed:_,updated:q,remote:x}=u;return{content:h.localContent,added:O,removed:_,updated:q,remote:x,localChange:O.length>0||_.length>0||q.length>0?2:0,remoteChange:x!==null?2:0}}async acceptRemote(h){const f=await this.extensionManagementService.getInstalled(),E=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),u=h.remoteContent?JSON.parse(h.remoteContent):null;if(u!==null){const O=(0,p.merge)(h.localExtensions,u,h.localExtensions,[],E),{added:_,removed:q,updated:x,remote:j}=O;return{content:h.remoteContent,added:_,removed:q,updated:x,remote:j,localChange:_.length>0||q.length>0||x.length>0?2:0,remoteChange:j!==null?2:0}}else return{content:h.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(h,f,E,u){let{skippedExtensions:O,localExtensions:_}=E[0][0],{added:q,removed:x,updated:j,remote:$,localChange:W,remoteChange:B}=E[0][1];if(W===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),W!==0&&(await this.backupLocal(JSON.stringify(_)),O=await this.updateLocalExtensions(q,x,j,O)),$){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify($);h=await this.updateRemoteUserData(M,u?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(f==null?void 0:f.ref)!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:rt.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,rt.EXTENSIONS_DATA_URI)){const E=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(E),O=this.getLocalExtensions(E).filter(_=>!u.some(q=>(0,L.areSameExtensions)({id:q},_.identifier)));return this.format(O)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let f=await super.resolveContent(h);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(h)),f){const E=this.parseSyncData(f);if(E)switch(this.extUri.basename(h)){case"extensions.json":return this.format(this.parseExtensions(E))}}return null}format(h){h.sort((u,O)=>!u.identifier.uuid&&O.identifier.uuid?-1:u.identifier.uuid&&!O.identifier.uuid?1:(0,D.compare)(u.identifier.id,O.identifier.id));const f=JSON.stringify(h),E=(0,I.format)(f,void 0,{});return(0,a.applyEdits)(f,E)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(E=>E.installed||E.disabled))return!0}catch(h){}return!1}async updateLocalExtensions(h,f,E,u){const O=[],_=[],q=await this.extensionManagementService.getInstalled();if(f.length){const j=q.filter(({identifier:$,isBuiltin:W})=>!W&&f.some(B=>(0,L.areSameExtensions)($,B)));await i.Promises.settled(j.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),O.push($.identifier)}))}(h.length||E.length)&&await i.Promises.settled([...h,...E].map(async j=>{const $=q.find(B=>(0,L.areSameExtensions)(B.identifier,j.identifier));if($&&$.isBuiltin){j.state&&$.manifest.version===j.version&&this.updateExtensionState(j.state,$.manifest.publisher,$.manifest.name,$.manifest.version),j.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,j.identifier.id),await this.extensionEnablementService.disableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,j.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,j.identifier.id),await this.extensionEnablementService.enableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,j.identifier.id)),O.push(j.identifier);return}const W=await this.extensionGalleryService.getCompatibleExtension(j.identifier);if(j.state&&($?$.manifest.version===j.version:!!W)){const B=$?$.manifest.publisher:W.publisher,M=$?$.manifest.name:W.name;this.updateExtensionState(j.state,B,M,$==null?void 0:$.manifest.version)}if(W)try{j.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,j.identifier.id,W.version),await this.extensionEnablementService.disableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,j.identifier.id,W.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,j.identifier.id,W.version),await this.extensionEnablementService.enableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,j.identifier.id,W.version)),$||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,j.identifier.id,W.version),await this.extensionManagementService.installFromGallery(W,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,j.identifier.id,W.version),O.push(W.identifier))}catch(B){_.push(j),this.logService.error(B),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,W.displayName||W.identifier.id)}else _.push(j)}));const x=[];for(const j of u)O.some($=>(0,L.areSameExtensions)($,j.identifier))||x.push(j);for(const j of _)x.some($=>(0,L.areSameExtensions)($.identifier,j.identifier))||x.push(j);return x}updateExtensionState(h,f,E,u){const O=n(f,E,this.storageService),_=u?this.extensionsStorageSyncService.getKeysForSync({id:(0,L.getGalleryExtensionId)(f,E),version:u}):void 0;_?_.forEach(q=>{O[q]=h[q]}):Object.keys(h).forEach(q=>O[q]=h[q]),r(f,E,O,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const f=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:E,isBuiltin:u,manifest:O})=>{const _={identifier:E,version:O.version};f.some(q=>(0,L.areSameExtensions)(q,E))&&(_.disabled=!0),u||(_.installed=!0);try{const q=this.extensionsStorageSyncService.getKeysForSync({id:E.id,version:O.version});if(q){const x=n(O.publisher,O.name,this.storageService);_.state=Object.keys(x).reduce((j,$)=>(q.includes($)&&(j[$]=x[$]),j),{})}}catch(q){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,m.getErrorMessage)(q))}return _})}};c.EXTENSIONS_DATA_URI=b.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),c=ue([Y(0,k.IEnvironmentService),Y(1,P.IFileService),Y(2,S.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncBackupStoreService),Y(5,R.IExtensionManagementService),Y(6,R.IGlobalExtensionEnablementService),Y(7,y.IIgnoredExtensionsManagementService),Y(8,v.IUserDataSyncLogService),Y(9,R.IExtensionGalleryService),Y(10,g.IConfigurationService),Y(11,v.IUserDataSyncResourceEnablementService),Y(12,d.ITelemetryService),Y(13,o.IExtensionsStorageSyncService)],c),e.ExtensionsSynchroniser=c;let s=class extends C.AbstractInitializer{constructor(h,f,E,u,O,_,q,x){super("extensions",q,x,_);this.extensionManagementService=h,this.galleryService=f,this.extensionEnablementService=E,this.storageService=u,this.ignoredExtensionsManagementService=O}async doInitialize(h){const f=h.syncData?await t(h.syncData,this.extensionManagementService):null;if(!f){this.logService.info("Skipping initializing extensions because remote extensions does not exist.");return}await this.initializeRemoteExtensions(f)}async initializeRemoteExtensions(h){const f=[],E=await this.extensionManagementService.getInstalled(),u=new Map,O=[],_={names:[],uuids:[]},q=[];for(const x of h)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(x.identifier.id)){const j=E.find($=>(0,L.areSameExtensions)($.identifier,x.identifier));j?(O.push({syncExtension:x,installedExtension:j}),x.disabled&&q.push(x.identifier)):x.installed&&(u.set(x.identifier.id.toLowerCase(),x),x.identifier.uuid?_.uuids.push(x.identifier.uuid):_.names.push(x.identifier.id),x.disabled&&q.push(x.identifier))}for(const{syncExtension:x,installedExtension:j}of O)if(x.state){const $=n(j.manifest.publisher,j.manifest.name,this.storageService);Object.keys(x.state).forEach(W=>$[W]=x.state[W]),r(j.manifest.publisher,j.manifest.name,$,this.storageService)}if(q.length)for(const x of q)this.logService.trace("Disabling extension...",x.id),await this.extensionEnablementService.disableExtension(x),this.logService.info("Disabling extension",x.id);if(_.names.length||_.uuids.length){const x=(await this.galleryService.query({ids:_.uuids,names:_.names,pageSize:_.uuids.length+_.names.length},w.CancellationToken.None)).firstPage;for(const j of x)try{const $=u.get(j.identifier.id.toLowerCase());$.state&&r(j.publisher,j.name,$.state,this.storageService),this.logService.trace("Installing extension...",j.identifier.id);const W=await this.extensionManagementService.installFromGallery(j,{isMachineScoped:!1});q.some(B=>(0,L.areSameExtensions)(B,j.identifier))||f.push(W),this.logService.info("Installed extension.",j.identifier.id)}catch($){this.logService.error($)}}return f}};s=ue([Y(0,R.IExtensionManagementService),Y(1,R.IExtensionGalleryService),Y(2,R.IGlobalExtensionEnablementService),Y(3,S.IStorageService),Y(4,y.IIgnoredExtensionsManagementService),Y(5,P.IFileService),Y(6,k.IEnvironmentService),Y(7,v.IUserDataSyncLogService)],s),e.ExtensionsInitializer=s}),define(Q[183],Z([0,1,26,20]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(P,g,p,C,d){if(!g)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const b=R(P,g);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const I=p?R(p,g):{added:Object.keys(g).reduce((y,m)=>(y.add(m),y),new Set),removed:new Set,updated:new Set},a=p?R(p,P):{added:Object.keys(P).reduce((y,m)=>(y.add(m),y),new Set),removed:new Set,updated:new Set},D={added:{},removed:[],updated:{}},S=v.deepClone(g),w=!p;for(const y of a.added.values())y!==T.SYNC_SERVICE_URL_TYPE&&w&&I.added.has(y)||(S[y]=P[y]);for(const y of a.updated.values())S[y]=P[y];for(const y of a.removed.values())C.unregistered.includes(y)||delete S[y];for(const y of I.added.values()){const m=g[y];if(C.machine.includes(y)){d.info(`GlobalState: Skipped adding ${y} in local storage because it is declared as machine scoped.`);continue}if(!(p&&a.added.has(y))){const o=P[y];o&&o.value===m.value||y===T.SYNC_SERVICE_URL_TYPE&&w&&a.added.has(y)||(o?D.updated[y]=m:D.added[y]=m)}}for(const y of I.updated.values()){const m=g[y];if(C.machine.includes(y)){d.info(`GlobalState: Skipped updating ${y} in local storage because it is declared as machine scoped.`);continue}if(!(a.updated.has(y)||a.removed.has(y))){const o=P[y];o&&o.value===m.value||(D.updated[y]=m)}}for(const y of I.removed.values()){if(C.machine.includes(y)){d.trace(`GlobalState: Skipped removing ${y} in local storage because it is declared as machine scoped.`);continue}a.updated.has(y)||a.removed.has(y)||D.removed.push(y)}return{local:D,remote:L(S,g)?null:S}}e.merge=k;function R(P,g){const p=Object.keys(P),C=Object.keys(g),d=C.filter(a=>p.indexOf(a)===-1).reduce((a,D)=>(a.add(D),a),new Set),b=p.filter(a=>C.indexOf(a)===-1).reduce((a,D)=>(a.add(D),a),new Set),I=new Set;for(const a of p)if(!b.has(a)){const D=P[a],S=g[a];v.equals(D,S)||I.add(a)}return{added:d,removed:b,updated:I}}function L(P,g){const{added:p,removed:C,updated:d}=R(P,g);return p.size===0&&C.size===0&&d.size===0}}),define(Q[184],Z([0,1,20,22,3,10,9,51,183,32,45,25,24,5,46,41,19,7,44,30,14]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w,y,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const i="globalState.argv.",t=["locale"];function n(h){const f=h.storage?Object.keys(h.storage).sort():[],E={};f.forEach(_=>E[_]=h.storage[_]),h.storage=E;const u=JSON.stringify(h),O=(0,a.format)(u,void 0,{});return(0,D.applyEdits)(u,O)}const r=1;let c=class st extends C.AbstractSynchroniser{constructor(f,E,u,O,_,q,x,j,$){super("globalState",f,_,$,E,u,q,x,O,j);this.environmentService=_,this.storageService=$,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(f.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(f.onDidFilesChange,W=>W.contains(this.environmentService.argvResource)),k.Event.filter($.onDidChangeValue,W=>W.scope===0&&W.target!==void 0?W.target===0:$.keys(0,0).includes(W.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(f,E,u){const O=f.syncData?JSON.parse(f.syncData.content):null,_=E&&E.syncData?JSON.parse(E.syncData.content):null,q=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const x=this.getStorageKeys(_),{local:j,remote:$}=(0,g.merge)(q.storage,O?O.storage:null,_?_.storage:null,x,this.logService),W={content:null,local:j,remote:$,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:$!==null?2:0};return[{localResource:this.localResource,localContent:n(q),localUserData:q,remoteResource:this.remoteResource,remoteContent:O?n(O):null,previewResource:this.previewResource,previewResult:W,localChange:W.localChange,remoteChange:W.remoteChange,acceptedResource:this.acceptedResource,storageKeys:x}]}async getMergeResult(f,E){return Object.assign(Object.assign({},f.previewResult),{hasConflicts:!1})}async getAcceptResult(f,E,u,O){if(this.extUri.isEqual(E,this.localResource))return this.acceptLocal(f);if(this.extUri.isEqual(E,this.remoteResource))return this.acceptRemote(f);if(this.extUri.isEqual(E,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${E.toString()}`)}async acceptLocal(f){return{content:f.localContent,local:{added:{},removed:[],updated:{}},remote:f.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(f){if(f.remoteContent!==null){const E=JSON.parse(f.remoteContent),{local:u,remote:O}=(0,g.merge)(f.localUserData.storage,E.storage,null,f.storageKeys,this.logService);return{content:f.remoteContent,local:u,remote:O,localChange:Object.keys(u.added).length>0||Object.keys(u.updated).length>0||u.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:f.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(f,E,u,O){let{localUserData:_}=u[0][0],{local:q,remote:x,localChange:j,remoteChange:$}=u[0][1];if(j===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),j!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(q),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),$!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const W=JSON.stringify({storage:x});f=await this.updateRemoteUserData(W,O?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(E==null?void 0:E.ref)!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:f}){return[{resource:this.extUri.joinPath(f,"globalState.json"),comparableResource:st.GLOBAL_STATE_DATA_URI}]}async resolveContent(f){if(this.extUri.isEqual(f,st.GLOBAL_STATE_DATA_URI)){const u=await this.getLocalGlobalState();return n(u)}if(this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f))return this.resolvePreviewContent(f);let E=await super.resolveContent(f);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(f)),E){const u=this.parseSyncData(E);if(u)switch(this.extUri.basename(f)){case"globalState.json":return n(JSON.parse(u.content))}}return null}async hasLocalData(){var f;try{const{storage:E}=await this.getLocalGlobalState();if(Object.keys(E).length>1||((f=E[`${i}.locale`])===null||f===void 0?void 0:f.value)!=="en")return!0}catch(E){}return!1}async getLocalGlobalState(){const f={},E=await this.getLocalArgvContent(),u=(0,p.parse)(E);for(const O of t)u[O]!==void 0&&(f[`${i}${O}`]={version:1,value:u[O]});for(const O of this.storageService.keys(0,0)){const _=this.storageService.get(O,0);_&&(f[O]={version:1,value:_})}return{storage:f}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(f){}return"{}"}async writeLocalGlobalState({added:f,removed:E,updated:u}){const O={},_={},q=(j,$)=>{for(const W of j){if(W.startsWith(i)){O[W.substring(i.length)]=$?$[W].value:void 0;continue}if($){const B=$[W];B.value!==String(this.storageService.get(W,0))&&(_[W]=B.value)}else this.storageService.get(W,0)!==void 0&&(_[W]=void 0)}};if(q(Object.keys(f),f),q(Object.keys(u),u),q(E),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const j of Object.keys(_))this.storageService.store(j,_[j],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(f){const E=await this.getLocalArgvContent();let u=E;for(const O of Object.keys(f))u=(0,P.edit)(u,[O],f[O],{});E!==u&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,T.VSBuffer.fromString(u)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(f){const E=this.storageService.keys(0,0),u=this.storageService.keys(0,1),O=[...E,...u],_=(f==null?void 0:f.storage)?Object.keys(f.storage).filter(q=>!q.startsWith(i)&&!O.includes(q)&&this.storageService.get(q,0)!==void 0):[];if(!w.isWeb){const q=[...v.ALL_SYNC_RESOURCES.map(x=>(0,v.getEnablementKey)(x)),v.SYNC_SERVICE_URL_TYPE];_.push(...q),u.push(...q)}return{user:E,machine:u,unregistered:_}}};c.GLOBAL_STATE_DATA_URI=I.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),c=ue([Y(0,L.IFileService),Y(1,v.IUserDataSyncStoreService),Y(2,v.IUserDataSyncBackupStoreService),Y(3,v.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,v.IUserDataSyncResourceEnablementService),Y(6,d.ITelemetryService),Y(7,b.IConfigurationService),Y(8,S.IStorageService)],c),e.GlobalStateSynchroniser=c;let s=class extends C.AbstractInitializer{constructor(f,E,u,O){super("globalState",u,O,E);this.storageService=f}async doInitialize(f){const E=f.syncData?JSON.parse(f.syncData.content):null;if(!E){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const u={},O={};for(const _ of Object.keys(E.storage))_.startsWith(i)?u[_.substring(i.length)]=E.storage[_].value:this.storageService.get(_,0)===void 0&&(O[_]=E.storage[_].value);if(Object.keys(u).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(q){}for(const q of Object.keys(u))_=(0,P.edit)(_,[q],u[q],{});await this.fileService.writeFile(this.environmentService.argvResource,T.VSBuffer.fromString(_))}if(Object.keys(O).length)for(const _ of Object.keys(O))this.storageService.store(_,O[_],0,0)}};s=ue([Y(0,S.IStorageService),Y(1,L.IFileService),Y(2,R.IEnvironmentService),Y(3,v.IUserDataSyncLogService)],s),e.GlobalStateInitializer=s;let l=class{constructor(f,E,u,O,_){this.userDataSyncStoreClient=f,this.storageService=E,this.environmentService=u,this.fileService=O,this.logService=_}getSyncStoreType(f){var E;const u=this.parseGlobalState(f);return(E=u==null?void 0:u.storage[v.SYNC_SERVICE_URL_TYPE])===null||E===void 0?void 0:E.value}async sync(f){const E=(0,v.createSyncHeaders)((0,m.generateUuid)());try{return await this.doSync(f,E)}catch(u){if(u instanceof v.UserDataSyncError)switch(u.code){case v.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(f,E)}throw u}}async doSync(f,E){const u=await this.userDataSyncStoreClient.read("globalState",null,E),O=this.parseGlobalState(u)||{storage:{}};O.storage[v.SYNC_SERVICE_URL_TYPE]={value:f,version:r};const _=await(0,y.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),q={version:r,machineId:_,content:n(O)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(q),u.ref,E)}parseGlobalState({content:f}){if(!f)return null;const E=JSON.parse(f);if((0,C.isSyncData)(E))return E?JSON.parse(E.content):null;throw new Error("Invalid remote data")}};l=ue([Y(1,S.IStorageService),Y(2,R.IEnvironmentService),Y(3,L.IFileService),Y(4,o.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Q[185],Z([0,1,9,20,180,32,122,10,24,7,17,18,45,25,19,22,3]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(o,i){const t=JSON.parse(o);if(!i)return(0,C.isUndefined)(t.all)?null:t.all;switch(p.OS){case 2:return(0,C.isUndefined)(t.mac)?null:t.mac;case 3:return(0,C.isUndefined)(t.linux)?null:t.linux;case 1:return(0,C.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=w;let y=class extends b.AbstractJsonFileSynchroniser{constructor(i,t,n,r,c,s,l,h,f,E){super(l.keybindingsResource,"keybindings",s,l,h,i,t,c,E,n,f,r);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:T.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:T.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:T.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(S.Event.filter(r.onDidChangeConfiguration,u=>u.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(i,t,n){const r=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null,c=t?this.getKeybindingsContentFromLastSyncUserData(t):null,s=await this.getLocalFileContent(),l=await this.getFormattingOptions();let h=null,f=!1,E=!1,u=!1;if(r){let _=s?s.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new T.UserDataSyncError((0,L.localize)(0,null),T.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!c||c!==_||c!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const q=await(0,k.merge)(_,r,c,l,this.userDataSyncUtilService);q.hasChanges&&(h=q.mergeContent,u=q.hasConflicts,f=u||q.mergeContent!==_,E=u||q.mergeContent!==r)}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=s.value.toString(),E=!0);const O={content:h,localChange:f?s?2:1:0,remoteChange:E?2:0,hasConflicts:u};return[{fileContent:s,localResource:this.localResource,localContent:s?s.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(i,t){return i.previewResult}async getAcceptResult(i,t,n,r){if(this.extUri.isEqual(t,this.localResource))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:i.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(i,t,n,r){var c;const{fileContent:s}=n[0][0];let{content:l,localChange:h,remoteChange:f}=n[0][1];if(h===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new T.UserDataSyncError((0,L.localize)(1,null),T.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(l||"[]",s,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),f!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const E=this.toSyncContent(l||"[]",(c=i.syncData)===null||c===void 0?void 0:c.content);i=await this.updateRemoteUserData(E,r?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(E){}(t==null?void 0:t.ref)!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(i,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const t=(0,R.parse)(i.value.toString());if((0,d.isNonEmptyArray)(t))return!0}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"keybindings.json"),comparableResource:t}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let t=await super.resolveContent(i);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(i)),t){const n=this.parseSyncData(t);if(n)switch(this.extUri.basename(i)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(n.content)}}return null}getKeybindingsContentFromLastSyncUserData(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(i.syncData.content)}getKeybindingsContentFromSyncContent(i){try{return w(i,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(i,t){let n={};try{n=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=i,p.OS){case 2:n.mac=i;break;case 3:n.linux=i;break;case 1:n.windows=i;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){let i=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return i!==void 0||(i=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,i!==void 0)?i:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=ue([Y(0,T.IUserDataSyncStoreService),Y(1,T.IUserDataSyncBackupStoreService),Y(2,T.IUserDataSyncLogService),Y(3,g.IConfigurationService),Y(4,T.IUserDataSyncResourceEnablementService),Y(5,v.IFileService),Y(6,P.IEnvironmentService),Y(7,a.IStorageService),Y(8,T.IUserDataSyncUtilService),Y(9,I.ITelemetryService)],y),e.KeybindingsSynchroniser=y;let m=class extends b.AbstractInitializer{constructor(i,t,n){super("keybindings",t,n,i)}async doInitialize(i){const t=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,D.VSBuffer.fromString(t)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,R.parse)(i.value.toString());return!(0,d.isNonEmptyArray)(t)}catch(i){return i.fileOperationResult===1}}getKeybindingsContentFromSyncContent(i){try{return w(i,!0)}catch(t){return this.logService.error(t),null}}};m=ue([Y(0,v.IFileService),Y(1,P.IEnvironmentService),Y(2,T.IUserDataSyncLogService)],m),e.KeybindingsInitializer=m}),define(Q[186],Z([0,1,26,32,41,46,51,20,18]),function(G,e,v,T,k,R,L,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function p(l,h,f){let E=[];f?E=d(f):E=C(h);const u=[],O=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const _ of E)_.startsWith("-")?O.push(_.substring(1)):u.push(_);return(0,g.distinct)([...l,...u].filter(_=>O.indexOf(_)===-1))}e.getIgnoredSettings=p;function C(l){let h=l.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=l.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:l.getValue("settingsSync.ignoredSettings")||[]}function d(l){const h=(0,T.parse)(l);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function b(l,h,f,E){if(f.length){const u=s(h),O=(0,T.parse)(h),_=(0,T.parse)(l),q=[];for(const x of f){const j=O[x],$=_[x];j===void 0?l=L.edit(l,[x],void 0,E):$!==void 0?l=L.edit(l,[x],j,E):q.push(i(x,u))}q.sort((x,j)=>x.startOffset-j.startOffset),q.forEach(x=>l=w(x.setting.key,h,l,E))}return l}e.updateIgnoredSettings=b;function I(l,h,f,E,u,O){const _=b(l,h,E,O),q=f!==_,x=f!==h;if(!q&&!x)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(q&&!x)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if(x&&!q)return{conflictsSettings:[],localContent:b(h,l,E,O),remoteContent:null,hasConflicts:!1};if(f===null&&D(l)){const se=a(l,h,E)?null:b(h,l,E,O);return{conflictsSettings:[],localContent:se,remoteContent:null,hasConflicts:!1}}let j=l,$=h;const W=(0,T.parse)(l),B=(0,T.parse)(h),M=f?(0,T.parse)(f):null,F=E.reduce((se,ce)=>(se.add(ce),se),new Set),A=S(W,B,F),U=S(M,W,F),N=S(M,B,F),z=new Map,H=new Set,K=se=>{H.add(se);const ce=u.filter(({key:he})=>he===se)[0];ce?(j=L.edit(j,[se],ce.value,O),$=L.edit($,[se],ce.value,O)):z.set(se,{key:se,localValue:W[se],remoteValue:B[se]})};for(const se of U.removed.values())N.updated.has(se)?K(se):$=L.edit($,[se],void 0,O);for(const se of N.removed.values())H.has(se)||(U.updated.has(se)?K(se):j=L.edit(j,[se],void 0,O));for(const se of U.updated.values())H.has(se)||(N.updated.has(se)?A.updated.has(se)&&K(se):$=L.edit($,[se],W[se],O));for(const se of N.updated.values())H.has(se)||(U.updated.has(se)?A.updated.has(se)&&K(se):j=L.edit(j,[se],B[se],O));for(const se of U.added.values())H.has(se)||(N.added.has(se)?A.updated.has(se)&&K(se):$=w(se,j,$,O));for(const se of N.added.values())H.has(se)||(U.added.has(se)?A.updated.has(se)&&K(se):j=w(se,$,j,O));const te=z.size>0||!a(j,$,E),X=te||!a(j,l,[]),ie=te||!a($,h,[]);return{localContent:X?j:null,remoteContent:ie?$:null,conflictsSettings:[...z.values()],hasConflicts:te}}e.merge=I;function a(l,h,f){if(l===h)return!0;const E=(0,T.parse)(l),u=(0,T.parse)(h),O=f.reduce((x,j)=>(x.add(j),x),new Set),_=s(l).filter(x=>!(x.setting&&O.has(x.setting.key))),q=s(h).filter(x=>!(x.setting&&O.has(x.setting.key)));if(_.length!==q.length)return!1;for(let x=0;x<_.length;x++){const j=_[x],$=q[x];if(j.setting&&$.setting){if(j.setting.key!==$.setting.key||!v.equals(E[j.setting.key],u[j.setting.key]))return!1}else if(!j.setting&&!$.setting){if(j.value!==$.value)return!1}else return!1}return!0}e.areSame=a;function D(l){return l?s(l).length===0:!0}e.isEmpty=D;function S(l,h,f){const E=l?Object.keys(l).filter(x=>!f.has(x)):[],u=Object.keys(h).filter(x=>!f.has(x)),O=u.filter(x=>E.indexOf(x)===-1).reduce((x,j)=>(x.add(j),x),new Set),_=E.filter(x=>u.indexOf(x)===-1).reduce((x,j)=>(x.add(j),x),new Set),q=new Set;if(l){for(const x of E)if(!_.has(x)){const j=l[x],$=h[x];v.equals(j,$)||q.add(x)}}return{added:O,removed:_,updated:q}}function w(l,h,f,E){const u=(0,T.parse)(h),O=s(h),_=s(f),q=y(l,O,_);return m(f,l,u[l],q,_,E)}e.addSetting=w;function y(l,h,f){const E=h.findIndex(O=>{var _;return((_=O.setting)===null||_===void 0?void 0:_.key)===l}),u=h[E-1];if(u){if(u.setting){const _=i(u.setting.key,f);if(_)return{index:f.indexOf(_),insertAfter:!0}}else{const _=t(E,h);if(_){const q=i(_.setting.key,f);if(q){const x=n(f.indexOf(q),f),j=r(h,_,h[E]);if(x){const $=r(f,q,x),W=c(j,$);return W?{index:f.indexOf(W),insertAfter:!0}:{index:f.indexOf(x),insertAfter:!1}}else{const $=r(f,q,f[f.length-1]),W=c(j,$);return W?{index:f.indexOf(W),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const O=h[E+1];if(O)if(O.setting){const _=i(O.setting.key,f);if(_)return{index:f.indexOf(_),insertAfter:!1}}else{const _=n(E,h);if(_){const q=i(_.setting.key,f);if(q){const x=t(f.indexOf(q),f),j=r(h,h[E],_);if(x){const $=r(f,x,q),W=c(j.reverse(),$.reverse());return W?{index:f.indexOf(W),insertAfter:!1}:{index:f.indexOf(x),insertAfter:!0}}else{const $=r(f,f[0],q),W=c(j.reverse(),$.reverse());return W?{index:f.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function m(l,h,f,E,u,O){let _;return E.index===-1?_=(0,k.setProperty)(l,[h],f,O):_=o(l,h,f,E,u,O).map(q=>(0,k.withFormatting)(l,q,O)[0]),(0,k.applyEdits)(l,_)}function o(l,h,f,E,u,O){var _;const q=`${JSON.stringify(h)}: ${JSON.stringify(f)}`,x=(0,R.getEOL)(O,l),j=u[E.index];if(E.insertAfter){const $=[];if(j.setting)$.push({offset:j.endOffset,length:0,content:","+q});else{const W=n(E.index,u),B=t(E.index,u),M=(_=B==null?void 0:B.setting)===null||_===void 0?void 0:_.commaOffset;B&&M===void 0&&$.push({offset:B.endOffset,length:0,content:","});const F=M!==void 0&&M>j.endOffset;$.push({offset:F?M+1:j.endOffset,length:0,content:W?x+q+",":x+q})}return $}else{if(j.setting)return[{offset:j.startOffset,length:0,content:q+","}];const $=(u[E.index-1]&&!u[E.index-1].setting?x:"")+q+(n(E.index,u)?",":"")+x;return[{offset:j.startOffset,length:0,content:$}]}}function i(l,h){return h.filter(f=>{var E;return((E=f.setting)===null||E===void 0?void 0:E.key)===l})[0]}function t(l,h){for(let f=l-1;f>=0;f--)if(h[f].setting)return h[f]}function n(l,h){for(let f=l+1;f<h.length;f++)if(h[f].setting)return h[f]}function r(l,h,f){const E=l.indexOf(h),u=l.indexOf(f);return l.filter((O,_)=>E<_&&_<u)}function c(l,h){if(l.length&&h.length){let f=0;for(;f<h.length&&f<l.length;f++)if(l[f].value!==h[f].value)return h[f-1];return h[f-1]}}function s(l){const h=[];let f=-1,E,u;const O={onObjectBegin:_=>{f++},onObjectProperty:(_,q,x)=>{f===0&&(E=q,u=_)},onObjectEnd:(_,q)=>{f--,f===0&&h.push({startOffset:E,endOffset:_+q,value:l.substring(E,_+q),setting:{key:u,commaOffset:void 0}})},onArrayBegin:(_,q)=>{f++},onArrayEnd:(_,q)=>{f--,f===0&&h.push({startOffset:E,endOffset:_+q,value:l.substring(E,_+q),setting:{key:u,commaOffset:void 0}})},onLiteralValue:(_,q,x)=>{f===0&&h.push({startOffset:E,endOffset:q+x,value:l.substring(E,q+x),setting:{key:u,commaOffset:void 0}})},onSeparator:(_,q,x)=>{if(f===0&&_===","){let j=h.length-1;for(;j>=0&&!h[j].setting;j--);const $=h[j];$&&h.splice(j,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:q}})}},onComment:(_,q)=>{f===0&&h.push({startOffset:_,endOffset:_+q,value:l.substring(_,_+q)})}};return(0,T.visit)(l,O),h}}),define(Q[187],Z([0,1,9,20,22,123,3,10,24,186,51,45,25,28,19,41]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function S(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function w(i){const t=JSON.parse(i);return S(t)?t:{settings:i}}e.parseSettingsSyncContent=w;let y=class extends d.AbstractJsonFileSynchroniser{constructor(t,n,r,c,s,l,h,f,E,u,O){super(n.settingsResource,"settings",t,n,r,c,s,E,u,l,h,f);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:T.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:T.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:T.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,n,r){const c=await this.getLocalFileContent(),s=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t),h=n?this.getSettingsSyncContent(n):null,f=await this.getIgnoredSettings();let E=null,u=!1,O=!1,_=!1;if(l){let x=c?c.value.toString().trim():"{}";x=x||"{}",this.validateContent(x),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const j=(0,p.merge)(x,l.settings,h?h.settings:null,f,[],s);E=j.localContent||j.remoteContent,u=j.localContent!==null,O=j.remoteContent!==null,_=j.hasConflicts}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),E=c.value.toString(),O=!0);const q={content:E,localChange:u?2:0,remoteChange:O?2:0,hasConflicts:_};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async getMergeResult(t,n){const r=await this.getFormattingOptions(),c=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,p.updateIgnoredSettings)(t.previewResult.content,"{}",c,r):null})}async getAcceptResult(t,n,r,c){const s=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(n,this.localResource))return{content:t.fileContent?(0,p.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:t.remoteContent!==null?(0,p.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return r===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:r!==null?(0,p.updateIgnoredSettings)(r,t.fileContent?t.fileContent.value.toString():"{}",l,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(t,n,r,c){const{fileContent:s}=r[0][0];let{content:l,localChange:h,remoteChange:f}=r[0][1];if(h===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(l,s,c),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),f!==0){const E=await this.getFormattingOptions(),u=this.getSettingsSyncContent(t),O=await this.getIgnoredSettings(l);l=(0,p.updateIgnoredSettings)(l,u?u.settings:"{}",O,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),c?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(E){}(n==null?void 0:n.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const n=await this.getFormattingOptions(),r=(0,C.edit)(t.value.toString(),[T.CONFIGURATION_SYNC_STORE_KEY],void 0,n);return!(0,p.isEmpty)(r)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:n}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let n=await super.resolveContent(t);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(t)),n){const r=this.parseSyncData(n);if(r){const c=this.parseSettingsSyncContent(r.content);if(c)switch(this.extUri.basename(t)){case"settings.json":return c.settings}}}return null}async resolvePreviewContent(t){let n=await super.resolvePreviewContent(t);if(n){const r=await this.getFormattingOptions(),c=await this.getIgnoredSettings();n=(0,p.updateIgnoredSettings)(n,"{}",c,r)}return n}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return w(t)}catch(n){this.logService.error(n)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtension,c=>!!c.gallery),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,c=>!c.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const n=await this._defaultIgnoredSettings;return(0,p.getIgnoredSettings)(n,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new T.UserDataSyncError((0,R.localize)(0,null),T.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const n=JSON.parse(t.value.toString());if(!o(n))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const r=this.parseSettingsSyncContent(n.content);if(!r||!r.settings)return;let c=r.settings;const s=await this.getFormattingOptions();for(const l in n)if(["version","content","machineId"].indexOf(l)===-1&&n[l]!==void 0){const h=(0,D.setProperty)(c,[l],n[l],s);h.length&&(c=(0,D.applyEdits)(c,h))}await this.fileService.writeFile(this.file,k.VSBuffer.fromString(c))}catch(t){}}};y=ue([Y(0,v.IFileService),Y(1,P.IEnvironmentService),Y(2,a.IStorageService),Y(3,T.IUserDataSyncStoreService),Y(4,T.IUserDataSyncBackupStoreService),Y(5,T.IUserDataSyncLogService),Y(6,T.IUserDataSyncUtilService),Y(7,g.IConfigurationService),Y(8,T.IUserDataSyncResourceEnablementService),Y(9,b.ITelemetryService),Y(10,I.IExtensionManagementService)],y),e.SettingsSynchroniser=y;let m=class extends d.AbstractInitializer{constructor(t,n,r){super("settings",n,r,t)}async doInitialize(t){const n=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!n){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(n.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,p.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return w(t)}catch(n){this.logService.error(n)}return null}};m=ue([Y(0,v.IFileService),Y(1,P.IEnvironmentService),Y(2,T.IUserDataSyncLogService)],m),e.SettingsInitializer=m;function o(i){return!!(i&&i.version!==void 0&&typeof i.version=="number"&&i.content!==void 0&&typeof i.content=="string"&&i.machineId!==void 0&&typeof i.machineId=="string")}}),define(Q[188],Z([0,1,20,10,9,24,45,25,22,181,19,26,3]),function(G,e,v,T,k,R,L,P,g,p,C,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let I=class extends L.AbstractSynchroniser{constructor(S,w,y,m,o,i,t,n,r){super("snippets",w,S,y,m,o,n,r,i,t);this.version=1,this.snippetsFolder=S.snippetsHome,this._register(this.fileService.watch(S.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(b.Event.filter(this.fileService.onDidFilesChange,c=>c.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(S,w,y){const m=await this.getSnippetsFileContents(),o=this.toSnippetsContents(m),i=S.syncData?this.parseSnippets(S.syncData):null,t=w&&w.syncData?this.parseSnippets(w.syncData):null;i?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,p.merge)(o,i,t);return this.getResourcePreviews(n,m,i||{})}async getMergeResult(S,w){return S.previewResult}async getAcceptResult(S,w,y,m){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:S.fileContent?S.fileContent.value.toString():null,localChange:0,remoteChange:S.fileContent?S.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:S.remoteContent,localChange:S.remoteContent!==null?S.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return y===void 0?{content:S.previewResult.content,localChange:S.previewResult.localChange,remoteChange:S.previewResult.remoteChange}:{content:y,localChange:y===null?S.fileContent!==null?3:0:2,remoteChange:y===null?S.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(S,w,y,m){const o=y.map(([i,t])=>Object.assign(Object.assign({},i),{acceptResult:t}));o.every(({localChange:i,remoteChange:t})=>i===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:i})=>i!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,m)),o.some(({remoteChange:i})=>i!==0)&&(S=await this.updateRemoteSnippets(o,S,m)),(w==null?void 0:w.ref)!==S.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(S),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:i}of o)try{await this.fileService.del(i)}catch(t){}}getResourcePreviews(S,w,y){const m=new Map;for(const o of Object.keys(S.local.added)){const i={content:S.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};m.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(S.local.updated)){const i={content:S.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of S.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(S.remote.added)){const i={content:S.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(S.remote.updated)){const i={content:S.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o],localContent:w[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of S.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of S.conflicts){const i={content:w[o]?w[o].value.toString():null,hasConflicts:!0,localChange:w[o]?2:1,remoteChange:y[o]?2:1};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o]||null,localContent:w[o]?w[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(w))if(!m.has(o)){const i={content:w[o]?w[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};m.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[o]||null,localContent:w[o]?w[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...m.values()]}async getAssociatedResources({uri:S}){let w=await super.resolveContent(S);if(w){const y=this.parseSyncData(w);if(y){const m=this.parseSnippets(y),o=[];for(const i of Object.keys(m)){const t=this.extUri.joinPath(S,i),n=this.extUri.joinPath(this.snippetsFolder,i),r=await this.fileService.exists(n);o.push({resource:t,comparableResource:r?n:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(S){if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(S);let w=await super.resolveContent(S);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(S)),w){const y=this.parseSyncData(w);if(y)return this.parseSnippets(y)[this.extUri.basename(S)]||null}return null}async hasLocalData(){try{const S=await this.getSnippetsFileContents();if(Object.keys(S).length)return!0}catch(S){}return!1}async updateLocalBackup(S){const w={};for(const y of S)y.fileContent&&(w[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(S,w){for(const{fileContent:y,acceptResult:m,localResource:o,remoteResource:i,localChange:t}of S)if(t!==0){const n=i?this.extUri.basename(i):this.extUri.basename(o),r=this.extUri.joinPath(this.snippetsFolder,n);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,g.VSBuffer.fromString(m.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,g.VSBuffer.fromString(m.content),w?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(S,w,y){const m=w.syncData?this.parseSnippets(w.syncData):{},o=(0,d.deepClone)(m);for(const{acceptResult:i,localResource:t,remoteResource:n,remoteChange:r}of S)if(r!==0){const c=t?this.extUri.basename(t):this.extUri.basename(n);r===3?delete o[c]:o[c]=i.content}return(0,p.areSame)(m,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(o),y?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(S){return JSON.parse(S.content)}toSnippetsContents(S){const w={};for(const y of Object.keys(S))w[y]=S[y].value.toString();return w}async getSnippetsFileContents(){const S={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof k.FileOperationError&&y.fileOperationResult===1)return S;throw y}for(const y of w.children||[]){const m=y.resource,o=this.extUri.extname(m);if(o===".json"||o===".code-snippets"){const i=this.extUri.relativePath(this.snippetsFolder,m),t=await this.fileService.readFile(m);S[i]=t}}return S}};I=ue([Y(0,T.IEnvironmentService),Y(1,k.IFileService),Y(2,C.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncBackupStoreService),Y(5,v.IUserDataSyncLogService),Y(6,R.IConfigurationService),Y(7,v.IUserDataSyncResourceEnablementService),Y(8,P.ITelemetryService)],I),e.SnippetsSynchroniser=I;let a=class extends L.AbstractInitializer{constructor(S,w,y){super("snippets",w,y,S)}async doInitialize(S){const w=S.syncData?JSON.parse(S.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const m of Object.keys(w)){const o=w[m];if(o){const i=this.extUri.joinPath(this.environmentService.snippetsHome,m);await this.fileService.createFile(i,g.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(i))}}await this.updateLastSyncUserData(S)}async isEmpty(){var S;try{return!((S=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||S===void 0?void 0:S.length)}catch(w){return w.fileOperationResult===1}}};a=ue([Y(0,k.IFileService),Y(1,T.IEnvironmentService),Y(2,v.IUserDataSyncLogService)],a),e.SnippetsInitializer=a}),define(Q[59],Z([0,1,4,3,2,20]),function(G,e,v,T,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,v.createDecorator)("IUserDataSyncAccountService");let L=class extends k.Disposable{constructor(g){super();this.userDataSyncStoreService=g,this._onDidChangeAccount=this._register(new T.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(g.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(g.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(g){(g&&this._account?g.token!==this._account.token||g.authenticationProviderId!==this._account.authenticationProviderId:g!==this._account)&&(this._account=g,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(g))}};L=ue([Y(0,R.IUserDataSyncStoreService)],L),e.UserDataSyncAccountService=L}),define(Q[189],Z([0,1,2,20,11,24,9,10,54,22,6]),function(G,e,v,T,k,R,L,P,g,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let d=class extends v.Disposable{constructor(I,a,D,S){super();this.environmentService=I,this.fileService=a,this.configurationService=D,this.logService=S,T.ALL_SYNC_RESOURCES.forEach(w=>this.cleanUpBackup(w))}async getAllRefs(I){const a=(0,k.joinPath)(this.environmentService.userDataSyncHome,I),D=await this.fileService.resolve(a);return D.children?D.children.filter(w=>w.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(w.name)).sort().reverse().map(w=>({ref:w.name,created:this.getCreationTime(w)})):[]}async resolveContent(I,a){if(!a){const D=await this.getAllRefs(I);D.length&&(a=D[D.length-1].ref)}if(a){const D=(0,k.joinPath)(this.environmentService.userDataSyncHome,I,a);return(await this.fileService.readFile(D)).value.toString()}return null}async backup(I,a){const D=(0,k.joinPath)(this.environmentService.userDataSyncHome,I),S=(0,k.joinPath)(D,`${(0,g.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(S,p.VSBuffer.fromString(a))}catch(w){this.logService.error(w)}try{this.cleanUpBackup(I)}catch(w){}}async cleanUpBackup(I){const a=(0,k.joinPath)(this.environmentService.userDataSyncHome,I);try{try{if(!await this.fileService.exists(a))return}catch(S){return}const D=await this.fileService.resolve(a);if(D.children){const S=D.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),w=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let y=S.filter(o=>Date.now()-this.getCreationTime(o)>w);const m=S.length-y.length;m<10&&(y=y.slice(10-m)),await C.Promises.settled(y.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(D){this.logService.error(D)}}getCreationTime(I){return I.ctime||new Date(parseInt(I.name.substring(0,4)),parseInt(I.name.substring(4,6))-1,parseInt(I.name.substring(6,8)),parseInt(I.name.substring(9,11)),parseInt(I.name.substring(11,13)),parseInt(I.name.substring(13,15))).getTime()}};d=ue([Y(0,P.IEnvironmentService),Y(1,L.IFileService),Y(2,R.IConfigurationService),Y(3,T.IUserDataSyncLogService)],d),e.UserDataSyncBackupStoreService=d}),define(Q[190],Z([0,1,5,2]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(b){this.service=b}listen(b,I){switch(I){case"onError":return this.service.onError}throw new Error(`Event not found: ${I}`)}call(b,I,a){switch(I){case"triggerSync":return this.service.triggerSync(a[0],a[1],a[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(a[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class R{constructor(b){this.service=b}listen(b,I){throw new Error(`Event not found: ${I}`)}call(b,I,a){switch(I){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(a[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(v.URI.revive(a[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=R;class L{constructor(b){this.channel=b}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(b){return this.channel.call("resolveUserKeybindings",[b])}async resolveFormattingOptions(b){return this.channel.call("resolveFormattingOptions",[b])}}e.UserDataSyncUtilServiceClient=L;class P{constructor(b){this.service=b}listen(b,I){switch(I){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${I}`)}async call(b,I,a){switch(I){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(a[0],a[1]);case"setEnablement":return this.service.setEnablement(a[0],a[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class g{constructor(b){this.service=b}listen(b,I){switch(I){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${I}`)}call(b,I,a){switch(I){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(a)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=g;class p{constructor(b){this.service=b}listen(b,I){switch(I){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${I}`)}call(b,I,a){switch(I){case"switch":return this.service.switch(a[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=p;class C extends T.Disposable{constructor(b){super();this.channel=b,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(b){return this.channel.call("switch",[b])}async getPreviousUserDataSyncStore(){const b=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(b)}revive(b){return{url:v.URI.revive(b.url),type:b.type,defaultUrl:v.URI.revive(b.defaultUrl),insidersUrl:v.URI.revive(b.insidersUrl),stableUrl:v.URI.revive(b.stableUrl),canSwitch:b.canSwitch,authenticationProviders:b.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(Q[191],Z([0,1,14,10]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends v.AbstractLogger{constructor(L,P){super();this.logger=this._register(L.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(L,...P){this.logger.trace(L,...P)}debug(L,...P){this.logger.debug(L,...P)}info(L,...P){this.logger.info(L,...P)}warn(L,...P){this.logger.warn(L,...P)}error(L,...P){this.logger.error(L,...P)}critical(L,...P){this.logger.critical(L,...P)}flush(){this.logger.flush()}};k=ue([Y(0,v.ILoggerService),Y(1,T.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(Q[60],Z([0,1,4,2,44,10,9,19,20,126,31,7,21,3]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,v.createDecorator)("IUserDataSyncMachinesService");const a="sync.currentMachineName";let D=class xe extends T.Disposable{constructor(w,y,m,o,i,t){super();this.storageService=m,this.userDataSyncStoreService=o,this.logService=i,this.productService=t,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,k.getServiceMachineId)(w,y,m)}async getMachines(w){const y=await this.currentMachineIdPromise;return(await this.readMachinesData(w)).machines.map(o=>Object.assign(Object.assign({},o),{isCurrent:o.id===y}))}async addCurrentMachine(w){const y=await this.currentMachineIdPromise,m=await this.readMachinesData(w);m.machines.some(({id:o})=>o===y)||(m.machines.push({id:y,name:this.computeCurrentMachineName(m.machines)}),await this.writeMachinesData(m))}async removeCurrentMachine(w){const y=await this.currentMachineIdPromise,m=await this.readMachinesData(w),o=m.machines.filter(({id:i})=>i!==y);o.length!==m.machines.length&&(m.machines=o,await this.writeMachinesData(m))}async renameMachine(w,y,m){const o=await this.currentMachineIdPromise,i=await this.readMachinesData(m),t=i.machines.find(({id:n})=>n===w);t&&(t.name=y,await this.writeMachinesData(i),i.machines.some(({id:n})=>n===o)&&this.storageService.store(a,y,0,1))}async setEnablement(w,y){const m=await this.readMachinesData(),o=m.machines.find(({id:i})=>i===w);o&&(o.disabled=y?void 0:!0,await this.writeMachinesData(m))}computeCurrentMachineName(w){const y=this.storageService.get(a,0);if(y)return y;const m=`${this.productService.nameLong} (${(0,d.PlatformToString)(d.isWeb?0:d.platform)})`,o=new RegExp(`${(0,b.escapeRegExpCharacters)(m)}\\s#(\\d+)`);let i=0;for(const t of w){const n=o.exec(t.name),r=n?parseInt(n[1]):0;i=r>i?r:i}return`${m} #${i+1}`}async readMachinesData(w){this.userData=await this.readUserData(w);const y=this.parse(this.userData);if(y.version!==xe.VERSION)throw new Error((0,p.localize)(0,null,this.productService.nameLong));return y}async writeMachinesData(w){var y;const m=JSON.stringify(w),o=await this.userDataSyncStoreService.write(xe.RESOURCE,m,((y=this.userData)===null||y===void 0?void 0:y.ref)||null);this.userData={ref:o,content:m},this._onDidChange.fire()}async readUserData(w){if(this.userData){const y=w&&w.latest?w.latest[xe.RESOURCE]:void 0;if(this.userData.ref===y)return this.userData;if(y===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(xe.RESOURCE,this.userData)}parse(w){if(w.content!==null)try{return JSON.parse(w.content)}catch(y){this.logService.error(y)}return{version:xe.VERSION,machines:[]}}};D.VERSION=1,D.RESOURCE="machines",D=ue([Y(0,R.IEnvironmentService),Y(1,L.IFileService),Y(2,P.IStorageService),Y(3,g.IUserDataSyncStoreService),Y(4,g.IUserDataSyncLogService),Y(5,C.IProductService)],D),e.UserDataSyncMachinesService=D}),define(Q[84],Z([0,1,6,3,2,20,59,25,15,19,10,60,124,54,5,11,7,31]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const y="sync.enable",m="sync.disableMachineEventually",o="sync.sessionId",i="sync.storeUrl",t="sync.productQuality";let n=class extends k.Disposable{constructor(l,h,f){super();this.storageService=l,this.environmentService=h,this.userDataSyncStoreManagementService=f,this._onDidChangeEnablement=new T.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(E=>this.onDidStorageChange(E)))}isEnabled(l){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(y,0,!!l)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(y,l,0,1)}onDidStorageChange(l){if(l.scope===0&&y===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=ue([Y(0,p.IStorageService),Y(1,C.IEnvironmentService),Y(2,R.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let r=class extends k.Disposable{constructor(l,h,f,E,u,O,_,q,x,j,$){var W;super();this.userDataSyncStoreManagementService=h,this.userDataSyncStoreService=f,this.userDataSyncResourceEnablementService=E,this.userDataSyncService=u,this.logService=O,this.userDataSyncAccountService=_,this.telemetryService=q,this.userDataSyncMachinesService=x,this.storageService=j,this.autoSync=this._register(new k.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=$,this.syncTriggerDelayer=this._register(new v.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(W=h.userDataSyncStore)===null||W===void 0?void 0:W.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(h.onDidChangeUserDataSyncStore(()=>{var B,M;(0,D.isEqual)(this.syncUrl,(B=h.userDataSyncStore)===null||B===void 0?void 0:B.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(M=h.userDataSyncStore)===null||M===void 0?void 0:M.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(f.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(T.Event.debounce(u.onDidChangeLocal,(B,M)=>B?[...B,M]:[M],1e3)(B=>this.triggerSync(B,!1,!1))),this._register(T.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,B])=>B)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(i,0);return l?a.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(i,l.toString(),0,1):this.storageService.remove(i,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(l){l?this.storageService.store(t,l,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:l,message:h}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(f=>this.onDidFinishSync(f))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(h&&this.logService.info(h),this.autoSync.clear()):h&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(h))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,I.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,h,f){try{this.userDataSyncAccountService.account&&!f&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(o,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(E){if(h)this.logService.error(E),this.updateEnablement(!1);else throw E}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(y,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const h=R.UserDataSyncError.toUserDataSyncError(l);h instanceof R.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:h.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),h.code===R.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):h.code===R.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):h.code===R.UserDataSyncErrorCode.LocalTooManyRequests||h.code===R.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):h.code===R.UserDataSyncErrorCode.UpgradeRequired||h.code===R.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):h.code===R.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with newer version than of client. Requires client upgrade.`)):h.code===R.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with older version than of client. Requires server reset.`)):h.code===R.UserDataSyncErrorCode.ServiceChanged||h.code===R.UserDataSyncErrorCode.DefaultServiceChanged?S.isWeb&&h.code===R.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(h),this.successiveFailures++),this._onError.fire(h)}async disableMachineEventually(){this.storageService.store(m,!0,0,1),await(0,v.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(m,0,!1)}stopDisableMachineEventually(){this.storageService.remove(m,0)}async triggerSync(l,h,f){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(h&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",f)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=ue([Y(0,w.IProductService),Y(1,R.IUserDataSyncStoreManagementService),Y(2,R.IUserDataSyncStoreService),Y(3,R.IUserDataSyncResourceEnablementService),Y(4,R.IUserDataSyncService),Y(5,R.IUserDataSyncLogService),Y(6,L.IUserDataSyncAccountService),Y(7,P.ITelemetryService),Y(8,d.IUserDataSyncMachinesService),Y(9,p.IStorageService),Y(10,R.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class c extends k.Disposable{constructor(l,h,f,E,u,O,_,q){super();this.lastSyncUrl=l,this.interval=h,this.userDataSyncStoreManagementService=f,this.userDataSyncStoreService=E,this.userDataSyncService=u,this.userDataSyncMachinesService=O,this.logService=_,this.storageService=q,this.intervalHandler=this._register(new k.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,k.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,v.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(l,h){const f=(0,v.createCancelablePromise)(async E=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,g.isPromiseCanceledError)(u))return}return this.doSync(l,h,E)});return this.syncPromise=f,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var l;return this.lastSyncUrl!==void 0&&!(0,D.isEqual)(this.lastSyncUrl,(l=this.userDataSyncStoreManagementService.userDataSyncStore)===null||l===void 0?void 0:l.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),h=this.userDataSyncStoreManagementService.userDataSyncStore;return!!h&&!!l&&(!(0,D.isEqual)(h.defaultUrl,l.defaultUrl)||!(0,D.isEqual)(h.insidersUrl,l.insidersUrl)||!(0,D.isEqual)(h.stableUrl,l.stableUrl))}async doSync(l,h,f){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let E;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(h),f.isCancellationRequested)return;let u=this.syncTask.manifest;if(u===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError((0,b.localize)(0,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError((0,b.localize)(1,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError((0,b.localize)(2,null),R.UserDataSyncErrorCode.TurnedOff);const O=this.storageService.get(o,0);if(O&&u&&O!==u.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError((0,b.localize)(3,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError((0,b.localize)(4,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError((0,b.localize)(5,null),R.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(u||void 0);if(f.isCancellationRequested)return;const q=_.find(x=>x.isCurrent);if(q==null?void 0:q.disabled)throw new R.UserDataAutoSyncError((0,b.localize)(6,null),R.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),u===null&&(u=await this.userDataSyncStoreService.manifest()),u&&u.session!==O&&this.storageService.store(o,u.session,0,1),f.isCancellationRequested)return;q||await this.userDataSyncMachinesService.addCurrentMachine(u||void 0)}catch(u){this.logService.error(u),E=u}this._onDidFinishSync.fire(E)}register(l){return super._register(l)}}c.INTERVAL_SYNCING="Interval"}),define(Q[192],Z([0,1,20,2,3,19,25,7]),function(G,e,v,T,k,R,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let g=class extends T.Disposable{constructor(C,d){super();this.storageService=C,this.telemetryService=d,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(C.onDidChangeValue(b=>this.onDidStorageChange(b)))}isResourceEnabled(C){return this.storageService.getBoolean((0,v.getEnablementKey)(C),0,!0)}setResourceEnablement(C,d){if(this.isResourceEnabled(C)!==d){const b=(0,v.getEnablementKey)(C);this.telemetryService.publicLog2(b,{enabled:d}),this.storeResourceEnablement(b,d)}}storeResourceEnablement(C,d){this.storageService.store(C,d,0,P.isWeb?0:1)}onDidStorageChange(C){if(C.scope===0){const d=v.ALL_SYNC_RESOURCES.filter(b=>(0,v.getEnablementKey)(b)===C.key)[0];if(d){this._onDidChangeResourceEnablement.fire([d,this.isResourceEnabled(d)]);return}}}};g=ue([Y(0,R.IStorageService),Y(1,L.ITelemetryService)],g),e.UserDataSyncResourceEnablementService=g}),define(Q[193],Z([0,1,20,2,4,3,182,185,184,43,25,18,19,187,11,188,30,6,15]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const m="sync.lastSyncTime";let o=class extends T.Disposable{constructor(r,c,s,l,h,f){super();this.userDataSyncStoreService=r,this.userDataSyncStoreManagementService=c,this.instantiationService=s,this.logService=l,this.telemetryService=h,this.storageService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new R.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new R.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(I.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(P.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(D.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(g.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(L.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(R.Event.any(...this.synchronisers.map(E=>R.Event.map(E.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(R.Event.any(...this.synchronisers.map(E=>R.Event.map(E.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(m,0,void 0),this.onDidChangeLocal=R.Event.any(...this.synchronisers.map(E=>R.Event.map(E.onDidChangeLocal,()=>E.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(r){await this.checkEnablement();const c=(0,S.generateUuid)();let s;try{const E=(0,v.createSyncHeaders)(c);r&&(E["Cache-Control"]="no-cache"),s=await this.userDataSyncStoreService.manifest(E)}catch(E){const u=v.UserDataSyncError.toUserDataSyncError(E);throw this.reportUserDataSyncError(u,c),u}let l=!1;const h=this;let f;return{manifest:s,run(){if(l)throw new Error("Can run a task only once");return f=(0,w.createCancelablePromise)(E=>h.sync(s,c,E)),f.finally(()=>f=void 0)},async stop(){if(f&&f.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const r=(0,S.generateUuid)(),c=(0,v.createSyncHeaders)(r);let s;try{s=await this.userDataSyncStoreService.manifest(c)}catch(l){const h=v.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(h,r),h}return new i(r,s,c,this.synchronisers,this.logService)}async sync(r,c,s){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!s.isCancellationRequested){const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,v.createSyncHeaders)(c);for(const f of this.synchronisers){if(s.isCancellationRequested)return;try{await f.sync(r,h)}catch(E){if(E instanceof v.UserDataSyncError)switch(E.code){case v.UserDataSyncErrorCode.TooLarge:throw new v.UserDataSyncError(E.message,E.code,f.resource);case v.UserDataSyncErrorCode.TooManyRequests:case v.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case v.UserDataSyncErrorCode.LocalTooManyRequests:case v.UserDataSyncErrorCode.Gone:case v.UserDataSyncErrorCode.UpgradeRequired:case v.UserDataSyncErrorCode.IncompatibleRemoteContent:case v.UserDataSyncErrorCode.IncompatibleLocalContent:throw E}const u=v.UserDataSyncError.toUserDataSyncError(E);this.reportUserDataSyncError(u,c),this.logService.error(E),this.logService.error(`${f.resource}: ${(0,p.toErrorMessage)(E)}`),this._syncErrors.push([f.resource,u])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(h){const f=v.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(f,c),f}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const r of this.synchronisers)try{r.status!=="idle"&&await r.stop()}catch(c){this.logService.error(c)}}async replace(r){await this.checkEnablement();for(const c of this.synchronisers)if(await c.replace(r))return}async accept(r,c,s,l){await this.checkEnablement();const h=this.getSynchroniser(r);await h.accept(c,s),l&&await h.apply(!1,(0,v.createSyncHeaders)((0,S.generateUuid)()))}async resolveContent(r){for(const c of this.synchronisers){const s=await c.resolveContent(r);if(s)return s}return null}getRemoteSyncResourceHandles(r){return this.getSynchroniser(r).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(r){return this.getSynchroniser(r).getLocalSyncResourceHandles()}getAssociatedResources(r,c){return this.getSynchroniser(r).getAssociatedResources(c)}getMachineId(r,c){return this.getSynchroniser(r).getMachineId(c)}async hasLocalData(){const r=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const c of r)if(await c.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(r){this.logService.error(r)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(m,0);for(const r of this.synchronisers)try{await r.resetLocal()}catch(c){this.logService.error(`${r.resource}: ${(0,p.toErrorMessage)(c)}`),this.logService.error(c)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const r of this.synchronisers)if(await r.hasPreviouslySynced())return!0;return!1}setStatus(r){const c=this._status;this._status!==r&&(this._status=r,this._onDidChangeStatus.fire(r),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const r=this.computeStatus();this.setStatus(r)}updateConflicts(){const r=this.computeConflicts();(0,d.equals)(this._conflicts,r,([c,s],[l,h])=>c===c&&(0,d.equals)(s,h,(f,E)=>(0,a.isEqual)(f.previewResource,E.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(r))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(m,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(r,c){this.telemetryService.publicLog2("sync/error",{code:r.code,url:r instanceof v.UserDataSyncStoreError?r.url:void 0,resource:r.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(r=>r.status==="hasConflicts").map(r=>[r.resource,r.conflicts.map(t)])}getSynchroniser(r){return this.synchronisers.find(c=>c.resource===r)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=ue([Y(0,v.IUserDataSyncStoreService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,k.IInstantiationService),Y(3,v.IUserDataSyncLogService),Y(4,C.ITelemetryService),Y(5,b.IStorageService)],o),e.UserDataSyncService=o;class i extends T.Disposable{constructor(r,c,s,l,h){super();this.id=r,this.manifest=c,this.syncHeaders=s,this.synchronisers=l,this.logService=h,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new R.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,w.createCancelablePromise)(r=>this.getPreviews(r))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(r){throw this.logService.error(r),r}}async accept(r,c){try{return await this.performAction(r,s=>s.accept(r,c))}catch(s){throw this.logService.error(s),s}}async merge(r){try{return r?await this.performAction(r,c=>c.merge(r)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(r){try{return await this.performAction(r,c=>c.discard(r))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const r=[];for(const[,c]of this.previews)for(const s of c.resourcePreviews)s.mergeState==="conflict"&&r.push(s.previewResource);for(const c of r)await this.discard(c);return this.previews}catch(r){throw this.logService.error(r),r}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const r=[];for(const[c,s]of this.previews){this.synchronizingResources.push([c,s.resourcePreviews.map(f=>f.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(f=>f.resource===c);for(const f of s.resourcePreviews)(f.localChange!==0||f.remoteChange!==0)&&f.mergeState==="preview"&&await l.merge(f.previewResource);const h=await l.apply(!1,this.syncHeaders);h&&r.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(f=>f[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}catch(r){throw this.logService.error(r),r}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,c]of this.previews){this.synchronizingResources.push([r,c.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const s=this.synchronisers.find(l=>l.resource===r);for(const l of c.resourcePreviews)await s.accept(l.remoteResource);await s.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,c]of this.previews){this.synchronizingResources.push([r,c.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const s=this.synchronisers.find(l=>l.resource===r);for(const l of c.resourcePreviews)await s.accept(l.localResource);await s.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async stop(){for(const r of this.synchronisers)try{await r.stop()}catch(c){(0,y.isPromiseCanceledError)(c)||this.logService.error(c)}this.reset()}async performAction(r,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const s=this.previews.findIndex(([,q])=>q.resourcePreviews.some(({localResource:x,previewResource:j,remoteResource:$})=>(0,a.isEqual)(r,x)||(0,a.isEqual)(r,j)||(0,a.isEqual)(r,$)));if(s===-1)return this.previews;const[l,h]=this.previews[s],f=h.resourcePreviews.find(({localResource:q,remoteResource:x,previewResource:j})=>(0,a.isEqual)(q,r)||(0,a.isEqual)(x,r)||(0,a.isEqual)(j,r));if(!f)return this.previews;let E=this.synchronizingResources.find(q=>q[0]===l);E||(E=[l,[]],this.synchronizingResources.push(E)),E[1].some(q=>(0,a.isEqual)(q,f.localResource))||(E[1].push(f.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const u=this.synchronisers.find(q=>q.resource===this.previews[s][0]),O=await c(u);O?this.previews.splice(s,1,this.toSyncResourcePreview(u.resource,O)):this.previews.splice(s,1);const _=this.synchronizingResources.findIndex(q=>q[0]===l);return this.synchronizingResources[_][1].splice(E[1].findIndex(q=>(0,a.isEqual)(q,f.localResource)),1),E[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const r=[];for(const[c,s]of this.previews){this.synchronizingResources.push([c,s.resourcePreviews.map(f=>f.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(f=>f.resource===c);let h=s;for(const f of s.resourcePreviews)(f.localChange!==0||f.remoteChange!==0)&&f.mergeState==="preview"&&(h=await l.merge(f.previewResource));h&&r.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(f=>f[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}async getPreviews(r){const c=[];for(const s of this.synchronisers){if(r.isCancellationRequested)return[];const l=await s.preview(this.manifest,this.syncHeaders);l&&c.push(this.toSyncResourcePreview(s.resource,l))}return c}toSyncResourcePreview(r,c){return[r,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(n){return{localResource:n.localResource,previewResource:n.previewResource,remoteResource:n.remoteResource,acceptedResource:n.acceptedResource,localChange:n.localChange,remoteChange:n.remoteChange,mergeState:n.mergeState}}}),define(Q[194],Z([0,1,3,20,5,2,17]),function(G,e,v,T,k,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(d,b){this.service=d,this.logService=b,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new v.Emitter}listen(d,b){switch(b){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${b}`)}async call(d,b,I){try{return await this._call(d,b,I)}catch(a){throw this.logService.error(a),a}}async _call(d,b,I){switch(b){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(I[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(I[0],k.URI.revive(I[1]),I[2],I[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(I[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(I[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(I[0]);case"getAssociatedResources":return this.service.getAssociatedResources(I[0],{created:I[1].created,uri:k.URI.revive(I[1].uri)});case"getMachineId":return this.service.getMachineId(I[0],{created:I[1].created,uri:k.URI.revive(I[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(b.startsWith("manualSync/")){const a=b.substring("manualSync/".length),D=I[0],S=this.getManualSyncTask(D);switch(I=I.slice(1),a){case"preview":return S.preview();case"accept":return S.accept(k.URI.revive(I[0]),I[1]);case"merge":return S.merge(k.URI.revive(I[0]));case"discard":return S.discard(k.URI.revive(I[0]));case"discardConflicts":return S.discardConflicts();case"apply":return S.apply();case"pull":return S.pull();case"push":return S.push();case"stop":return S.stop();case"_getStatus":return S.status;case"dispose":return this.disposeManualSyncTask(S)}}throw new Error("Invalid call")}getManualSyncTask(d){const b=this.manualSyncTasks.get(this.createKey(d));if(!b)throw new Error(`Manual sync taks not found: ${d}`);return b.manualSyncTask}async createManualSyncTask(){const d=new R.DisposableStore,b=d.add(await this.service.createManualSyncTask());return d.add(b.onSynchronizeResources(I=>this.onManualSynchronizeResources.fire({manualSyncTaskId:b.id,data:I}))),this.manualSyncTasks.set(this.createKey(b.id),{manualSyncTask:b,disposables:d}),{id:b.id,manifest:b.manifest,status:b.status}}disposeManualSyncTask(d){var b;d.dispose();const I=this.createKey(d.id);(b=this.manualSyncTasks.get(I))===null||b===void 0||b.disposables.dispose(),this.manualSyncTasks.delete(I)}createKey(d){return`manualSyncTask-${d}`}}e.UserDataSyncChannel=P;class g extends R.Disposable{constructor(d){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new v.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new v.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new v.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new v.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(b,I,a){return d.call(b,I,a).then(null,D=>{throw T.UserDataSyncError.toUserDataSyncError(D)})},listen(b,I){return d.listen(b,I)}},this.channel.call("_getInitialData").then(([b,I,a])=>{this.updateStatus(b),this.updateConflicts(I),a&&this.updateLastSyncTime(a),this._register(this.channel.listen("onDidChangeStatus")(D=>this.updateStatus(D))),this._register(this.channel.listen("onDidChangeLastSyncTime")(D=>this.updateLastSyncTime(D)))}),this._register(this.channel.listen("onDidChangeConflicts")(b=>this.updateConflicts(b))),this._register(this.channel.listen("onSyncErrors")(b=>this._onSyncErrors.fire(b.map(([I,a])=>[I,T.UserDataSyncError.toUserDataSyncError(a)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:d,manifest:b,status:I}=await this.channel.call("createManualSyncTask"),a=this,D=new p(d,b,I,{async call(S,w,y){return a.channel.call(`manualSync/${S}`,[d,...(0,L.isArray)(w)?w:[w]],y)},listen(S,w){return v.Event.map(v.Event.filter(a.channel.listen(`manualSync/${S}`,w),y=>!D.isDiposed()&&y.manualSyncTaskId===d),y=>y.data)}});return D}replace(d){return this.channel.call("replace",[d])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(d,b,I,a){return this.channel.call("accept",[d,b,I,a])}resolveContent(d){return this.channel.call("resolveContent",[d])}async getLocalSyncResourceHandles(d){return(await this.channel.call("getLocalSyncResourceHandles",[d])).map(({created:I,uri:a})=>({created:I,uri:k.URI.revive(a)}))}async getRemoteSyncResourceHandles(d){return(await this.channel.call("getRemoteSyncResourceHandles",[d])).map(({created:I,uri:a})=>({created:I,uri:k.URI.revive(a)}))}async getAssociatedResources(d,b){return(await this.channel.call("getAssociatedResources",[d,b])).map(({resource:a,comparableResource:D})=>({resource:k.URI.revive(a),comparableResource:k.URI.revive(D)}))}async getMachineId(d,b){return this.channel.call("getMachineId",[d,b])}async updateStatus(d){this._status=d,this._onDidChangeStatus.fire(d)}async updateConflicts(d){this._conflicts=d.map(([b,I])=>[b,I.map(a=>Object.assign(Object.assign({},a),{localResource:k.URI.revive(a.localResource),remoteResource:k.URI.revive(a.remoteResource),previewResource:k.URI.revive(a.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(d){this._lastSyncTime!==d&&(this._lastSyncTime=d,this._onDidChangeLastSyncTime.fire(d))}}e.UserDataSyncChannelClient=g;class p extends R.Disposable{constructor(d,b,I,a){super();this.id=d,this.manifest=b,this._disposed=!1,this._status=I;const D=this;this.channel={async call(S,w,y){try{const m=await a.call(S,w,y);return D.isDiposed()||(D._status=await a.call("_getStatus")),m}catch(m){throw T.UserDataSyncError.toUserDataSyncError(m)}},listen(S,w){return a.listen(S,w)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const d=await this.channel.call("preview");return this.deserializePreviews(d)}async accept(d,b){const I=await this.channel.call("accept",[d,b]);return this.deserializePreviews(I)}async merge(d){const b=await this.channel.call("merge",[d]);return this.deserializePreviews(b)}async discard(d){const b=await this.channel.call("discard",[d]);return this.deserializePreviews(b)}async discardConflicts(){const d=await this.channel.call("discardConflicts");return this.deserializePreviews(d)}async apply(){const d=await this.channel.call("apply");return this.deserializePreviews(d)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(d){return d.map(([b,I])=>[b,{isLastSyncFromCurrentMachine:I.isLastSyncFromCurrentMachine,resourcePreviews:I.resourcePreviews.map(a=>Object.assign(Object.assign({},a),{localResource:k.URI.revive(a.localResource),remoteResource:k.URI.revive(a.remoteResource),previewResource:k.URI.revive(a.previewResource),acceptedResource:k.URI.revive(a.acceptedResource)}))}])}}}),define(Q[195],Z([0,1,2,20,40,11,29,24,31,44,10,9,19,30,7,3,6,17,5,15]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const o="sync.previous.store",i="sync.donot-make-requests-until",t="sync.user-session-id",n="sync.machine-session-id",r=100,c=1e3*60*5;let s=class extends v.Disposable{constructor(O,_,q){super();this.productService=O,this.configurationService=_,this.storageService=q,this._onDidChangeUserDataSyncStore=this._register(new D.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(D.Event.filter(q.onDidChangeValue,x=>{var j;return x.key===T.SYNC_SERVICE_URL_TYPE&&x.scope===0&&this.userDataSyncStoreType!==((j=this.userDataSyncStore)===null||j===void 0?void 0:j.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(T.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(T.SYNC_SERVICE_URL_TYPE,O,0,a.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[T.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(T.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,_){O=a.isWeb&&(O==null?void 0:O.web)?Object.assign(Object.assign({},O),O.web):O;const q=Object.assign(Object.assign({},O||{}),_||{});if(q&&(0,w.isString)(q.url)&&(0,w.isObject)(q.authenticationProviders)&&Object.keys(q.authenticationProviders).every(x=>(0,w.isArray)(q.authenticationProviders[x].scopes))){const x=q,j=!!x.canSwitch&&!(_==null?void 0:_.url),$=x.url===x.insidersUrl?"insiders":"stable",W=(j?this.userDataSyncStoreType:void 0)||$,B=(_==null?void 0:_.url)||(W==="insiders"?x.insidersUrl:W==="stable"?x.stableUrl:x.url);return{url:y.URI.parse(B),type:W,defaultType:$,defaultUrl:y.URI.parse(x.url),stableUrl:y.URI.parse(x.stableUrl),insidersUrl:y.URI.parse(x.insidersUrl),canSwitch:j,authenticationProviders:Object.keys(x.authenticationProviders).reduce((M,F)=>(M.push({id:F,scopes:x.authenticationProviders[F].scopes}),M),[])}}}};s=ue([Y(0,g.IProductService),Y(1,P.IConfigurationService),Y(2,b.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let l=class extends s{constructor(O,_,q){super(O,_,q);const x=this.storageService.get(o,0);x&&(this.previousConfigurationSyncStore=JSON.parse(x));const j=this.productService[T.CONFIGURATION_SYNC_STORE_KEY];j?this.storageService.store(o,JSON.stringify(j),0,1):this.storageService.remove(o,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=ue([Y(0,g.IProductService),Y(1,P.IConfigurationService),Y(2,b.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let h=class extends v.Disposable{constructor(O,_,q,x,j,$,W){super();this.requestService=q,this.logService=x,this.storageService=W,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new D.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new D.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,p.getServiceMachineId)(j,$,W).then(B=>{const M={"X-Client-Name":`${_.applicationName}${a.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":B};return _.commit&&(M["X-Client-Commit"]=_.commit),M}),this.session=new E(r,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,v.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,_){this.authToken={token:O,type:_}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,R.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(i,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(O==null?void 0:O.getTime())&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,S.createCancelablePromise)(q=>(0,S.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),q).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,q=>null)):this.storageService.remove(i,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",O),q={},x=await this.request(_.toString(),{type:"GET",headers:q},[],L.CancellationToken.None);return(await(0,k.asJson)(x)||[]).map(({url:$,created:W})=>({ref:(0,R.relativePath)(_,_.with({path:$})),created:W*1e3}))}async resolveContent(O,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",O,_).toString(),x={};x["Cache-Control"]="no-cache";const j=await this.request(q,{type:"GET",headers:x},[],L.CancellationToken.None);return await(0,k.asText)(j)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),q={};await this.request(_,{type:"DELETE",headers:q},[],L.CancellationToken.None)}async read(O,_,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();q=Object.assign({},q),q["Cache-Control"]="no-cache",_&&(q["If-None-Match"]=_.ref);const j=await this.request(x,{type:"GET",headers:q},[304],L.CancellationToken.None);if(j.res.statusCode===304)return _;const $=j.res.headers.etag;if(!$)throw new T.UserDataSyncStoreError("Server did not return the ref",x,T.UserDataSyncErrorCode.NoRef,j.res.headers[T.HEADER_OPERATION_ID]);const W=await(0,k.asText)(j);return{ref:$,content:W}}async write(O,_,q,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();x=Object.assign({},x),x["Content-Type"]="text/plain",q&&(x["If-Match"]=q);const $=await this.request(j,{type:"POST",data:_,headers:x},[],L.CancellationToken.None),W=$.res.headers.etag;if(!W)throw new T.UserDataSyncStoreError("Server did not return the ref",j,T.UserDataSyncErrorCode.NoRef,$.res.headers[T.HEADER_OPERATION_ID]);return W}async manifest(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();O=Object.assign({},O),O["Content-Type"]="application/json";const q=await this.request(_,{type:"GET",headers:O},[],L.CancellationToken.None),x=await(0,k.asJson)(q),j=this.storageService.get(t,0);return j&&x&&j!==x.session&&this.clearSession(),x===null&&j&&this.clearSession(),x&&this.storageService.store(t,x.session,0,1),x}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(O,{type:"DELETE",headers:_},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(n,0)}async request(O,_,q,x){if(!this.authToken)throw new T.UserDataSyncStoreError("No Auth Token Available",O,T.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new T.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too many requests (429).`,O,T.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const j=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),j),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:O,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let $;try{$=await this.session.request(O,_,x)}catch(F){if(!(F instanceof T.UserDataSyncStoreError)){const A=(0,m.isPromiseCanceledError)(F)?T.UserDataSyncErrorCode.RequestCanceled:(0,m.getErrorMessage)(F).startsWith("XHR timeout")?T.UserDataSyncErrorCode.RequestTimeout:T.UserDataSyncErrorCode.RequestFailed;F=new T.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,A,void 0)}throw this.logService.info("Request failed",O),F}const W=$.res.headers[T.HEADER_OPERATION_ID],B={url:O,status:$.res.statusCode,"execution-id":_.headers[T.HEADER_EXECUTION_ID],"operation-id":W},M=(0,k.isSuccess)($)||$.res.statusCode&&q.indexOf($.res.statusCode)!==-1;if(M?this.logService.trace("Request succeeded",B):this.logService.info("Request failed",B),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new T.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,T.UserDataSyncErrorCode.Unauthorized,W);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new T.UserDataSyncStoreError(`${_.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,T.UserDataSyncErrorCode.Conflict,W);if($.res.statusCode===410)throw new T.UserDataSyncStoreError(`${_.type} request '${O}' failed because the requested resource is not longer available (410).`,O,T.UserDataSyncErrorCode.Gone,W);if($.res.statusCode===412)throw new T.UserDataSyncStoreError(`${_.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,T.UserDataSyncErrorCode.PreconditionFailed,W);if($.res.statusCode===413)throw new T.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too large payload (413).`,O,T.UserDataSyncErrorCode.TooLarge,W);if($.res.statusCode===426)throw new T.UserDataSyncStoreError(`${_.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,T.UserDataSyncErrorCode.UpgradeRequired,W);if($.res.statusCode===429){const F=$.res.headers["retry-after"];throw F?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(F)*1e3)),new T.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too many requests (429).`,O,T.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,W)):new T.UserDataSyncStoreError(`${_.type} request '${O}' failed because of too many requests (429).`,O,T.UserDataSyncErrorCode.TooManyRequests,W)}if(!M)throw new T.UserDataSyncStoreError("Server returned "+$.res.statusCode,O,T.UserDataSyncErrorCode.Unknown,W);return $}addSessionHeaders(O){let _=this.storageService.get(n,0);_===void 0&&(_=(0,I.generateUuid)(),this.storageService.store(n,_,0,1)),O["X-Machine-Session-Id"]=_;const q=this.storageService.get(t,0);q!==void 0&&(O["X-User-Session-Id"]=q)}};h=ue([Y(1,g.IProductService),Y(2,k.IRequestService),Y(3,T.IUserDataSyncLogService),Y(4,C.IEnvironmentService),Y(5,d.IFileService),Y(6,b.IStorageService)],h),e.UserDataSyncStoreClient=h;let f=class extends h{constructor(O,_,q,x,j,$,W){var B;super((B=O.userDataSyncStore)===null||B===void 0?void 0:B.url,_,q,x,j,$,W);this._register(O.onDidChangeUserDataSyncStore(()=>{var M;return this.updateUserDataSyncStoreUrl((M=O.userDataSyncStore)===null||M===void 0?void 0:M.url)}))}};f=ue([Y(0,T.IUserDataSyncStoreManagementService),Y(1,g.IProductService),Y(2,k.IRequestService),Y(3,T.IUserDataSyncLogService),Y(4,C.IEnvironmentService),Y(5,d.IFileService),Y(6,b.IStorageService)],f),e.UserDataSyncStoreService=f;class E{constructor(O,_,q,x){this.limit=O,this.interval=_,this.requestService=q,this.logService=x,this.requests=[],this.startTime=void 0}request(O,_,q){if(this.isExpired()&&this.reset(),_.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new T.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,T.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(_,q)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=E}),define(Q[196],Z([0,1,20,3,57,84,59,25,19,60,31]),function(G,e,v,T,k,R,L,P,g,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let d=class extends R.UserDataAutoSyncService{constructor(I,a,D,S,w,y,m,o,i,t,n,r){super(I,a,D,S,w,m,o,i,t,n,r);this._register(T.Event.debounce(T.Event.any(T.Event.map(y.onDidFocusWindow,()=>"windowFocus"),T.Event.map(y.onDidOpenWindow,()=>"windowOpen")),(c,s)=>c?[...c,s]:[s],1e3)(c=>this.triggerSync(c,!0,!1)))}};d=ue([Y(0,C.IProductService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,v.IUserDataSyncStoreService),Y(3,v.IUserDataSyncResourceEnablementService),Y(4,v.IUserDataSyncService),Y(5,k.INativeHostService),Y(6,v.IUserDataSyncLogService),Y(7,L.IUserDataSyncAccountService),Y(8,P.ITelemetryService),Y(9,p.IUserDataSyncMachinesService),Y(10,g.IStorageService),Y(11,v.IUserDataAutoSyncEnablementService)],d),e.UserDataAutoSyncService=d}),define(Q[197],Z([0,1,3,2,6]),function(G,e,v,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends T.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:g,getActiveWindowId:p}){super();this.disposables=this._register(new T.DisposableStore),v.Event.latch(v.Event.any(P,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>p()),(async()=>{try{const d=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:d}catch(d){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Q[61],Z([0,1,107,8,27,6,23,204,205,17]),function(G,e,v,T,k,R,L,P,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(t,n){let r=n.message;switch(t){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=t,this.cause=n}}e.ExtractError=C;function d(i){const t=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,r)=>n+r,t&61440)}function b(i){if(i instanceof C)return i;let t;return/end of central directory record signature not found/.test(i.message)&&(t="CorruptZip"),new C(t,i)}function I(i,t,n,r,c,s){const l=T.dirname(t),h=T.join(r,l);if(!h.startsWith(r))return Promise.reject(new Error(v.localize(0,null,t)));const f=T.join(r,t);let E;return s.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(k.promises.mkdir(h,{recursive:!0})).then(()=>new Promise((u,O)=>{if(!s.isCancellationRequested)try{E=(0,k.createWriteStream)(f,{mode:n}),E.once("close",()=>u()),E.once("error",O),i.once("error",O),i.pipe(E)}catch(_){O(_)}}))}function a(i,t,n,r){let c=(0,R.createCancelablePromise)(()=>Promise.resolve()),s=0;return r.onCancellationRequested(()=>{c.cancel(),i.close()}),new Promise((l,h)=>{const f=new R.Sequencer,E=u=>{u.isCancellationRequested||(s++,i.readEntry())};i.once("error",h),i.once("close",()=>c.then(()=>{r.isCancellationRequested||i.entryCount===s?l():h(new C("Incomplete",new Error(v.localize(1,null,s,i.entryCount))))},h)),i.readEntry(),i.on("entry",u=>{if(!r.isCancellationRequested){if(!n.sourcePathRegex.test(u.fileName)){E(r);return}const O=u.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(O)){const x=T.join(t,O);c=(0,R.createCancelablePromise)(j=>k.promises.mkdir(x,{recursive:!0}).then(()=>E(j)).then(void 0,h));return}const _=S(i,u),q=d(u);c=(0,R.createCancelablePromise)(x=>f.queue(()=>_.then(j=>I(j,O,q,t,n,x).then(()=>E(x)))).then(null,h))}})})}function D(i,t=!1){return new Promise((n,r)=>{(0,P.open)(i,t?{lazyEntries:!0}:void 0,(c,s)=>{c?r(b(c)):n((0,p.assertIsDefined)(s))})})}function S(i,t){return new Promise((n,r)=>{i.openReadStream(t,(c,s)=>{c?r(b(c)):n((0,p.assertIsDefined)(s))})})}function w(i,t){return new Promise((n,r)=>{const c=new g.ZipFile;t.forEach(l=>{l.contents?c.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&c.addFile(l.localPath,l.path)}),c.end();const s=(0,k.createWriteStream)(i);c.outputStream.pipe(s),c.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(i))})}e.zip=w;function y(i,t,n={},r){const c=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let s=D(i,!0);return n.overwrite&&(s=s.then(l=>(0,L.rimraf)(t).then(()=>l))),s.then(l=>a(l,t,{sourcePathRegex:c},r))}e.extract=y;function m(i,t){return D(i).then(n=>new Promise((r,c)=>{n.on("entry",s=>{s.fileName===t&&S(n,s).then(l=>r(l),l=>c(l))}),n.once("close",()=>c(new Error(v.localize(2,null,t))))}))}function o(i,t){return m(i,t).then(n=>new Promise((r,c)=>{const s=[];n.once("error",c),n.on("data",l=>s.push(l)),n.on("end",()=>r(Buffer.concat(s)))}))}e.buffer=o}),define(Q[198],Z([0,1,61,112]),function(G,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(R){return(0,v.buffer)(R,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch(P){throw new Error((0,T.localize)(0,null))}})}e.getManifest=k}),define(Q[199],Z([0,1,27,56,2,23,8,14,28,34,6,5,10,129,113,31,61,7,18,16,9,11]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w,y,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const t="scanningSystem",n="scanningUser",r="extracting",c="deleting",s="renaming";let l=class extends k.Disposable{constructor(f,E,u,O,_){super();this.beforeRemovingExtension=f,this.fileService=E,this.logService=u,this.environmentService=O,this.productService=_,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=L.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new C.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(f){const E=[];(f===null||f===0)&&E.push(this.scanSystemExtensions().then(null,u=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(u).message,t)))),(f===null||f===1)&&E.push(this.scanUserExtensions(!0).then(null,u=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(u).message,n))));try{const u=await Promise.all(E);return(0,y.flatten)(u)}catch(u){throw this.joinErrors(u)}}async scanUserExtensions(f){this.logService.trace("Started scanning user extensions");let[E,u]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return u=u.filter(O=>!E[new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),f&&(u=(0,p.groupByExtension)(u,_=>_.identifier).map(_=>_.sort((q,x)=>T.rcompare(q.manifest.version,x.manifest.version))[0])),this.logService.trace("Scanned user extensions:",u.length),u}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(f,E,u){const O=f.key(),_=L.join(this.extensionsPath,`.${O}`),q=L.join(this.extensionsPath,O);try{await R.rimraf(q)}catch(j){try{await R.rimraf(q)}catch($){}throw new g.ExtensionManagementError((0,a.localize)(0,null,q,f.id),c)}await this.extractAtLocation(f,E,_,u);try{await this.rename(f,_,q,Date.now()+2*60*1e3),this.logService.info("Renamed to",q)}catch(j){this.logService.info("Rename failed. Deleting from extracted location",_);try{R.rimraf(_)}catch($){}throw j}let x=null;try{x=await this.scanExtension(d.URI.file(L.join(this.extensionsPath,O)),1)}catch(j){}if(x)return x;throw new Error((0,a.localize)(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(f,E){this.setMetadata(f,E),E.isMachineScoped=E.isMachineScoped||void 0,E.isBuiltin=E.isBuiltin||void 0;const u=L.join(f.location.fsPath,"package.json"),O=await v.promises.readFile(u,"utf8"),{manifest:_}=await this.parseManifest(O);return _.__metadata=E,await R.writeFile(u,JSON.stringify(_,null,"	")),f}getUninstalledExtensions(){return this.withUninstalledExtensions(f=>f)}async withUninstalledExtensions(f){return this.uninstalledFileLimiter.queue(async()=>{let E;try{E=await v.promises.readFile(this.uninstalledPath,"utf8")}catch(_){if(_.code!=="ENOENT")throw _}let u={};if(E)try{u=JSON.parse(E)}catch(_){}const O=f(u);return Object.keys(u).length?await R.writeFile(this.uninstalledPath,JSON.stringify(u)):await R.rimraf(this.uninstalledPath),O})}async removeExtension(f,E){this.logService.trace(`Deleting ${E} extension from disk`,f.identifier.id,f.location.fsPath),await R.rimraf(f.location.fsPath),this.logService.info("Deleted from disk",f.identifier.id,f.location.fsPath)}async removeUninstalledExtension(f){await this.removeExtension(f,"uninstalled"),await this.withUninstalledExtensions(E=>delete E[new p.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).key()])}async extractAtLocation(f,E,u,O){this.logService.trace(`Started extracting the extension from ${E} to ${u}`);try{await R.rimraf(u)}catch(_){throw new g.ExtensionManagementError(this.joinErrors(_).message,c)}try{await(0,S.extract)(E,u,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${u}:`,f.id)}catch(_){try{await R.rimraf(u)}catch(q){}throw new g.ExtensionManagementError(_.message,_ instanceof S.ExtractError&&_.type?_.type:r)}}async rename(f,E,u,O){try{await v.promises.rename(E,u)}catch(_){if(w.isWindows&&_&&_.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${E} to ${u} with 'EPERM' error. Trying again...`,f.id),this.rename(f,E,u,O);throw new g.ExtensionManagementError(_.message||(0,a.localize)(2,null,E,u),_.code||s)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const f=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return f;const E=this.scanDevSystemExtensions(),[u,O]=await Promise.all([f,E]);return[...u,...O]}async scanExtensionsInDir(f,E){const u=new C.Limiter(10),O=await this.fileService.resolve(d.URI.file(f));return O.children?(await Promise.all(O.children.filter(q=>q.isDirectory).map(q=>u.queue(()=>this.scanExtension(q.resource,E))))).filter(q=>q&&q.identifier):[]}async scanExtension(f,E){var u,O;if(E===1&&(0,i.basename)(f).indexOf(".")===0)return null;try{const _=await this.fileService.resolve(f);if(_.children){const{manifest:q,metadata:x}=await this.readManifest(f.fsPath),j=(u=_.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M)))===null||u===void 0?void 0:u.resource,$=(O=_.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M)))===null||O===void 0?void 0:O.resource,W={id:(0,p.getGalleryExtensionId)(q.publisher,q.name)},B={type:E,identifier:W,manifest:q,location:f,readmeUrl:j,changelogUrl:$,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:E===0};return x&&this.setMetadata(B,x),B}}catch(_){E!==0&&this.logService.trace(_)}return null}async scanDefaultSystemExtensions(){const f=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",f.length),f}async scanDevSystemExtensions(){const f=this.getDevSystemExtensionsList();if(f.length){const E=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",E.length),E.filter(u=>f.some(O=>(0,p.areSameExtensions)(u.identifier,{id:O})))}else return[]}setMetadata(f,E){f.publisherDisplayName=E.publisherDisplayName||null,f.publisherId=E.publisherId||null,f.identifier.uuid=E.id,f.isMachineScoped=!!E.isMachineScoped,f.isBuiltin=f.type===0||!!E.isBuiltin}async removeUninstalledExtensions(){const f=await this.getUninstalledExtensions(),E=await this.scanAllUserExtensions(),u=new Set;for(const q of E)f[new p.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version).key()]||u.add(q.identifier.id.toLowerCase());const O=(0,p.groupByExtension)(E,q=>q.identifier);await C.Promises.settled(O.map(async q=>{const x=q.sort((j,$)=>T.rcompare(j.manifest.version,$.manifest.version))[0];u.has(x.identifier.id.toLowerCase())||await this.beforeRemovingExtension(x)}));const _=E.filter(q=>f[new p.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version).key()]);await C.Promises.settled(_.map(q=>this.removeUninstalledExtension(q)))}async removeOutdatedExtensions(){const f=await this.scanAllUserExtensions(),E=[],u=(0,p.groupByExtension)(f,O=>O.identifier);E.push(...(0,y.flatten)(u.map(O=>O.sort((_,q)=>T.rcompare(_.manifest.version,q.manifest.version)).slice(1)))),await C.Promises.settled(E.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(f=>f.name)}joinErrors(f){const E=Array.isArray(f)?f:[f];return E.length===1?E[0]instanceof Error?E[0]:new Error(E[0]):E.reduce((u,O)=>new Error(`${u.message}${u.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=L.normalize(L.join(m.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(f){const E=[v.promises.readFile(L.join(f,"package.json"),"utf8").then(q=>this.parseManifest(q)),v.promises.readFile(L.join(f,"package.nls.json"),"utf8").then(void 0,q=>q.code!=="ENOENT"?Promise.reject(q):"{}").then(q=>JSON.parse(q))],[{manifest:u,metadata:O},_]=await Promise.all(E);return{manifest:(0,I.localizeManifest)(u,_),metadata:O}}parseManifest(f){return new Promise((E,u)=>{try{const O=JSON.parse(f),_=O.__metadata||null;E({manifest:O,metadata:_})}catch(O){u(new Error((0,a.localize)(3,null)))}})}};l=ue([Y(1,o.IFileService),Y(2,P.ILogService),Y(3,b.INativeEnvironmentService),Y(4,D.IProductService)],l),e.ExtensionsScanner=l}),define(Q[200],Z([0,1,27,111,8,23,2,18,61,28,34,10,6,3,56,5,36,7,14,142,43,25,68,11,30,70,4,16,29,198,150,199,151]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w,y,m,o,i,t,n,r,c,s,l,h,f,E,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const _="unsetUninstalled",q="downloading",x="validating",j="local",$="unknown";let W=class extends L.Disposable{constructor(M,F,A,U,N,z){super();this.environmentService=M,this.galleryService=F,this.logService=A,this.downloadService=U,this.telemetryService=N,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new I.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new I.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new I.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new I.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const H=this._register(z.createInstance(O.ExtensionsLifecycle));this.extensionsScanner=this._register(z.createInstance(u.ExtensionsScanner,K=>H.postUninstall(K))),this.manifestCache=this._register(new m.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(z.createInstance(E.ExtensionsDownloader)),this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(K=>K.cancel()),this.uninstallingExtensions.forEach(K=>K.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const F=await this.collectFiles(M),A=await(0,g.zip)((0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)()).fsPath,F);return D.URI.file(A)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const F=await this.downloadVsix(M),A=k.resolve(F.fsPath);return(0,f.getManifest)(A)}async collectFiles(M){const F=async U=>{let N=await R.readdir(U);N=N.map(K=>k.join(U,K));const z=await Promise.all(N.map(K=>v.promises.stat(K)));let H=Promise.resolve([]);return z.forEach((K,te)=>{const X=N[te];K.isFile()&&(H=H.then(ie=>[...ie,X])),K.isDirectory()&&(H=H.then(ie=>F(X).then(se=>[...ie,...se])))}),H};return(await F(M.location.fsPath)).map(U=>({path:`extension/${k.relative(M.location.fsPath,U)}`,localPath:U}))}async install(M,F={}){return this.logService.trace("ExtensionManagementService#install",M.toString()),(0,b.createCancelablePromise)(async A=>{const U=await this.downloadVsix(M),N=k.resolve(U.fsPath),z=await(0,f.getManifest)(N),H={id:(0,C.getGalleryExtensionId)(z.publisher,z.name)};let K=1;if(z.engines&&z.engines.vscode&&!(0,t.isEngineValid)(z.engines.vscode,S.default.version))throw new Error(T.localize(0,null,H.id,S.default.version));const te=new C.ExtensionIdentifierWithVersion(H,z.version),ie=(await this.getInstalled(1)).find(ce=>(0,C.areSameExtensions)(H,ce.identifier));if(ie)if(F.isMachineScoped=F.isMachineScoped||ie.isMachineScoped,F.isBuiltin=F.isBuiltin||ie.isBuiltin,K=2,te.equals(new C.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version)))try{await this.extensionsScanner.removeExtension(ie,"existing")}catch(ce){throw new Error(T.localize(1,null,z.displayName||z.name))}else a.gt(ie.manifest.version,z.version)&&await this.uninstallExtension(ie);else{const ce=await this.unsetUninstalledAndGetLocal(te);if(ce)try{await this.extensionsScanner.removeExtension(ce,"existing")}catch(he){throw new Error(T.localize(2,null,z.displayName||z.name))}}this.logService.info("Installing the extension:",H.id),this._onInstallExtension.fire({identifier:H,zipPath:N});let se;try{se=await this.getGalleryMetadata((0,C.getGalleryExtensionId)(z.publisher,z.name))}catch(ce){}try{const ce=await this.installFromZipPath(te,N,Object.assign(Object.assign({},se||{}),F),F,K,A);return this.logService.info("Successfully installed the extension:",H.id),ce}catch(ce){throw this.logService.error("Failed to install the extension:",H.id,ce.message),ce}})}async downloadVsix(M){if(M.scheme===l.Schemas.file)return M;if(!this.downloadService)throw new Error("Download service is not available");const F=(0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)());return await this.downloadService.download(M,F),F}async installFromZipPath(M,F,A,U,N,z){try{const H=await this.installExtension({zipPath:F,identifierWithVersion:M,metadata:A},z);try{await this.installDependenciesAndPackExtensions(H,void 0,U)}catch(K){(0,P.isNonEmptyArray)(H.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",H.identifier.id,K.message),(0,P.isNonEmptyArray)(H.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",H.identifier.id,K.message)}return this._onDidInstallExtension.fire({identifier:M,zipPath:F,local:H,operation:N}),H}catch(H){throw this._onDidInstallExtension.fire({identifier:M,zipPath:F,operation:N,error:H}),H}}async canInstall(M){return!0}async installFromGallery(M,F={}){if(!this.galleryService.isEnabled())throw new Error(T.localize(3,null));try{M=await this.checkAndGetCompatibleVersion(M)}catch(N){const z=N&&N.code?N.code:$;throw this.logService.error("Failed to install extension:",M.identifier.id,N?N.message:z),this.reportTelemetry(this.getTelemetryEvent(1),(0,C.getGalleryExtensionTelemetryData)(M),void 0,N),N instanceof Error&&(N.name=z),N}const A=new C.ExtensionIdentifierWithVersion(M.identifier,M.version).key();let U=this.installingExtensions.get(A);return U||(U=(0,b.createCancelablePromise)(N=>this.doInstallFromGallery(M,F,N)),this.installingExtensions.set(A,U),U.finally(()=>this.installingExtensions.delete(A))),U}async doInstallFromGallery(M,F,A){const U=new Date().getTime();let N=1;this.logService.info("Installing extension:",M.identifier.id),this._onInstallExtension.fire({identifier:M.identifier,gallery:M});try{const H=(await this.getInstalled(1)).find(X=>(0,C.areSameExtensions)(X.identifier,M.identifier));H&&(N=2);const K=await this.downloadInstallableExtension(M,N);K.metadata.isMachineScoped=F.isMachineScoped||(H==null?void 0:H.isMachineScoped),K.metadata.isBuiltin=F.isBuiltin||(H==null?void 0:H.isBuiltin);const te=await this.installExtension(K,A);try{await this.extensionsDownloader.delete(D.URI.file(K.zipPath))}catch(X){}if(!F.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(te,H,F)}catch(X){try{await this.uninstall(te)}catch(ie){}throw X}return H&&a.neq(H.manifest.version,M.version)&&await this.setUninstalled(H),this.logService.info("Extensions installed successfully:",M.identifier.id),this._onDidInstallExtension.fire({identifier:M.identifier,gallery:M,local:te,operation:N}),this.reportTelemetry(this.getTelemetryEvent(N),(0,C.getGalleryExtensionTelemetryData)(M),new Date().getTime()-U,void 0),te}catch(z){const H=z&&z.code?z.code:$;throw this.logService.error("Failed to install extension:",M.identifier.id,z?z.message:H),this._onDidInstallExtension.fire({identifier:M.identifier,gallery:M,operation:N,error:H}),this.reportTelemetry(this.getTelemetryEvent(N),(0,C.getGalleryExtensionTelemetryData)(M),new Date().getTime()-U,z),z instanceof Error&&(z.name=H),z}}async checkAndGetCompatibleVersion(M){if(await this.isMalicious(M))throw new p.ExtensionManagementError(T.localize(4,null),p.INSTALL_ERROR_MALICIOUS);const F=await this.galleryService.getCompatibleExtension(M);if(!F)throw new p.ExtensionManagementError(T.localize(5,null,M.identifier.id,S.default.version),p.INSTALL_ERROR_INCOMPATIBLE);return F}async reinstallFromGallery(M){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(6,null));const F=await this.findGalleryExtension(M);if(!F)throw new Error(T.localize(7,null));await this.setUninstalled(M);try{await this.extensionsScanner.removeUninstalledExtension(M)}catch(A){throw new Error(T.localize(8,null,(0,o.toErrorMessage)(A)))}await this.installFromGallery(F)}getTelemetryEvent(M){return M===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(M){const F=await this.getExtensionsReport();return(0,C.getMaliciousExtensionsSet)(F).has(M.identifier.id)}async downloadInstallableExtension(M,F){const A={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let U;try{this.logService.trace("Started downloading extension:",M.identifier.id);const N=await this.extensionsDownloader.downloadExtension(M,F);this.logService.info("Downloaded extension:",M.identifier.id,U),U=N.fsPath}catch(N){throw new p.ExtensionManagementError(this.joinErrors(N).message,q)}try{const N=await(0,f.getManifest)(U);return{zipPath:U,identifierWithVersion:new C.ExtensionIdentifierWithVersion(M.identifier,N.version),metadata:A}}catch(N){throw new p.ExtensionManagementError(this.joinErrors(N).message,x)}}async installExtension(M,F){try{const A=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(A)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(A,M.metadata):A}catch(A){throw w.isMacintosh?new p.ExtensionManagementError(T.localize(9,null),_):new p.ExtensionManagementError(T.localize(10,null),_)}return this.extractAndInstall(M,F)}async unsetUninstalledAndGetLocal(M){return await this.isUninstalled(M)?(this.logService.trace("Removing the extension from uninstalled list:",M.id),await this.unsetUninstalled(M),this.logService.info("Removed the extension from uninstalled list:",M.id),(await this.getInstalled(1)).find(U=>new C.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version).equals(M))||null):null}async extractAndInstall({zipPath:M,identifierWithVersion:F,metadata:A},U){let N=await this.extensionsScanner.extractUserExtension(F,M,U);return this.logService.info("Installation completed.",F.id),A&&(N=await this.extensionsScanner.saveMetadataForLocalExtension(N,A)),N}async installDependenciesAndPackExtensions(M,F,A){if(!!this.galleryService.isEnabled()){const U=M.manifest.extensionDependencies||[];if(M.manifest.extensionPack)for(const N of M.manifest.extensionPack)F&&F.manifest.extensionPack&&F.manifest.extensionPack.some(z=>(0,C.areSameExtensions)({id:z},{id:N}))||U.every(z=>!(0,C.areSameExtensions)({id:z},{id:N}))&&U.push(N);if(U.length){const N=await this.getInstalled(),z=U.filter(H=>N.every(({identifier:K})=>!(0,C.areSameExtensions)(K,{id:H})));if(z.length){const K=(await this.galleryService.query({names:z,pageSize:U.length},h.CancellationToken.None)).firstPage;try{await b.Promises.settled(K.map(te=>this.installFromGallery(te,A)))}catch(te){try{await this.rollback(K)}catch(X){}throw te}}}}}async rollback(M){const A=(await this.getInstalled(1)).filter(U=>M.some(N=>new C.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version).equals(new C.ExtensionIdentifierWithVersion(N.identifier,N.version))));await b.Promises.settled(A.map(U=>this.uninstall(U)))}async uninstall(M,F={}){this.logService.trace("ExtensionManagementService#uninstall",M.identifier.id);const A=await this.getInstalled(1),U=A.find(N=>(0,C.areSameExtensions)(N.identifier,M.identifier));if(!U)throw new Error(T.localize(11,null,M.manifest.displayName||M.manifest.name));try{await this.checkForDependenciesAndUninstall(U,A,F)}catch(N){throw this.joinErrors(N)}}async updateMetadata(M,F){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,Object.assign(Object.assign({},M.manifest.__metadata||{}),F)),this.manifestCache.invalidate(),M}async updateExtensionScope(M,F){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,Object.assign(Object.assign({},M.manifest.__metadata||{}),{isMachineScoped:F})),this.manifestCache.invalidate(),M}async getGalleryMetadata(M){const F=await this.findGalleryExtensionByName(M);return F?{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId}:void 0}async findGalleryExtension(M){if(M.identifier.uuid){const F=await this.findGalleryExtensionById(M.identifier.uuid);return F||this.findGalleryExtensionByName(M.identifier.id)}return this.findGalleryExtensionByName(M.identifier.id)}async findGalleryExtensionById(M){return(await this.galleryService.query({ids:[M],pageSize:1},h.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(M){return(await this.galleryService.query({names:[M],pageSize:1},h.CancellationToken.None)).firstPage[0]}joinErrors(M){const F=Array.isArray(M)?M:[M];return F.length===1?F[0]instanceof Error?F[0]:new Error(F[0]):F.reduce((A,U)=>new Error(`${A.message}${A.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}async checkForDependenciesAndUninstall(M,F,A){try{await this.preUninstallExtension(M);const U=A.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(M,F);await this.uninstallExtensions(M,U,F,A)}catch(U){throw await this.postUninstallExtension(M,new p.ExtensionManagementError(U instanceof Error?U.message:U,j)),U}await this.postUninstallExtension(M)}async uninstallExtensions(M,F,A,U){const N=[M,...F];if(!U.donotCheckDependents)for(const z of N)this.checkForDependents(z,N,A,M);await b.Promises.settled([this.uninstallExtension(M),...F.map(z=>this.doUninstall(z))])}checkForDependents(M,F,A,U){const N=this.getDependents(M,A);if(N.length){const z=N.filter(H=>F.indexOf(H)===-1);if(z.length)throw new Error(this.getDependentsErrorMessage(M,z,U))}}getDependentsErrorMessage(M,F,A){return A===M?F.length===1?T.localize(12,null,A.manifest.displayName||A.manifest.name,F[0].manifest.displayName||F[0].manifest.name):F.length===2?T.localize(13,null,A.manifest.displayName||A.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name):T.localize(14,null,A.manifest.displayName||A.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name):F.length===1?T.localize(15,null,A.manifest.displayName||A.manifest.name,M.manifest.displayName||M.manifest.name,F[0].manifest.displayName||F[0].manifest.name):F.length===2?T.localize(16,null,A.manifest.displayName||A.manifest.name,M.manifest.displayName||M.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name):T.localize(17,null,A.manifest.displayName||A.manifest.name,M.manifest.displayName||M.manifest.name,F[0].manifest.displayName||F[0].manifest.name,F[1].manifest.displayName||F[1].manifest.name)}getAllPackExtensionsToUninstall(M,F,A=[]){if(A.indexOf(M)!==-1)return[];A.push(M);const U=M.manifest.extensionPack?M.manifest.extensionPack:[];if(U.length){const N=F.filter(H=>!H.isBuiltin&&U.some(K=>(0,C.areSameExtensions)({id:K},H.identifier))),z=[];for(const H of N)z.push(...this.getAllPackExtensionsToUninstall(H,F,A));return[...N,...z]}return[]}getDependents(M,F){return F.filter(A=>A.manifest.extensionDependencies&&A.manifest.extensionDependencies.some(U=>(0,C.areSameExtensions)({id:U},M.identifier)))}async doUninstall(M){try{await this.preUninstallExtension(M),await this.uninstallExtension(M)}catch(F){throw await this.postUninstallExtension(M,new p.ExtensionManagementError(F instanceof Error?F.message:F,j)),F}await this.postUninstallExtension(M)}async preUninstallExtension(M){if(!await R.exists(M.location.fsPath))throw new Error(T.localize(18,null));this.logService.info("Uninstalling extension:",M.identifier.id),this._onUninstallExtension.fire(M.identifier)}async uninstallExtension(M){let F=this.uninstallingExtensions.get(M.identifier.id);return F||(F=(0,b.createCancelablePromise)(async()=>{const A=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...A.filter(U=>(0,C.areSameExtensions)(U.identifier,M.identifier)))}),this.uninstallingExtensions.set(M.identifier.id,F),F.finally(()=>this.uninstallingExtensions.delete(M.identifier.id))),F}async postUninstallExtension(M,F){if(F)this.logService.error("Failed to uninstall extension:",M.identifier.id,F.message);else if(this.logService.info("Successfully uninstalled extension:",M.identifier.id),M.identifier.uuid)try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"uninstall")}catch(U){}this.reportTelemetry("extensionGallery:uninstall",(0,C.getLocalExtensionTelemetryData)(M),void 0,F);const A=F?F instanceof p.ExtensionManagementError?F.code:$:void 0;this._onDidUninstallExtension.fire({identifier:M.identifier,error:A})}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(M){return(await this.filterUninstalled(M)).length===1}filterUninstalled(...M){return this.extensionsScanner.withUninstalledExtensions(F=>{const A=[];for(const U of M)F[U.key()]&&A.push(U.key());return A})}setUninstalled(...M){const F=M.map(A=>new C.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version));return this.extensionsScanner.withUninstalledExtensions(A=>(F.forEach(U=>A[U.key()]=!0),A))}unsetUninstalled(M){return this.extensionsScanner.withUninstalledExtensions(F=>delete F[M.key()])}getExtensionsReport(){const M=new Date().getTime();return(!this.reportedExtensions||M-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=M),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const M=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${M.length} reported extensions from service`),M}catch(M){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(M,F,A,U){const N=U?U instanceof p.ExtensionManagementError?U.code:$:void 0;this.telemetryService.publicLogError(M,Object.assign(Object.assign({},F),{success:!U,duration:A,errorcode:N}))}};W=ue([Y(0,d.INativeEnvironmentService),Y(1,p.IExtensionGalleryService),Y(2,y.ILogService),Y(3,(0,s.optional)(c.IDownloadService)),Y(4,i.ITelemetryService),Y(5,s.IInstantiationService)],W),e.ExtensionManagementService=W}),define(Q[206],Z([0,1,27,38,207,100,36,99,33,75,50,146,10,161,128,28,200,172,24,163,40,164,25,58,170,79,80,175,14,76,155,55,2,165,70,160,159,140,139,148,147,77,171,69,152,9,154,16,31,20,193,195,190,57,158,191,196,169,19,167,192,59,189,173,60,71,130,197,174,84,83,82,4,149,141,15,43,8,81,178,177,194,137,143,176]),function(G,e,v,T,k,R,L,P,g,p,C,d,b,I,a,D,S,w,y,m,o,i,t,n,r,c,s,l,h,f,E,u,O,_,q,x,j,$,W,B,M,F,A,U,N,z,H,K,te,X,ie,se,ce,he,me,we,Ie,Ae,ke,Fe,Ue,Me,De,Te,$e,He,Ne,ze,J,ne,re,ge,V,ee,oe,ae,le,de,ve,ye,Ee,be,Pe,Se,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ce extends O.Disposable{constructor(fe){super();this.configuration=fe,this.server=this._register(new P.Server),(0,k.gracefulify)(v),this.registerListeners()}registerListeners(){const fe=()=>this.dispose();process.once("exit",fe),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",fe)}async open(){const fe=await this.initServices();(0,X.registerConfiguration)(),fe.invokeFunction(Le=>{const _e=Le.get(h.ILogService);_e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Le),this.registerErrorHandler(_e)}),this._register((0,O.combinedDisposable)(new x.NodeCachedDataCleaner(this.configuration.nodeCachedDataDir),fe.createInstance(j.LanguagePackCachedDataCleaner),fe.createInstance($.StorageDataCleaner,this.configuration.backupWorkspacesPath),fe.createInstance(W.LogsDataCleaner),fe.createInstance(ee.LocalizationsUpdater),fe.createInstance(oe.DeprecatedExtensionsCleaner)))}async initServices(){const fe=new p.ServiceCollection,Le=new I.NativeEnvironmentService(this.configuration.args);fe.set(b.INativeEnvironmentService,Le);const _e=new g.StaticRouter(je=>je==="main"),Ze=new f.LogLevelChannelClient(this.server.getChannel("logLevel",_e)),et=this._register(new h.MultiplexLogService([this._register(new h.ConsoleLogger(this.configuration.logLevel)),this._register(new F.SpdLogLogger("sharedprocess",(0,de.join)(Le.logsPath,"sharedprocess.log"),!0,this.configuration.logLevel))])),qe=this._register(new f.FollowerLogService(Ze,et));fe.set(h.ILogService,qe);const Ge=new M.MessagePortMainProcessService(this.server,_e);fe.set(B.IMainProcessService,Ge);const Be=this._register(new N.FileService(qe));fe.set(z.IFileService,Be);const tt=this._register(new H.DiskFileSystemProvider(qe));Be.registerProvider(K.Schemas.file,tt);const We=this._register(new m.ConfigurationService(Le.settingsResource,Be));fe.set(y.IConfigurationService,We),await We.initialize();const Ke=new Ae.NativeStorageService(void 0,Ge,Le);fe.set(ke.IStorageService,Ke),await Ke.initialize(),this._register((0,O.toDisposable)(()=>Ke.flush())),fe.set(te.IProductService,Object.assign({_serviceBrand:void 0},L.default)),fe.set(o.IRequestService,new C.SyncDescriptor(i.RequestService)),fe.set(Pe.IChecksumService,new C.SyncDescriptor(Se.ChecksumService));const Je=g.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});fe.set(he.INativeHostService,Je),fe.set(q.IDownloadService,new C.SyncDescriptor(_.DownloadService));const it=this._register(new ze.ActiveWindowManager(Je)),nt=new g.StaticRouter(je=>it.getActiveClientId().then(ft=>je===ft));fe.set(He.IExtensionRecommendationNotificationService,new Ne.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",nt)));const Xe=this._register(new me.LoggerService(qe,Be));fe.set(h.ILoggerService,Xe);const{appRoot:at,extensionsPath:ct,extensionDevelopmentLocationURI:lt,isBuilt:ut,installSourcePath:ht}=Le;let Qe,Ve;if(!lt&&!Le.disableTelemetry&&L.default.enableTelemetry){if(Ve=new J.TelemetryLogAppender(Xe,Le),L.default.aiConfig&&L.default.aiConfig.asimovKey&&ut){const je=new l.AppInsightsAppender("monacoworkbench",null,L.default.aiConfig.asimovKey);this._register((0,O.toDisposable)(()=>je.flush())),Ve=(0,n.combinedAppender)(je,Ve)}Qe=new s.TelemetryService({appender:Ve,commonProperties:(0,r.resolveCommonProperties)(Be,(0,T.release)(),process.arch,L.default.commit,L.default.version,this.configuration.machineId,L.default.msftInternalDomains,ht),sendErrorTelemetry:!0,piiPaths:[at,ct]},We)}else Qe=n.NullTelemetryService,Ve=n.NullAppender;this.server.registerChannel("telemetryAppender",new c.TelemetryAppenderChannel(Ve)),fe.set(t.ITelemetryService,Qe);const dt=new pe.CustomEndpointTelemetryService(We,Qe);return fe.set(t.ICustomEndpointTelemetryService,dt),fe.set(D.IExtensionManagementService,new C.SyncDescriptor(S.ExtensionManagementService)),fe.set(D.IExtensionGalleryService,new C.SyncDescriptor(w.ExtensionGalleryService)),fe.set(D.IExtensionTipsService,new C.SyncDescriptor(Te.ExtensionTipsService)),fe.set(u.ILocalizationsService,new C.SyncDescriptor(E.LocalizationsService)),fe.set(U.IDiagnosticsService,new C.SyncDescriptor(A.DiagnosticsService)),fe.set(Me.IUserDataSyncAccountService,new C.SyncDescriptor(Me.UserDataSyncAccountService)),fe.set(X.IUserDataSyncLogService,new C.SyncDescriptor(we.UserDataSyncLogService)),fe.set(X.IUserDataSyncUtilService,new ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",je=>je.ctx!=="main"))),fe.set(D.IGlobalExtensionEnablementService,new C.SyncDescriptor(Fe.GlobalExtensionEnablementService)),fe.set(re.IIgnoredExtensionsManagementService,new C.SyncDescriptor(re.IgnoredExtensionsManagementService)),fe.set(ge.IExtensionsStorageSyncService,new C.SyncDescriptor(ge.ExtensionsStorageSyncService)),fe.set(X.IUserDataSyncStoreManagementService,new C.SyncDescriptor(se.UserDataSyncStoreManagementService)),fe.set(X.IUserDataSyncStoreService,new C.SyncDescriptor(se.UserDataSyncStoreService)),fe.set($e.IUserDataSyncMachinesService,new C.SyncDescriptor($e.UserDataSyncMachinesService)),fe.set(X.IUserDataSyncBackupStoreService,new C.SyncDescriptor(De.UserDataSyncBackupStoreService)),fe.set(X.IUserDataAutoSyncEnablementService,new C.SyncDescriptor(ne.UserDataAutoSyncEnablementService)),fe.set(X.IUserDataSyncResourceEnablementService,new C.SyncDescriptor(Ue.UserDataSyncResourceEnablementService)),fe.set(X.IUserDataSyncService,new C.SyncDescriptor(ie.UserDataSyncService)),fe.set(Ee.ILocalPtyService,this._register(new ye.PtyHostService(qe))),new d.InstantiationService(fe)}initChannels(fe){const Le=new a.ExtensionManagementChannel(fe.get(D.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Le);const _e=g.ProxyChannel.fromService(fe.get(u.ILocalizationsService));this.server.registerChannel("localizations",_e);const Ze=g.ProxyChannel.fromService(fe.get(U.IDiagnosticsService));this.server.registerChannel("diagnostics",Ze);const et=new a.ExtensionTipsChannel(fe.get(D.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const qe=g.ProxyChannel.fromService(fe.get(Pe.IChecksumService));this.server.registerChannel("checksum",qe);const Ge=new ce.UserDataSyncMachinesServiceChannel(fe.get($e.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ge);const Be=g.ProxyChannel.fromService(fe.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Be);const tt=new ce.UserDataSyncAccountServiceChannel(fe.get(Me.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",tt);const We=new ce.UserDataSyncStoreManagementServiceChannel(fe.get(X.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",We);const Ke=new be.UserDataSyncChannel(fe.get(X.IUserDataSyncService),fe.get(h.ILogService));this.server.registerChannel("userDataSync",Ke);const Je=this._register(fe.get(V.IInstantiationService).createInstance(Ie.UserDataAutoSyncService)),it=new ce.UserDataAutoSyncChannel(Je);this.server.registerChannel("userDataAutoSync",it);const nt=fe.get(Ee.ILocalPtyService),Xe=g.ProxyChannel.fromService(nt);this.server.registerChannel(ve.TerminalIpcChannels.LocalPty,Xe)}registerErrorHandler(fe){window.addEventListener("unhandledrejection",Le=>{(0,ae.onUnexpectedError)(Le.reason),Le.preventDefault()}),(0,ae.setUnexpectedErrorHandler)(Le=>{const _e=(0,le.toErrorMessage)(Le,!0);!_e||fe.error(`[uncaught exception in sharedProcess]: ${_e}`)})}}async function Re(Oe){const fe=new Ce(Oe);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await fe.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Re})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/84fe402d655e029eb1a5c04e675bf64788fa7fcf/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
